/*
* ImagiNet Compiler 4.2.671
* Copyright (c) 2019- [Imagimob AB], All Rights Reserved.
* 
* Generated at 11/09/2023 13:23:19 UTC. Any changes will be lost.
* 
* Model ID  0f255fcf-f511-4cb0-9fc1-7ab57066d460
* 
* Memory    Size                      Efficiency
* Buffers   7248 bytes (RAM)          100 %
* State     9592 bytes (RAM)          100 %
* Readonly  53316 bytes (Flash)       100 %
* 
* Backend              tensorflow
* Keras Version        2.10.0
* Backend Model Type   Sequential
* Backend Model Name   conv1d-medium-balanced-2-Downscale-GlobalAvgPool
* 
* Class Index | Symbol Label
* 0           | unlabelled
* 1           | sirens
* 
* Layer                          Shape           Type       Function
* Sliding Window (data points)   [512]           float      dequeue
*    window_shape = [512]
*    stride = 320
*    buffer_multiplier = 1
* Hann smoothing                 [512]           float      dequeue
*    sym = True
* Real Discrete Fourier Transform [257,2]         float      dequeue
*    axis = 0
* Frobenius norm                 [257]           float      dequeue
*    axis = 0
* Mel Filterbank                 [30]            float      dequeue
*    num_filters = 30
*    sample_rate = 16000
*    f_low = 200
*    f_high = 7000
*    htk = True
*    librosa = False
* Clip                           [30]            float      dequeue
*    min = 0.000316227766016
*    max = 3.40282347E+38
* Logarithm                      [30]            float      dequeue
*    base = 0
* Sliding Window (data points)   [50,30]         float      dequeue
*    window_shape = [50,30]
*    stride = 180
*    buffer_multiplier = 1
* Input Layer                    [50,30]         float      dequeue
*    shape = [50,30]
* Convolution 1D                 [24,13]         float      dequeue
*    filters = 13
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 2
*    padding = valid
*    activation = linear
*    use_bias = True
*    trainable = True
*    weight = float[3,30,13]
*    bias = float[13]
* Convolution 1D                 [12,16]         float      dequeue
*    filters = 16
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 2
*    padding = same
*    activation = linear
*    use_bias = False
*    trainable = True
*    weight = float[3,13,16]
* Batch Normalization            [12,16]         float      dequeue
*    epsilon = 0.001
*    trainable = True
*    scale = True
*    center = True
*    axis = 2
*    gamma = float[16]
*    beta = float[16]
*    mean = float[16]
*    variance = float[16]
* Activation                     [12,16]         float      dequeue
*    activation = relu
*    trainable = True
* Convolution 1D                 [12,32]         float      dequeue
*    filters = 32
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 1
*    padding = same
*    activation = linear
*    use_bias = False
*    trainable = True
*    weight = float[3,16,32]
* Convolution 1D                 [12,32]         float      dequeue
*    filters = 32
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 1
*    padding = same
*    activation = linear
*    use_bias = False
*    trainable = True
*    weight = float[3,32,32]
* Batch Normalization            [12,32]         float      dequeue
*    epsilon = 0.001
*    trainable = True
*    scale = True
*    center = True
*    axis = 2
*    gamma = float[32]
*    beta = float[32]
*    mean = float[32]
*    variance = float[32]
* Activation                     [12,32]         float      dequeue
*    activation = relu
*    trainable = True
* Convolution 1D                 [12,32]         float      dequeue
*    filters = 32
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 1
*    padding = same
*    activation = linear
*    use_bias = False
*    trainable = True
*    weight = float[3,32,32]
* Convolution 1D                 [12,32]         float      dequeue
*    filters = 32
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 1
*    padding = same
*    activation = linear
*    use_bias = False
*    trainable = True
*    weight = float[3,32,32]
* Batch Normalization            [12,32]         float      dequeue
*    epsilon = 0.001
*    trainable = True
*    scale = True
*    center = True
*    axis = 2
*    gamma = float[32]
*    beta = float[32]
*    mean = float[32]
*    variance = float[32]
* Activation                     [12,32]         float      dequeue
*    activation = relu
*    trainable = True
* Global average pooling 1D      [32]            float      dequeue
*    trainable = True
* Dense                          [2]             float      dequeue
*    units = 2
*    use_bias = True
*    activation = linear
*    trainable = True
*    weight = float[32,2]
*    bias = float[2]
* Activation                     [2]             float      dequeue
*    activation = softmax
*    trainable = True
* 
* Exported functions:
* 
* int IMAI_dequeue(float *restrict data_out)
*    Description: Dequeue features. RET_SUCCESS (0) on success, RET_NODATA (-1) if no data is available, RET_NOMEM (-2) on internal memory error
*    Parameter data_out is Output of size float[2].
* 
* int IMAI_enqueue(const float *restrict data_in)
*    Description: Enqueue features. Returns SUCCESS (0) on success, else RET_NOMEM (-2) when low on memory.
*    Parameter data_in is Input of size float[1].
* 
* void IMAI_init(void)
*    Description: Initializes buffers to initial state. This function also works as a reset function.
* 
* 
* Disclaimer:
*   The generated code relies on the optimizations done by the C compiler.
*   For example many for-loops of length 1 must be removed by the optimizer.
*   This can only be done if the functions are inlined and simplified.
*   Check disassembly if unsure.
*   tl;dr Compile using gcc with -O3 or -Ofast
*/

#ifndef _IMAI_MODEL_H_
#define _IMAI_MODEL_H_
#ifdef _MSC_VER
#pragma once
#endif

#include <stdint.h>

typedef struct {    
    char *name;
    double TP; // True Positive or Correct Positive Prediction
    double FN; // False Negative or Incorrect Negative Prediction
    double FP; // False Positive or Incorrect Positive Prediction
    double TN; // True Negative or Correct Negative Prediction
    double TPR; // True Positive Rate or Sensitivity, Recall
    double TNR; // True Negative Rate or Specificity, Selectivity
    double PPV; // Positive Predictive Value or Precision
    double NPV; // Negative Predictive Value
    double FNR; // False Negative Rate or Miss Rate
    double FPR; // False Positive Rate or Fall-Out
    double FDR; // False Discovery Rate
    double FOR; // False Omission Rate
    double F1S; // F1 Score
} IMAI_stats;

/*
* Tensorflow Train Set
* 
* (ACC) Accuracy 82.869 %
* (F1S) F1 Score 83.182 %
* 
* Name of class                                            (unlabelled)           sirens
* (TP) True Positive or Correct Positive Prediction              262908            98001
* (FN) False Negative or Incorrect Negative Prediction            46287            28320
* (FP) False Positive or Incorrect Positive Prediction            28320            46287
* (TN) True Negative or Correct Negative Prediction               98001           262908
* (TPR) True Positive Rate or Sensitivity, Recall               85.03 %          77.58 %
* (TNR) True Negative Rate or Specificity, Selectivity          77.58 %          85.03 %
* (PPV) Positive Predictive Value or Precision                  90.28 %          67.92 %
* (NPV) Negative Predictive Value                               67.92 %          90.28 %
* (FNR) False Negative Rate or Miss Rate                        14.97 %          22.42 %
* (FPR) False Positive Rate or Fall-Out                         22.42 %          14.97 %
* (FDR) False Discovery Rate                                     9.72 %          32.08 %
* (FOR) False Omission Rate                                     32.08 %           9.72 %
* (F1S) F1 Score                                                87.57 %          72.43 %
*/


#define IMAI_TRAIN_AVG_ACC 0.8286928608822638 // Accuracy
#define IMAI_TRAIN_AVG_F1S 0.8318167137070678 // F1 Score

#define IMAI_TRAIN_STATS { \
 {name: "(unlabelled)", TP: 262908, FN: 46287, FP: 28320, TN: 98001, TPR: 0.8502983554067, TNR: 0.7758092478685, PPV: 0.9027566030738, NPV: 0.6792040918163, FNR: 0.1497016445932, FPR: 0.2241907521314, FDR: 0.0972433969261, FOR: 0.3207959081836, F1S: 0.8757426014659, }, \
 {name: "sirens", TP: 98001, FN: 28320, FP: 46287, TN: 262908, TPR: 0.7758092478685, TNR: 0.8502983554067, PPV: 0.6792040918163, NPV: 0.9027566030738, FNR: 0.2241907521314, FPR: 0.1497016445932, FDR: 0.3207959081836, FOR: 0.0972433969261, F1S: 0.7242996352671, }, \
}

#ifdef IMAI_STATS_ENABLED
static const IMAI_stats IMAI_train_stats[] = IMAI_TRAIN_STATS;
#endif

/*
* Tensorflow Validation Set
* 
* (ACC) Accuracy 86.126 %
* (F1S) F1 Score 87.051 %
* 
* Name of class                                            (unlabelled)           sirens
* (TP) True Positive or Correct Positive Prediction               68761             8756
* (FN) False Negative or Incorrect Negative Prediction             8744             3743
* (FP) False Positive or Incorrect Positive Prediction             3743             8744
* (TN) True Negative or Correct Negative Prediction                8756            68761
* (TPR) True Positive Rate or Sensitivity, Recall               88.72 %          70.05 %
* (TNR) True Negative Rate or Specificity, Selectivity          70.05 %          88.72 %
* (PPV) Positive Predictive Value or Precision                  94.84 %          50.03 %
* (NPV) Negative Predictive Value                               50.03 %          94.84 %
* (FNR) False Negative Rate or Miss Rate                        11.28 %          29.95 %
* (FPR) False Positive Rate or Fall-Out                         29.95 %          11.28 %
* (FDR) False Discovery Rate                                     5.16 %          49.97 %
* (FOR) False Omission Rate                                     49.97 %           5.16 %
* (F1S) F1 Score                                                91.68 %          58.38 %
*/


#define IMAI_VALIDATION_AVG_ACC 0.8612617217012577 // Accuracy
#define IMAI_VALIDATION_AVG_F1S 0.8705133143299507 // F1 Score

#define IMAI_VALIDATION_STATS { \
 {name: "(unlabelled)", TP: 68761, FN: 8744, FP: 3743, TN: 8756, TPR: 0.8871814721630, TNR: 0.7005360428834, PPV: 0.9483752620545, NPV: 0.5003428571428, FNR: 0.1128185278369, FPR: 0.2994639571165, FDR: 0.0516247379454, FOR: 0.4996571428571, F1S: 0.9167583278336, }, \
 {name: "sirens", TP: 8756, FN: 3743, FP: 8744, TN: 68761, TPR: 0.7005360428834, TNR: 0.8871814721630, PPV: 0.5003428571428, NPV: 0.9483752620545, FNR: 0.2994639571165, FPR: 0.1128185278369, FDR: 0.4996571428571, FOR: 0.0516247379454, F1S: 0.5837527917597, }, \
}

#ifdef IMAI_STATS_ENABLED
static const IMAI_stats IMAI_validation_stats[] = IMAI_VALIDATION_STATS;
#endif

#define IMAI_API_QUEUE

// All symbols in order
#define IMAI_SYMBOL_MAP {"unlabelled", "sirens"}

// Model GUID (16 bytes)
#define IMAI_MODEL_ID {0xcf, 0x5f, 0x25, 0x0f, 0x11, 0xf5, 0xb0, 0x4c, 0x9f, 0xc1, 0x7a, 0xb5, 0x70, 0x66, 0xd4, 0x60}

// First nibble is bit encoding, second nibble is number of bytes
#define IMAGINET_TYPES_NONE	(0x0)
#define IMAGINET_TYPES_FLOAT32	(0x14)
#define IMAGINET_TYPES_FLOAT64	(0x18)
#define IMAGINET_TYPES_INT8	(0x21)
#define IMAGINET_TYPES_INT16	(0x22)
#define IMAGINET_TYPES_INT32	(0x24)
#define IMAGINET_TYPES_INT64	(0x28)
#define IMAGINET_TYPES_QDYN8	(0x31)
#define IMAGINET_TYPES_QDYN16	(0x32)
#define IMAGINET_TYPES_QDYN32	(0x34)

// data_in [1] (4 bytes)
#define IMAI_DATA_IN_COUNT (1)
#define IMAI_DATA_IN_TYPE float
#define IMAI_DATA_IN_TYPE_ID IMAGINET_TYPES_FLOAT32
#define IMAI_DATA_IN_SCALE (1)
#define IMAI_DATA_IN_OFFSET (0)
#define IMAI_DATA_IN_IS_QUANTIZED (0)

// data_out [2] (8 bytes)
#define IMAI_DATA_OUT_COUNT (2)
#define IMAI_DATA_OUT_TYPE float
#define IMAI_DATA_OUT_TYPE_ID IMAGINET_TYPES_FLOAT32
#define IMAI_DATA_OUT_SCALE (1)
#define IMAI_DATA_OUT_OFFSET (0)
#define IMAI_DATA_OUT_IS_QUANTIZED (0)

#define IMAI_KEY_MAX (52)



// Return codes
#define IMAI_RET_SUCCESS 0
#define IMAI_RET_NODATA -1
#define IMAI_RET_NOMEM -2

// Exported methods
int IMAI_dequeue(float *restrict data_out);
int IMAI_enqueue(const float *restrict data_in);
void IMAI_init(void);

#endif /* _IMAI_MODEL_H_ */
