/******************************************************************************
 * MP3Encoder.h
 * Copyright (C) Infineon Technologies AG 2021
 *
 * Use of this file is subject to the terms of use agreed between (i) you or
 * the company in which ordinary course of business you are acting and (ii)
 * Infineon Technologies AG or its licensees. If and as long as no such terms
 * of use are agreed, use of this file is subject to following:
 *
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated
 * by a source language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *****************************************************************************/
#ifndef IsrTaskPrios
#define IsrTaskPrios

/*****************************************************************************/
/*----------------------------------Includes---------------------------------*/
/*****************************************************************************/
#include "FreeRTOSConfig.h"
#include "FreeRTOS.h"
#include "task.h"

/*****************************************************************************/
/*-----------------------------------Macros----------------------------------*/
/*****************************************************************************/



#define TaskPrio_Main           configMAX_PRIORITIES-5

#define TaskPrio_UartHandler    tskIDLE_PRIORITY + 1
#define TaskPrio_UartTx         configMAX_PRIORITIES-2
#define TaskPrio_UartRx         configMAX_PRIORITIES-2


#define TaskPrio_IdleLED        tskIDLE_PRIORITY

//ETH
#define TaskPrio_EthMacRX       configMAX_PRIORITIES-2
#define TaskPrio_EthLinkStatus  tskIDLE_PRIORITY + 1
#define TaskPrio_lwIPHandler    configMAX_PRIORITIES-3

//CPU0 ISR's
#define Isr_Eth_Rx          29
#define Isr_Eth_Tx          28
#define Isr_Uart_Tx         27
#define Isr_Uart_Rx         26

/*****************************************************************************/
/*------------------------------Global variables-----------------------------*/
/*****************************************************************************/

/*****************************************************************************/
/*-------------------------------Data Structures-----------------------------*/
/*****************************************************************************/

/*****************************************************************************/
/*-------------------------Global Variables/Constants------------------------*/
/*****************************************************************************/

/*****************************************************************************/
/*----------------------------Function Prototypes----------------------------*/
/*****************************************************************************/

/*****************************************************************************/
/*----------------------Inline Function Implementations----------------------*/
/*****************************************************************************/


#endif /* IsrTaskPrios */










