/*
* ImagiNet Compiler 4.2.671
* Copyright (c) 2019- [Imagimob AB], All Rights Reserved.
* 
* Generated at 11/09/2023 13:23:20 UTC. Any changes will be lost.
* 
* Model ID  0f255fcf-f511-4cb0-9fc1-7ab57066d460
* 
* Memory    Size                      Efficiency
* Buffers   7248 bytes (RAM)          100 %
* State     9592 bytes (RAM)          100 %
* Readonly  53316 bytes (Flash)       100 %
* 
* Backend              tensorflow
* Keras Version        2.10.0
* Backend Model Type   Sequential
* Backend Model Name   conv1d-medium-balanced-2-Downscale-GlobalAvgPool
* 
* Class Index | Symbol Label
* 0           | unlabelled
* 1           | sirens
* 
* Layer                          Shape           Type       Function
* Sliding Window (data points)   [512]           float      dequeue
*    window_shape = [512]
*    stride = 320
*    buffer_multiplier = 1
* Hann smoothing                 [512]           float      dequeue
*    sym = True
* Real Discrete Fourier Transform [257,2]         float      dequeue
*    axis = 0
* Frobenius norm                 [257]           float      dequeue
*    axis = 0
* Mel Filterbank                 [30]            float      dequeue
*    num_filters = 30
*    sample_rate = 16000
*    f_low = 200
*    f_high = 7000
*    htk = True
*    librosa = False
* Clip                           [30]            float      dequeue
*    min = 0.000316227766016
*    max = 3.40282347E+38
* Logarithm                      [30]            float      dequeue
*    base = 0
* Sliding Window (data points)   [50,30]         float      dequeue
*    window_shape = [50,30]
*    stride = 180
*    buffer_multiplier = 1
* Input Layer                    [50,30]         float      dequeue
*    shape = [50,30]
* Convolution 1D                 [24,13]         float      dequeue
*    filters = 13
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 2
*    padding = valid
*    activation = linear
*    use_bias = True
*    trainable = True
*    weight = float[3,30,13]
*    bias = float[13]
* Convolution 1D                 [12,16]         float      dequeue
*    filters = 16
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 2
*    padding = same
*    activation = linear
*    use_bias = False
*    trainable = True
*    weight = float[3,13,16]
* Batch Normalization            [12,16]         float      dequeue
*    epsilon = 0.001
*    trainable = True
*    scale = True
*    center = True
*    axis = 2
*    gamma = float[16]
*    beta = float[16]
*    mean = float[16]
*    variance = float[16]
* Activation                     [12,16]         float      dequeue
*    activation = relu
*    trainable = True
* Convolution 1D                 [12,32]         float      dequeue
*    filters = 32
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 1
*    padding = same
*    activation = linear
*    use_bias = False
*    trainable = True
*    weight = float[3,16,32]
* Convolution 1D                 [12,32]         float      dequeue
*    filters = 32
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 1
*    padding = same
*    activation = linear
*    use_bias = False
*    trainable = True
*    weight = float[3,32,32]
* Batch Normalization            [12,32]         float      dequeue
*    epsilon = 0.001
*    trainable = True
*    scale = True
*    center = True
*    axis = 2
*    gamma = float[32]
*    beta = float[32]
*    mean = float[32]
*    variance = float[32]
* Activation                     [12,32]         float      dequeue
*    activation = relu
*    trainable = True
* Convolution 1D                 [12,32]         float      dequeue
*    filters = 32
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 1
*    padding = same
*    activation = linear
*    use_bias = False
*    trainable = True
*    weight = float[3,32,32]
* Convolution 1D                 [12,32]         float      dequeue
*    filters = 32
*    kernel_size = 3
*    dilation_rate = 1
*    strides = 1
*    padding = same
*    activation = linear
*    use_bias = False
*    trainable = True
*    weight = float[3,32,32]
* Batch Normalization            [12,32]         float      dequeue
*    epsilon = 0.001
*    trainable = True
*    scale = True
*    center = True
*    axis = 2
*    gamma = float[32]
*    beta = float[32]
*    mean = float[32]
*    variance = float[32]
* Activation                     [12,32]         float      dequeue
*    activation = relu
*    trainable = True
* Global average pooling 1D      [32]            float      dequeue
*    trainable = True
* Dense                          [2]             float      dequeue
*    units = 2
*    use_bias = True
*    activation = linear
*    trainable = True
*    weight = float[32,2]
*    bias = float[2]
* Activation                     [2]             float      dequeue
*    activation = softmax
*    trainable = True
* 
* Exported functions:
* 
* int IMAI_dequeue(float *restrict data_out)
*    Description: Dequeue features. RET_SUCCESS (0) on success, RET_NODATA (-1) if no data is available, RET_NOMEM (-2) on internal memory error
*    Parameter data_out is Output of size float[2].
* 
* int IMAI_enqueue(const float *restrict data_in)
*    Description: Enqueue features. Returns SUCCESS (0) on success, else RET_NOMEM (-2) when low on memory.
*    Parameter data_in is Input of size float[1].
* 
* void IMAI_init(void)
*    Description: Initializes buffers to initial state. This function also works as a reset function.
* 
* 
* Disclaimer:
*   The generated code relies on the optimizations done by the C compiler.
*   For example many for-loops of length 1 must be removed by the optimizer.
*   This can only be done if the functions are inlined and simplified.
*   Check disassembly if unsure.
*   tl;dr Compile using gcc with -O3 or -Ofast
*/

#include <float.h>
#include <math.h>
#include <stdint.h>
#include <string.h>

#include "model.h"

// Working memory
static int8_t _buffer[7248];
static int8_t _state[9592];

// Parameters
static const uint32_t _K4[] = {
    0x0, 0x381e87c4, 0x391e863b, 0x39b25423, 0x3a1e8019, 0x3a77a0f6, 0x3ab2449b, 0x3af29a52, 
    0x3b1e6790, 0x3b487014, 0x3b776514, 0x3b95a260, 0x3bb2068a, 0x3bd0ddef, 0x3bf2275e, 0x3c0af0c6, 
    0x3c1e058c, 0x3c325144, 0x3c47d325, 0x3c5e8a59, 0x3c767600, 0x3c87ca96, 0x3c94f373, 0x3ca2b513, 
    0x3cb10eef, 0x3cc00079, 0x3ccf891c, 0x3cdfa83e, 0x3cf05d41, 0x3d00d3bf, 0x3d09c324, 0x3d12fc79, 
    0x3d1c7f61, 0x3d264b7e, 0x3d306070, 0x3d3abdd2, 0x3d45633d, 0x3d505049, 0x3d5b8488, 0x3d66ff8d, 
    0x3d72c0e4, 0x3d7ec81a, 0x3d858a5c, 0x3d8bd322, 0x3d923e20, 0x3d98cb17, 0x3d9f79c6, 0x3da649eb, 
    0x3dad3b42, 0x3db44d87, 0x3dbb8073, 0x3dc2d3c0, 0x3dca4724, 0x3dd1da56, 0x3dd98d0a, 0x3de15ef5, 
    0x3de94fc9, 0x3df15f37, 0x3df98cef, 0x3e00ec51, 0x3e0520fd, 0x3e096453, 0x3e0db62a, 0x3e121654, 
    0x3e1684a9, 0x3e1b00fb, 0x3e1f8b1e, 0x3e2422e6, 0x3e28c824, 0x3e2d7aab, 0x3e323a4b, 0x3e3706d7, 
    0x3e3be01f, 0x3e40c5f2, 0x3e45b820, 0x3e4ab678, 0x3e4fc0c8, 0x3e54d6df, 0x3e59f88a, 0x3e5f2596, 
    0x3e645dd0, 0x3e69a105, 0x3e6eeeff, 0x3e74478b, 0x3e79aa74, 0x3e7f1784, 0x3e824743, 0x3e8507a1, 
    0x3e87ccc2, 0x3e8a968a, 0x3e8d64dd, 0x3e9037a0, 0x3e930eb6, 0x3e95ea04, 0x3e98c96d, 0x3e9bacd4, 
    0x3e9e941e, 0x3ea17f2c, 0x3ea46de3, 0x3ea76026, 0x3eaa55d6, 0x3ead4ed8, 0x3eb04b0c, 0x3eb34a56, 
    0x3eb64c99, 0x3eb951b5, 0x3ebc598e, 0x3ebf6406, 0x3ec270fd, 0x3ec58056, 0x3ec891f3, 0x3ecba5b5, 
    0x3ecebb7e, 0x3ed1d32f, 0x3ed4ecaa, 0x3ed807cf, 0x3edb2480, 0x3ede429f, 0x3ee1620c, 0x3ee482a8, 
    0x3ee7a455, 0x3eeac6f2, 0x3eedea63, 0x3ef10e86, 0x3ef4333d, 0x3ef7586a, 0x3efa7dec, 0x3efda3a4, 
    0x3f0064ba, 0x3f01f79e, 0x3f038a6f, 0x3f051d1d, 0x3f06af97, 0x3f0841d0, 0x3f09d3b7, 0x3f0b653c, 
    0x3f0cf651, 0x3f0e86e5, 0x3f1016e9, 0x3f11a64e, 0x3f133504, 0x3f14c2fc, 0x3f165025, 0x3f17dc72, 
    0x3f1967d3, 0x3f1af237, 0x3f1c7b91, 0x3f1e03d0, 0x3f1f8ae6, 0x3f2110c4, 0x3f22955a, 0x3f241899, 
    0x3f259a73, 0x3f271ad8, 0x3f2899b9, 0x3f2a1709, 0x3f2b92b7, 0x3f2d0cb6, 0x3f2e84f6, 0x3f2ffb69, 
    0x3f317001, 0x3f32e2af, 0x3f345365, 0x3f35c214, 0x3f372eaf, 0x3f389927, 0x3f3a016e, 0x3f3b6776, 
    0x3f3ccb32, 0x3f3e2c94, 0x3f3f8b8d, 0x3f40e811, 0x3f424212, 0x3f439982, 0x3f44ee55, 0x3f46407c, 
    0x3f478fec, 0x3f48dc96, 0x3f4a266f, 0x3f4b6d69, 0x3f4cb177, 0x3f4df28e, 0x3f4f30a0, 0x3f506ba2, 
    0x3f51a386, 0x3f52d842, 0x3f5409c9, 0x3f553810, 0x3f56630a, 0x3f578aac, 0x3f58aeeb, 0x3f59cfbb, 
    0x3f5aed11, 0x3f5c06e2, 0x3f5d1d24, 0x3f5e2fcb, 0x3f5f3ecc, 0x3f604a1e, 0x3f6151b6, 0x3f62558a, 
    0x3f63558f, 0x3f6451bc, 0x3f654a07, 0x3f663e67, 0x3f672ed2, 0x3f681b3e, 0x3f6903a2, 0x3f69e7f7, 
    0x3f6ac831, 0x3f6ba44a, 0x3f6c7c39, 0x3f6d4ff4, 0x3f6e1f74, 0x3f6eeab2, 0x3f6fb1a4, 0x3f707443, 
    0x3f713289, 0x3f71ec6c, 0x3f72a1e7, 0x3f7352f3, 0x3f73ff87, 0x3f74a79e, 0x3f754b32, 0x3f75ea3b, 
    0x3f7684b4, 0x3f771a97, 0x3f77abdd, 0x3f783882, 0x3f78c080, 0x3f7943d1, 0x3f79c270, 0x3f7a3c5a, 
    0x3f7ab188, 0x3f7b21f6, 0x3f7b8da1, 0x3f7bf483, 0x3f7c5699, 0x3f7cb3df, 0x3f7d0c52, 0x3f7d5fee, 
    0x3f7daeaf, 0x3f7df893, 0x3f7e3d97, 0x3f7e7db8, 0x3f7eb8f4, 0x3f7eef48, 0x3f7f20b3, 0x3f7f4d32, 
    0x3f7f74c3, 0x3f7f9766, 0x3f7fb519, 0x3f7fcdda, 0x3f7fe1a9, 0x3f7ff085, 0x3f7ffa6d, 0x3f7fff61, 
    0x3f7fff61, 0x3f7ffa6d, 0x3f7ff085, 0x3f7fe1a9, 0x3f7fcdda, 0x3f7fb519, 0x3f7f9766, 0x3f7f74c3, 
    0x3f7f4d32, 0x3f7f20b3, 0x3f7eef48, 0x3f7eb8f4, 0x3f7e7db8, 0x3f7e3d97, 0x3f7df893, 0x3f7daeaf, 
    0x3f7d5fee, 0x3f7d0c52, 0x3f7cb3df, 0x3f7c5699, 0x3f7bf483, 0x3f7b8da1, 0x3f7b21f6, 0x3f7ab188, 
    0x3f7a3c5a, 0x3f79c270, 0x3f7943d1, 0x3f78c080, 0x3f783882, 0x3f77abdd, 0x3f771a97, 0x3f7684b4, 
    0x3f75ea3b, 0x3f754b32, 0x3f74a79e, 0x3f73ff87, 0x3f7352f3, 0x3f72a1e7, 0x3f71ec6c, 0x3f713289, 
    0x3f707443, 0x3f6fb1a4, 0x3f6eeab2, 0x3f6e1f74, 0x3f6d4ff4, 0x3f6c7c39, 0x3f6ba44a, 0x3f6ac831, 
    0x3f69e7f7, 0x3f6903a2, 0x3f681b3e, 0x3f672ed2, 0x3f663e67, 0x3f654a07, 0x3f6451bc, 0x3f63558f, 
    0x3f62558a, 0x3f6151b6, 0x3f604a1e, 0x3f5f3ecc, 0x3f5e2fcb, 0x3f5d1d24, 0x3f5c06e2, 0x3f5aed11, 
    0x3f59cfbb, 0x3f58aeeb, 0x3f578aac, 0x3f56630a, 0x3f553810, 0x3f5409c9, 0x3f52d842, 0x3f51a386, 
    0x3f506ba2, 0x3f4f30a0, 0x3f4df28e, 0x3f4cb177, 0x3f4b6d69, 0x3f4a266f, 0x3f48dc96, 0x3f478fec, 
    0x3f46407c, 0x3f44ee55, 0x3f439982, 0x3f424212, 0x3f40e811, 0x3f3f8b8d, 0x3f3e2c94, 0x3f3ccb32, 
    0x3f3b6776, 0x3f3a016e, 0x3f389927, 0x3f372eaf, 0x3f35c214, 0x3f345365, 0x3f32e2af, 0x3f317001, 
    0x3f2ffb69, 0x3f2e84f6, 0x3f2d0cb6, 0x3f2b92b7, 0x3f2a1709, 0x3f2899b9, 0x3f271ad8, 0x3f259a73, 
    0x3f241899, 0x3f22955a, 0x3f2110c4, 0x3f1f8ae6, 0x3f1e03d0, 0x3f1c7b91, 0x3f1af237, 0x3f1967d3, 
    0x3f17dc72, 0x3f165025, 0x3f14c2fc, 0x3f133504, 0x3f11a64e, 0x3f1016e9, 0x3f0e86e5, 0x3f0cf651, 
    0x3f0b653c, 0x3f09d3b7, 0x3f0841d0, 0x3f06af97, 0x3f051d1d, 0x3f038a6f, 0x3f01f79e, 0x3f0064ba, 
    0x3efda3a4, 0x3efa7dec, 0x3ef7586a, 0x3ef4333d, 0x3ef10e86, 0x3eedea63, 0x3eeac6f2, 0x3ee7a455, 
    0x3ee482a8, 0x3ee1620c, 0x3ede429f, 0x3edb2480, 0x3ed807cf, 0x3ed4ecaa, 0x3ed1d32f, 0x3ecebb7e, 
    0x3ecba5b5, 0x3ec891f3, 0x3ec58056, 0x3ec270fd, 0x3ebf6406, 0x3ebc598e, 0x3eb951b5, 0x3eb64c99, 
    0x3eb34a56, 0x3eb04b0c, 0x3ead4ed8, 0x3eaa55d6, 0x3ea76026, 0x3ea46de3, 0x3ea17f2c, 0x3e9e941e, 
    0x3e9bacd4, 0x3e98c96d, 0x3e95ea04, 0x3e930eb6, 0x3e9037a0, 0x3e8d64dd, 0x3e8a968a, 0x3e87ccc2, 
    0x3e8507a1, 0x3e824743, 0x3e7f1784, 0x3e79aa74, 0x3e74478b, 0x3e6eeeff, 0x3e69a105, 0x3e645dd0, 
    0x3e5f2596, 0x3e59f88a, 0x3e54d6df, 0x3e4fc0c8, 0x3e4ab678, 0x3e45b820, 0x3e40c5f2, 0x3e3be01f, 
    0x3e3706d7, 0x3e323a4b, 0x3e2d7aab, 0x3e28c824, 0x3e2422e6, 0x3e1f8b1e, 0x3e1b00fb, 0x3e1684a9, 
    0x3e121654, 0x3e0db62a, 0x3e096453, 0x3e0520fd, 0x3e00ec51, 0x3df98cef, 0x3df15f37, 0x3de94fc9, 
    0x3de15ef5, 0x3dd98d0a, 0x3dd1da56, 0x3dca4724, 0x3dc2d3c0, 0x3dbb8073, 0x3db44d87, 0x3dad3b42, 
    0x3da649eb, 0x3d9f79c6, 0x3d98cb17, 0x3d923e20, 0x3d8bd322, 0x3d858a5c, 0x3d7ec81a, 0x3d72c0e4, 
    0x3d66ff8d, 0x3d5b8488, 0x3d505049, 0x3d45633d, 0x3d3abdd2, 0x3d306070, 0x3d264b7e, 0x3d1c7f61, 
    0x3d12fc79, 0x3d09c324, 0x3d00d3bf, 0x3cf05d41, 0x3cdfa83e, 0x3ccf891c, 0x3cc00079, 0x3cb10eef, 
    0x3ca2b513, 0x3c94f373, 0x3c87ca96, 0x3c767600, 0x3c5e8a59, 0x3c47d325, 0x3c325144, 0x3c1e058c, 
    0x3c0af0c6, 0x3bf2275e, 0x3bd0ddef, 0x3bb2068a, 0x3b95a260, 0x3b776514, 0x3b487014, 0x3b1e6790, 
    0x3af29a52, 0x3ab2449b, 0x3a77a0f6, 0x3a1e8019, 0x39b25423, 0x391e863b, 0x381e87c4, 0x0
};

static const uint32_t _K11[] = {
    0x6, 0x8, 0xa, 0xd, 0xf, 0x12, 0x15, 0x18, 
    0x1b, 0x1f, 0x23, 0x27, 0x2b, 0x30, 0x35, 0x3b, 
    0x40, 0x47, 0x4d, 0x55, 0x5c, 0x65, 0x6d, 0x77, 
    0x81, 0x8c, 0x98, 0xa4, 0xb2, 0xc0, 0xcf, 0xe0
};

static const uint32_t _K18[] = {
    0xbcf5d2b5, 0x3d84688e, 0x3e107c77, 0xbe18c158, 0xbe046935, 0x3cd8b5f5, 0x3dcee249, 0xbe07f568, 
    0xbb93b368, 0x3e4f1a86, 0x3dc367b2, 0xbd3fa1d0, 0xbb92a6b5, 0xbd10c374, 0x3d0c6bdc, 0x3dec3b24, 
    0xbde5b2f5, 0x3c4b1034, 0x3e0d31ce, 0xbd0dc100, 0x3e1ddf92, 0xbd4e2eb5, 0xbe1b0353, 0x3c7ad9cf, 
    0xbde3c88b, 0xbc81c455, 0x3c0e82f1, 0xbcf6fbc5, 0xbde04df1, 0x3da28730, 0x3e420414, 0xbe2b7fae, 
    0x3e242dba, 0x3e2d9be9, 0x3be49a58, 0xbe5968b4, 0x3b131d28, 0x3e586535, 0xbe2ab211, 0x3d0ce738, 
    0x3ce61474, 0x3db54cde, 0xbd00d96a, 0xbe1d70d6, 0x3e06ea5c, 0xbe126724, 0x3d1f8bbf, 0x3e3ebe4b, 
    0x3c8d977a, 0x3dee3f22, 0xbd033a73, 0x3e2a70ec, 0xbd139239, 0x3e29f7b8, 0xbe55d979, 0x3e03be1a, 
    0x3e41a4ce, 0x3d0d29e8, 0x3dd6b274, 0xbe0b9484, 0x3d848f83, 0xbe48a003, 0x3dd5cb15, 0x3e38da6b, 
    0xbe43b39c, 0x3e433fd7, 0xbd8c6413, 0xbe3d92aa, 0xbdda16cb, 0x3a787ff0, 0x3d973e8b, 0x3e42e5bd, 
    0x3e4d78fc, 0xbe21e52b, 0xbe595262, 0xbdef0d24, 0xbb748ef0, 0x3db889eb, 0xbb14b007, 0x3e2bf561, 
    0xbd081552, 0x3d069e6c, 0x3d9d8073, 0x3e23dd94, 0x3d7e4134, 0x3e55e4bf, 0x3d28fbca, 0xbd8077e4, 
    0xbe35ef5a, 0x3c319a7e, 0x3d279ece, 0xbc977660, 0xbd2a700a, 0x3c3974d8, 0x3ddc7d96, 0xbe06ddb2, 
    0xbd9c5991, 0xbc8fa7c0, 0x3e15dd5a, 0x3e45c96c, 0xbe4af0a5, 0x3e2b0d47, 0x3d807a44, 0xbde0c98b, 
    0x3e1c3897, 0xbdd39d28, 0x3db3cdcc, 0x3de8d602, 0xbe17a05a, 0x3e313a86, 0x3c2a314c, 0xbdbf4c64, 
    0xbe21b871, 0x3d461f18, 0x3e0acc41, 0xbd7faecf, 0xbe1feda9, 0x3ba552e4, 0xbdac5204, 0x3c3add30, 
    0x3d8141db, 0x3e2347c1, 0xbe4d2754, 0xbe3cdae2, 0xbe3f6dad, 0x3e4a5153, 0xbe3a649b, 0x3d635ed9, 
    0x3e466c4f, 0x3c957b24, 0xbdc81e3f, 0xbd94d83b, 0xbe281cc1, 0x3dd7b62c, 0xbe1e9992, 0xbe0d0cdf, 
    0xbcc3bbd2, 0x3c644566, 0x3e4380c9, 0xbe58931e, 0xbdfd154a, 0xbde5e29c, 0xbd4ef5ab, 0xbdb2bde2, 
    0xbd8ca58c, 0xbd5f3544, 0x3d594c4c, 0xbd47f404, 0xbd8184f9, 0x3d508d10, 0x3d8008fe, 0xbdf4ffdf, 
    0x3e2fbc93, 0xbb032ee6, 0xbdc37c2b, 0xbdc77d9f, 0xbb956bab, 0x3e57927a, 0xbe5e0e38, 0xbdea6932, 
    0xbe17779c, 0xbd19f86c, 0x3d9f719f, 0xbe02ebfb, 0x3e537e85, 0x3e0e84c4, 0xbd3c716d, 0xbdc6106f, 
    0x3e2b3e0e, 0x3de0cc40, 0xbcd4b8ab, 0xbdb11ec9, 0x3d8aa8ac, 0x3e5d2c21, 0x3e54514f, 0xbdf95fb0, 
    0xbdc805b1, 0x3db6d466, 0xbe01ba46, 0xbd3d7e15, 0xbe5736fa, 0x3d39e226, 0xbdec1191, 0x3e1218bc, 
    0xbe3eff97, 0xbda1de53, 0x3dc7c2e3, 0xbe32148a, 0xbcf88214, 0xbcb90ce6, 0xbdc032f9, 0xbdcc0185, 
    0xbd95a59d, 0x3d2ab4d2, 0xbe26b131, 0xbdebe11c, 0xbc79a0a6, 0x3daf1f84, 0x3e3f7aa1, 0xbe011365, 
    0xbe55620b, 0x3d91f866, 0x3e00532b, 0xbd088496, 0x3d539400, 0x3df22e8b, 0xbe449081, 0x3d99fdd6, 
    0xbe600d81, 0x3d963b22, 0x3bf5f42e, 0x3debbbde, 0xbe5a272a, 0xbce9c282, 0xbc335408, 0xbd8373db, 
    0x3e2c45c8, 0x3de64dfc, 0xbe3d399d, 0x3cfef605, 0x3e1bf3a4, 0x3cb4521f, 0x3e16182b, 0xbcdd13fe, 
    0xbe47fe0c, 0x3d149903, 0xbd862123, 0xbe27b44b, 0x3e3a801e, 0x3d25c601, 0x3dfdf325, 0x3c6fd73f, 
    0x3d97bed7, 0xbd626312, 0xbda2e8f0, 0x3d85a732, 0x3e4cc317, 0xbe41220e, 0x3e43dac2, 0x3dfe48b5, 
    0xbe3228e1, 0xbe54ed94, 0x3c4ef385, 0x3e371038, 0x3b9995db, 0xbdfac946, 0xbdf53ee4, 0x3e59a35d, 
    0xbe5abd4f, 0xbe32f650, 0xbe40b539, 0x3e2277ec, 0x3e3a59a3, 0x3e41f41f, 0xbcbec83d, 0x3e126f8b, 
    0x3e4ac7e3, 0x3d1177d5, 0x3dbf971d, 0xbe308db3, 0xbe40dddf, 0x3d9d2127, 0x3d4df5e4, 0x3e0cd9c7, 
    0xbde8d742, 0xbd84c492, 0x3cf24062, 0x3e18c64e, 0xbe3d6ad9, 0xbe5f45aa, 0xbdd087ab, 0x3da25713, 
    0xbdb3534d, 0xbdda26b4, 0x3e0218ca, 0x3e5d57f2, 0x3c911971, 0x3da20f27, 0xbe3f2de4, 0xbd150d4a, 
    0x3e04b81e, 0x3d55b01d, 0xbd5c38f6, 0xbe433953, 0x3c71e14c, 0x3d2e1f36, 0x3d4384ef, 0xbdc620d7, 
    0x3cfe8801, 0x3e2f3c5b, 0x3e2e4c33, 0xbe41d2a1, 0x3e051f9e, 0x3d4b1540, 0xbe34e35a, 0xbe297e01, 
    0xbcd07a00, 0xbe396a7f, 0x3ca85cbc, 0x3e0162de, 0xbd3cd6cd, 0x3d462d7f, 0x3d70b28f, 0xbe1193e0, 
    0x3e1cb4b3, 0x3c331548, 0xbcbc82f4, 0x3dc6bd26, 0x3e2daa6f, 0xbe466caf, 0x3e155a27, 0x3d474421, 
    0xbdf8fe21, 0x3e4f127f, 0x3e1bd681, 0x3e542cf2, 0xbc84d896, 0xbe52f81c, 0xbe51c298, 0x3dced897, 
    0x3e20d7e7, 0x3d83f7af, 0xbe5d2a58, 0x3e1b9cff, 0x3d004d6a, 0xbdc20645, 0x3e2f102f, 0x3e33f2d3, 
    0xbd9677ca, 0x3e16c6d0, 0x3c13dcd7, 0x3e59651c, 0x3de74983, 0xbdd63602, 0x3dd9ba6b, 0xbddfabf6, 
    0x3e291773, 0xbdccc171, 0xbdb06392, 0x3dbf84da, 0xbdbe95c4, 0x3e4c0ea5, 0xbe17acea, 0xbdb97251, 
    0x3de2671d, 0x3e157fba, 0x3e22d310, 0xbe0f8c20, 0x3e1494f8, 0x3e2c19df, 0xbe46451a, 0x3e5bb15a, 
    0xbd784a8e, 0xbd91a50a, 0x3d1b976d, 0xbdd50491, 0xbd1f8d34, 0xbe513d82, 0xbdebc064, 0xbd10b1c4, 
    0x3de2abb7, 0xbdbdcec1, 0xbd8b5840, 0x3e02dac6, 0xbdf21e05, 0x3e10fa8c, 0x3e579e3f, 0xbd0ab840, 
    0xbc7071c7, 0x3e073050, 0xbe508efe, 0x3ddd6ccc, 0xbd121966, 0x3e590de1, 0xbe3920a4, 0x3e1f7cfd, 
    0x3e35ee22, 0x3e567b4c, 0xbcac366f, 0x3e16cfd0, 0xbd9eb8d6, 0x3ded6247, 0x3e53aa2f, 0x3e3944a0, 
    0x3d4f1c24, 0x3e492284, 0x3d3aeef7, 0xbd9703fc, 0x3d9a9cfc, 0x3e400cc2, 0xbda300cb, 0x3d0af4b2, 
    0xbe50c4e7, 0x3e4c0c95, 0xb9a53239, 0x3e5674fe, 0xbe29db5e, 0xbe531340, 0xbd1d1490, 0x3d544b02, 
    0xbdab70f4, 0xbe3df65c, 0x3e28760b, 0x3e36c378, 0x3db05bd6, 0xbe5b022f, 0xbcee01de, 0xbd9be03b, 
    0x3cbb6783, 0x3e2437cd, 0x3e119652, 0xbc923506, 0xbdf44adf, 0x3d0ea578, 0xbe3332cb, 0xbe573db3, 
    0x3e3c8f9b, 0x3ce478b0, 0xbd1ff473, 0x3e075a32, 0xbbc64cf2, 0x3e2cf5a3, 0x3d39c606, 0xbe3b3014, 
    0x3caf2ab3, 0xbd0d7870, 0x3e2a3c51, 0x3da5c2e9, 0x3e4501dc, 0x3b93c59b, 0x3e36f16c, 0xbe2acf8c, 
    0xbd567c12, 0xbd9bb89c, 0xbe50ea2c, 0x3e3ffee0, 0x3d118523, 0x3e242910, 0xbdf61baa, 0xbd44952d, 
    0x3d91191a, 0xbe37f101, 0x3e0e19e4, 0x3dc62816, 0xbd928124, 0xbde15209, 0x3d184961, 0x3e50dc90, 
    0x3e4c72df, 0x3c62b986, 0x3da6c052, 0xbdef6fcf, 0xbe1c4f79, 0x3c89fa06, 0xbe1700ae, 0xbdeb70aa, 
    0x3df8b1e6, 0xbd747259, 0xbbb12266, 0x3df7b97c, 0x3d6842f9, 0x3e06ea8d, 0xbddc437b, 0x3e4eaef1, 
    0xbdb6952a, 0xbdc9bad8, 0xbe59b7c9, 0xbdfabfcf, 0x3dc7505f, 0x3e23404d, 0x3a7a220f, 0xbd590c31, 
    0x3dd44216, 0xbc83ad5a, 0x3e1bef01, 0xbd7121c9, 0x3dde5a12, 0x3e1455f6, 0xbcc387db, 0xbdd2d0ee, 
    0x3dea45da, 0x3dca20a8, 0x3c507657, 0xbd93c0ed, 0x3df51dfd, 0x3e1585e3, 0xbb6178ed, 0xbe26cf74, 
    0xbd619c50, 0x3dacccc2, 0x3dbdd368, 0x3e528cc4, 0x3e1ce7d0, 0xbe592aa4, 0x3d13ca11, 0xbe0ad30e, 
    0x3e5118c2, 0x3e10a973, 0x3dc9f2f8, 0xbe00f61d, 0x3e4d593c, 0xbd93da2c, 0xbe08195f, 0xbc36c1e8, 
    0x3e343837, 0xbe4011fe, 0x3dc16a5b, 0xbe3f7597, 0xbd73aace, 0x3e3eb6fd, 0x3dd4ff0d, 0x3e4f416c, 
    0xbdf5fd89, 0xbaafd9b3, 0xbe27ef40, 0xbe1792f5, 0xbd059662, 0x3e2c153e, 0x3d8e5eba, 0x3e45ffe5, 
    0x3dc80355, 0x3b83edc5, 0xbc408801, 0xbe37251b, 0x3cba49e6, 0x3bd4b495, 0xbdf9bb59, 0xbdd71e74, 
    0xbe37248e, 0xbdf3b795, 0x3e26f0c3, 0x3e0d5ae6, 0x3e41dd09, 0xbe54c6c0, 0xbd565017, 0x3e5c11c5, 
    0xbe3b87c0, 0xbd9b5716, 0x3d9ef366, 0xbdd712db, 0x3e36eacf, 0x3e1c4477, 0xbe375c01, 0xbe409264, 
    0xbe5cd7df, 0x3d14eaa6, 0xbd96402f, 0x3e4d4908, 0xbda05d7d, 0xbddc20e0, 0x3bb492a2, 0x3d0bcfe1, 
    0xbc9e72f7, 0x3e0eca8a, 0xbe3d4dd2, 0xbd82f954, 0xbe362528, 0x3e471e5a, 0xbdb9809c, 0x3d52c229, 
    0xbe3be691, 0x3da3e4cc, 0x3d259b75, 0xbe1cd54c, 0xbe18316c, 0xbc889ded, 0x3dbc3d51, 0xbda76f98, 
    0xbd011c25, 0x3ddeae6f, 0x3d7fd35f, 0xbe0e7555, 0x3e5b2ac6, 0xbcaa59f2, 0x3e3f4213, 0x3d0081fb, 
    0x3e1c9347, 0xbd9681f2, 0x3e00dbb5, 0xbe317ad2, 0x3dfb365c, 0x3e4a04ae, 0xbe4535f5, 0x3cac5402, 
    0xbe4c2d87, 0xbe31cd28, 0x3d1daefc, 0xbe02e601, 0xbe0f8edb, 0x3d38ae1d, 0x3de1ed5a, 0x3ddcad4a, 
    0x3d247c4d, 0x3e4428a1, 0xbd676a0a, 0xbe12ae88, 0xbe4f3a7b, 0x3d045e85, 0xbe20e906, 0xbad3b6fa, 
    0x3cd0b9d8, 0xbcd673aa, 0xbd847958, 0xbde51193, 0x3e04c4bd, 0xbe00173c, 0x3d096db2, 0x3d5f9eb4, 
    0x3d3c12ad, 0xbc632ebd, 0xbc745800, 0x3df46ec1, 0xbdfd30af, 0xbe096513, 0x3e506849, 0x3e035a45, 
    0x3d5d5b4b, 0x3dab2a10, 0xbd53afde, 0xbd70d1f3, 0x3d53596b, 0xbc30e0af, 0xbe0e9af5, 0x3dbff3db, 
    0x3dbdcc01, 0xbde67123, 0xbcf8c1a8, 0xbe498c74, 0x3e3054a4, 0x3caa2d88, 0xbe4c113c, 0x3cf27626, 
    0x3e305bbf, 0x3b8ff328, 0xbe200591, 0xbe538994, 0x3e4c0f98, 0xbd465b4b, 0xbe353cce, 0xbe100499, 
    0xbdebcca7, 0xbce489c5, 0x3da3372b, 0xbdf4e5f3, 0xbe464498, 0xbdb9445c, 0xbe585594, 0xbe5648f1, 
    0x3e267f3f, 0xbd913f50, 0xbe446a74, 0xbd40298e, 0xbdbed3b3, 0x3d550262, 0x3e2c8609, 0x3d6ce573, 
    0x3c0812a7, 0x3dac1d8f, 0x3d077fef, 0xbd2ea587, 0xbdbb3e4c, 0x3ddefdd1, 0x3da8392d, 0xbe1dbfcb, 
    0x3d131f69, 0x3e169a02, 0x3e5ad7fa, 0xbe21fb5e, 0xbde658a0, 0x3d5e37d6, 0xbe3fded6, 0x3d8e428e, 
    0x3e487bc3, 0x3e262066, 0xbd2cc853, 0x3d8a86c0, 0xbe3d65aa, 0x3d7322d9, 0x3e481ca2, 0x3dad13a8, 
    0x3d768d15, 0x3e449b31, 0x3e10aaa0, 0xbe25b960, 0x3d9fda6f, 0x3e06878a, 0x3e14788d, 0x3c1455b2, 
    0x3e5ad763, 0xbda78ac7, 0xbdc22f3e, 0xbe434bf7, 0xbe4a5c44, 0xbe1b05a4, 0xbd2755d3, 0x3da37a0c, 
    0x3c844799, 0x3e0fc3ab, 0x3da70884, 0xbce5a30a, 0xbe482932, 0xbd681255, 0x3db5c438, 0xbdf57252, 
    0x3d796a56, 0xbe375fa2, 0xbe33b6f5, 0x3dbbc089, 0xbe58918e, 0x3e2e5eb6, 0xbe2900f2, 0x3e29541e, 
    0x3e4890c6, 0x3e1c59b9, 0x3d1b10a7, 0xbdd31b23, 0xbd8d5740, 0x3dd7512e, 0xbd3546e5, 0xbd2f26a2, 
    0xbdbd05de, 0x3e31ec31, 0x3dbe1bf0, 0xbe2a670e, 0x3c150885, 0x3d156d98, 0xbe06ed4d, 0xbde3a3b5, 
    0xbe4e0082, 0x3e57c684, 0xbe0dc1df, 0xbd403c2a, 0xbe389671, 0x3c113651, 0x3df560cc, 0xbe2adfc0, 
    0x3e093da6, 0xbe02ce4b, 0xbe249f39, 0x3ddd698f, 0x3e1f2c95, 0xbe268fdd, 0xbdcb61cf, 0xbe5e1605, 
    0x3b93f388, 0xbd59e14e, 0x3e0486f3, 0x3e08727d, 0x3e4c394b, 0xbe5ad33c, 0x3e132928, 0xbcf80c03, 
    0x3dfb86ea, 0x3d6a969c, 0x3d067b9d, 0x3c1983e2, 0xbddf1d41, 0xbe3418ea, 0xbcf83238, 0xbd80b22f, 
    0xbe27f536, 0xbe0dabb6, 0x3df82dc7, 0x3e49a2ee, 0xbdcaa4eb, 0xbe45e2ec, 0x3d985ebc, 0xbe3d499c, 
    0xbe12fb41, 0xbdaa26cb, 0xbd82b896, 0x3e10b437, 0x3dcfc52a, 0xbe0928f0, 0x3c610926, 0xbe35d44f, 
    0x3e3a60f0, 0xbdf5b12c, 0x3e2218fc, 0x3daa3c72, 0x3e3056fc, 0xbdc5decb, 0x3e2d2df7, 0xbe4aadc7, 
    0x3d56d4c3, 0xbd9484d8, 0xbe446c15, 0x3bbee66f, 0xbd6b722d, 0x3dbc5821, 0xbe54a35e, 0xbdd587c8, 
    0xbe1733fd, 0x3e469ec2, 0x3d6aba7d, 0xbe12b858, 0x3d14ba5e, 0xbc604e6f, 0x3dbf0cb5, 0xbc6e4273, 
    0xbd000f4f, 0x3dcf762e, 0x3e17803f, 0xbd372ee1, 0x3e0907eb, 0xbdc3bda1, 0xbe0d709a, 0xbda3dd75, 
    0x3dd72825, 0xbd07c50a, 0xbe30fd84, 0x3e0cc86e, 0x3e1bf4ae, 0x3d8376ad, 0xbdf9c346, 0xbe326577, 
    0x3d381745, 0xbd135566, 0xbc23a962, 0xbe1ac94a, 0xbe17165c, 0x3e565d52, 0xbe1ccf46, 0x3bb62ac2, 
    0x3d9527b9, 0xbe1a825c, 0x3d8ce7c9, 0xbdd4fa78, 0xbc8c49c5, 0xbe4ee1a4, 0x3d18584f, 0xbdf77ce8, 
    0xbe3e69d1, 0x3e17ad4a, 0x3dbc1e1c, 0xbe2f3b7f, 0x3e410e28, 0x3e478651, 0xbe23dc0f, 0x3d55fb46, 
    0xbd8637b8, 0xbe005546, 0xbd87f96d, 0xbd8ab744, 0x3d20f75a, 0xbe12b3c7, 0x3d918193, 0x3e144d5a, 
    0x3d736fc6, 0x3e2bb93e, 0x3e386785, 0x3d01ad15, 0x3d9703c2, 0x3e2d36b0, 0x3de9f0dc, 0x3d53d9d8, 
    0x3a731a34, 0x3cfd8a08, 0x3e4e2c39, 0xbd372f82, 0x3e58b345, 0x3d49aceb, 0x3e14636b, 0x3c4ef33e, 
    0xbe5a71be, 0x3e025a46, 0x3ca1bcbc, 0x3e1d2aa6, 0x3d551bf2, 0xbd991ac8, 0xbdeb6cd9, 0x3d40ab38, 
    0xbdabe142, 0xbdce2aae, 0x3c5fc89b, 0xbe10bc10, 0x3d945222, 0xbc66b142, 0xbdc255a9, 0x3d53f4e7, 
    0x3e04018e, 0xbe4958bf, 0xbda68e7b, 0x3e1913a3, 0xbe19855c, 0xbe1e77cf, 0x3d90659d, 0xbc82c7f2, 
    0xbe5b3f36, 0x3e51dc71, 0x3b39d536, 0x3b9d8ec2, 0x3d81ca8d, 0x3e52d019, 0xbd6ee6c0, 0xbb319297, 
    0x3dc0edf5, 0xbe1769d4, 0x3de9ac15, 0xbe0b9d3f, 0xbe43daf5, 0x3da0d7ae, 0x3b9d7139, 0xbd8dd93d, 
    0x3e3a2d29, 0x3d57a24b, 0x3e3f8f39, 0xbe052003, 0xbe56e842, 0x3e0893df, 0x3d23ab49, 0x3d11eaaa, 
    0xbd446bda, 0xbdc6a13c, 0xbd1e6a57, 0xbdc10fc2, 0xbd3aaa5c, 0xbe5568b7, 0xbe56f647, 0xbde46b4f, 
    0xbe5b0593, 0x3e135a43, 0x3bc6b172, 0x3d6c68cb, 0x3e2f0298, 0x3cbdb0f9, 0x3d7c5857, 0x3de07da2, 
    0xbe526b82, 0xbd393031, 0xbdf1247e, 0xbe29aa41, 0x3e04b6b4, 0xbddbb35b, 0x3dd4c962, 0xbccc0df3, 
    0xbe279c85, 0x3cf35387, 0xbe58963e, 0xbdcce45d, 0x3e5c1a00, 0x3d80ab16, 0xbd171e71, 0x3dd6626e, 
    0xbd84882b, 0x3ce3dddc, 0x3cd4bd65, 0xbe4f2099, 0x3e18a079, 0xbd480780, 0xbe49b176, 0xbc66d669, 
    0xbe16ab81, 0x3c7ed99c, 0xbe1ceb2b, 0x3daca66f, 0xbd378bb3, 0xbd9e8409, 0x3db459b4, 0x3d10fb7c, 
    0x3e40cdce, 0xbbc662b1, 0xbe0c592c, 0x3d8b2676, 0xbde2ca1a, 0xbd30e2b7, 0xbd256877, 0x3e3c1f63, 
    0x3e23e452, 0xbe358738, 0xbe3be301, 0xbd037e6f, 0xbdac9d6e, 0x3e3382d4, 0x3d8f65e2, 0xbd1becee, 
    0xbe5ae8bd, 0xbe06f710, 0xbd915905, 0x3d3b57c7, 0x3ce2f0b8, 0xbddec6cc, 0x3cb93920, 0x3e078088, 
    0x3b95700a, 0x3dddfa58, 0xbdee9b80, 0x3e263341, 0xbd27d558, 0xbc689a28, 0x3e07a366, 0x3e1905cb, 
    0x3d6648c5, 0x3e13ad38, 0x3e56197b, 0xbca3f510, 0xbe0d3be4, 0xbba0349c, 0x3de028e4, 0xba83af7c, 
    0xbd1282c7, 0x3e2c4b9a, 0xbd4ec6c7, 0xbdf49afe, 0xbdc64ad7, 0x3d801508, 0xbe0f5be4, 0xbe347e99, 
    0xbe120a16, 0xbce5f75a, 0x3e206594, 0x3d81c2d3, 0x3e46fb67, 0xbe04ec32, 0x3dabb7cd, 0x3e53245f, 
    0xbe0d5e48, 0xbdadaf24, 0x3cf0ac64, 0x3dd6b46c, 0x3e0b09b7, 0xbd662c00, 0x3c9aa396, 0x3daddba5, 
    0x3e0c6525, 0x3c6442c4, 0x3dc74720, 0xbda49ca0, 0x3d85ed73, 0x3df3fc9c, 0x3e366c28, 0x3d4ff06e, 
    0xbd7977ae, 0x3d8661a5, 0x3d42a8ad, 0xbe3c2ebe, 0xbd41868c, 0x3e26545d, 0x3e0150f8, 0xbc8714bc, 
    0xbc8477e3, 0x3d547389, 0xbb8313e1, 0xbdad4c36, 0x3da009a6, 0xbd200b52, 0xbe12e5b4, 0xbe40dc86, 
    0xbe2a4f45, 0xbce0c27f, 0x3d412701, 0xbdf82759, 0xbe2490a4, 0xbe56841f, 0x3e3b7e2d, 0xbd195963, 
    0xbe0d3e1d, 0xbdb2dcb0, 0xbe1b2b52, 0x3c623392, 0x3e0f08e3, 0xbd8f683f, 0xbda83190, 0x3c8cf068, 
    0x3ca47f5c, 0x3e4d0bb7, 0x3e32b418, 0xbddaf2c9, 0x3db0ad57, 0xbdf9ba54, 0x3c0ca4df, 0x3d611fd8, 
    0x3d986767, 0xbd92235e, 0xbce9746a, 0x3ce4c35d, 0xbcb75d9e, 0xbe2b7426, 0xbce2d0b9, 0xbc331b8d, 
    0xbdf5f32c, 0xbca1ca12, 0xbe039121, 0xbe0125d9, 0xbe0271c4, 0x3db68948, 0x3e2ffc38, 0x3dd9239e, 
    0x3e02da8a, 0xbd82b659, 0x3d827126, 0xbe02455a, 0x3e552c72, 0xbda63b3b, 0x3e461169, 0x3cd1bb06, 
    0x3d812eb2, 0xbe5af38f, 0xbe1314f1, 0x3e48e47d, 0xbbcd928a, 0x3d416563, 0xbe3e8757, 0xbd456cfd, 
    0x3c37705c, 0x3e50ca19, 0x3d00ad06, 0xbde81b36, 0x3e2fc278, 0x3e272e20, 0x3e154258, 0xbe34007c, 
    0xbe5864bb, 0xbe138341, 0x3e582bfc, 0xbcb1155a, 0x3e38f50c, 0x3dcad106, 0xbd0b70ea, 0xbc339dce, 
    0x3e3ebb6f, 0xbe461d57, 0xbda89fa9, 0x3e374039, 0xbda41517, 0x3dac953d, 0xbdf80dec, 0xbd3db768, 
    0x3d8c645d, 0xbe2312fb, 0x3e09677b, 0xbdfcffa8, 0xbde48331, 0xbe4a51d2, 0xbe1277f8, 0xbe33d8f8, 
    0x3d627b8a, 0x3d9a5add, 0x3d30a321, 0xbe1bb8e2, 0x3e52ef37, 0x3c91e4b0, 0x3dc824b3, 0x3d6464b2, 
    0xbcfd26b3, 0xbdd24380, 0xbc86d016, 0xbe0ce31c, 0xbdd4f796, 0xbc215aee, 0x3e3fe9bc, 0x3e391887, 
    0x3e440b6e, 0xbdd8e336, 0x3e3afd14, 0xbdf400d8, 0x3deda84c, 0x3dbf4e6a, 0xbe4b33af, 0x3cd85553, 
    0x3e4e5ef8, 0x3dc95458, 0x3e5369fa, 0xbc8ff01c, 0xbe1fe018, 0x3e3c8865, 0xbe31f96d, 0xbe4592d6, 
    0xbe119f10, 0xbe342cfa
};

static const uint32_t _K19[] = {
    0x38b46481, 0x3c1ba916, 0xba892b11, 0xb9afda6d, 0xbb994dc6, 0x3bef6e38, 0x3bd0bd67, 0x3b69ef2b, 
    0xbbeb5d43, 0x3b397e7b, 0xbbefd4c4, 0xbbddb270, 0x3c150a22
};

static const uint32_t _K22[] = {
    0x3d22a5bf, 0x3e658149, 0xbd103946, 0x3da1d39d, 0x3e0438d8, 0xbcf8ce88, 0xbdbee125, 0x3e631920, 
    0x3d700dfc, 0xbdc9df38, 0x3b2828ca, 0xbe7e17df, 0xbe6ab052, 0x3df48613, 0x3e6a1883, 0xbd47c9b2, 
    0xbe3c379a, 0x3e1e4f5b, 0xbe64796d, 0x3e78de8b, 0x3d33cfd1, 0xbe4a8a47, 0x3dfa97bd, 0x3e752ee6, 
    0xbe21c8ea, 0xbe065d5c, 0xbe55380f, 0xbe539f72, 0xbc84d091, 0xbe423807, 0xbe4dd5f4, 0xbe0f7fd4, 
    0x3d25987a, 0xbe601295, 0xbc312a9e, 0x3e1ddf9d, 0x3e80b592, 0x3e7c1647, 0xbe7cf22b, 0xbe812113, 
    0xbe0ab5eb, 0x3dcb3b1c, 0x3e48027d, 0x3e282713, 0x3e706c7c, 0xbda7e996, 0x3e60664f, 0x3d0c051a, 
    0x3dffc30a, 0xbd99b105, 0x3d2112a2, 0xbe3cb520, 0x3d1f28ad, 0x3e1177bf, 0x3df627e2, 0xbe54616f, 
    0xbe852453, 0xbe0c264f, 0x3cafff95, 0x3d2c3419, 0x3e128005, 0x3e626b51, 0x3e2ca0a6, 0xbd142c6d, 
    0xbdc4b453, 0x3c6255c5, 0x3e3d1e72, 0xbe0559c0, 0x3e331706, 0x3d709507, 0x3e5e06a5, 0x3db23725, 
    0x3ca286cc, 0x3cd83c80, 0xbdbedc94, 0xbe507402, 0xbd89b60a, 0x3e06ab84, 0xbe0e13d3, 0xbb377c65, 
    0x3e0fadea, 0xbd4cfcae, 0x3c6e7971, 0x3cb6032f, 0xbe53701a, 0xbdb48ab9, 0xbe5c11ca, 0x3c9f889c, 
    0xbe06c5d8, 0xbddb0a31, 0xbe80c4f6, 0x3de21a1c, 0xbe005223, 0xbdbddc31, 0x3e8ac049, 0x3e18e581, 
    0x3e8009e1, 0x3e825dad, 0x3ddc1170, 0x3dcebb1b, 0x3e07c570, 0x3dcb9f57, 0x3ceb1c7c, 0x3e75e405, 
    0x3dd2d431, 0xbcba78df, 0x3df229f4, 0xbd1015b4, 0x3e15a988, 0xbe69c31c, 0xbd53578b, 0xbd207cf5, 
    0x3ce25bdb, 0x3e060a51, 0x3ddf0c67, 0x3e4e3d8c, 0xbe31589b, 0xbcba75eb, 0x3dd4a13b, 0x3e187cbb, 
    0xbe79e9e8, 0x3e585d00, 0x3e6326b1, 0x3de2245d, 0x3c7472aa, 0xbe5e9ef6, 0x3d643695, 0xbdd74c3b, 
    0x3e00f6b1, 0x3e3ca658, 0x3deca138, 0xbd999c80, 0xbe79509d, 0xbc58e44f, 0xbdafbfb9, 0xbe2714f8, 
    0x3dd6dce4, 0xbe81dd78, 0xbe125376, 0x3e57330f, 0x3e2ce2d7, 0xbe29f5fd, 0x3d92ad56, 0xbe136cd4, 
    0x3dc2e487, 0x3d202871, 0xbe409e54, 0xbe2f6754, 0xbc6476e7, 0x3e5e5384, 0x3e187a94, 0xbe6efec7, 
    0x3e2f3db1, 0xbd6d4f46, 0xbe33df32, 0x3e713abb, 0x3dae17d2, 0x3e3160cd, 0xbe7cba38, 0xbd2990f7, 
    0xbe02749d, 0xbe204df0, 0x3e70c1b4, 0x3d676861, 0x3e6d6b78, 0x3e165b9e, 0xbd00ca20, 0x3e415053, 
    0x3e84cca3, 0xbc1b4492, 0x3e78e6a5, 0x3e0a8c86, 0x3d474391, 0xbde63def, 0xbe6f29c6, 0x3ac15421, 
    0x3be09a2e, 0xbe3beda6, 0xbe56ddcc, 0xbe7914d7, 0x3dfda3b9, 0x3d594efe, 0xbca6ad58, 0x3dc0bce6, 
    0x3dd63519, 0xbd654ccd, 0x3e544b0e, 0xbd71df9f, 0x3e5bf7ef, 0xbd7e9f12, 0xbe8398c1, 0x3e6156ef, 
    0xbe753849, 0x3d10aa79, 0xbc3424ee, 0xbe27ae05, 0xbe4a06ad, 0x3d80ba8a, 0x3e496a56, 0x3ce93384, 
    0x3c572543, 0xbd8017d1, 0x3d4c5a64, 0xbddd0c62, 0x3d4ea52c, 0x3b96f967, 0xbc4cf4ea, 0xbe02a7c2, 
    0xbe48480d, 0x3e1b155c, 0xbd98e34c, 0xbe6daa84, 0x3d5d512a, 0x3dd32e73, 0xbd86003b, 0xbdb6007f, 
    0xbe496d60, 0xbe86ddaa, 0xbde11f8b, 0x3df95af3, 0x3ddc1e56, 0xbe30012c, 0x3e7e04dc, 0x3e3293bb, 
    0xbd03dba4, 0xbdfe1d76, 0xbced3e37, 0x3e80cacf, 0xbe407aba, 0xbdb9a22a, 0xbe8434c6, 0xbd25617b, 
    0xbde57c3e, 0xbd151385, 0xbce33f2a, 0xbd517a7a, 0x3e17e90a, 0x3e0df6a2, 0x3dc4c440, 0x3d61a486, 
    0xbe54c1b9, 0x3e020a07, 0x3d0053e6, 0x3cfdb390, 0xbe4de9b6, 0x3e7e9277, 0x3d977941, 0x3ae27f61, 
    0xbdde4cc9, 0xbe82a902, 0x3e7687d8, 0xbd6a2a8d, 0xbe453a3a, 0x3e48c218, 0xbdc595b3, 0x3d8eb256, 
    0x3e3f2fd2, 0x3e7647a1, 0xbdecbea3, 0x3e2e7a55, 0xbdbc8d63, 0x3d23abf8, 0xbcd2227c, 0x3e23a73e, 
    0x3e160ff3, 0x3e1cf98c, 0x3e13865a, 0x3c83d809, 0x3b901e12, 0x3d64f4c6, 0x3d2a9534, 0x3e3f5e52, 
    0x3db603e3, 0xbe18d3ca, 0x3e4e5783, 0x3da44039, 0xbe1d86e2, 0x3d2df993, 0xbe83b84d, 0x3e39d3df, 
    0xbe680f9a, 0x3e677396, 0x3d8d2c15, 0x3e855783, 0x3d19515c, 0x3de87f20, 0x3cd4f972, 0xbdd0ba96, 
    0xbcfd9080, 0x3d2fce4b, 0x3e685f5e, 0x3dfd08f1, 0xbe852d83, 0xbd93d82a, 0x3e006bc7, 0x3e7ea45f, 
    0xbd2f41c9, 0x3e37672b, 0x3d7e5c2d, 0xbe81f106, 0xbe11eecc, 0xbe80bc33, 0x3931f759, 0x3e1ba215, 
    0x3d0380ed, 0x3e83faaa, 0x3e135eb1, 0x3e23f168, 0x3d8e77fe, 0xbe5d96a0, 0xbdeb0649, 0xbdc0bd4b, 
    0xbdfc722b, 0x3e824acd, 0xbe4e9e1a, 0xbde24129, 0xbc5808f2, 0x3e1e1018, 0xbbf002c5, 0x3e724eec, 
    0x3c89cf2c, 0xbe150a58, 0xbe15d48c, 0xbe549a21, 0xbe240305, 0xbb61a376, 0xbe7ec642, 0xbe84c305, 
    0x3e6476d3, 0xbbc121c3, 0x3e814d22, 0x3e1d46c1, 0x3e58ae84, 0x3dff0cbc, 0xbdfde803, 0x3d82c6f7, 
    0xbe1c9484, 0xbc5d7c90, 0x3e28ce8f, 0x3e2aad9c, 0xbd563909, 0x3e207be1, 0xbdbe8f85, 0xbdd74f63, 
    0x3e2d6753, 0xbe5c5e2a, 0xbd850c09, 0xbc561ee7, 0xbd6663f4, 0xbe19a7e8, 0xbda716b1, 0x3d984c81, 
    0x3e5a06bc, 0x3e7ee56e, 0xbe76cefd, 0x3e3b59a0, 0x3e7d8dfa, 0x3df8e946, 0xbe15fcde, 0xbe31ce3b, 
    0xbe1fce19, 0xbc29e5a6, 0xbde3a3a3, 0x3d4156c9, 0x3ddf0ee5, 0x3e0327c1, 0x3e255b94, 0x3e14a559, 
    0xbe84ddf7, 0xbe51d7e6, 0x3e805de2, 0xbe133f55, 0x3e6f00fa, 0xbe3a8d8c, 0xbe6db2d1, 0xbda61acf, 
    0x3e7643d0, 0x3e79dcb2, 0xbda5c8da, 0x3e7a8503, 0x3e802ea2, 0x3e63cfc9, 0xbd78e5d1, 0x3d5ec290, 
    0xbe58613e, 0xbe26d011, 0x3cc66e93, 0xbe7a599e, 0xbdb5439a, 0xbe249e4d, 0x3d0d55da, 0xbdd75788, 
    0xbe614965, 0xbd1d06d4, 0x3dfecd7a, 0x3c4f73c5, 0xbe1c572c, 0xbe519d93, 0xbe009042, 0xbd815113, 
    0xbe506823, 0x3d827651, 0xbe222e24, 0x3e39cd11, 0x3e7241f4, 0xbe5433a5, 0xbe16e15b, 0x3e309256, 
    0x3e1a1ad2, 0xbe1934c9, 0xbd5b558c, 0xbde9f0c4, 0x3e42aef6, 0xbe66c85b, 0xbe2ff258, 0x3e74c345, 
    0xbe7d52e2, 0xbe82920e, 0x3d64dd92, 0x3d918a4e, 0x3e24290c, 0xbe54498f, 0xbe6c338c, 0xbe3eff07, 
    0xbc75431f, 0x3d6195ac, 0x3d9ce8c4, 0xbde6ee30, 0x3e2a8384, 0x3e100791, 0xbe08dc0a, 0x3e41127a, 
    0x3d8dfb8d, 0x3e5c009a, 0x3dca19d3, 0x3e75f3b4, 0xbda97b9d, 0x3e2af2f0, 0xbe238682, 0xbe44e3fd, 
    0xbd8ac697, 0x3e3fe45c, 0x3dbe365f, 0x3d768a2f, 0x3d87d626, 0x3e682b4b, 0x3d35627f, 0x3e463f38, 
    0xbe072581, 0x3c23b942, 0x3ca1dc60, 0xbe7ea58b, 0xbe0c6805, 0xbdbb7363, 0x3d1a3fec, 0xbdfe27e2, 
    0x3e501269, 0xbd81e319, 0x3d7e80a9, 0xbcaa3127, 0x3e798e66, 0xbe09be0f, 0x3e04e986, 0xbe4cee23, 
    0xbd6fc4de, 0x3e235613, 0xbdae4c4e, 0x3c8fe618, 0x3e5d05ad, 0x3e8071eb, 0xbe5ac3c9, 0xbcaffcbb, 
    0xbe1b792e, 0xbe04bc24, 0x3e09b223, 0xbcd27f10, 0x3e2ee193, 0xbe0247cf, 0xbe77d6f9, 0xbe3ca372, 
    0x3de6f9b2, 0xbd88516b, 0x3e361363, 0xbe1dca25, 0xbdda0f72, 0xbde8d926, 0x3e4c5483, 0x3dad39ab, 
    0x3e881ee7, 0xbe55e775, 0x3e284f6a, 0xbe06dd33, 0x3e22ea31, 0x3d167f63, 0x3c784896, 0xbc584862, 
    0x3e343743, 0x3d4b2805, 0xbde2b674, 0x3e1c494e, 0x3d61532a, 0x3e6ead4a, 0xbe6815fa, 0x3d4379a1, 
    0xbe4eb543, 0x3dba9d29, 0x3e81e347, 0x3e426c8d, 0xbe7d726c, 0xbe0ddd36, 0x3ca7f064, 0xbe8502ff, 
    0xbd97aab8, 0x3e5a0c4b, 0xbdeee602, 0x3e7eb294, 0xbe536274, 0xbc6e430c, 0x3a62c563, 0x3d4b8773, 
    0xbc4b7386, 0x3d8e80d8, 0xbc9ba86b, 0xbde51c88, 0xbe227975, 0xbe893f08, 0x3e6717e1, 0xbdb30e61, 
    0xbe69acba, 0x3e698d72, 0xbd3ab057, 0xbe38c5af, 0x3e679ea6, 0xbc7cec6a, 0xbdc67d24, 0x3e3a72be, 
    0xbdbc6be7, 0x3d912a34, 0x3e56d218, 0x3e73d6eb, 0xbe7b5310, 0x3e061864, 0xbdf7d161, 0xbda65aa4, 
    0xbdabc9cc, 0x3d9e221d, 0xbe4ec0aa, 0x3abd4e95, 0xbe0426b2, 0x3e1a68f6, 0xbdc5e8a4, 0x3e6e0548, 
    0xbe787c2d, 0x3e48f7eb, 0x3e4f3caa, 0x3e630ed2, 0x3e7cdca3, 0xbe6f2765, 0x3e87f37b, 0xbe612239, 
    0xbce57fe3, 0x3e73e572, 0xbe1af780, 0xbe4a4284, 0xbe275439, 0xbc8553d2, 0x3e2c5bab, 0x3ca967ca, 
    0x3e0e474c, 0xbe3b333b, 0xbe7e266e, 0xbda31d00, 0xbe2a52d8, 0xbdb35096, 0xbe720e11, 0xbe5477bc, 
    0xbe7d0743, 0xbd732000, 0x3e112295, 0xbe094f32, 0xbe2b33a2, 0x3e83e1a7, 0x3d6fd89e, 0xbe1ca49f, 
    0xbe1ccc2b, 0xbdf26318, 0xbe4bc06d, 0xbd86bc84, 0xbe39bb96, 0x3e638d98, 0xbcc9b37c, 0x3d162316, 
    0xbe1a0b0a, 0x3d7fb348, 0x3df4374f, 0xbe1bfaad, 0xbe15348c, 0xbe74c5ce, 0xbd5b9498, 0xbe7d7128, 
    0xbe2c0a6b, 0x3da8a6e3, 0x3d3e76d2, 0x3e306269, 0x3e7772ea, 0x3dde1a0c, 0xbe206757, 0xbd617f62, 
    0x3c8a4f57, 0x3e5aefee, 0x3ad2c13f, 0x3d917daa, 0xbdd29614, 0x3e371e55, 0x3cbd1f71, 0x3d5114b8, 
    0xbdb27f51, 0x3e0473b8, 0x3e47ea63, 0xbe75491c, 0xbd36e3cc, 0xbe131e17, 0x3e6abc6c, 0x3c9a4f17
};

static const uint32_t _K24[] = {
    0x3ec19bea, 0x3f3c1be3, 0x3ece3850, 0x3f3a6799, 0x3f4f0811, 0x3f33f427, 0x3f1891bb, 0x3f8519f8, 
    0x3f96ec4d, 0x3ecb64ad, 0x3e32e6c6, 0x3ecfdbb3, 0x3f72d99c, 0x3eda8001, 0x3e578cbe, 0x3e8f48e2
};

static const uint32_t _K25[] = {
    0xbf02a5e7, 0xbee343e6, 0x3f7631ca, 0xbeb90d87, 0xbf01ecbd, 0xbf5fad00, 0x3f09fa4d, 0x3cd47b12, 
    0x3d6389ed, 0x3ee6b938, 0x3f613acc, 0x3f4bdb22, 0xbf1eaa32, 0xbf898e99, 0xbf496e33, 0x3f629ec2
};

static const uint32_t _K29[] = {
    0x3e13fca8, 0xbca48a3b, 0x3e01ad11, 0xbd2c8b2d, 0x3da97b09, 0x3d98fb51, 0x3d94e2f0, 0xbd9b3c4c, 
    0x3e306621, 0x3d0c6bc3, 0xbd9127eb, 0xbba59aff, 0xbda17dee, 0xbdd781c2, 0x3e0de909, 0xbe149cc0, 
    0x3da3a054, 0x3e27096f, 0xbdbb60ae, 0x3dc2ab1d, 0x3e1689a6, 0xbcfc34ec, 0x3dda5137, 0x3dded964, 
    0x3dd0c8b3, 0xbe4d3a41, 0xbde69e87, 0xbe1368a3, 0xbdd1acf4, 0xbbab34f6, 0xbd1a2963, 0x3cf80ec5, 
    0x3d951e89, 0x3dea3ada, 0x3bb32474, 0xbe25a141, 0x3d59d06b, 0xbdd7fc64, 0x3dc05511, 0xbe051dab, 
    0xbe3b62ef, 0xbe3f732e, 0xbd064ea9, 0xbc89d183, 0x3dadf523, 0xbe136482, 0xbe24d6fe, 0xbe05d24d, 
    0xbdb0651e, 0xbbe2d887, 0x3da67068, 0x3cb00805, 0xbd0e737f, 0x3d500bab, 0x3de0e0fd, 0xbcc7d43f, 
    0xbd82a315, 0xbd019c8e, 0xbdb0166d, 0x3c205a80, 0x3d97eb95, 0x3ce2fd5a, 0xbe4e8ec8, 0xbe36088d, 
    0x3b3a1661, 0xbe1b0164, 0x3d5a9318, 0xbe386a1d, 0x3e3f2704, 0xbe538338, 0xbd0fd7b4, 0x3d718868, 
    0x3da239e3, 0x3e074d41, 0x3e0dba48, 0xbe0ffa01, 0xbe27e928, 0xbe275754, 0xbe22ca14, 0x3e160934, 
    0xbda4e088, 0xbd8ded0c, 0x3ce595f5, 0x3e062539, 0x3d82bcb6, 0xbdd23f59, 0x3ca490cb, 0xbd9c071a, 
    0xbdde495a, 0x3e0391cb, 0x3daf6f59, 0x3d9c6379, 0xbe137130, 0x3ceff95c, 0x3e11dc83, 0x3c4c0fb8, 
    0x3dbc2d42, 0xbe05662c, 0x3dc618a0, 0x3dbb3cb0, 0xbd13e7d1, 0xbdf922f6, 0x3dce1bb4, 0x3dc5a282, 
    0x3d82f453, 0x3e1a0a77, 0xbd7c4dfe, 0x3e2819c2, 0x3e34900c, 0x3d82016c, 0x3d782b83, 0xbe49ec59, 
    0x3e26357f, 0x3da25c1a, 0xbdf1b026, 0xbdbd1a12, 0x3e08b8a2, 0x3dc83f6f, 0x3e441003, 0x3e3a26d8, 
    0xbdea98bf, 0xbd1a0442, 0xbdcbe7f9, 0xbe46e439, 0x3e3fcaa0, 0x3dc4f1e2, 0x3e36b0b2, 0xbe2484c2, 
    0x3e000a21, 0x3dd0c531, 0x3e0e3e7f, 0x3da16e74, 0x3c25a588, 0xbe0b02dc, 0xbc2d6578, 0xbe280483, 
    0x3de58331, 0x3d95b8b0, 0xbd265244, 0xbd68074c, 0x3dc42909, 0x3dd4b232, 0xbe0877f4, 0x3d069863, 
    0xbd22cc57, 0xbe4bb9c0, 0xbc758eb5, 0xbde5b31d, 0x3e2b43fb, 0x3da9bf7d, 0x3de59e93, 0xbccb1d46, 
    0xbad280b1, 0xbd8a9923, 0xbd870c34, 0xbc814728, 0xbdd1add7, 0x3db39e9e, 0xbddfef00, 0x3e0d2e64, 
    0x3e3e569a, 0x3e2886d1, 0x3db88029, 0xbd933765, 0xbe0b1f5b, 0xbbae21b7, 0xbd0e2d39, 0x3d315295, 
    0xbe465623, 0xbdb75b91, 0x3c5cc100, 0x3c4e3840, 0xbdc41453, 0x3c592022, 0x3d7543c5, 0xbe175a69, 
    0xbe2a0615, 0xbe0024d5, 0x3d2221dc, 0xbe2f3a35, 0xbb5b7b04, 0xbd9c01fe, 0x3d7d4fc4, 0x3d727e3f, 
    0x3d9eac98, 0xbd11f468, 0x3d1a5330, 0x3cb0d95b, 0xbdbe499f, 0x3dee537a, 0xbd0469a1, 0x3e16d267, 
    0x3e274956, 0x3da2d37a, 0x3dbd1daa, 0x3e0523ee, 0x3d81eabf, 0x3d00bb3a, 0xbe43138b, 0x3e26be40, 
    0x3e24a798, 0x3d5e5ff8, 0xbe1f67cb, 0x3de7c76a, 0x3e19db1b, 0x3c31de9f, 0x3e44648e, 0xbda8da0f, 
    0xbd4524b7, 0x3b69384e, 0x3ba619f7, 0xbe492932, 0xbdec88b1, 0x3cc03e7f, 0xbe21b333, 0x3dfdb01b, 
    0x3d6a1bf1, 0xbd98c64f, 0x3d188b27, 0xbd374d86, 0x3d8d3972, 0x3de15beb, 0x3e31a29b, 0x3e3b2810, 
    0xbe4b8189, 0xbd48adc1, 0x3d167a2e, 0xbd23698c, 0xbdd6712c, 0xbe0b7587, 0xbd083aab, 0x3e4a37c0, 
    0xbdcf1c40, 0xbe30aa18, 0x3e4cf144, 0x3e371e48, 0xbdf5a565, 0x3d707c35, 0xbe199ba9, 0x3d745769, 
    0xbe4d88d3, 0x3debae33, 0x3da1af92, 0x3e04bf6b, 0x3db17d00, 0x3c6d0350, 0xbdb31735, 0x3d88aea2, 
    0xbe4e9f87, 0x3dc2924c, 0xbe0e77f7, 0x3d3b99bc, 0xbded6380, 0x3dc98ef7, 0x3e11983f, 0xbe503eb4, 
    0x3e342130, 0x3e07ae42, 0xbc29cc20, 0x3e2c5d00, 0x3ddb68fb, 0xbce2e63e, 0xbdc51e63, 0x3d2b4f35, 
    0x3e1e697d, 0xbe271d60, 0xbc8e50e1, 0xbc19e441, 0xbddfb749, 0xbe0a957a, 0x3e250a60, 0x3cbb6969, 
    0xbd827d1a, 0x3d062779, 0x3d9f28ad, 0xbd645dbd, 0xbc0365aa, 0x3de124b9, 0xbd224c05, 0xbd027e14, 
    0x3e48059d, 0x3bae94df, 0xbd874638, 0x3ce87adc, 0x3e27ed71, 0xbe2c49c3, 0xbe299c40, 0x3e4bcf98, 
    0x3daea792, 0xbe1eb7da, 0x3e3f3087, 0x3d8aa2d9, 0xbe2486bc, 0xbddf216f, 0x3dbf5bea, 0xbe0edb58, 
    0x3e14969f, 0xbda18876, 0x3cafba16, 0x3d140b83, 0xbe418778, 0xbd8f0330, 0xbc38be78, 0x3dc26cb7, 
    0xbd9b2739, 0xbe3165e1, 0xbc164ecd, 0xbcd27627, 0xbe35351b, 0xbd4d9171, 0x3e3bceae, 0x3e1de79b, 
    0xbe335cee, 0xbdd35e37, 0xbd92387e, 0x3e093df0, 0xbd56f23d, 0x3e206eda, 0x3e07450b, 0xbe2918f4, 
    0xbdca7592, 0x3e1ef461, 0x3e2eb7b0, 0xbe3c27fa, 0x3e151f97, 0x3dcc6c0e, 0xbd6bf7af, 0xbe29bc51, 
    0x3e447b93, 0x3cf5a22d, 0x3e0a21ef, 0x3e1decbd, 0xbc3a160a, 0x3d019107, 0xbd5cad7f, 0xbdef6066, 
    0xbce7f726, 0x3dc8e5b7, 0x3e252219, 0x3d4a66e3, 0x3df8e145, 0xbe108286, 0x3e443039, 0xbd60bea5, 
    0x3c412e59, 0x3e2ed1ba, 0xbda42fbf, 0xbdb87e86, 0xbd7aa50f, 0x3d7c4dce, 0xbdccc779, 0xbc28263d, 
    0xbe455ccd, 0x3dd13b3a, 0x3dc059a1, 0xbdc01b54, 0xbe12e488, 0xbdd20269, 0xbd6748b2, 0x3de94ce0, 
    0x3db08193, 0xbe013ea2, 0x3d8f0a9c, 0x3e4870db, 0x3dca679f, 0x3ba5d927, 0x3e1bb141, 0xbe24c634, 
    0xbe506bfb, 0xbe491ddb, 0x3e3ffc00, 0x3d6a47c7, 0x3e153e4f, 0xbe1d0e37, 0x3e1a1d9a, 0xbd918464, 
    0x3dd9642b, 0xbdbb0e53, 0xbe4dd615, 0x3e340dcc, 0x3d181d56, 0x3e2f3cdf, 0xbdf2b635, 0x3e2fd342, 
    0x3b891d28, 0x3d2f17d9, 0xbd41cd1c, 0x3e218f57, 0x3e2a3f94, 0xbd0dd25f, 0x3d33a952, 0xbd0ba8c1, 
    0x3d480a99, 0xbdb44e6b, 0xbdedf69c, 0x3e300c4a, 0x3ddcad70, 0x3ac506a6, 0x3e49a9a9, 0x3e045ef2, 
    0xbceaf170, 0xbc1eefae, 0x3e1b193c, 0xbe38c89b, 0xbe2e9ca8, 0xbe21a32f, 0xbdeb6688, 0xbdd68590, 
    0xbb9e125c, 0x3d0ea07c, 0x3d7b40bf, 0xbd736259, 0xbdc83334, 0x3e0d7905, 0x3decf7e5, 0xbd2474e3, 
    0xbdc276b8, 0x3e20d4ab, 0x3dba3bb1, 0x3db0b7fa, 0x3cc0177d, 0x3de0ae66, 0xbdf91740, 0xbe25ad4e, 
    0xbe460867, 0xbe070946, 0xbddb73e8, 0x3d7f6e67, 0x3ceec7c1, 0x3d959387, 0xbd8e2887, 0xbdfd0fca, 
    0xbd87bb5a, 0x3d5bb434, 0x3dba9214, 0xbd1e044c, 0xbe2a0b1c, 0xbd9f1820, 0xbcab6c11, 0xbd3e492b, 
    0x3dcfbb37, 0xbdb0814f, 0xbe0b6fe3, 0x3e423310, 0x3dec138b, 0xbdfaf33f, 0xbddc3982, 0x3d9fb5cb, 
    0x3ddfd4e2, 0xbe206752, 0xbe1f7d9f, 0xbdf009ce, 0xbd2152cc, 0xbd96b7f8, 0xbe211fdd, 0xbe29bbea, 
    0x3c10de9f, 0xbda8a16a, 0xbd8477d0, 0x3e04fb86, 0xbdf0145d, 0x3e235acd, 0xbd3508f9, 0xbd9b19e6, 
    0x3e46a27d, 0x3e4ce57d, 0x3d65b504, 0xbe24725b, 0xbd922c7c, 0x3dae33c7, 0x3d05e21c, 0xbdb123fe, 
    0x3d6f58b0, 0x3dbc45db, 0xbd89fb0b, 0x3e44987f, 0x3df10deb, 0x3d29569d, 0xbe02951f, 0xbd8e6a8c, 
    0x3e1d95f5, 0x3df91b4a, 0x3d4bff7d, 0xbe02aaa7, 0xbde38e32, 0xbe5135eb, 0xbe01c8c8, 0x3de09dc9, 
    0x3dfccdce, 0x3dbb216a, 0xbd87e76e, 0xbe3e897d, 0xbc63298d, 0x3e3e44b3, 0x3d94f0a7, 0x3b8d0be0, 
    0x3d3226f3, 0xbc363da8, 0xbc46ad72, 0x3d47df6e, 0xbe4b4da1, 0x3dfae922, 0xbd620860, 0xbe27b5cf, 
    0xbd927469, 0x3e388d70, 0x3e281db2, 0x3db5fbb3, 0xbdcdf049, 0x3e114e4b, 0xbe4938df, 0xbe4ea054, 
    0x3d013f70, 0x3e3b3e13, 0xbe087020, 0x3e0cc7fe, 0xbe326818, 0x3e410805, 0xbc98b136, 0xbdfddcef, 
    0xba3e90ad, 0xbe0c5d4d, 0xbe49f17b, 0xbda56e45, 0xbe2e113a, 0xbd546d58, 0xbd340a9c, 0xbe4e8bf3, 
    0x3e0d0956, 0xbcdcd089, 0x3e33817d, 0xbe29fec3, 0x3db29bf5, 0xbe150855, 0xbc0c3da1, 0xbe436b52, 
    0x3d3cd345, 0xbc37c34e, 0x3b3ad32d, 0x3e3e29ce, 0xbe2502f0, 0x3d898126, 0xbe41f34e, 0x3d817140, 
    0x3cf75162, 0xbe2b9973, 0xbe467da0, 0xbe4e1fd4, 0x3e324322, 0x3d083cf0, 0xbe42a887, 0x3e1c42a5, 
    0x3dc85608, 0x3e42c79a, 0x3e3f9a13, 0xbe1d17f5, 0x3e16a9aa, 0x3d203385, 0xbca80b90, 0xbdadf4c1, 
    0xbddf0244, 0xbd650ef8, 0xbe20be31, 0xbd1dd5b7, 0x3e3332a9, 0xbde794e1, 0x3daae61d, 0x3d72eb8e, 
    0x3e51ba86, 0xbdde9395, 0x3dc5889e, 0x3d07befe, 0xbe0cb06d, 0xbde8225d, 0x3e28a14c, 0xbda8fefe, 
    0x3e495da0, 0xbbdb97c7, 0xbd8a627a, 0x3d7159f6, 0x3e0f17c0, 0xbdc61948, 0xbe509660, 0x3d0a0ec9, 
    0x3e016e4d, 0xbd9b450e, 0xbc2c1e9e, 0xbbf4e53d, 0x3cc005fb, 0xbe47b374, 0x3cbaa8e0, 0x3d7b677c, 
    0xbde0c683, 0x3d54f34f, 0x3e1c4c98, 0xbd800bb1, 0x3e49d70a, 0x3d9b9918, 0x3cbc1751, 0xbe35bb36, 
    0x3e3beb26, 0x3dcfbf33, 0xbe401b08, 0x3d000fe7, 0x3da91d85, 0x3e1809b0, 0xbc7a0cb1, 0x3d97e23e, 
    0x3e06b254, 0x3db9e0d2, 0x3d98a9ff, 0xbde678ff, 0x3e1d90b1, 0x3d8c81ba, 0x3d5b3bdb, 0xbdc74525, 
    0x3e47562f, 0xbc8e470a, 0xbcdefbdb, 0xbe16e0f5, 0xbe42dc69, 0xbc6a7641, 0x3dd9e195, 0x3e2ac2cf, 
    0x3e1924bc, 0x3cc6bf21, 0xbdac5bc0, 0x3e350b1c, 0x3d945f0e, 0x3e2163c2, 0xbe13b614, 0x3e369ff6, 
    0x3df082a0, 0xbe45396d, 0x3d193fa7, 0xbd59e292, 0xbe040d02, 0xbe243c33, 0x3d1f5be3, 0xbd31064c, 
    0xbe12636f, 0xbd2b1739, 0x3dc09baf, 0xbcbb4b6b, 0xbdfbaf2c, 0x3e437abe, 0xbdcc4dd8, 0xbe0f7858, 
    0xbd8f0f28, 0xbe4339ae, 0x3e24f054, 0x3d5d1e62, 0x3e35a782, 0x3e51d753, 0x3c85434a, 0xbe0368ea, 
    0xbe2643d5, 0xbdab6761, 0x3d46a6d9, 0x3e28a826, 0x3e09fe88, 0xbdcaa330, 0xbded78dd, 0xbd94100e, 
    0xbddd4ccd, 0xbd03da71, 0x3de07ebd, 0xbe1098b3, 0x3e0bf2cb, 0x3d4356f7, 0x3da9f5a3, 0xbdc41995, 
    0x3d9ddad4, 0xbbb72315, 0xbbec67de, 0xbbb9ac33, 0x3dc62702, 0x3df04b66, 0xbe1e9bd1, 0xbe42c0f3, 
    0x3e49ae4b, 0x3dfbfc3c, 0xbde6c914, 0xbe01d34e, 0xbe2166dd, 0x3e4ecde0, 0x3bcc888d, 0x3af03520, 
    0x3e420487, 0x3cef1c52, 0x3da5806e, 0x3d3c46bf, 0x3e5307cf, 0x3dd1f1f3, 0xbe3f4a99, 0x3dfa93c3, 
    0xbd2f8569, 0xbd4f1d4d, 0xbd4acea0, 0x3dc1aced, 0x3e09358f, 0xbe353aeb, 0xbe458181, 0x3d9eaf72, 
    0xbcb4ce47, 0x3e48dee9, 0x3db2460e, 0x3dd07c2b, 0xbe39257f, 0xbd7da6e2, 0xbdfe4c59, 0x3e07a04f, 
    0xbda0ecf9, 0xbe270d82, 0x3cf7741a, 0x3de577ac, 0x3e2302af, 0x3e05679b, 0x3c7ba594, 0x3dbad1a4, 
    0xbe02d8cd, 0xbd7de20e, 0xbc542066, 0x3d9b6e47, 0xbc8d9e24, 0x3de50273, 0x3e44a1a7, 0xbde8a8c9, 
    0x3e27f894, 0xbde02913, 0x3b8b03e3, 0x3d990a9f, 0xbdebeaad, 0x3e1f644c, 0xbd715bff, 0x3d3f2e42, 
    0xbb9fae0c, 0xbe2055dd, 0x3dad8624, 0xbd05bdd0, 0x3cbd63bf, 0x3dd95723, 0x3e3e8a62, 0x3c88b81c, 
    0x3e0b6b35, 0x3bb39d79, 0x3e4c9cbb, 0xbe4c77e9, 0xbda3a3a4, 0x3d3410b2, 0x3de79a3a, 0x3da4df12, 
    0x3e0b1a51, 0x3d8572ad, 0x3db36135, 0x3e2a20e6, 0xbc2fab49, 0xbce58c37, 0xbdcc40dd, 0x3dbcb5b9, 
    0x3db3f15f, 0x3e30b7e5, 0xbd71f942, 0xbe26011e, 0xbe0d78c1, 0xbcc6a2cd, 0x3d5fadee, 0xbdf5d4af, 
    0xbae85b65, 0x3dde0bdb, 0x3dce0d53, 0x3e45d132, 0x3d2f3311, 0xbd8d9efc, 0x3e23908b, 0x3c3a158a, 
    0x3e20a1b4, 0xbc8042eb, 0x3c134917, 0xbd0b750b, 0xbdf932d0, 0xbd59fa13, 0x3c177e0a, 0x3e3be4d9, 
    0xbda726b4, 0xbe365682, 0xbca1195a, 0xbe3b616f, 0xbd316606, 0x3e2a809f, 0x3cfd5e95, 0x3e2b4169, 
    0xbe229029, 0x3e4193fa, 0x3e1d25f6, 0x3e25201e, 0xbe047370, 0x3d570d41, 0xbd818f7b, 0x3e147108, 
    0x3cf6e404, 0x3dbe0607, 0xbd6bbcfd, 0x3afb7851, 0xbe3b5a59, 0x3df2b421, 0xbe3fdcf3, 0x3e1a416d, 
    0xbda568ef, 0xbdc26264, 0x3ce0e58b, 0x3c4712fa, 0xbe3dc6e6, 0x3e203e7e, 0xbd153055, 0xbd969499, 
    0x3db5b627, 0xbdb3f348, 0x3b4cec82, 0x3e220c0b, 0xbd2baf46, 0xbe2667bf, 0xbe1b7176, 0x3e1cba70, 
    0xbdd08546, 0xbd4ef42d, 0xbddc1899, 0xbdef2598, 0xbe188d9c, 0x3e1657ab, 0xbe18658b, 0xbe16488e, 
    0x3d374580, 0x3db1074a, 0x3e509066, 0xbe33643d, 0xbd5da400, 0x3d99f89e, 0xbdea6f5d, 0xbd65e551, 
    0x3e33af91, 0xbc3f21f6, 0xbab99196, 0x3deecdbf, 0x3dfe2186, 0xbd1cd465, 0x3d4c9e99, 0x3d4337a6, 
    0xbdb0061c, 0x3de90ef7, 0x3d34e659, 0x3dcb114e, 0xbd72faec, 0x3e088f0c, 0x3dbd7c96, 0x3e2da90a, 
    0x3db4757d, 0xbe0c4ec0, 0x3e4b74f2, 0xbdb5ffaf, 0xbe385884, 0xbd46b653, 0xbe12251f, 0xbd0fb863, 
    0xbdcd1319, 0xbd1b5383, 0xbd48c989, 0xbcdf5fd1, 0xbe189a0a, 0xbdeb986d, 0xbe1a530e, 0x3d67cf30, 
    0xbdb260cc, 0x3c97b364, 0x3df5c40c, 0x3e08e08b, 0xbe16a41f, 0x3e01c438, 0x3d651e67, 0xbe4a0318, 
    0xbdbe85dd, 0x3e3163e9, 0xbc9421bd, 0xbe15581b, 0x3dde9b7d, 0x3dd2e38d, 0xbd5eddf4, 0x3da133a3, 
    0x3e40a1c0, 0x3bc2403d, 0xbd8e60ef, 0xbe39d1d1, 0x3c134d03, 0xbd509702, 0xbe3ff52f, 0x3dc56d25, 
    0x3e41f065, 0x3d2f2b64, 0xbe29d7ef, 0xbde01f27, 0xbdadcf65, 0xbd7f9715, 0xbdf5cb50, 0x3db11beb, 
    0xbe419a04, 0x3d040916, 0x3dbbc450, 0xbdb91449, 0x3cea48fb, 0x3d8f52a1, 0xbe281436, 0x3e1ed001, 
    0xbe23cce9, 0xbbb74ab7, 0xbe07fb09, 0xbb54a891, 0xbe420bc0, 0x3d9d6b0c, 0x3e1ce35c, 0xbca9ba01, 
    0xbd4919d6, 0xbda3f30b, 0xbe070bf7, 0x3db9e28c, 0x3e054a54, 0x3cb3ddbb, 0xbe0ca0cf, 0x3e1b9658, 
    0xbe198075, 0xbd8f8a1b, 0xbde378c5, 0xbe09bb7d, 0xbd1036ea, 0x3dce9c1f, 0xbdfc8bde, 0xbe1eb51a, 
    0x3c1e55de, 0xbdfd2342, 0x3e0a80ee, 0x3d81282a, 0xbe113b94, 0x3e2705b3, 0x3dc0de9e, 0xbdc3848e, 
    0x3db44121, 0x3e3f28df, 0x3d44b1a4, 0xba195840, 0x3e2dbb30, 0x3da719a9, 0xbd890a5c, 0x3d3b1a88, 
    0xbe186ada, 0xbe371274, 0x3dd5625b, 0xbd219301, 0xbde55749, 0xbdfa3522, 0x3d2ec55c, 0xbd8f3a35, 
    0xbe0a923c, 0xbe17f6de, 0x3e521da8, 0xbe125396, 0x3dfc8e2c, 0xbd5dff4a, 0x3e291557, 0xbe419a6f, 
    0x3d6a95c7, 0xbe1f965d, 0xbd59c51f, 0x3e25e67d, 0x3ced683d, 0xbe290d25, 0x3dcf85c0, 0xbdb632db, 
    0x3e554ca5, 0x3e4ab66e, 0xbddb3348, 0x3e2eb33e, 0xbdc7bace, 0x3e2c0064, 0xbd16d798, 0xbe0bc97a, 
    0xbdf15313, 0xbe1d70b3, 0xbdcaed58, 0x3dce89ac, 0xbcfb03de, 0x3d3bd98c, 0xbdf96878, 0x3df4bd7e, 
    0xbcf76c09, 0x3bd4cc3f, 0x3e06e0f9, 0x3e36d7d9, 0x3e1e63a5, 0xbddb8af8, 0x3e30601b, 0x3dd72e7d, 
    0xbe202fdb, 0xbe11605e, 0xbe344326, 0x3e179741, 0xbd51feef, 0xbdb9a121, 0xbd9a5c99, 0x3e02720f, 
    0xbdfdeab4, 0x3e32f9e4, 0x3dcfa5a5, 0x3d9911b3, 0xbd7870ba, 0xbdd1389c, 0xbdeacb79, 0xbdab3033, 
    0x3d30c002, 0xbde5afda, 0x3db3e157, 0x3bdcdffa, 0xbe324740, 0xbc57e25f, 0x3e4732cf, 0xbdb496e8, 
    0xbe53e76f, 0xbd79fb75, 0x3d5968fe, 0xbe3991d1, 0xbc9c01d2, 0x3dcc65c1, 0x3e47e1e1, 0xbcd64ecc, 
    0xbd43b7be, 0xbdda3b5d, 0x3ddd223a, 0x3e4420be, 0xbcd3d9ea, 0x3c51db66, 0xbdbf6cab, 0xbe0f8f8c, 
    0x3e36a375, 0x3e28cf0c, 0xbdfb8a18, 0xbdba8bf5, 0x3e230f0e, 0xbe4869a5, 0x3d20c39d, 0xbe12aca6, 
    0x3df53650, 0xbda30d70, 0xbde7628b, 0xbe005cd4, 0xbc94efe2, 0xbd8ff19c, 0x3de19611, 0xbe3578d5, 
    0xbe12bd46, 0xbd86698e, 0xbd904f9b, 0xbdaa0211, 0x3cbb9ca4, 0x3e17a4f9, 0x3d9746c8, 0x3d402c52, 
    0x3e282bb6, 0x3ce8e3fa, 0x3c5e685c, 0xbe488e7e, 0xbe5401a6, 0x3e150105, 0x3d7f4985, 0x3d6f4abf, 
    0x3e0afa8b, 0x3e21e2ed, 0xbd20f2ca, 0x3e3f3bd5, 0xbe3f3a03, 0x3e1345bf, 0x3c802aa0, 0xbc731bd9, 
    0xbd64b242, 0xbcc90f1d, 0xbc8b9074, 0x3e2f1abe, 0x3e44ab21, 0xbd7645c9, 0x3c550c7c, 0xbe15d052, 
    0xbb94052a, 0x3e26570b, 0x3e0b53ff, 0xbbdad2b3, 0x3daff2a9, 0x3d0e569f, 0xbe464166, 0xbe17d2cf, 
    0xbd61a9d3, 0x3dbd0004, 0xbe4157e9, 0xbddb30cb, 0xbe41e923, 0x3e08cf45, 0x3cda8c7e, 0x3e221a97, 
    0x3de4ef40, 0x3c7ae2e2, 0xbe4515d0, 0x3e2601d0, 0x3df19a06, 0xbc5ee010, 0x3c2e8148, 0x3b22ebf6, 
    0x3e350303, 0xbdd90f76, 0xbe0aa582, 0xbc98e57d, 0x3e5412f8, 0x3e192e14, 0x3e4b551e, 0xbbae97f5, 
    0x3e463c8e, 0x3e16e6e4, 0x3e40359b, 0x3e241ca9, 0x3d9ae4fe, 0x3e31ac19, 0x3e038dcc, 0xbe1e8721, 
    0xbe08f4ef, 0x3da48eb3, 0xbd37e04d, 0x3d12b52a, 0x3d71cb3a, 0x3e2fc6f7, 0xbe3bebf6, 0x3e2f3602, 
    0x3c94affe, 0xbdead1c6, 0xbdde089c, 0xbaa27041, 0x3dc61674, 0x3dfb01b1, 0x3de6a381, 0xbc33a613, 
    0x3d910a5e, 0xbd1ec9b4, 0x3daac471, 0x3d252f5c, 0xbe4d6107, 0x3e435c27, 0xbe08d41b, 0x3e00d078, 
    0xbe3c85f9, 0x3ba7dfc2, 0x3e16f734, 0xbe29da85, 0x3e23faf4, 0x3e19a43c, 0xbe2c540e, 0xbe36c9cc, 
    0xbdd64593, 0xbe0ccc2c, 0x3e195580, 0xbdc7bf96, 0xbd799cc6, 0x3e0fd037, 0x3dfc5835, 0x3d020b7b, 
    0x3d3d2845, 0x3bb5064c, 0x3d8a228a, 0xbe2dab50, 0x3e460f8f, 0x3e38d901, 0x3d2eb00b, 0x3e4f7b5f, 
    0xbd82fe62, 0xbd0e8461, 0xbe359a2a, 0xbc14ebfe, 0xbd17775b, 0x3e47e192, 0xbdf3bb91, 0x3c221281, 
    0xbe18cffa, 0xbe0e1b84, 0x3d6a10d9, 0xbe452312, 0xbd84d5df, 0xbe35ae29, 0xb9fad093, 0x3e1cc91b, 
    0x3e3a1bee, 0x3d76e045, 0xbcab7537, 0xbdbc5544, 0xbc834273, 0x3e3ba529, 0xbd6b1d8e, 0x3e1403ee, 
    0xbe348cf5, 0x3d495ea6, 0xbe304476, 0x3e50f098, 0x3dfabac6, 0xbd58f041, 0xbc2881ed, 0x3e283238, 
    0xbdfef98a, 0x3dcd7a1f, 0xbde85d6d, 0xbdc451ca, 0x3e07a624, 0xbda73370, 0x3e1fc2a2, 0x3e0605e1, 
    0xbc82c266, 0xbe292ffb, 0xbcb92776, 0xbe083221, 0x3e3da0b7, 0x3de78cff, 0x3ded6b35, 0x3dbdc4ee, 
    0xbe2eabe2, 0x3dec8647, 0x3e274c1f, 0xbc9a0eae, 0xbdb58276, 0xbe273f1f, 0x3d228660, 0xbe410101, 
    0x3e1dd64e, 0x3e05752a, 0x3de9aa83, 0x3e05e686, 0xbe53e9be, 0xbe2727d9, 0x3e29cb1a, 0x3d5f792c, 
    0x3e30a7bf, 0x3dc05a88, 0xbdf58517, 0xbcd74fbd, 0x3e122235, 0xbe3db4e0, 0x3e47351e, 0x3d17aa70, 
    0xbdfb5b22, 0xbdb855fc, 0x3d8edced, 0xbe3a7f4d, 0x3db07b01, 0xbdef00af, 0xbd9553b3, 0x3d36d005, 
    0xbe00ac57, 0xbcdacbad, 0x3c58ea35, 0x3c110030, 0xbd216b68, 0x3df8245d, 0xbd10714c, 0xbde13560, 
    0xbe202814, 0xbd387e46, 0xbb8940d7, 0x3e0cc266, 0xbd15ec2a, 0x3d5bd98e, 0x3dcea702, 0xbe0d909a, 
    0x3d9005b9, 0x3e3998bb, 0x3de298e5, 0x3d5998c2, 0x3e39f50b, 0xbcbb704c, 0xbe1695d5, 0x3d4ea6f7, 
    0x3dd04a68, 0x3e22ed57, 0x3da9d809, 0xbdee2993, 0x3d828dd7, 0x3de8367b, 0x3da88e12, 0xbd11f3fe, 
    0x3e0d368e, 0xbe011702, 0x3c57ad88, 0xbcf02c28, 0x3c9d57c9, 0x3daabc45, 0x3e381557, 0x3e33175a, 
    0xbdaed1c7, 0x3d331881, 0xbdead74c, 0xbd6255f6, 0xbacf3cd7, 0x3e0de845, 0x3df7481f, 0x3e4d32ca, 
    0xbe4ae915, 0xbce0874f, 0xbb78b42f, 0x3e483964, 0xbe473019, 0xbc832d96, 0x3df7da9f, 0xbe40182e, 
    0x3de39130, 0xbe0d8203, 0xbe210e75, 0x3cef26ce, 0xbd96d45c, 0x3d448599, 0x3c365216, 0x3dcfa9d1, 
    0x3e3b286c, 0xbddf502c, 0xbe3f9693, 0xbe2e9b95, 0xbd3a89a4, 0x3e34334c, 0xbdf9fe6f, 0xbde2a451, 
    0xbe29337c, 0xbe34aa34, 0xbd4ccebf, 0x3e41a16d, 0xbe06cd93, 0x3e38f7ea, 0xbc599e9b, 0x3b47e42f, 
    0x3da93dc2, 0x3df31f26, 0xbdc7cf8f, 0x3db74fc6, 0xbe3313a1, 0xbdcbe390, 0x3e49f690, 0xbe2dd85f, 
    0xbe4a0755, 0xbda8276c, 0x3a3452a4, 0xbd57c5ed, 0x3df50791, 0xbe2e5222, 0x3d9b8054, 0x3d5128bd, 
    0xbdf8c5be, 0x3dd7e366, 0x3e1371cf, 0xbe218912, 0x3dc71a4f, 0x3e290d75, 0xbe0cbec8, 0x3c912fd8, 
    0xbdf67711, 0x3e27aa07, 0xbe4aaf1d, 0xbd176a73, 0x3e035b26, 0xbcbe6589, 0xbdb83b72, 0xbd6ab0c0, 
    0x3defabc1, 0xbe0b9a90, 0x3c81ae1b, 0xbc7fa48b, 0x3d0f30df, 0x3e1575fd, 0xbcf17374, 0x3dc98ad6, 
    0xbde985b1, 0xbdd32b3b, 0x3d3ae7f5, 0x3db0a10f, 0x3e46a78d, 0x3e2b2fd0, 0x3dca77c0, 0x3d88c533, 
    0x3e4f5c24, 0x3e1722c3, 0x3d8672af, 0xbe35f359, 0x3c20321a, 0x3daf3aab, 0x3e4b01c6, 0x3d174898, 
    0xbdaff1f1, 0x3e3d5d81, 0xbd488d3f, 0x3d999e8c, 0xbd997c71, 0xbdba3f4d, 0x3cb7b654, 0xbe40baf7, 
    0x3e0294b1, 0xbe1d2c67, 0x3de05eab, 0x3cf78f68, 0xbe3f852b, 0xbe4257df, 0x3db70bfa, 0x3de85601, 
    0x3e185bc0, 0x3de4f424, 0xbe1bb03f, 0xbdd47dd0, 0x3e4029ad, 0xbd9d8ffc, 0x3dce1642, 0x3dbb4d8a, 
    0x3c8d9442, 0xbe06f97a, 0x3d024c5a, 0x3cbbdb12, 0x3c8cc037, 0x3decc19e, 0xbbc4e769, 0xbc0651c9, 
    0xbd31aca0, 0xbe16aa92, 0x3e02c99f, 0xbdad57cc, 0x3d26776e, 0xbc50c703, 0x3d473b12, 0xbdf4cb22, 
    0xbdd692a2, 0xbe46b48b, 0xbd03ba73, 0xbe34c78e, 0x3e1c38fe, 0x3ca813fa, 0xbd51c2b6, 0xbe4b3805, 
    0x3e248b07, 0xbe3ec33c, 0xbe4cb2da, 0x3e065f06, 0xbe3780b7, 0xbb5967fd, 0xbe05af95, 0x3d904bbc, 
    0x3e3a4bde, 0x3c5ac161, 0x3e0465e9, 0x3de7450f, 0x3d1b9f2c, 0x3c505769, 0x3c4fcf7b, 0x3e1b50f3, 
    0x3e08fc2e, 0xbe3c0351, 0xbd4ad084, 0x3d77596b, 0xbd04a391, 0xbd9fb00e, 0x3df49f3f, 0xbd83df6b, 
    0x3de06646, 0xbe19061c, 0x3e1b5e04, 0x3db54b95, 0x3e16984e, 0xbdf0ec76, 0xbdd50c5b, 0xbd8a4d52, 
    0xbd7f82b9, 0xbe1c26e4, 0x3e235c66, 0xbd982a01, 0x3e1421ad, 0x3e48ea51, 0xbe3e8b32, 0x3e35029c, 
    0x3de173a0, 0x3c8fd9b8, 0xbe03684e, 0x3d78ffe7, 0x3e367d3b, 0x3e14384a, 0x3e288193, 0x3c995f52, 
    0xbd98d8a4, 0xbcd2ec10, 0xbdfb3cf2, 0xbd46a6de, 0xbdb9099b, 0x3e3499d1, 0x3d920175, 0x3d9e8d6d, 
    0xbdb8df42, 0xbd738666, 0xbd8d112e, 0xbdda132c, 0xbe2c43ca, 0xbe2b3196, 0x3e2fee0f, 0xbe1b7cfa, 
    0x3e143786, 0x3e304418, 0xbe3597ce, 0xbe06e93b, 0xbdcdcc4a, 0x3e31ed3c, 0x3db42e02, 0x3e4a3f17, 
    0x3db0c17a, 0x3df2846d, 0x3e276ac7, 0xbc240f12, 0xbd86240a, 0x3e11e4a7, 0xbdb45966, 0xbe0aea82, 
    0x3df2affe, 0x3e456b1b, 0xbe0e4b6d, 0xbc34d6e0, 0x3e00b603, 0x3d3b9992, 0xbe4c5f41, 0xbe005139, 
    0xbe1dc735, 0x3dacffa4, 0x3e401d82, 0xbe10813d, 0xbded57e3, 0xbdec08ff, 0x3e1cedab, 0x3de3502d
};

static const uint32_t _K31[] = {
    0xbe1bb03c, 0x3d017364, 0xbe23eac9, 0x3e1e8da7, 0xbc8f1096, 0xbdb1b7cb, 0x3dd0fc41, 0xbbe59aaa, 
    0x3e002244, 0x3d1fa098, 0xbde9f505, 0xbd68098a, 0xbdacc769, 0x3e1dc6cb, 0x3ddcb0c5, 0xbe1e8bb0, 
    0x3dc3f3a2, 0xbdd1ce47, 0xba22c912, 0xbe012965, 0xbc8d0444, 0xbd96725a, 0xbc1423c1, 0xbdc8fa76, 
    0xbd8b3f01, 0x3d382a94, 0x3ce3b973, 0xbe0dd383, 0xbe23c517, 0xbe0bf20e, 0x3da8b1d4, 0x3cbc7143, 
    0xbdab8bb2, 0x3d894140, 0xbdaf321d, 0x3d495abe, 0xbdad9c24, 0x3e01b96d, 0x3e16cc55, 0x3d4c0e88, 
    0x3d9e1024, 0xbcb04b9e, 0xbcbd42b0, 0xbe10c398, 0x3ddc0005, 0xbca1f341, 0xbdbdbc94, 0xbdac8242, 
    0x3de9d775, 0x3e015acc, 0x3e05fa74, 0x3dc23f29, 0xbcca5011, 0x3d93d1ce, 0x3dbd9249, 0x3d5c821e, 
    0xbe0d9c42, 0xbd907cba, 0x3e1558fc, 0xbde26585, 0x3d68354f, 0xbd70366d, 0x3debc46c, 0xbd481a2d, 
    0x3deecef4, 0x3e173bb6, 0xbdaab739, 0xbe1433fa, 0x3d0e3e96, 0xbe2204c6, 0xbd02c38d, 0xbcd125dd, 
    0x3cfe99bb, 0x3de24099, 0xbe2257cf, 0xbe1c02b0, 0x3c020dfc, 0x3e1686cd, 0x3ddf1336, 0xbd6a29c4, 
    0x3dafcee0, 0xbd48a33b, 0xbb241d00, 0xbd0a7ac0, 0xbe258876, 0x3e26a32a, 0x3d8dfb4f, 0xbe003541, 
    0xbd2d2dd8, 0xbdf3ade8, 0x3e32c9ca, 0x3db5ba3e, 0xbe199f3f, 0xbc182b58, 0x3e142e03, 0x3dd83798, 
    0x3d0decec, 0xbe03bdf6, 0xbdcab50a, 0xbd96718c, 0xbba48e89, 0x3b47cecb, 0xbda01e9a, 0x3dfcb888, 
    0x3e2e1f19, 0x3e0cfac3, 0x3e1a2488, 0x3c866e3f, 0x3e0ee55f, 0x3dd83640, 0x3b31dc3a, 0xbd20ef76, 
    0xbe0830d4, 0x3da73440, 0x3cd81c02, 0x3c2079d8, 0xbe172de9, 0x3d87794c, 0xbdbc13dd, 0x3e0ba149, 
    0x3d6b8027, 0x3dba53e3, 0xbe17fd64, 0xbe30aa0c, 0x3df48337, 0xbe0266d2, 0x3dc4c89a, 0x3c88597b, 
    0xbdaddb30, 0x3ddf6ace, 0x3c2481bc, 0x3e2c94d5, 0xbe0717bf, 0xbd227a46, 0xbd89b8a6, 0xbc39adb4, 
    0xbd9d6f24, 0xbd7c62b6, 0x3c501397, 0x3de9a8c2, 0xbe14c81d, 0xbc8a8864, 0xbe269743, 0xbe0c4041, 
    0x3dbc7054, 0x3e0cccad, 0xbdaff654, 0xbd9d03d8, 0x3df2c5b8, 0x3d5cd70c, 0x3e2a0f9b, 0xbe009dd5, 
    0x3cf96707, 0x3d7ddb15, 0x3de7c7a3, 0xbd2f54f8, 0x3de26801, 0xbdbccce3, 0x3bb39807, 0xbd90dc34, 
    0x3e07fd8a, 0x3e13cc4b, 0x3c39a9bb, 0xbd86ca75, 0x3cb09f2d, 0xbd3523f7, 0x3dc4bc70, 0x3c03109e, 
    0xbdfaf685, 0x3c8da7bf, 0xbd31ffc6, 0xbda39431, 0x3d3b5fef, 0x3dfb06e6, 0x3e3aecaf, 0xbe29c125, 
    0xbe07a42e, 0xbdb65a3f, 0x3bc93ba5, 0xbe1471b4, 0xbe024563, 0x3df202ce, 0x3d472df9, 0x3c2d6816, 
    0xbe2e3513, 0x3e05017a, 0x3e075b5c, 0xbd255b1a, 0x3d921de0, 0xbe14c56d, 0x3dceac8e, 0xbd2c1733, 
    0x3d9cd6ef, 0x3e134c18, 0xbe2fa2a9, 0xbe2345c2, 0xbda501ae, 0xbb322a1d, 0x3e26cbce, 0xbdfa519e, 
    0x3be99611, 0x3d8eaa52, 0xbe0b0f1e, 0x3df3c348, 0xbd03d3e1, 0xbe1cf008, 0x3d00ede4, 0xbd490ebd, 
    0xbde72830, 0xbcbc0f37, 0xbca7e881, 0x3e1b1841, 0x3d2e69a6, 0xbdbf31fe, 0x3e2c0e55, 0x3e1395fa, 
    0xbd86c01d, 0x3cd9b73b, 0xbd8995e1, 0xbd5151d3, 0xbe2c842d, 0xbd77a3a0, 0x3e27c680, 0x3e2a5a2c, 
    0x3e1d623b, 0x3e3442b3, 0x3ddbc218, 0x3c51a99d, 0x3e1fc86d, 0xbde45016, 0x3d012a03, 0x3bf9862f, 
    0x3ce54ab8, 0x3e11c6d1, 0xbdd87537, 0xbd6d3b2f, 0x3dd025a1, 0xbe275375, 0xbdc2026f, 0x3dde3b0b, 
    0x3e152ea2, 0x3db389dc, 0x3e00208b, 0x3cbc098e, 0xbc253d1d, 0x3e07b7d0, 0x3d5d97d3, 0x3dc18cb1, 
    0xbe0bffed, 0xbe326cce, 0xbe14aa01, 0xbdf1fbde, 0xbda97fea, 0x3cd18f3a, 0x3d070893, 0x3e32de77, 
    0xbe00c3ed, 0xbd5116bb, 0x3de89a02, 0x3dbc7af7, 0x3dcadbfb, 0xbd285052, 0x3d716323, 0x3df0c30e, 
    0xbdc29587, 0xbd368161, 0x3e11ad66, 0x3da6e2c8, 0xbcbd3f77, 0xbcfa8eed, 0x3dff40b9, 0xbd1e777f, 
    0x3e0b9c06, 0x3d43d4d4, 0xbdc477cf, 0x3e0bc520, 0x3e1793dd, 0xbe2499c1, 0xbe273e26, 0x3da868b4, 
    0x3d8009d8, 0xbc4bf070, 0x3ddc5984, 0x3d7d6a88, 0xbe054044, 0x3e0828ac, 0xbb2b286e, 0x3e164b18, 
    0xbce72001, 0x3cdd848a, 0xbe0fc3e7, 0xbe0799fe, 0xbc08c876, 0x3d14821a, 0xbd10ca97, 0x3daba9ca, 
    0xbd9adcce, 0x3e113a35, 0xbdb77155, 0x3e3b9bf9, 0xbdc2d200, 0xbe19999b, 0xbcdee439, 0x3e371d48, 
    0xbd836be9, 0xbe23de6c, 0x3e09cbca, 0x3dd81048, 0xbdef5e87, 0xbd48d296, 0x3d2a1bb6, 0x3da0f60d, 
    0xbdb07cab, 0x3da10248, 0x3dba4fa6, 0x3daa7dbc, 0x3e1070d2, 0xbd905384, 0xbdd29ec7, 0xbe275cd5, 
    0x3e04435f, 0x3cb12c15, 0xbd20a31a, 0xbd90fddd, 0xbe155031, 0x3d8dfec8, 0x3d798ae9, 0x3dae895f, 
    0x3c8d0925, 0xbd7cc2ce, 0x3dc0e6a1, 0xbd65cd43, 0x3e38e4c2, 0xbdc994cb, 0xbe1db66a, 0xba028f32, 
    0xbd105541, 0x3df23310, 0xbda77122, 0x3bea7286, 0x3e05f19e, 0xbe2cb5db, 0x3bb30c1d, 0x3dcd8062, 
    0x3e0687f0, 0x3cfee233, 0xbd557bb3, 0x3de7bf0b, 0xbc83c956, 0xbe16b952, 0xbddc4a9f, 0xbdfb459f, 
    0xbddbb887, 0xbce0a97e, 0x3d79409d, 0xbe2c5513, 0x3d8d92cc, 0xbe06c07b, 0x3e0c466c, 0x3e27b518, 
    0xbdb0d1a7, 0x3dc7971a, 0xbe03cefb, 0xbd85b665, 0xbd8f2988, 0xbd4476b1, 0xbd40a94c, 0x3d770c33, 
    0x3d9cd1c7, 0x3db3ebed, 0x3db3a7e0, 0xbcc5ac4b, 0xbd9b019e, 0x3e19fa32, 0x3cbc241f, 0xbc3b75aa, 
    0xbe02a3f2, 0xbe031ad3, 0x3e042992, 0x3df28bbf, 0xbda2d061, 0xbe27f5f3, 0xbdac0a00, 0xbd9b9e9b, 
    0x3d4cb844, 0xbd719508, 0x3d9f6967, 0x3de4c0ef, 0xbe114766, 0x3c5f541e, 0x3dda6918, 0x3d55cd05, 
    0xbc146761, 0x3d7779e5, 0xbde66613, 0xbe1ac5dc, 0xbdaee309, 0x3d332e4e, 0xbdcbaa9a, 0x3b8747af, 
    0x3e21e1fd, 0x3db96f66, 0xbd474d71, 0xbd0ea593, 0xbd9b9792, 0xbdea8565, 0x3e156510, 0x3d7f31cd, 
    0xbd88e002, 0xbe2d564e, 0x3cb08285, 0x3d2e84ee, 0xbd72650b, 0x3e1d8b95, 0x3ce87186, 0xbe142d1b, 
    0xbd3a981f, 0x3dc8d1ab, 0x3e2e592f, 0xbc3645b3, 0xba54600d, 0x3d1b8503, 0xbda1857d, 0xbb398dc3, 
    0x3e1ce84d, 0xbe1ee141, 0xbdd2e792, 0x3e03941d, 0x3ded0a14, 0xbe382659, 0x3e030795, 0xbe01cd89, 
    0x3e1914d7, 0xbd947f74, 0xbd616f33, 0xbdc75a61, 0x3d3ea532, 0xbc173cc4, 0xbda20cb2, 0xbe3378bb, 
    0x3ce8da74, 0xbe2b1f00, 0xbcc07890, 0x3de551a9, 0x3dad84e2, 0x3d463a88, 0x3dce2231, 0xbdae304e, 
    0x3dd332fd, 0x3e1057c1, 0x3e25b64a, 0x3e1459c4, 0x3bc93c34, 0x3ca2395b, 0x3d668151, 0xbd7d6d44, 
    0xbd90324d, 0xbe092ac0, 0x3daac779, 0x3e1d3455, 0xbd0a4885, 0x3d93b376, 0x3d985812, 0xbe2e9448, 
    0xbdfbae18, 0x3d27e9f6, 0xbdeb30a5, 0xbe27d0fe, 0xbdd6456a, 0x3e0a243f, 0x3e23f69c, 0xbdc32b6c, 
    0x3da22530, 0xbdcbe234, 0x3e0fc79e, 0xbcad50b8, 0xbda0976f, 0xbe31a404, 0xbdd960db, 0x3df4c7ce, 
    0xbe00115b, 0x3da25bc6, 0xbdddc791, 0x3d8e813e, 0xbcba628b, 0xbc1c8b1f, 0x3dc25a83, 0xbd26651e, 
    0xbd862b1a, 0xbd9fa0f8, 0xbcd9b14c, 0x3d990429, 0xbd5fa0ae, 0x3d4ed0db, 0xbcebb741, 0xbd0e2c73, 
    0x3c82d87d, 0xbc031ea8, 0x3e0c67f4, 0x3d9a63bc, 0xb56bba1a, 0x3ded2428, 0xbe21f226, 0xbe020390, 
    0x3cf4eea4, 0x3dce208f, 0xba45cef6, 0x3d6c9fa9, 0x3e1bd3d4, 0x3d256de4, 0x3decf567, 0xbe37833e, 
    0x3e2983e0, 0xbe280114, 0x3ce9107c, 0x3d3ea6f8, 0x3c7ea7c9, 0xbcb03a38, 0x3d29adc9, 0x3e1f8561, 
    0xbddc4d7b, 0x3d5b4f1f, 0xbbea43b6, 0xbd52cf42, 0x3df16801, 0xbd193cf7, 0x3d3035f5, 0x3df5cb9c, 
    0x3e0a3b53, 0x3e2549f0, 0xbe2a8d61, 0xbe0abd9d, 0x3e2efcc5, 0x3ddae537, 0xbd0662a6, 0x3e29aae8, 
    0x3dfa8668, 0xbccd64a7, 0x3da1651a, 0xbdc95e95, 0x3e118fdb, 0x3dc894e4, 0xbdea0d0d, 0x3da3a93e, 
    0xbc74fd8f, 0xbcea4983, 0x3d5c96e6, 0x3ceb652c, 0xbd0db3fd, 0xbdff8d86, 0x3dd38686, 0x3e142c2c, 
    0x3e340e7d, 0x3d558c6f, 0x3bd871b5, 0xbe0f2682, 0xbdaab685, 0xbe0f19bc, 0x3d974f23, 0x3db9b378, 
    0x3c74c72a, 0xbe1deaf0, 0xbd656606, 0xbdc3c604, 0xbe0fe6fe, 0x3d10f798, 0x3c0f6c6b, 0x3e25f47c, 
    0xbdb7a298, 0xbd08f9a0, 0x3e12cfc7, 0x3dde4bc0, 0x3e2869a9, 0xbe1e5d5c, 0xbd5584d6, 0x3e240f14, 
    0x3e21f19b, 0x3d9a5f9a, 0x3cdf1b6f, 0x3d1e20d4, 0xbe2ffc54, 0x3da59c14, 0xbda023b6, 0xbe044a5b, 
    0xbe23d063, 0xbc585077, 0x3e0c5153, 0x3db3a880, 0xbdc4c450, 0x3d59ff16, 0xbe1f2962, 0xbde87ec6, 
    0xbd433c62, 0xbdcbaa5f, 0xbd9babf1, 0xbe24e4e2, 0xbce555ac, 0x3e000737, 0xbe23a394, 0x3cbbcd20, 
    0xbce6cf9f, 0xbe0af99f, 0xbdb2a01c, 0x3afe4eb1, 0x3c349a0e, 0xbe1b62c6, 0xbd2ba425, 0xbe157ea9, 
    0x3df8bf68, 0x3d6a2aeb, 0x3e184f9b, 0xbe136341, 0x3bc3f372, 0x3cf33480, 0x3d50b74a, 0xbc9e113a, 
    0xbdd4237b, 0xbb726e5b, 0x3dea95f1, 0xbc332210, 0x3dfd092c, 0x3e26960b, 0xbe22bd01, 0x3dc72d0d, 
    0xbdb9d43e, 0xbc38dcd1, 0x3e1877d4, 0x3df7d317, 0x3d9b1099, 0x3e2ffc51, 0x3e2bd5ca, 0xbe2ad45a, 
    0xbd5edd1d, 0xbcb6452d, 0xbd6d72f8, 0x3ddcb289, 0xbe293550, 0x3e076e27, 0x3e038f6c, 0xbded8740, 
    0x3dcfe279, 0x3caf1ffc, 0x3c78b176, 0x3e302e29, 0xbdcaaca9, 0x3deb5285, 0xbe102a54, 0x3d9c8a9b, 
    0xbdc4b98e, 0xbdaddcea, 0xbcbc6f53, 0xbe2448ac, 0xbd51c114, 0xbd864571, 0x3dd3c0c3, 0xbd387c80, 
    0x3e0cc587, 0x3df3f69c, 0x3d92ff3c, 0xbcc3706a, 0xbd417617, 0xbe1a2a1c, 0x3e1f5c7e, 0x3d7eb35a, 
    0xbe090933, 0x3d465403, 0xbc71c4e4, 0xbe010a0c, 0x3daf4c9c, 0x3d3b5090, 0x3e2571ac, 0x3e2aaaea, 
    0xbe214760, 0xbcbe1fd6, 0xbde43ccf, 0xbd7bca2a, 0xbdbc6f58, 0xbdada308, 0x3d8837da, 0x3d977a33, 
    0xbd3483eb, 0x3da40515, 0x3dcd76ce, 0xbd7fe916, 0xbd5ab584, 0x3e19cd13, 0x3df3a745, 0xbd198613, 
    0x3b7d3208, 0x3e025d3c, 0x3e1f7bc7, 0xbd663f80, 0x3dd1f5fb, 0x3d929584, 0xbdda4f68, 0x3d50b2ae, 
    0xbcadd027, 0xbd1b0966, 0xbe17aabc, 0x3e034f89, 0xbd8a3742, 0x3d1fd085, 0xbe0aa850, 0x3dc48651, 
    0x3d754c36, 0xbd217997, 0xbe1bd796, 0x3e2efe55, 0x3d6be952, 0x3dd58821, 0xbe1bef99, 0x3dbccb66, 
    0x3deda770, 0xbe1671c6, 0x3e266ac2, 0xbd98cdec, 0x3da79c9e, 0xbddbd0e2, 0x3e21c9ae, 0x3c7c2f1c, 
    0xbda55bef, 0xbda69bbb, 0x3e1c819a, 0x3c1ffbe2, 0x3e187ee8, 0xbc9ce73b, 0xbe14b5a7, 0xbe02e74d, 
    0x39b990c1, 0xbe0dc46c, 0xbd341aa5, 0x3dbd7126, 0x3d98258e, 0xbde97c4e, 0x3e074b23, 0xbd00a712, 
    0x3d4ddfc8, 0x3bd5caaa, 0xbd32bffc, 0x3e22cbc4, 0xbe02a284, 0x3d1a06a3, 0xbde46360, 0x3dcf5270, 
    0x3d8b0e7d, 0x3e1aa1a4, 0xbe24d8d0, 0xbe2f9d9c, 0x3c17dee5, 0x3cc3cd02, 0x3de89905, 0xbc735faa, 
    0x3c54e43a, 0xbe2b48a0, 0xbe064b09, 0xbd7ea1da, 0x398a6e8b, 0x3e1a4367, 0xbe0ec67d, 0xbde41c3d, 
    0x3da208fd, 0x3db4b4ad, 0x3d28f036, 0xbd9e6b87, 0xbd4f6711, 0xbe2601b6, 0xbddd53fb, 0xbe032929, 
    0xbc048330, 0xbde66898, 0x3d8ca811, 0xbe35f4ef, 0xbd4fc1e1, 0xbdfb017c, 0xbe357f01, 0x3de75d98, 
    0xbdb9058a, 0xbc5a32fb, 0xbd05ecd2, 0x3d8da15a, 0xbe18ddd8, 0x3d630d96, 0xbd8b3ebf, 0x3d5c512a, 
    0x3e23b0fa, 0xbbe4edeb, 0x3e00fd48, 0xbd301581, 0xbdc0272b, 0xbd85a5f7, 0xbd758611, 0xbca17f8a, 
    0x3e069597, 0xbda0a513, 0xbe305861, 0xbcad9045, 0x3d3a0b72, 0xbc56f204, 0xbd13f515, 0x3e1f27ea, 
    0x3d6ed406, 0xbdcefca6, 0xbb8ed632, 0xbdbdd42b, 0xbddbd2ab, 0xbe0cbc7b, 0xbd38b8fb, 0xbe15a587, 
    0x3dc60274, 0x3e31c3a1, 0x3d61b8a1, 0x3d4068e9, 0x3dc38181, 0x3e2e0cd9, 0xbdd8d085, 0x3d62a5c2, 
    0x3d01c06c, 0x3e29f6be, 0xbb7f5112, 0x3d378bdb, 0x3dfb2924, 0x3d0f2092, 0x3d30e41d, 0x3a5cd192, 
    0x3ccac366, 0x3c8c0686, 0xbda2890c, 0xbdcdc58b, 0x3e11e226, 0x3d8c61d4, 0x3d5e4dfa, 0xbd88e85e, 
    0xbe122eb9, 0xbccc90da, 0x3e1b27b6, 0x3e2eff25, 0xbd9a3c93, 0xbd5ddd3d, 0xbd94ce8c, 0xbe3e9748, 
    0x3e0fbcd1, 0x3dde54e3, 0x3e147f1c, 0xbd0fd235, 0x3c9d10ea, 0x3d80c264, 0x3e083144, 0x3db8dea4, 
    0xbdf2badc, 0x3da188a0, 0xbcb7158e, 0x3ca6e053, 0x3df98bcf, 0x3e235005, 0x3dae20ae, 0xbd835e2b, 
    0xbd62eb1d, 0x3c0cb606, 0x3ce2a030, 0xbe10f8fc, 0xbdb11b0c, 0x3df72b0e, 0xbddd04e1, 0xbc947698, 
    0xbd094f39, 0x3e0db42e, 0x3b2c1d9a, 0xbdf84ce0, 0xbe0ae53e, 0x3e2b9d61, 0x3d6368ee, 0x3dec3a17, 
    0x3e02f3c0, 0x3d8f03f5, 0x3dfab72f, 0x3c475785, 0xbd369d31, 0x3e2f8435, 0xbda5ea7b, 0x3e2fe057, 
    0x3db9b107, 0xbdcecbf2, 0x3de81bf3, 0x3e08d876, 0xbc6e621c, 0xbe34c9f7, 0xbd78ba4f, 0xbe2cf15e, 
    0xbddc2ec6, 0x3cded478, 0x3d82903e, 0x3db3b438, 0xbe2fa342, 0xbd82fd49, 0x3bab13df, 0x3d1c6a01, 
    0xbe2010bc, 0x3c1e7058, 0x3d0debf7, 0x3c98ebf7, 0xbe2797dd, 0xbe09dde1, 0x3d1e7950, 0xbc3a7018, 
    0xbdbf6e03, 0xbe3394a5, 0xbe005134, 0x3e13bf1f, 0x3d8dc390, 0x3d51e570, 0xbd9727d6, 0x3db75f27, 
    0xbdef9a64, 0xbd0f2acc, 0xbdffc386, 0x3c8873ad, 0x3da67ce6, 0x3d609e2e, 0x3e186420, 0xbe0ab436, 
    0x3d31147d, 0xbd5aa923, 0x3dadee69, 0x3d0989b1, 0xbde0e090, 0xbe281e0d, 0xbca43b00, 0xbe2246b5, 
    0x3d47dc16, 0x3dee4f2d, 0xbaf5ba47, 0x3dab8f41, 0xbe170e5a, 0xbd9b6065, 0x3da46137, 0x3d8ff157, 
    0x3e02e391, 0xbdf3719f, 0x3dfef1fc, 0xbd9261db, 0x3d895fe5, 0x3e29fd83, 0xbdcd28f6, 0x3d5f6d0b, 
    0xbc2c74b3, 0x3d6638dd, 0xbdacf52c, 0xbd38edb7, 0xbe212dc2, 0xbe1e5621, 0x3e2c446e, 0x3d0fc68c, 
    0x3d347a3c, 0xbb91b9dc, 0xbddf2ba1, 0xbdd5e94a, 0xbdae893b, 0xbb31fa0b, 0x3d663067, 0xbe2d6e1a, 
    0xbd9cf8c0, 0xbdb55a67, 0x3deeb2f4, 0x3d7e1d05, 0xbd90523a, 0xbe32dfbd, 0xbbcbb59c, 0x3e37414f, 
    0x3b18dc72, 0x3e240f8d, 0xbc9eba6f, 0xbd58e750, 0x3dbe0742, 0xbe262d84, 0xbd98bcb1, 0x3e0df271, 
    0xbdd41a4e, 0xbe24c9cd, 0x3d8456a1, 0xbdf19233, 0xbdd05540, 0xbb2f5673, 0x3e05fe4b, 0x3def63ae, 
    0x3ded24b2, 0xbd876f41, 0xbe04b40e, 0x3e0b9933, 0xbe34027d, 0x3c125167, 0x3c4c22b8, 0xbda54142, 
    0x3de432eb, 0xbddc3a8b, 0x3d20c1d4, 0x3e31b0c8, 0xbdcbf9b9, 0xbe3baf6e, 0x3d9e8f1c, 0xbd97970c, 
    0x3d517de2, 0xbd8d39fa, 0x3cdd601e, 0xbd99e10c, 0xbdb6a17e, 0xbe1f1930, 0xbddb0397, 0x3e2341e4, 
    0xbdc14d7c, 0x3dae3267, 0xbe066c5b, 0xbd2f3c0c, 0x3c0c94db, 0xbc29e131, 0xbe2cd915, 0x3e27831b, 
    0xbdf295cd, 0xbccafea5, 0x3d034a57, 0xbe28316d, 0xbe37e5e8, 0x3e375c3a, 0x3d443158, 0xbd1feeaf, 
    0x3c6f2325, 0x3dcb3fd7, 0xbd2c5387, 0xbe18db74, 0x3d110f8f, 0x3b224606, 0x3e0686ee, 0xbdf0ff95, 
    0xbd32f613, 0xbe2e1d86, 0xbe1367dd, 0x3dbeade2, 0xbbf4c41d, 0xbe359950, 0x3c5898f5, 0xbd136edd, 
    0xbdd7b9da, 0xbd633fb0, 0x3d939874, 0x3d33b435, 0x3e261f11, 0x3d7704d9, 0x3d94bec7, 0x3e0f74dd, 
    0x3d802587, 0x3d696df7, 0xbbe6d259, 0x3df88713, 0x3dc3cacb, 0xbca90585, 0xbe229825, 0x3cd088b3, 
    0x3df0daa0, 0x3d4b4e17, 0xbda315da, 0xbe0a9ec6, 0x3d618447, 0x3dd64c6d, 0xbdd4f1ca, 0xbc0d4e59, 
    0x3e27c716, 0x3ca7c008, 0x3c15d994, 0xbe2e3c9e, 0x3e2360b9, 0xbdab9206, 0xbded0b8f, 0xbc3201e7, 
    0xbe12cca2, 0xbd2d4ffc, 0xbdca741f, 0x3dae6d00, 0x3e2a6b34, 0xbcb5b01d, 0x3da74452, 0x3d94a120, 
    0x3ce4f61a, 0xbb96f0c3, 0x3d5ef19b, 0xbb6cce3c, 0xbe3d422a, 0xbd8c02ac, 0xbe0f5cfc, 0x3db80190, 
    0x3ddad070, 0x3cdbf8fb, 0xbe1112df, 0x3db07fa1, 0x3cc98cae, 0x3cb59b81, 0xbd328384, 0xbd8f2ca3, 
    0xbde6dde9, 0x3e2fb61e, 0x3d89a9d0, 0x3db2da2a, 0xbe3409ab, 0x3c890ed6, 0xbe141037, 0x3dedb05a, 
    0xbc10566d, 0x3d6a7aae, 0xbcf4383f, 0xbdecd41b, 0x3df4aef6, 0x3e328182, 0x3e239fa3, 0xbe1e6cf2, 
    0xbe16d811, 0xbd210c8c, 0xbd6b85a2, 0xbd4090d4, 0x3ddd9f00, 0xbda784ec, 0x3ccac1cb, 0xbdf113a3, 
    0x3db98eb5, 0x3e324071, 0x3cad895c, 0x3c252601, 0x3e093931, 0x3be5ad67, 0x3d810a38, 0xbe110fa4, 
    0xbe3d63be, 0xbdda381b, 0x3e173e43, 0x3e0683d9, 0x3da29ebf, 0x3dcbe641, 0xbe2e39e1, 0xbd2d8dcd, 
    0x3df00efa, 0x3d950075, 0x3d353c52, 0x3e2e2608, 0xbdac112c, 0xbd7ad320, 0xbda521e4, 0x3d864cde, 
    0x3e1aa841, 0xbdc4a86c, 0xbce5d96a, 0x3d869eb5, 0xbc38591d, 0xbdbebb79, 0x3c7abefb, 0x3e1ad6d5, 
    0x3dd3b897, 0x3d1d2f79, 0xbc7c87bd, 0xbdfd6d36, 0x3d7b195e, 0xbdeaa2d7, 0xbe06ec2a, 0xbd79c812, 
    0xbdcebb28, 0xbdf4176f, 0xbe2cb9eb, 0xbdc94e94, 0xbe11ab71, 0x3db9bbcd, 0x3b955f08, 0xbe0d03bb, 
    0x3e1175ed, 0xbdff78d2, 0x3e1b6411, 0xbdc054ec, 0x3dfcf9f2, 0x3e082f8d, 0x3dee1043, 0x3de2a445, 
    0xbe2de9b5, 0x3c1b4bf6, 0x3d35b0f1, 0x3dd2c8e1, 0x3e253112, 0xbdb9120f, 0xbdbe08a8, 0xbdd4bdde, 
    0xbe0006ea, 0xba71c04d, 0x3d0e4609, 0xbe15697e, 0x3e02775e, 0xbe26a0ea, 0x3d203209, 0x3d2a8ffe, 
    0x3e28c5b5, 0x3e04d977, 0x3db5c783, 0xbb6ae6ba, 0x3c192189, 0x3d9e539c, 0xbe02d586, 0xbcdf15d3, 
    0xbd441582, 0xbdba5630, 0x3e20fec3, 0xbdc50523, 0x3d1632d5, 0x3cf57055, 0xbd96749a, 0x3e1e73a6, 
    0xbd53a4c0, 0xbe09e025, 0xbcc21d34, 0x3d838635, 0xbd9d11dd, 0x3cf8a41c, 0x3d456d31, 0xbdcba4fe, 
    0xbe12cd36, 0x3db2b40a, 0x3d832099, 0xbe0c959f, 0x3c41b73d, 0xbd75fd61, 0x3bea6cbf, 0x3e2c2bcd, 
    0xbe0283f0, 0x3d893368, 0x3c078dbf, 0x3dd9f12e, 0xbe091312, 0x3e296420, 0x3e1d3f46, 0xbe1088cb, 
    0x3b443685, 0x3df42125, 0xbd87036b, 0xbd83439a, 0x3e0d26ae, 0x3b63b05e, 0x3d6aa31f, 0xbd59c666, 
    0x3d76369b, 0xbe1b4592, 0x3d3d1d9e, 0xbd565900, 0xbe0ae221, 0xbe0b346c, 0x3a059ee5, 0x3c112f87, 
    0x3dc08f1d, 0x3e17f783, 0xbe290c84, 0x3d04d9ae, 0x3d2c3542, 0x3c347b78, 0xbd91b957, 0xbe0cf269, 
    0x3d9abee3, 0x3da9b41c, 0x3ceb6c1f, 0x3dd87673, 0x3d94e07a, 0xbd3fe321, 0xbd29a05e, 0xbdc9c427, 
    0x3db676ce, 0x3df3a3d9, 0xbdf48b66, 0xbdf56679, 0xbd1ab770, 0x3e356d7f, 0xbcd46ea7, 0x3d130012, 
    0xbc126030, 0x3cfae99e, 0x3d3dddfa, 0xbd843cf8, 0xbe15e91f, 0xbe0b1566, 0x3dccf3f1, 0xbe33715a, 
    0x3dbbdd4c, 0xbe2f2b6f, 0x3df57026, 0x3dd487e1, 0x3dcac369, 0x3e0aa2bb, 0x3df26d14, 0xbdece698, 
    0xbd83b525, 0xbe0f858c, 0x3e0d6f12, 0x3e25486f, 0x3d0a436a, 0xbe346d0b, 0x3db65072, 0xbd818a38, 
    0x3ddb6909, 0x3df03f4b, 0x3df26893, 0x3df2676d, 0xbdbf680f, 0x3df940ee, 0x3e2396d2, 0xbe118dc1, 
    0x3dc53f3b, 0xbdd941d5, 0x3d6114d3, 0x3d5e2cd9, 0x3d3b7f74, 0x3d9082fa, 0x3df87f7c, 0x3cbb0f67, 
    0x3e0d4cf1, 0x3dc7eadd, 0xbd385e95, 0xbd858e79, 0xbd681b68, 0xbde7dddf, 0xbde46e2f, 0xbd43103e, 
    0xbd8c00d5, 0xbd5f2177, 0x3deb47f8, 0x3e3a4cd4, 0x3d1b68df, 0xbb88de01, 0x3dcb3aaa, 0x3d64967a, 
    0x3d77d3ab, 0xbd6d0fdf, 0x3df2be57, 0xbda742a6, 0xbbac3677, 0x3dc7f070, 0x3dec1eba, 0xbddb31a7, 
    0xbcff371a, 0xbda77589, 0x3b32142b, 0xbc702d4f, 0x3d8469fa, 0x3e04b072, 0xbdaf7c85, 0xbdbc0463, 
    0xbdfa3a30, 0x3e21010a, 0xbc0493e4, 0x3e03dd0b, 0x3dafdade, 0x3e2e35f4, 0x3e2477a1, 0x3d4cf31a, 
    0xbe2b2d3f, 0xbe010761, 0xbe17209a, 0xbda038d1, 0x3dd198c0, 0xbd6813cf, 0xbe1bbab7, 0xbbbaa5bc, 
    0x3de3fd7d, 0x3d8070bd, 0x3e0085ee, 0xbc168e1a, 0xbd7dd8ff, 0x3e132c94, 0x3e19770e, 0xbdbcbc5c, 
    0xbdfe0069, 0x3cb3551f, 0x3de935d2, 0xbdaafb20, 0x3d962dc8, 0xbe24547d, 0x3e1596f9, 0x3e1b5c4d, 
    0x3d53a87b, 0x3adf75e5, 0xbca92f70, 0x3dbaa509, 0xbe13ef0b, 0x3cb401f2, 0xbd560ed2, 0x3cea42a9, 
    0xbd563fee, 0x3e18c8a8, 0xbe172af2, 0xbde9732a, 0xbb5f46d5, 0x3d1e2e65, 0xbe1b47d6, 0x3d279731, 
    0x3e1b802b, 0xbe25806c, 0x3de75f4d, 0x3d4c480d, 0x3dc90cee, 0xbd7a15a9, 0x3e0a427c, 0xbe2e8540, 
    0x3e33e6f7, 0xbe0b8bec, 0xbda72094, 0xbd9e8fc9, 0x3e0c905f, 0x3d40b06d, 0xbe20381f, 0x3cc8802e, 
    0x3d8b1ad9, 0xbcf5e95a, 0xbd45cace, 0xbcd34a60, 0xbd2d3b33, 0x3d9fd23b, 0x3e1c9ecd, 0xbe245a34, 
    0x3cfaff97, 0xbe121c73, 0x3de93822, 0xbc66f338, 0xbd10a881, 0x3e319aae, 0xbb3f3245, 0x3e273584, 
    0xbc9378f6, 0x3d56801f, 0x3e017ece, 0xbbe9be94, 0xbddbfe0f, 0x3da206a1, 0x3e13241f, 0xbd3a8614, 
    0x3e248000, 0x3db87111, 0x3d49f608, 0xbd39307f, 0xbdd0be7e, 0xbe1722fd, 0x3cd3d131, 0xbbbf93a5, 
    0xbe0a04ec, 0x3d8c6806, 0x3d068b39, 0xbdc21842, 0x3da7c03f, 0x3cc742e7, 0xbd38da4a, 0x3dffa491, 
    0xbddb3059, 0xbe0287f3, 0x3cadb711, 0xbd1c2845, 0x3d088f0d, 0xbc2a7878, 0xbe374806, 0x3d216892, 
    0xbc4ee3e4, 0xbdf77761, 0xbd257872, 0x3da3251a, 0x3d8f234c, 0xbcb41f60, 0x3db13d76, 0x3db74419, 
    0xbd63baf2, 0x3d9927c1, 0xbd9f0f05, 0x3e0b6d0c, 0xbda359da, 0xbe27ca97, 0x3b91d667, 0x3df808ea, 
    0x3cb5bd4d, 0xbc6a5c5a, 0x3e25a977, 0xbda52cd7, 0xbda183c6, 0xbd0def1d, 0xba91c53b, 0xbcb4b54b, 
    0xbd630853, 0x3e19f1b3, 0xbe2247e1, 0x3e054e74, 0x3dd54b60, 0xbd64adf9, 0xbdf57793, 0x3e03dd74, 
    0x3e3d87b1, 0x3e2897e4, 0xbe28dda3, 0x3dc95e35, 0x3d9302c2, 0x3e1d70db, 0xbd5df82f, 0x3d8cc741, 
    0x3d36a6b0, 0x3dc6dc22, 0xbc3d8284, 0x3d94bd8d, 0x3dcb5cc9, 0xbe3082f8, 0xbe1265d7, 0x3d965599, 
    0x3d5f85c3, 0xbe1f04c7, 0xbe060005, 0xbe05dfe7, 0x3e144654, 0xbe2fabbc, 0xbde7b6f2, 0xbdf13bba, 
    0xbe405408, 0x3d48ba52, 0xbe07c08f, 0xbe0411d5, 0xbdd0b4bc, 0xbb0c1511, 0xbcf4b695, 0xbdb1f192, 
    0xbd8b1e7b, 0xbd8e4f3b, 0xbdd9db3b, 0x3e1c2be4, 0xbe1fd38c, 0x3e2647d2, 0x3d45e11b, 0x3d1b00ea, 
    0x3db8f5af, 0x3d0cfb18, 0x3e080c60, 0xbd0fd95a, 0x3d012627, 0x3d0607b8, 0xbc831f12, 0x3e312b22, 
    0xbdf1d90c, 0x3d8a172a, 0x3d9b3ade, 0x3d93ef4b, 0xbcf19fb2, 0xbd89477e, 0x3e1be2f2, 0xbd3aa1ca, 
    0xbd83e642, 0xbe14b73d, 0x3e18f755, 0xbde6f759, 0xbd160932, 0xbdb012fc, 0xbc4028bc, 0x3e053cd5, 
    0x3d3d7934, 0x3cc081e9, 0x3d5db4e0, 0x3e0724f5, 0x3df0f5ca, 0x3d804c21, 0xbbc6d4df, 0xbe20ecc7, 
    0x3e33f858, 0xbddc617b, 0xbdb5fccb, 0xbdb71efa, 0xbd0d2bc8, 0xbe11bc19, 0xbdf1cae6, 0xbdf25d95, 
    0x3d451ad3, 0xbe28feb4, 0xbd3cd3c8, 0x3cb687f9, 0x3d76ecc5, 0x3e0073dc, 0xbd5dc244, 0xbe2ca9f8, 
    0x3d49d321, 0xbdb061ba, 0xbe2a3cf4, 0x3db71c34, 0x3de55199, 0xbdef8983, 0x3cec336a, 0x3d78439f, 
    0x3da2042c, 0xbdc29717, 0x3c43a765, 0x3c39d188, 0xbd041976, 0x3c0c463a, 0x3d70ad5b, 0xbe20520e, 
    0x3e25c414, 0x3df0b828, 0xbdf769ee, 0x3e0a82ec, 0xbe292a19, 0xbd5e15e2, 0xbde9e75b, 0xbe289c16, 
    0x3d5a69c2, 0xbda609d4, 0xbc148a98, 0xbdb22364, 0x3dfba2c9, 0x3e1918e4, 0x3d9d6d8c, 0xbd32ff77, 
    0x3de5a926, 0xbe2649ed, 0xbe195ddc, 0x3d5bd01b, 0x3d2c73c3, 0xbe0e15aa, 0x3defd6cd, 0xbdbc2357, 
    0x3e1f1e0f, 0xbda08dad, 0xbdd22006, 0xbd602682, 0x3df7e14b, 0xbe236c99, 0x3e228b04, 0xbb99bb64, 
    0x3e3661f2, 0xbbd9f779, 0x3daf56f7, 0x3dd40738, 0xbd365ce5, 0xbdea3443, 0x3d25e092, 0xbc7c6484, 
    0xbcd6d592, 0x3d55d6f7, 0x3c985693, 0x3e2b71b7, 0xbd18e4b4, 0x3e1c9fdd, 0xbdd2f210, 0x3d09f46d, 
    0xbca23feb, 0x3d8671a0, 0xbd98c277, 0x3dba2fac, 0xbcb60a78, 0x3e16fb35, 0xbe333943, 0xbdf346e7, 
    0xbe266737, 0xbd01f26f, 0x3d71bf00, 0x3bbf6ad2, 0x3e324fe4, 0xbde2fb17, 0x3d978788, 0x3c4ba410, 
    0x3e2c2d23, 0xbd5cb81c, 0xbd13af0d, 0x3def22a9, 0xbe316a94, 0x3e0630a4, 0x3e1a3f98, 0xbdeb4202, 
    0x3dd73e2a, 0xbd918185, 0xbda422df, 0x3d9f3a1e, 0xbcfb8b16, 0xbdb55a1b, 0x3e308db2, 0x3e2d63ba, 
    0xbdbbcc66, 0x3e09e18e, 0x3b4341f9, 0x3d212bf4, 0xbe0f483b, 0x3dae61fb, 0x3df1bc11, 0x3e255460, 
    0x3cee97d9, 0x3df2e577, 0x3da5620e, 0x3dbdb76d, 0x3da7f498, 0xbc5d1116, 0xbe30ba6e, 0xbe1c096c, 
    0x3e1815e6, 0x3c82bece, 0x3dbae0db, 0xbd32fe05, 0x3e282ab5, 0x3d3b2b4c, 0x3e129b97, 0x3d7403b0, 
    0xbd4fb2b8, 0x3dc5b859, 0x3bf6da37, 0x3dc35094, 0x3e0b58b9, 0x3df9dba8, 0xbdd20250, 0x3df20426, 
    0xb9ae9b96, 0x3e205ece, 0x3dce3c58, 0x3d6a6f20, 0xbd159893, 0x3d82a5e2, 0x3e248d73, 0xbdcb43b4, 
    0x3d8196ce, 0xbe1cb499, 0x3df8b9cc, 0xbda91ca4, 0xbcb0595d, 0x3df08076, 0xbdf62c52, 0xbe0417b6, 
    0xbdcfac23, 0x3d2726fd, 0x3e0233d9, 0xbcd67652, 0x3dbf1d24, 0xbd107147, 0xbd0d6590, 0x3da79700, 
    0xbc022498, 0x3d8653d9, 0x3e0dc91b, 0xbd88eb69, 0x3e1e289f, 0x3e1f27d7, 0x3d122b47, 0xbd35820e, 
    0x3e209f71, 0xbd14d65f, 0xbd1e3844, 0xbe178b3d, 0x3e306044, 0x3d3aaf3b, 0x3def58f0, 0x3dcf2e7a, 
    0xbdddefd2, 0xbc1cc2c5, 0x3dc0c7dd, 0xbde32c02, 0xbd80fc13, 0xbd834afe, 0x3daafb67, 0xbe2f67e9, 
    0xbe09d5c3, 0xbe02f2e9, 0xbe09f173, 0xbcd31760, 0xbda874ea, 0xbdcc3df0, 0xbe08ac80, 0xbceb7e68, 
    0xbdd50640, 0x3d6ca79c, 0xbd440c33, 0xbc6c00f7, 0x3e0d52ea, 0x3d9a0054, 0xbdbda05e, 0xbc194a91, 
    0xbd95feea, 0x3e13ac35, 0x3adb138a, 0x3c717805, 0xbd9c9618, 0xbd4b68ba, 0x3ca32f29, 0xbd8cb8a0, 
    0xbbb22ce6, 0x3e1c0832, 0x3e07037e, 0xbd09fd92, 0xbd01e45f, 0xbdbf27da, 0xbe15e813, 0x3d6b7101, 
    0x3d9b52c2, 0x3e0443fb, 0x3e0316e2, 0x3de67fc7, 0x3e0fbcb9, 0xbde62905, 0x3cf8fd7e, 0x3dea5ea1, 
    0x3dce0e0b, 0x3b324c0c, 0x3cf40c0c, 0xbcad8fa4, 0xbdb3efac, 0x3d80079e, 0xbd280ab6, 0xbdef2ae3, 
    0x3e036064, 0x3ce72ea7, 0x3d232244, 0xbc560e46, 0xbc35ce42, 0x3dc5c15e, 0x3d1a50ef, 0x3e1d64b5, 
    0x3d1e1fa6, 0xbd4a5342, 0x3b077e59, 0x3e0fc40b, 0xbe1421d1, 0x3e1add71, 0x3e11d2a6, 0x3df21559, 
    0x3e02aff8, 0x3ca88b25, 0x3e1f141f, 0x3b9f816b, 0xbd990259, 0xba4fe4fc, 0x3c80c9f5, 0x3e18df43, 
    0xbc8c08ef, 0xbcd1d756, 0x3d927b5c, 0x3ceebdb2, 0xbe2364f1, 0x3c652e07, 0x3dbfc4fb, 0xbe090a1c, 
    0xbde4b081, 0xbd449c79, 0xbdcb8803, 0xbde2305c, 0x3db03abe, 0xbdd5f164, 0x3e159733, 0xbe13ed4d, 
    0x3ded176e, 0x3d69d09b, 0xbc9b8320, 0xbd8b770d, 0x3d91e342, 0xbe0bd79e, 0xbe070536, 0xbdc251da, 
    0xbe33f037, 0x3dcbdaaa, 0xbe0b4096, 0xbdc95254, 0x3d9e2af0, 0x3d267e4c, 0x3da3b3c5, 0xbdb4db51, 
    0xbdd1d541, 0x3dd557e0, 0xbda8103f, 0x3c999edc, 0x3d938c80, 0x3e319a83, 0x3dcf3a4b, 0xbd1f51c7, 
    0xbd66cb22, 0xbde1e5fc, 0x3e305415, 0x3d8873c1, 0x3dd4d1bf, 0xbd2e704d, 0x3db28013, 0x3d259172, 
    0x3e0e884d, 0xbd99af4a, 0xbcbbaed6, 0x3dd2da7a, 0xbda325b9, 0xbdabe1f1, 0x3dd209c2, 0x3db71ec6, 
    0xbe2d4165, 0x3da78299, 0xbe28471d, 0xbc9b0bdb, 0xbd09858e, 0xbe29052f, 0xbbb0787d, 0xbe3a9b0c, 
    0x3e2ca5b3, 0xbe1547de, 0xbe2ed0f4, 0x3dda7445, 0x3e187b07, 0x3ce2cbce, 0xbd4bccce, 0x3e0179b8, 
    0x3d7af57b, 0x3df2213d, 0xbcac7af7, 0xbe0ab17a, 0x3e10714b, 0xbda9a8a0, 0xbd16216e, 0xbd3d4cb3, 
    0x3e01d389, 0x3d9e2265, 0x3db8cac6, 0x3cfc6d3e, 0x3db8d734, 0x3c0ebe77, 0x3e034929, 0xbe1729eb, 
    0xbd0d1646, 0xbd46405d, 0x3dd2a3a6, 0xbdad5d02, 0xbe1989a7, 0x3cf59098, 0x3e006b16, 0xbc03b7fa, 
    0xbd0be8ae, 0xbe2b09e6, 0x3d9c7939, 0x3db52b45, 0xbe2bb7c6, 0x3dd2799f, 0xbdbfa07e, 0xbcd6809d, 
    0x3bdf580e, 0xbe2eaa4d, 0xbdc7bc5a, 0xbe14b2f8, 0x3e22cb52, 0x3e2cb4d7, 0xbdde10fd, 0x3cdf28a3, 
    0xbdae7744, 0x3dc6be8a, 0x3db0d3b0, 0x3d7b7eea, 0x3ca29537, 0x3e339a7d, 0xbdef381b, 0x3dd0aa09, 
    0xbe2dcb6b, 0xbe06273d, 0xbd1a9c4d, 0xbe0a7eb9, 0xbdf90d02, 0xbd1f8375, 0x3e0f6782, 0x3e25ccd8, 
    0xbe1d919c, 0xbd1c1971, 0xbdb5bdec, 0xbd9a085e, 0x3ce1dbcb, 0xbc9f7df1, 0xbe0bf3e7, 0xbe0716c5, 
    0x3ce440af, 0x3d197933, 0x3e2b8ad3, 0xbce51acc, 0x3d7da126, 0xbd077101, 0xbd9b2a56, 0x3db9022a, 
    0x3d2f4a63, 0xbde8bbf3, 0xbdd77e20, 0xbbacb7ec, 0x3ddbd066, 0xbe149e57, 0x3dbe988a, 0x3e10608f, 
    0xbc91a700, 0x3e2dd81b, 0x3de98d06, 0xbcc2cb67, 0x3e00edf3, 0xbe0071e0, 0xbe291c69, 0x3dcbcf78, 
    0xbc8ef4ad, 0x3c3a7f01, 0x3dabab7e, 0x3e04f59d, 0x3d40d552, 0xbe29498f, 0x3dae4764, 0x3d807044, 
    0xbc049ce9, 0x3d6b1dfd, 0xbd495d1a, 0x3d2ace2b, 0x3d5617d6, 0xbe2d310e, 0x3df4b7f9, 0x3c20edff, 
    0x3e0d38d4, 0x3d8a5d1d, 0xbdefaa1d, 0x3e0f86b3, 0x3ddce4e2, 0x3de39664, 0xbe0cb44a, 0x3dfa4eb3, 
    0xbcd00980, 0xbda80417, 0x3dfbd2ee, 0x3e0b4b43, 0x3e1e44d3, 0xbb915e5b, 0xbd9291c9, 0xbc92b700, 
    0xbe18fd17, 0xbd7ba0b3, 0xbe249588, 0x3c6d5d29, 0xbc879ca4, 0x3e1805c1, 0xbcd2c017, 0xbd83d740, 
    0xbe26269c, 0xbe161909, 0xbdc2f1c0, 0x3d7eee54, 0xbad3a429, 0x3e255f0d, 0x3db8c184, 0x3d189ba8, 
    0xbd1b8c1e, 0xbe196711, 0x3e265f63, 0xbd83db5f, 0xbda26310, 0x3dcddfdb, 0xbdc82a38, 0x3dd902fd, 
    0xbabfa377, 0x3e23806f, 0x3d917f19, 0xbe1f20e5, 0xbda8dff6, 0x3d943666, 0xbd83e929, 0xbd0e4c49, 
    0xbe003925, 0xbdf662cd, 0x3d27d181, 0xbd3df58e, 0x3d95cdb7, 0x3decfec7, 0xbe13a81f, 0x3d581baa, 
    0x3e342d50, 0x3db099ca, 0x3cfcd8b0, 0x3e1baf9e, 0xbc705726, 0x3cd62a35, 0x3cb2c6c5, 0xbda1029f, 
    0xbe1aa402, 0xbd5690d4, 0xbd2e2697, 0xbd8f1630, 0x3e28902e, 0xbe0fb6e8, 0x3dab3552, 0x3cfd5e73, 
    0x3e013f64, 0xbc5ceee2, 0x3e343ee4, 0xbd00ed20, 0xbdd1545d, 0xbe347694, 0x3e0c7e45, 0x3d46e4bc, 
    0xbe197368, 0xbd174ac6, 0xbe33463e, 0x3e0ce477, 0x3e1aeb50, 0xbdfed6c9, 0x3c3f8ad6, 0xbe2be249, 
    0xbd2b7058, 0xbe2941cf, 0xbc89cbf7, 0xbd800e2f, 0xbd300fa6, 0xbde91cd5, 0x3d923cad, 0x3dace93c, 
    0xbdc3ce25, 0xbe17204c, 0x3be64736, 0x3e0b2fdf, 0xbe169628, 0xbd5c33f7, 0x3df8a3eb, 0x3e190ba7, 
    0x3ca6c010, 0xbd60eec8, 0x3bdd7752, 0xbcda1bdf, 0xbda60112, 0x3e1b17f5, 0x3cb979a5, 0xbdf1057d, 
    0xbe17dd5f, 0x3c944131, 0xbdc4514f, 0x3e1f5e92, 0xbd81d96c, 0xbe20e3f6, 0xbd892496, 0xbd9036b0, 
    0x3e0cb4c2, 0x3c842810, 0x3d92226f, 0x3d03bf0e, 0xbd1dda98, 0xbe2a2a78, 0xbdf2a583, 0xbda33947, 
    0x3ccae8e5, 0xbda26e10, 0x3b8d4fd6, 0xbd0d3632, 0xbd3588e6, 0xbdf2a31a, 0x3e0674e8, 0xbdfbe473, 
    0xbc8c5ac8, 0xbd15a781, 0x3d9d3ed1, 0xbd6e4e37, 0xbde32312, 0xbd3e9634, 0xbd321383, 0xbde6c8f1, 
    0x3de3d4f1, 0x3d473e9b, 0xbe08030b, 0xbd0ee385, 0xbdca8d8d, 0x3e37454c, 0x3e024897, 0x3d31de60, 
    0xbd26ee2f, 0x3e29157e, 0x3dd8f30f, 0x3daf70cf, 0xbdaf8fce, 0x3ce39566, 0xbb29857f, 0x3db3022d, 
    0x3d4a1f11, 0xbd98205f, 0x3e0a6d84, 0x3e0b1b88, 0x3cba1d28, 0xbd50d675, 0x3e1a1cb8, 0x3cdea59d, 
    0x3e232200, 0xbd680882, 0x3dbacf64, 0xbe2029b8, 0xbce803bf, 0x3db61b8a, 0x3db7e281, 0x3d88b28e, 
    0x3cb1beb8, 0xbdf022f0, 0x3c5b6034, 0x3dc161bd, 0x3e011bf9, 0x3da32f00, 0x3df44cfa, 0xbca67196, 
    0xbd9cfee3, 0x3e09e06b, 0x3cefa07d, 0xbd6d3292, 0x3d517d5f, 0x3e1e5210, 0x3df38e9a, 0x3dcbb312, 
    0x3e100a44, 0x3d6978af, 0x3d8e9386, 0x3d797c34, 0x3e0c210b, 0xbdd0af12, 0x3dd2ff85, 0xbcef9d34, 
    0xbd430a0d, 0xbe27fcae, 0xbe0e32e8, 0xbda8aaf5, 0x3dc8b3aa, 0xbd77a5bd, 0xbdc256b4, 0xbd9a5c50, 
    0xbdccb692, 0xbe1ed932, 0xbcb8bc5d, 0xbd4b8780, 0xbd387b79, 0x3d614e50, 0xbd421594, 0x3cbd2341, 
    0xbbaf0692, 0xbe18d38b, 0xbd902bcd, 0xbca97a39, 0xbe39b307, 0x3dd1ddfa, 0xbd1414f5, 0x3d11660c, 
    0xbdf5ae64, 0xbe1bacaf, 0x3e26dda0, 0x3db883c9, 0xbd430820, 0x3dd512f7, 0xbe2367d5, 0xbdddbb06, 
    0xbdb7f4ef, 0x3b1a9702, 0x3dad0995, 0x3d8b845c, 0x3de778f2, 0xbe1f6628, 0xbc98cb8b, 0x3cfd0f6a, 
    0xbe1ce845, 0x3e143f3a, 0x3d17640a, 0xbcf26811, 0x3bc51930, 0xbd67636a, 0xbdade45e, 0x3da84664, 
    0x3d98c3ca, 0xbe38d6e8, 0xbce17fef, 0x3d7b2c30, 0xbcb36621, 0xbdad9b5a, 0xbe032098, 0xbe1008ca, 
    0xbe1cb93b, 0x3dad8022, 0x3d9cecd8, 0x3e277a11, 0xbd6b8a1f, 0xbb5575ed, 0x3e06518d, 0x3e0cda93, 
    0x3e144fd2, 0x3b09e434, 0xbddc889a, 0xbdfc4f89, 0xbdc87873, 0xbe187922, 0x3d222bcf, 0x3db91f75, 
    0x3d91553b, 0xbe031c76, 0x3d32e991, 0xbe073232, 0xbcca8535, 0xbcfb0fc5, 0xbdf9a12e, 0xbdd78df7, 
    0xbe051d26, 0xbd678fd1, 0x3cee9be6, 0x3dfba650, 0xbdb2086a, 0x3d8f509f, 0xbe28d5d5, 0x3dd4091f, 
    0xbcb5f322, 0xbc98455f, 0x3dded16c, 0xbe1b07d2, 0xbe125731, 0xbe272f97, 0x3da7b336, 0xbb3b1578, 
    0xbd0b9981, 0x3c8a1e00, 0xbd0d2bc4, 0x3d8e2e88, 0xbdd256bd, 0x3db6552f, 0x3e16155c, 0x3e04ed50, 
    0x3b99d6fc, 0xbd9acffc, 0xbd8056b6, 0x3d66b751, 0x3cfa4e1f, 0x3da04fab, 0xbcaf99bc, 0x3df6bd53, 
    0x3e1675ea, 0x3e02ea80, 0x3e2acd71, 0x3e0ec05f, 0x3e2fa210, 0x3e0da2ed, 0x3c6729a1, 0x3d9fb339, 
    0xbe3aa7dd, 0xbe21c6ef, 0xbd60ba2a, 0xbe33afe4, 0xbb177e0f, 0x3e09c73c, 0x3dfed65a, 0x3dd9e774, 
    0xbca3e098, 0xbdcd243b, 0x3df94d6c, 0xbd8c173f, 0xbd980e5e, 0x3d1e3779, 0x3d9694c3, 0xbd9028ba, 
    0x3de44159, 0x3d8ee92f, 0xbdea6ed1, 0xbe2e85f5, 0x3dfa0926, 0xbdb04ec9, 0xbd609433, 0xbd444333, 
    0x3cb0252f, 0x3dc4abfc, 0xbdbc79b7, 0x3bcdcd40, 0xbddfcb68, 0x3d87fa36, 0x3d9dc5bd, 0x3e111ba4, 
    0x3e0a9dca, 0x3de12b39, 0x3c2989ef, 0xbd7aa6fd, 0x3e1669ea, 0x3e301ded, 0xbcf62e88, 0x3e012505, 
    0x3d6d9043, 0x3dc7e406, 0xbd5a7449, 0xbd90d461, 0xbdc81cc2, 0x3ddc9e00, 0x3e360825, 0xbe23bd86, 
    0xbd82d3ca, 0xbd8bcb77, 0xbe0e58bb, 0xbe13f2f3, 0x3e11d602, 0x3e0666db, 0xbde83646, 0x3db8da01, 
    0xbe1a7e65, 0x3e1574d4, 0xbe05c177, 0x3d92abbe, 0x3d1f0fdf, 0xbe028637, 0x3e2e1122, 0x3cb2839e, 
    0x3e0824af, 0x3e2903a7, 0xbd612558, 0xbde7a933, 0xbdd09908, 0x3b3c9145, 0xbd28252c, 0x3d52d8df, 
    0xbd2595aa, 0xbdc37d31, 0x3d6d4e5e, 0x3b1b53e4, 0xbdb9d62d, 0xbdcc37f7, 0x3de33981, 0x3dcefdc1, 
    0x3da661a5, 0x3b7acfa7, 0x3d5b86ff, 0x3d189f63, 0x3cf4a90c, 0xbe1d860d, 0x3d9f569d, 0x3c5163e5, 
    0xbd0ed753, 0x3da2395b, 0x3db4c3e6, 0x3d375af4, 0x3d9aaa01, 0x3d15b5b1, 0x3e1153f9, 0xbbcc5147, 
    0xbe061185, 0xbc5145aa, 0x3e01ca7b, 0x3d3470cb, 0x3e0c1d0f, 0xbdfbdc25, 0xbd9c6fe0, 0x3cc4be13, 
    0x3df0c9db, 0xbde88fac, 0x3de37b35, 0x3e2ccc33, 0xbe0ec5fd, 0x3d14ebe0, 0xbe231415, 0xbdd3d58e, 
    0x3e1aecff, 0xbe28ac9a, 0xbdede85e, 0x3e2098e0, 0x3bdcf640, 0xbe089ad4, 0xbd26d362, 0x3dd8f606, 
    0xbcb771ef, 0xbde757d8, 0xbd289c94, 0x3e02173c, 0x3cb5bebc, 0x3d01ade8, 0xbd6acea3, 0x3d163042, 
    0x3dd15329, 0xbcfb08d2, 0xbe27fd55, 0xbe021948, 0x3e018852, 0xbde426dd, 0x3caaca18, 0x3cdf4cd1, 
    0xbdc48466, 0xbd8f4b48, 0xbcb7cbc6, 0xbd3c74a0, 0xbcab3b4c, 0x3e093c53, 0x3d83a7a0, 0x3dcdba5f, 
    0xbdcac609, 0x3e06cecb, 0xbe1837c4, 0x3c3c6382, 0xbddbafd2, 0xbd95da67, 0x3c4be2e1, 0x3e0d816d, 
    0xbe292585, 0x3e2b14ad, 0xbdc1845f, 0x3e20df4e, 0xbd37f490, 0xbb36bbfe, 0x3d098942, 0x3e0ca1f2, 
    0xbe1273f3, 0xbe321be2, 0xbd9f0ec5, 0xbe21f294, 0xbd381297, 0x3e1da8d6, 0x3e3882ca, 0xbdf00821, 
    0xbdb69ac2, 0x3cc60932, 0x3dd36060, 0xbe2aa016, 0x3dbd93bb, 0x3e2352ab, 0xbe2303a9, 0x3df5fda3, 
    0x3d78d62b, 0x3ddca96a, 0xbdf11db8, 0xbdeb87f8, 0x3e00babd, 0x3e009aa4, 0xbd90fe64, 0xbdd648dd, 
    0xbda68d4e, 0x3e0c44cf, 0x3d925595, 0xbda76c8e, 0xbdaca645, 0xbd3704f8, 0xbc5fafb8, 0xbd611c84, 
    0x3e000c22, 0xbe1862d8, 0x3d62e658, 0xbe2f78ec, 0x3b3b7314, 0xbd7dcaf7, 0x3d590f69, 0x3e112831, 
    0xbd390fa7, 0x3e02a027, 0xbde58d9e, 0x3d77cdb4, 0x3d7ab859, 0x3d27bfc9, 0x3e19dc43, 0x3dfaf446, 
    0xbc4c79f7, 0xbd00c7d1, 0xbda9e85d, 0xbe17c4df, 0x3dadfb2f, 0xbde744bf, 0xbd10c0c0, 0xbd11a942, 
    0xbd33cf8c, 0xbdb59b89, 0xbe134d73, 0xbcd8d6db, 0xbd1d799e, 0x3dd575fb, 0xbdb36d47, 0xbcf35e26, 
    0xbbc10245, 0xbc959f1e, 0xbcaaf4fb, 0x3e220e21, 0xbe31323c, 0x3ce7340f, 0x3d185d10, 0x3e32c415, 
    0xbdd47d9e, 0x3d8deeff, 0xbd87ed7e, 0xbe128506, 0x3e044486, 0x3e19eece, 0xbd644b7f, 0xbdb38c88, 
    0xbe1dcc0f, 0x3e19b1b3, 0x3ca70067, 0xbd11376d, 0xbe1db96e, 0xbdb04b48, 0x3dde3601, 0xbdf64209, 
    0xbe09e1ab, 0x3dd5f1f0, 0x3db97353, 0xbdb97dca, 0xbb9d3886, 0x3daf144d, 0x3de9b53e, 0x3e26d85d, 
    0x3de59261, 0xbd763548, 0xbcdbb5ad, 0x3dbb894b, 0xbe2f9db4, 0x3ddbb9c1, 0xbcb3021d, 0x3df7ee30, 
    0x3cdca970, 0xbdcb839d, 0x3e15ee09, 0xbd926fe1, 0x3c24165f, 0xbd16f90b, 0xbe0cb498, 0x3cb5d370, 
    0x3db775be, 0x3930db14, 0xbd355572, 0x3d8732c2, 0xbce8cece, 0xbdf96c2e, 0xbdb5e7ee, 0xbd67f619, 
    0xbde10c3d, 0x3c8ce4b3, 0x3c04ced4, 0xbb344f17, 0x3e39cf8c, 0x3b236e3c, 0x3e2a6b07, 0xbe0f77c0, 
    0x3d208345, 0x3cf421f5, 0x3e357ce8, 0x3d0a625e, 0xbe27a77e, 0xbd38cdbf, 0xbc8bbf57, 0xbdf0773a, 
    0x3deeb575, 0x3d917ab3, 0xbdaab799, 0x3cdc71e1, 0x3aca92f0, 0xbe037f4e, 0x3daf9e0e, 0x3e0e3207, 
    0xbdef8805, 0xbdd0ffb2, 0xbcb2fd81, 0x3dc7c4a4, 0xbe271b75, 0x3e2f0532, 0x3e1f8506, 0x3e121c23, 
    0xbcb432bb, 0x3e1d84bf, 0x3d509e80, 0xbe0bb717, 0x3d5a28ff, 0xbe333c51, 0xbe078745, 0x3dd19f0e, 
    0xbe107402, 0x3e088891, 0x3dbeb813, 0x3e1e03a5, 0xbd019fc7, 0xbe29cc10, 0xbd9917a2, 0xbd66df0f, 
    0x3d2f0155, 0x3ddedf81, 0x3e2ce2c3, 0xbdb53665, 0x3cbf6c6c, 0xbe19edc8, 0xbdba9625, 0xbd97ea34, 
    0xbd853b38, 0x3e0d4c5f, 0x3d6d608e, 0x3de15876, 0xbe2242db, 0x3e1b5585, 0x3d535391, 0xbe275c51, 
    0xbdd8e51b, 0x3d1a6fa1, 0xbdba4f5e, 0xbb14984c, 0x3e18771f, 0x3e27dddb, 0x3e1b25e8, 0xbcccdb66, 
    0x3dcdd7a4, 0xbe0f98e3, 0x3e17840d, 0xbe1693db, 0xbdd39fe2, 0xbc3ba4b7, 0x3db2a38b, 0xbe16185f, 
    0xbdf18071, 0x3d86e511, 0xbc1c77f5, 0xbbe5ac5b, 0x3d4b9ed3, 0xbd8bbca7, 0xbdd42389, 0xbe02f858, 
    0x3d9d1561, 0xbd345a69, 0x3da35815, 0xbd9855b4, 0x3b858002, 0xbc166173, 0xbb86ca90, 0xbe1ac6b1, 
    0x3e1a29b8, 0xbdf23dd3, 0xbd540b85, 0xbdfacbe3, 0x3e22f355, 0x3de052d6, 0xbd894f11, 0x3d0dfecb, 
    0xbd3dac4b, 0xbd5b8319, 0x3aa9f09e, 0xbd104fb5, 0xbe168b1a, 0x3d9ccbf6, 0xbdfc2a23, 0x3e26bfc8, 
    0xbe20360a, 0xbe2b1c15, 0x3d3ee44e, 0xbe2f7b38, 0xbe03aaa8, 0xbdda0c40, 0x3e015cd4, 0xbe076ae2, 
    0x3c437250, 0x3d196068, 0x3db670cf, 0xbd97a75f, 0xbd98eed8, 0xbe02b43d, 0x3d72d7ef, 0x3d3a4fd8, 
    0xbd4078ba, 0xbc20f002, 0xbb5aa6ff, 0xbe1d543f, 0xbc3e85c9, 0x3e237c29, 0x3cb47a73, 0x3db40156, 
    0x3ca01e77, 0x3d9fa0b1, 0xb9eee779, 0x3cccba26, 0xbd811359, 0x3d9d9744, 0x3e00e707, 0xbd7ab66e, 
    0xbe0c6ef1, 0x3d95a60c, 0xbb046f49, 0x3e2b9d9f, 0x3d937432, 0x3dc74e69, 0xbe0f9768, 0xbdc9d10e, 
    0x3db0abf1, 0xbdddd6d9, 0xbd82dc00, 0xbdfb470f, 0xbdc882a9, 0xbdb7790a, 0x3e1f9d55, 0xbde67145, 
    0x3e00a4bf, 0x3e048636, 0xbe1fc3c0, 0x3db43812, 0xbe2df2bb, 0xbd4ff783, 0xbda7f31f, 0xbe1e51f9, 
    0xbd58a00a, 0xbd2d6aa4, 0xbca3001e, 0xbdeadd80, 0xbcc4577b, 0xbd09d98f, 0x3e133382, 0x3e094619, 
    0xbde087c5, 0xbd4da9b3, 0x3c314de5, 0x3de9fa7d, 0xbdf11095, 0x3e34416c, 0xbd1c7120, 0xbe243727, 
    0xbe165985, 0xbd34f232, 0x3e021f74, 0x3d96efce, 0xbe03bfce, 0x3dc85044, 0x3cc841e1, 0xbdd7fafa, 
    0xbc90aeb6, 0xbcbaed4d, 0x3dc21848, 0xbe330431, 0x3bbe7b39, 0x3dcacd2b, 0xbc87087e, 0x3dd58013, 
    0xbe1fa9a2, 0xbcd703e7, 0x3e05ac67, 0xbdc71006, 0xbd9c51eb, 0xbd4a12ad, 0x3dab2b35, 0xbd7c2381, 
    0xbd086a65, 0x3e3070d1, 0xbcaa0c1e, 0x3df8b04b, 0xbd6bf549, 0x3d029af4, 0x3ddfb0b2, 0x3e14aa46, 
    0xbd9a6fe5, 0xbe0d0c96, 0x3cd7b00a, 0x3d6d1a08, 0x3e2786c6, 0x3e284776, 0xbd4f77f6, 0xbd87aecc, 
    0x3b8c8874, 0x3e33746c, 0x3e060357, 0x3dbfdf49, 0x3e0ae69a, 0xbe2366d3, 0x3d961b3f, 0x3de44b0f, 
    0x3c0e26b5, 0xbcfdc936, 0xbd7a3f4d, 0xbe243891, 0xbde777fd, 0x3d8c0cd9, 0x3d8406a9, 0x3cf43ce7, 
    0x3e2e1612, 0x3cff4c01, 0xbddfb94d, 0xbd988a76, 0xbd433d0e, 0xbdceea03, 0xbca0f46d, 0xbd09b39f, 
    0xbd8c8ba9, 0xbd94506e, 0x3e2302e5, 0xbd22c019, 0x3ddc6413, 0xbd2f9737, 0x3db76c42, 0x3cb314d1, 
    0x3e2b6342, 0x3e1bea9c, 0x3dec351a, 0xbd109f85, 0x3d6553d1, 0xbddfb55b, 0x3e1d7538, 0xbc31113f, 
    0xbe12092e, 0x3e26ad71, 0xbd677c7a, 0x3e0d8bac, 0xbd82632e, 0x3dcef9ec, 0x3d854bc8, 0x3d964c9a, 
    0x3e240fac, 0xbdf46ad3, 0x3d503804, 0xbd3ba19c, 0xbce7c4c3, 0xbc85a4a1, 0x3d9f5a1a, 0xbdbb29b7, 
    0x3db17b05, 0xbcc060fa, 0x3d76aa29, 0xbe0ce233, 0xbd938067, 0x3d2fa8ae, 0xbdc6311a, 0xbd30f75c, 
    0xbd995f1e, 0xbdcca12d, 0x3ccdc2e9, 0x3e369313, 0xbc5168b6, 0x3d4d1258, 0xbb59f032, 0x3d13c4f9, 
    0xbd1c8b1b, 0x3e2f26c9, 0x3d3b9bef, 0xbdfb2469, 0x3de334a7, 0xbe25e487, 0x3ddbc7ee, 0x3e2048b6, 
    0x3d8e9da9, 0x3e2c5fa8, 0xbd9ba6bb, 0xbdd73ab1, 0x3d89a60c, 0xbdb47913, 0xbe0e6cc9, 0xbd88f900, 
    0x3d483538, 0xbdbf4b81, 0x3c31506c, 0x3c89ecee, 0x3d6a10f5, 0xbe27e5e0, 0xbd86696a, 0x3e2cf615, 
    0x3cb6ef63, 0x3d1900e7, 0x3d9cd75a, 0x3d33a755, 0x3d5d70a2, 0x3e21e1a0, 0x3d1178d5, 0x3c44d016, 
    0xbca4b833, 0xbd013991, 0x3d76df94, 0x3dfc422f, 0x3da62a64, 0xbdccea8e, 0xbd22d91c, 0xbe0e603f, 
    0xbe076536, 0x3c72cef6, 0x3e2ee35d, 0xbd8414ea, 0x3daed7f0, 0x3dbca765, 0xbda89260, 0xbd8f0f6c, 
    0xbdb1b98f, 0x3de4906a, 0x3e079b0b, 0x3e242a4f, 0x3bd8c95e, 0xbe20579e, 0xbe1e39c2, 0xbe2a89e3, 
    0xbe2188b8, 0x3e0f6b49, 0x3e21623b, 0x3db1d0ec, 0x3db77137, 0x3dcd0540, 0x3b511e6a, 0xbd02d51f, 
    0xbdb80124, 0xbd91d3e2, 0xbd3a0cf6, 0xbcb3d069, 0x3e019a70, 0x3e172a76, 0x3dce4bc2, 0xbdbfe478, 
    0xbe11a93c, 0x3e36eff5, 0xbe2018b3, 0x3e20fbb5, 0x3dd0ddaa, 0xbb1291b2, 0xbde98af3, 0xbd293421, 
    0x3e2c7c62, 0xbda02075, 0xbcf7dc01, 0xbdc6c2e0, 0x3e08ec59, 0xbe090f74, 0x3dadab73, 0x3e1622dd, 
    0xbcbf88dc, 0x3da56c23, 0x3e1ea02b, 0xbd13c3ab, 0xbda3d1c4, 0xbe2663bb, 0x3d72f63a, 0x3dcec4e6, 
    0x3defae60, 0xbd5c6032, 0x3d54d2e1, 0xbd764ea3, 0x3c600076, 0x3d008c17, 0x3d6148f9, 0x3bd2f1a3, 
    0xbe1a62c0, 0xbe05461d, 0x3e2b74cd, 0x3db67d12, 0x3c5fe184, 0x3df865e6, 0x3d51659c, 0xbd8983ed, 
    0xbab8131e, 0x3dbc6c14, 0x3cde4fac, 0xbd2c95b9, 0x3d7197a6, 0xbd24e59e, 0xbe1b2653, 0x3e21c00c, 
    0x3de04253, 0xbd13f03c, 0xbdf08931, 0x3dfb53dd, 0x3d0a11a3, 0xbbd01ef1, 0xbcfa5126, 0x3c98d39d, 
    0xbdebeef2, 0x3ba5e3be, 0xbd8a3467, 0xbdaa2169, 0x3df70366, 0xbd6c7a75, 0xbdf36ffe, 0x3dfe5f43, 
    0xbe31d0f2, 0x3dbbf560, 0xbe2d8563, 0x3e2eaaaf, 0xbde2c9d7, 0xbd2a4dcb, 0xbdf88565, 0x3cfd8b12, 
    0x3e1c4821, 0x3d662c70, 0x3cd9fa7e, 0x3bade2f2, 0x3e2589be, 0x3e01bc79, 0xbde3b11c, 0x3e2409a8, 
    0x3e3810d8, 0xbde86d91, 0x3dd36cc6, 0xbdf6c404, 0x3db0e84a, 0x3dcd081f, 0x3e0f37c7, 0xbdcfcfaa, 
    0xbd0c734c, 0xbd6ff5e0, 0xbdc69ea5, 0x3e0c6899, 0xbd498c03, 0x3db1fe4f, 0x3dab6ac2, 0xbdc9fae9, 
    0x3e16a40c, 0x3e0f44de, 0x3c37fc54, 0x3b75f904, 0x3db0fa1f, 0x3e078b13, 0x3d70def7, 0x3e085e2c
};

static const uint32_t _K33[] = {
    0x3fe1aaf0, 0x402c4fc5, 0x40071c84, 0x3fc77e35, 0x40698aca, 0x40023fa1, 0x3ffb0de7, 0x403a0fb4, 
    0x3fd78ca3, 0x3ff245b0, 0x4033bef6, 0x400aeba4, 0x401e8542, 0x3fbbb1c4, 0x3ffd9585, 0x40464450, 
    0x40260fb7, 0x400416fc, 0x3fbee009, 0x4003b19c, 0x400eb80e, 0x402c49cf, 0x3ffcd896, 0x4015fd04, 
    0x401eb528, 0x4002e8ab, 0x40455e9f, 0x40313ce5, 0x400a26df, 0x3f871831, 0x40260bd1, 0x4024fed1
};

static const uint32_t _K34[] = {
    0x3e366124, 0xbe93bf10, 0xbec1af4c, 0xbdd7a4e2, 0xbe4a3510, 0xbf5a0e77, 0x3f175866, 0x3fb14144, 
    0x3eb96689, 0x3e94aa58, 0xbede91d3, 0x3f6df8c6, 0x3cb70288, 0x3f04414f, 0x3e26a7ce, 0xbf6a4c36, 
    0xbe5fd557, 0x3f3eb5eb, 0xbe94ef68, 0xbeccfa5b, 0xbf8ad85c, 0xbf7c47e5, 0x3f09e210, 0x3e377bf9, 
    0xbfa5617e, 0x3ed86f5f, 0xbf3b6ed9, 0x3ed7527d, 0xbcb8cd3b, 0xbed633b5, 0x3e6bdbe9, 0xbe8c9432
};

static const uint32_t _K38[] = {
    0xbe2b0e6a, 0xbc9fc2f6, 0x3d2c7e18, 0xbdea78b7, 0x3d2f5ea5, 0x3d53867a, 0x3db31f22, 0x3e2f56fe, 
    0xbe16eeb9, 0x3e054ff5, 0x3e11658d, 0xbd8bb296, 0xbce8b3ed, 0xbd9b6273, 0xbe0cf1c8, 0xbd0dfafd, 
    0x3e2587d6, 0xbd9cb594, 0xbd5aad8e, 0xbd039d78, 0x3c7fa6e6, 0x3e27a1e4, 0xbe17630a, 0x3e233b15, 
    0xbdefbbea, 0xbe3b3fcc, 0x3d89ed38, 0x3da13f63, 0xbc74ee05, 0xbe1eff6f, 0xbbee1031, 0x3e2482ee, 
    0xbe33feaa, 0xbda1718b, 0xbe099249, 0x3d6fd432, 0xbd2f1c78, 0x3e343e73, 0x3d488cfb, 0x3d1a9b40, 
    0x3d1dd46a, 0xbde1a226, 0xbcf382f5, 0x3de64f49, 0xbdefb56a, 0xbcf49cd4, 0xbdbfb323, 0xbe2ed86c, 
    0xbe00dbb7, 0xbe22544f, 0x3e23ec69, 0x3e0bb66e, 0xbe1b144d, 0x3db1e343, 0xbe150b74, 0xbdf721a4, 
    0x3d4fd708, 0xbd40ac50, 0xbd2ac337, 0x3d446b2b, 0xbe1f17db, 0xbd1011d8, 0x3e16e540, 0xbd74be50, 
    0xbe10a6f6, 0xbdf21c26, 0xbbb95246, 0x3c2a36a0, 0x3d350988, 0x3ccde4e3, 0xbd82c701, 0xbd872315, 
    0x3e249ae4, 0x3d22489c, 0x3d25aead, 0x3ce25516, 0x3de47dfe, 0x3cf0fdad, 0xbd3d5e77, 0xbc7a37ce, 
    0x3d7eb57c, 0xbdf9fa24, 0x3d8f8029, 0xbdc2f7ad, 0xbd03dccb, 0xbdd0f4ae, 0x3e1d7545, 0x3dc68899, 
    0x3de8a28b, 0xbddddaa0, 0xbb2f4fdf, 0xbe27feb2, 0x3c829290, 0xbe012fa7, 0xbe0aa691, 0xbbacc044, 
    0xbdf28ec9, 0xbcd4848d, 0x3c08d918, 0xbe04f16e, 0x3e0393db, 0x3da06aa0, 0x3e057db1, 0x3dee6d9d, 
    0xbd403700, 0xbe2a2618, 0x3dfc0546, 0xbbc56f11, 0xbe3cc2fd, 0x3d9f8dc5, 0x3d85152d, 0xbe1c4da8, 
    0x3c9c3307, 0x3e34a44f, 0x3e2d87e0, 0x3daa35ad, 0x3dc9aa2e, 0xbdcf3f45, 0x3b4dfe49, 0x3dec67f6, 
    0xbda5dee7, 0xbe2c7aab, 0xbd33e764, 0xbc7ea6cf, 0x3df103ab, 0xbbb9b7ef, 0x3d908442, 0xbe175c2c, 
    0xbe1b5322, 0x3e270ab5, 0x3e0ea7ed, 0x3e08a67a, 0x3cc03b1c, 0xbd845503, 0xbdd67c29, 0x3d1853db, 
    0xbe262d2d, 0xbe0b7985, 0x3db01b33, 0x3e213cd5, 0xbc7ea43a, 0xbdbd1779, 0xbe048cc8, 0xbad0cd7e, 
    0xbdf8c15d, 0x3e310938, 0x3e032dd9, 0x3db395dc, 0xbd851f2a, 0xbd8be733, 0x3da3b959, 0xbd81142e, 
    0xbe2e4e8e, 0x3e2797d8, 0xbcbf4ce8, 0xbdd855aa, 0xbdde0200, 0x3e2bc83f, 0x3e1314bd, 0xbc23871e, 
    0xbd74454c, 0xbe246a23, 0x3cc363c8, 0x3dcdfd94, 0x3cb270f6, 0x3e0a2337, 0xbdee0753, 0x3df0e292, 
    0x3e0dd602, 0xbd96b1c7, 0x3d8764ec, 0x3d66e744, 0x3ddb9b6b, 0x3df1b046, 0x3e052131, 0xbda49fb7, 
    0x3e04f239, 0xbe09ca41, 0xbcd7344f, 0xbdeec48b, 0x3dea9ecc, 0xbcd681fc, 0x3e16780b, 0x3e00cefa, 
    0xbdbd2984, 0xbd318e0f, 0x3b01d546, 0x3dbdccd1, 0xbdc3ccfb, 0x3c68fc70, 0x3c8b426c, 0x3d701fc3, 
    0x3e01c1ab, 0xbd004728, 0x3dae95b0, 0xbd4c670e, 0x3e0709be, 0x3b8e1e18, 0x3e1062a3, 0x3e2d0e5b, 
    0x3d4a924e, 0x3cc027ef, 0x3e221a62, 0x3c9383db, 0x3d2b5f87, 0xbcc7fbfa, 0xbd8915e3, 0xbdf13dea, 
    0xbe25bae1, 0x3d84f2ea, 0xbe195ad8, 0x3d4ed44b, 0x3e1d0a4b, 0xbd4e56cb, 0x3d6cf4cd, 0x3e188bc1, 
    0x3cc9421e, 0xbdeee392, 0x3e046f1d, 0x3b8014a1, 0x3e2cef7d, 0x3caae972, 0xbddbcd0a, 0x3d12c7a6, 
    0xbdf14ec2, 0x3cde3dfc, 0x3db0048a, 0xbdeec14d, 0x3d889081, 0x3d64b766, 0xbdd6397f, 0xbda65230, 
    0x3c9f2c28, 0x3e1e3ca8, 0x3c937a67, 0x3ddaa0fa, 0xbdc05a46, 0xbdbf63a5, 0xbe0452ae, 0x3b9e4423, 
    0xbd44f433, 0xbe2e20c9, 0x3d496aa6, 0x3da4f24e, 0x3bb44fa2, 0x3d9ed86b, 0xbe2c6a78, 0xbe336a88, 
    0x3d5c55b9, 0x3e02648b, 0xbb951a0f, 0x3e028ba6, 0xbb4d6f05, 0xbdc9a9ec, 0xbd62b9d5, 0x3a9c801b, 
    0x3dcafd5e, 0x3c0b4d42, 0xbe31891a, 0x3bb71d59, 0x3e2714d4, 0xbdef9832, 0xbdd68808, 0x3d427172, 
    0xbdbb5413, 0x3db4619b, 0x3dd3b3a1, 0xbd51a74b, 0xbdf7e278, 0xbd54531b, 0x3e10b17b, 0xbdd7effe, 
    0xbe096e6a, 0x3e0e3bd2, 0x3d60de11, 0xbe30597f, 0xbd905ae3, 0xbe012b64, 0x3da205ca, 0xbe32dbfa, 
    0x3dc86442, 0xbc9981f1, 0xbcf3222d, 0xbc477011, 0x3dce3f14, 0x3df32a4a, 0xbe0674e0, 0x3e111377, 
    0x3c93cd02, 0xbe2df943, 0x3c8d518b, 0x3dbbc95a, 0xbdab0779, 0xbe05a6c7, 0xbc1f684d, 0x3b7bbe1d, 
    0x3e0943e8, 0xbe31c7cf, 0x3de1e062, 0xbdbe1072, 0x3e17051e, 0x3dc046f1, 0x3e1d866d, 0x3d50d22e, 
    0xbd384ace, 0x3cb57108, 0xbdd22d82, 0xbe0c52db, 0x3e23a811, 0xbdcf2b0c, 0x3dee42ce, 0xbe0c4b3e, 
    0x3e0e99a3, 0x3df2c71e, 0xbe25095a, 0x3c881c9e, 0x3d8e3fd0, 0x3d6b424b, 0x3e06166e, 0xbe046c10, 
    0x3dadb076, 0x3c80f6e2, 0x3d947c6c, 0xbe03be1c, 0x3d9e70c6, 0xbd0f5ca2, 0xbdcd6fac, 0xbe1e36a1, 
    0xbc20c29d, 0xbc811ff7, 0x3e33a032, 0xbe39014b, 0x3da296b2, 0x3d90ae66, 0xbda407c3, 0x3d7e34f7, 
    0xbd70a19b, 0x3e11fdae, 0x3d1764f4, 0xbe003744, 0xbd8e22e1, 0xbdff2d1f, 0xbda6d342, 0x3d6a7a97, 
    0x3c9540d6, 0xbd0e0dce, 0xbcec292c, 0xbd4158b2, 0xbdcdd186, 0x3e04a6e5, 0x3e147202, 0xbd8f71d0, 
    0xbdd524dc, 0x3d1e6b52, 0xbcaadf6e, 0x3cfa4578, 0x3dc0312d, 0xbe1dbfeb, 0xbe2cf996, 0xbe22b9b9, 
    0xbd21c518, 0xbdc8c814, 0xbbb17578, 0xbda8893d, 0x3d8b2b91, 0x3d17e2c0, 0xbe157e3f, 0x3d8e2efb, 
    0xbdcb0354, 0x3e267edd, 0xbe3070cb, 0xbc241900, 0x3c7eeb6b, 0xbdb973cd, 0xbe20ece4, 0x3e39a481, 
    0x3dce46b1, 0x3d204016, 0x3cf157aa, 0x3e30ce04, 0x3e1fcfcb, 0xbde61dd7, 0xbbac70a7, 0xbd4dc715, 
    0xbce3d4de, 0x3d7eb8db, 0xbd302e97, 0xbe042576, 0x3d2dfd70, 0xbd4e4030, 0x3dcfd684, 0x3dfe4168, 
    0x3da0e412, 0xbd1489dc, 0xbd79c0c9, 0xbbd50d0a, 0xbe0299e3, 0x3d6471fd, 0xbdbf70cd, 0xbdce91f0, 
    0xbda66b19, 0x3ddd0f30, 0x3c936804, 0xbd333ecb, 0xbc21baac, 0x3d88c3fa, 0x3c0b66a5, 0x3dabd01b, 
    0x3e0da059, 0xbe2426ea, 0xbdea36f9, 0x3e03b726, 0x3d293187, 0x3c88d6c1, 0x3d9dc184, 0xbe094a39, 
    0xbe0a50c0, 0x3cae4790, 0xbcc7e977, 0xbd83aff9, 0x3bf684c3, 0xbd0b30bb, 0x3da19561, 0x3e199d55, 
    0xbd01378e, 0xbdaf54a3, 0xbd920150, 0x3e1f93cd, 0x3de0bf31, 0xbe25b8e8, 0x3e1b2795, 0x3e31726b, 
    0x3d8b0f4c, 0xbd6ff7fb, 0x3e2b6609, 0xbd612191, 0xbe21961b, 0x3dacaa19, 0x3e0f5f23, 0x3d55f0fe, 
    0xbcad52c1, 0xbd6feaf0, 0x3de784a1, 0x3df56d9d, 0x3e028fc7, 0x3e1cb09a, 0x3d02e6a4, 0xbe218d58, 
    0x3dbe6336, 0x3dff6234, 0x3d9dedd0, 0x3ccf331a, 0xbe1598cc, 0x3e171f86, 0x3d5a770b, 0x3dcd0b75, 
    0x3e0ea6a4, 0x3df56f10, 0xbd58baaf, 0x3d83cb87, 0xbdd9cf5b, 0xbe178ff1, 0x3dec2244, 0xbe1bb964, 
    0x3dbdff77, 0xbd006dc2, 0xbddf8f4b, 0x3d97a99d, 0x3cf73d82, 0x3e08a4a3, 0x3e1d4739, 0x3dc22b58, 
    0x3d6f355c, 0x3dbb7f15, 0x3d3a6222, 0xbd2fa232, 0xba303326, 0xbd08759c, 0x3e363df8, 0x3ddbda12, 
    0x3d0e83ab, 0xbd7d9a10, 0x3d596b21, 0xbd87bf28, 0x3d73211e, 0xbda4a8ad, 0xbd3de4de, 0xbded3c47, 
    0x3c5f547c, 0x3d017eba, 0x3e0d4d15, 0x3e0558ea, 0x3d82c7a5, 0x3e1d054d, 0xbda66314, 0x3dd8dfe6, 
    0x3da04f4c, 0xbdd1606e, 0x3cecd340, 0x3db3dcfb, 0xbdee941d, 0x3d9e4ab4, 0xbd4df336, 0x3d6d31b0, 
    0x3daa21b7, 0x3dee35e5, 0xbe1891d0, 0xbc35cdf9, 0x3d7ea0e3, 0x3d5203a6, 0x3da2b682, 0xbb07cbd1, 
    0x3d7b2271, 0xbd83b121, 0xbc2b7437, 0x3c93b3f2, 0xbda9da8b, 0xbd17d5b5, 0x3de150b7, 0xbd3356f7, 
    0x3d0c52ea, 0x3d617c36, 0xbc10766d, 0x3b1b207c, 0x3dac89bc, 0xbcc1cc2b, 0xbd098b8e, 0xbe0227e8, 
    0xbc3ca930, 0x3e20f132, 0xba87bb70, 0x3df8c37a, 0x3d662efc, 0x3df7dbea, 0x3d3e6dbe, 0x3c9c930e, 
    0x3d034e83, 0x3e0bb034, 0x3e2aa565, 0xbce94d61, 0xbe35b948, 0xbe19c3a0, 0x3cf2d03e, 0x3bee9446, 
    0xbdf79ed8, 0x3d5e77b7, 0x3de7d6e6, 0x3e256385, 0xbde1219e, 0x3e20902a, 0x3e24130e, 0xbd9f78b4, 
    0xbdfd4231, 0xbe055f23, 0xbcb098bb, 0x3c4be339, 0x3dacb7bc, 0x3e2ee757, 0xbc8e7b2a, 0xbdc42834, 
    0x3e136656, 0xbdd86672, 0x3e1463aa, 0x3e1114ce, 0xbdba93c1, 0xbd624d3b, 0x3e37d00b, 0xbd8d7f2b, 
    0xbe2f2b74, 0xbca13d19, 0xbe285515, 0x3e3c7894, 0x3d0de0cf, 0xbdd4eef9, 0x3dd1e2d9, 0xbe2ab885, 
    0xbde5f8d4, 0x3de1c6e8, 0x3bb7821c, 0x3cd6c853, 0xbda500bd, 0xbe185d7f, 0xbdf2123a, 0x3aba80a6, 
    0xbde4f7b0, 0x3d90cb29, 0xbe282471, 0xbd4da216, 0x3e02d2be, 0xbccea6e1, 0x3e11baaf, 0x3db92588, 
    0x3e2cb14c, 0xbd5e62d4, 0xbdce012f, 0xbe304f80, 0xbc796603, 0xbe0d20cd, 0x3cf04ef6, 0x3df61ec6, 
    0xbdc5ed46, 0xbe21c045, 0x3e00fff0, 0x3cf917f4, 0xbdfdd244, 0x3e297dc0, 0xbe2286fa, 0x3dfaba7f, 
    0x3d3e942a, 0xbe3a76f3, 0x3a5fb31b, 0x3cadfd13, 0x3c8a8ff6, 0xbd51bd49, 0xbe282e48, 0xbde5fbd6, 
    0xbd3aab3b, 0x3d2a7b69, 0x3d9a6889, 0xbde792e6, 0x3d484d2b, 0xbd34b9a8, 0xbd6b7277, 0xbd1479eb, 
    0xbba87d7c, 0xbe337b41, 0xbddc3db1, 0x3de3a8f6, 0xbdfc29e5, 0x3d661900, 0xbd1f083f, 0x3d90d557, 
    0x3dcea61e, 0xbdbe2fe2, 0xbd9a057d, 0x3d033c7c, 0x3e147a8a, 0xbdfbf3a0, 0x3de2ce3a, 0xbafa8e5a, 
    0x3d0c0834, 0xbe09d3d6, 0xbe077ab8, 0x3d30b946, 0x3c05965d, 0x3d1c1970, 0x3ca6c2eb, 0x3dfc97f9, 
    0xbe0eb351, 0xbe247c8a, 0x3b069848, 0xbe06c802, 0xbd67f3d4, 0xbe2a355e, 0xbda95fd4, 0x3cd5932a, 
    0x3e1eae1c, 0xbe0c37f7, 0x3e2a08c8, 0xbe34b7d6, 0x3aa83c10, 0x3c8bf908, 0xbe184d8c, 0x3de6951c, 
    0x3e2b9223, 0xbe104f93, 0x3b2c8e6a, 0x3caaeab2, 0x3d3cbdf4, 0xbd4eda7c, 0x3dcfa6ef, 0xbd2b07f6, 
    0xbd40f9b1, 0x3da5a31d, 0xbd90be73, 0x3e04dec0, 0xbb8a86b3, 0x3d5111fd, 0x3e192c3f, 0x3e2d5de3, 
    0x3d9511a2, 0x3d9346d9, 0xbe00ada8, 0xbe19e901, 0x3e377f8f, 0xbda8301c, 0xbd981c4c, 0xbd3cce9d, 
    0xbd2c9265, 0xbdda8961, 0x3d4111c8, 0x3d2ff09c, 0xbd5251b3, 0xbe06c8db, 0x3d91e043, 0xbddf885c, 
    0xbc6d4a12, 0xbdd8ec76, 0x3b18d5d9, 0x3d903a4b, 0x3e064205, 0xbcbb0c35, 0x3ca2a697, 0x3d8459f9, 
    0x3e1f046f, 0xbdffa20b, 0x3e314874, 0xbc7ab904, 0xbd95b8f1, 0x3df336a2, 0x3d8613b5, 0xbe2ab63a, 
    0xbd59e515, 0x3e240f65, 0x3d87db81, 0x3c850060, 0x3d1429ba, 0xbcdf54e9, 0xbd5d35ae, 0xbdd1a614, 
    0xbca60116, 0x3d36d338, 0x3dcd19f5, 0xbe10e86e, 0x3c9ba2af, 0xbde8e641, 0x3df07c6c, 0x3db8d41c, 
    0xbdf6e58c, 0x3e292b94, 0x3c9ae95a, 0xbde1282e, 0x3d5b1133, 0x3d5146a6, 0x3c8a87b1, 0x3e36aa06, 
    0x3e123626, 0xbe15071b, 0xbd37700a, 0xbc203aaa, 0x3e0ff2a8, 0xbdc9ab3f, 0x3e079e76, 0xbde96222, 
    0xbe32794b, 0x3d56aab1, 0x3d6706e5, 0xbda0ccd8, 0x3a9bfece, 0xbe225071, 0xbd3a41ee, 0x3bc48b63, 
    0x3e331a3d, 0xbd0cf166, 0x3c8bc127, 0xbde743d6, 0xbe01fc6d, 0xbe236bd1, 0xbb921cb5, 0x3df26324, 
    0xbd783cc3, 0x3d717bfa, 0x3e1b6554, 0xbdb530ee, 0x3d5fc2b1, 0x3d7cff36, 0xbdd0a6da, 0x3b5edef5, 
    0xbd0eb276, 0xbd272aa4, 0xbdfba5d2, 0x3e156bb0, 0xbe0148a0, 0x3e389f2d, 0xbd2e09f6, 0x3e2434d9, 
    0x3d40357f, 0x3e1621b0, 0x3dc4b3f8, 0x3e202ecc, 0x3d7fe07a, 0xba5887b7, 0x3d76046f, 0x3e18e0df, 
    0x3a002bed, 0xbd875b87, 0xbd50a5a0, 0x3d55b75d, 0xbd8bc852, 0x3d5d1c5c, 0xbe06395a, 0xbb74349b, 
    0x3d769a88, 0xbe042fab, 0xbdb59b8c, 0x3dd568b7, 0x3d0ff682, 0xbd2f4b4b, 0xbc8c9b2b, 0xbe1e815b, 
    0x3e1a1779, 0xbe0df798, 0x3c3e7c0e, 0xbe12795c, 0x3e315c02, 0xbdbe3ae0, 0xbc439acd, 0x3da779da, 
    0xbd8ac122, 0xbc38e8b1, 0x3dddf410, 0x3daac8e9, 0x3d8133b2, 0xbdbf2f33, 0x3dfc96cb, 0x3d2f9dcb, 
    0x3e282939, 0x3d59d7b1, 0x3cddc14a, 0xbd209ba2, 0xbd838b55, 0xbddfa09c, 0x3deda668, 0x3e3e96a4, 
    0xbe0fe67c, 0x3da47811, 0xbde2e422, 0xbdffd920, 0xbd93c913, 0x3db0ff5d, 0xbdb34938, 0xbc0f2e5c, 
    0xbd128149, 0xbe2abdad, 0x3e232f31, 0xbd944ff5, 0x3e2cd231, 0x3d45cf30, 0xbe0d1276, 0xbcbd681f, 
    0xbdc0dc3b, 0xbd39e01c, 0xbd18e9b1, 0x3cf89586, 0x3df3447e, 0x3ddc5554, 0x3e17ff5a, 0x3df1bb7d, 
    0x3e217bb3, 0xbb796414, 0x3e01a0c9, 0x3df3aee5, 0xbd6b0260, 0x3db14cba, 0x3d7949f1, 0x3df4b022, 
    0xbe1147c8, 0xbe27d6a2, 0xbda8bd63, 0xbda76ea7, 0xbc9cc187, 0xbd576cbd, 0xbc8c137f, 0x3d99f82c, 
    0x3ddbf6aa, 0x3e22b9c7, 0xbde06d53, 0x3e13685e, 0xbc141097, 0xbe1b3638, 0xbd77a634, 0xbe329586, 
    0x3e21e334, 0x3ccf0635, 0x3d2fdeef, 0xbdf1cfb6, 0xbd8300ac, 0x3dd09587, 0xbda07339, 0x3dfd0246, 
    0xbe1d2015, 0x3e1f5490, 0xbd392f6a, 0x3dd4f3f0, 0xbd7318bb, 0x3d5630c1, 0x3e1cfd62, 0x3e10f41a, 
    0x3dbcfb50, 0xbd83d1c3, 0xbdab5678, 0xbb92b055, 0x3e01b757, 0x3d89396d, 0x3dcb365f, 0x3b33eac6, 
    0xbe313b54, 0x3e20c021, 0xbd4f2031, 0x3d07e4b5, 0x3d3169df, 0xbdb5be6d, 0xbc409433, 0xbd87210e, 
    0xbe1adf80, 0x3c8e9fc8, 0xbb48cde4, 0xbd9219f8, 0x3d5bd7f1, 0x3e06d41e, 0x3e0d17f5, 0xbde634a5, 
    0x3c5a8630, 0x3da416e9, 0x3e18c4a5, 0x3e0bfd94, 0x3d824264, 0xbe17095c, 0x3dc2db77, 0x3cf871c6, 
    0xbd57504c, 0x3e291611, 0x3e0890ac, 0x3cbd632b, 0x3cac1c63, 0xbe148f3d, 0xbca0be7f, 0x3dd9ee11, 
    0xbcb43aff, 0xbe37160e, 0xb9db56c6, 0xbd36bf1c, 0xbd626c83, 0xbe04427c, 0x3d072201, 0x3da2cc46, 
    0x3b8ba69a, 0x3e0b4a9a, 0xbe032544, 0x3d9eb47d, 0xbdd8aec9, 0xbe3799d7, 0x3df0610c, 0x3e1cc0b8, 
    0x3b80e76f, 0xbe11f220, 0x3c0f913c, 0xbd9cfc17, 0x3ceec9d3, 0x3c859ee9, 0xbd5a92d4, 0x3dbee7d1, 
    0x3c9619ff, 0x3e0313dd, 0xbd011be6, 0xbd85baf6, 0x3c3d38ef, 0x3d17f203, 0x3c6463b7, 0xbd44b8df, 
    0x3d833ccf, 0x3e2f3d2b, 0xbdda5faa, 0xbe22b775, 0xbe1c20da, 0x3d823ab2, 0x3db5901a, 0x3bd8ebc3, 
    0x3e028cf9, 0xbe1ef672, 0x3d7158bd, 0xbd2c658a, 0xbe22a7fd, 0x3db45bba, 0xbd8331ff, 0x3d7a3b0c, 
    0xbd90132e, 0x3d3c82f4, 0xbe2d4627, 0xbc823a33, 0xbd749f5c, 0x3dba267a, 0xbd5a195b, 0xbe127200, 
    0xbc590a9e, 0xbdaaa8ff, 0x3c15d6b8, 0xbd05ae8b, 0x3c16ded8, 0xbd7d72ed, 0xbdd5e7e5, 0x3db1fa9a, 
    0xbd16efc6, 0x3d74001e, 0xbe0e1701, 0x3e2f84c2, 0x3da75063, 0xbd236595, 0xbd069953, 0x3d62eb4b, 
    0x3e1d2cd3, 0xbdbe108f, 0xbdf147aa, 0xbc8b526d, 0xbd346044, 0x3d76496a, 0xbd46e81e, 0x3dedf81d, 
    0x3e01d5e4, 0x3d722389, 0xbda820e1, 0x3e07d6ec, 0x3d646b8a, 0xbe2523e0, 0x3dd0bdef, 0x3d061e28, 
    0xbc7caa59, 0x3d3f9fd4, 0xbda734d1, 0x3dc62144, 0xbde6ac5c, 0x3ddaa8d1, 0x3d032416, 0xbcfd2444, 
    0xbadaf57c, 0xbcbdba32, 0x3e24d9cd, 0xbcbd15c6, 0x3d9a569f, 0x3d8b8f7d, 0xbd6e5ba4, 0x3da59a83, 
    0x3e3554d3, 0xbd1656fd, 0xbe26f8ab, 0xbd29ae04, 0xbdbac868, 0xbd14ee41, 0xbdafa721, 0x3d932a74, 
    0x3ce00bd1, 0xbda5d26b, 0x3d92cea2, 0xbd6d7d4a, 0x3db3e14a, 0xbcbcbee6, 0xbdeb9ab0, 0xbcf82e42, 
    0xbdc3f9d4, 0x3ddd84e8, 0xbe0661c0, 0x3da2a1be, 0x3ca041c6, 0x3e33d4ba, 0xbd3f83ab, 0x3d16f6b1, 
    0x3d0881cf, 0xbd928d39, 0xbe0b0ed1, 0xbda069c0, 0xbe23e3db, 0xbd7f7d64, 0xbe2734cd, 0x3db98cba, 
    0x3ca98f82, 0xbdd0247c, 0x3b780348, 0xbcfc8b1e, 0xbe0179e7, 0x3cd65db9, 0x37df5fae, 0x3dbcbb42, 
    0x3e29bc3c, 0xbe01999a, 0x3de12852, 0xbd325715, 0x3d8a53f3, 0x3dc5e7b5, 0x3bc3de90, 0x3e144553, 
    0x3df70d71, 0xbdda58ed, 0xbc0b8cd8, 0xbe2c403c, 0xbcd56e89, 0x3e1eca83, 0xbe2d2215, 0x3d03f558, 
    0x3d88041f, 0x3d7d29e2, 0x3d877b52, 0xbe31fdc7, 0xbe11f1d0, 0xbd8c6b55, 0xbe30feaa, 0x3e2703de, 
    0xbe1fd516, 0xbdd36b50, 0x3cebe493, 0xbe2a4bd7, 0x3d87b08e, 0xbdaca6df, 0xbd29d82e, 0x3e1661ca, 
    0xbda9fb3e, 0xbe1f5a51, 0x3d23a47f, 0x3e00ce48, 0x3db746ec, 0xbe26777d, 0xbe16cd68, 0x3deb71bb, 
    0x3d930948, 0x3d6b8232, 0x3e0638af, 0x3e0b23e3, 0xbe2050ee, 0xbd911352, 0xbe09e8f6, 0xbd85c1d5, 
    0xbdc07379, 0x3b63b693, 0xbe0c90fa, 0xbd149de3, 0xbc1efa5d, 0x3e138810, 0x3e1b7b96, 0xbdf6c3f1, 
    0x3d01606d, 0xbca5acff, 0x3d338b00, 0xbe105209, 0x3d9150bd, 0xbe0b2927, 0x3e260539, 0xbdf9eb24, 
    0x3e0d3332, 0xbdce7f16, 0xbdd5c423, 0xbccd8a3b, 0xbd54c2f6, 0xbe09f167, 0xbdd84592, 0xbe24ae04, 
    0xbdc16cc7, 0xbd77dcd7, 0xbd50d874, 0x3d734228, 0x3e02cb98, 0x3e0695ec, 0xbdca5c5c, 0x3da2ed66, 
    0xbd0ade1e, 0x3dc4aac9, 0x3d621d8b, 0x3d1ed359, 0xbe0d5988, 0xbc50e192, 0xbe2a78cb, 0x3df7d6ca, 
    0xbdb5ec16, 0xbd87a34c, 0xbd198175, 0xbd7a48ae, 0x3d247913, 0x3d5b3b37, 0x3d832511, 0x3aefe7a4, 
    0xbd5f8f06, 0xbc7a4809, 0x3e2bbad2, 0xbe080df6, 0xbdf6d666, 0xbd08e317, 0xbe22934f, 0xbdc866b1, 
    0xbd375aec, 0xbdede4d8, 0x3c3ea87d, 0xbe1b59bd, 0x3d590806, 0xbc5d7bc5, 0xbdfd9065, 0x3c0ea8fb, 
    0xbc261cf7, 0x3e15bbbe, 0xbe2423db, 0xbe23680d, 0xbc03f986, 0x3e13d795, 0xbc371546, 0x3dcd9e7a, 
    0xbdab7171, 0x3cf43165, 0x3d3af306, 0x3da84fd2, 0x3e000107, 0x3d133a0d, 0x3d7069e0, 0xbe0c2e43, 
    0x3ddcfbcb, 0x3cd73d60, 0xbd5250ca, 0xbcfc078f, 0x3a70d0ec, 0xbdb9d444, 0xbd1ccd20, 0x3d074942, 
    0x3dd64619, 0xbc802fb6, 0x3d1ec738, 0xbc98581d, 0x3cdb1507, 0xbd05ba8c, 0xbe172d38, 0x3cb3af8a, 
    0x3dc51c22, 0xbd24d5ef, 0xbdc39523, 0xbc87c14d, 0x3d23d2a2, 0xbc5334ed, 0x3e2ff04d, 0x3d4840de, 
    0xbd6d58fb, 0x3c703b9e, 0x3d9725e7, 0x3d03546a, 0xbdcfbfb0, 0x3d45fd0e, 0xbbbb0efc, 0x3e00e1ea, 
    0xbd099710, 0x3dabb658, 0x3e34ce33, 0xbd86c9c0, 0xbdb34d5b, 0xbd181440, 0xbe00ed69, 0x3d596020, 
    0x3b2f5d79, 0x3e0bcc1b, 0xbde30fea, 0xbe13ac5e, 0xbb9336d1, 0xbd591d34, 0x3c5bef9b, 0x3e2ca997, 
    0xbdcb3ed8, 0x3c9d2a13, 0x3e054d50, 0x3deca1f3, 0xbc97e38a, 0x3e09b1eb, 0xbe1e7fbe, 0x3dbd491c, 
    0xbe272f98, 0x3df41b12, 0x3e08e23e, 0xbd56c7d6, 0xbd93663e, 0xbcc0d6c5, 0xbe22103c, 0xbdcce9e5, 
    0x3de955a1, 0xbdc81e48, 0x3c9971cf, 0xbdd7858f, 0x3d89774b, 0x3e2518ef, 0x3dc3db96, 0x3d599f0b, 
    0xbd0c7fbc, 0x3d24b936, 0x3dcc1fec, 0xbdb9c931, 0x3d62f1e5, 0xbe0688d3, 0xbdc1e528, 0x3d498c33, 
    0xbdf85b33, 0x3dbdbdf8, 0x3e0f18a6, 0x3e17a034, 0xbd92eae9, 0x3da76a51, 0x3c961861, 0xbe246aa1, 
    0xbc25460e, 0xbe1153c0, 0x3e0aca7c, 0x3e0992bc, 0x3d817731, 0x3c82f207, 0xbdfe2878, 0x3e344b35, 
    0x3d174c3c, 0xbd1edb6d, 0xbdea669c, 0xbd2e6094, 0x3c634471, 0x3dc32916, 0x3d0ff4f9, 0x3e1e69f4, 
    0x3d55b304, 0xbdebe124, 0x3d01b559, 0x3defb824, 0xbd977870, 0x3ca3b8e6, 0xbd919d05, 0x3dd6a4af, 
    0xbcbab2c8, 0xbd21ed71, 0x3d845f6d, 0xbe3d3478, 0xbe2295bc, 0xbd431ad5, 0xbdee1bcc, 0x3d65c62d, 
    0xbe03ebde, 0xbe323c34, 0xbda58642, 0x3e32add2, 0x3c800934, 0xbe262722, 0x3e2a66dd, 0x3de816d0, 
    0x3dee2169, 0xbd50667a, 0xbd9dbdda, 0xbce51792, 0x3e0b5184, 0xbd64f8d6, 0xbd992493, 0x3e2acf6c, 
    0x3c7e3828, 0xbddfa90d, 0xbe2bec97, 0x3e3e3eb3, 0xbe3138ff, 0xbe0e00c5, 0x3dad1fd2, 0x3d3e5d9c, 
    0x3e0d2353, 0xbd9561f2, 0xbe2a9964, 0x3d32d356, 0x3cd20170, 0xbe16c1cf, 0x3e1ccfbd, 0x3e0401a6, 
    0x3cfafc23, 0xbd22a6af, 0x3de1606e, 0x3c840921, 0xbdb58d9b, 0x3dbf5912, 0xbe1c4e0b, 0xbd24ddda, 
    0x3c844174, 0xbd73649f, 0x3e242b1f, 0x3e1b3ea7, 0xbd44ed30, 0xbd83a5c4, 0xbe01a2b0, 0xbdfb449a, 
    0x3e1d5038, 0x3def9130, 0x3dc008c3, 0x3e2c2822, 0x3e04eb2c, 0xbdc8095f, 0x3d4ac759, 0xbb3e9e21, 
    0xbe074ca3, 0xbdc82c30, 0x3e37b1ae, 0x3e2f205b, 0xbe009430, 0xbd238dec, 0xbdb54d57, 0x3e22969a, 
    0x3d21a701, 0x3df57f01, 0xbe349515, 0x3d807430, 0xbe040d55, 0x3dccbd1f, 0xbdedf1cd, 0xbe2f78bf, 
    0xbe111b22, 0x3a813eb2, 0xbc39ad4e, 0xbe0f5cf9, 0x3d894c72, 0x3e06ce22, 0x3c20e80e, 0xbd4f4572, 
    0xbe0eb181, 0x3e0ee97b, 0x3e02a102, 0x3c8c35c8, 0x3e297710, 0xbd5777bc, 0x3d7ef76b, 0x3d809534, 
    0x3ccfc800, 0x3d140ee6, 0x3e27c406, 0xbd8d1399, 0x3da0dfec, 0x3c3ea5a6, 0xbdf47c74, 0x3d256505, 
    0xbd941144, 0xbb20d524, 0xbe045b6f, 0xbdd50ee6, 0x3e26de6d, 0x3d1bd477, 0x3e2545ce, 0x3de6da15, 
    0xbac5deac, 0x3d061e80, 0x3c87d0bf, 0x3d4a0ef0, 0xbe28c8e6, 0x3db86092, 0x3e101fb9, 0x3da7d707, 
    0x3deab690, 0xbd349328, 0xbd8b1797, 0x3d4c6d2f, 0xbdf666f1, 0x3e20d86c, 0x3d814b61, 0x3e0f7fdf, 
    0x3d946a28, 0x3e0fe48f, 0xbe332cfb, 0x3e081c51, 0x3c466743, 0x3d786181, 0x3dd63a38, 0x3e1eb637, 
    0xbd1485c2, 0xbcb5c130, 0xbe10f1b2, 0xbe19aef5, 0x3d891651, 0xbda3b132, 0x3dfaeed8, 0x3cfd13a2, 
    0x3d559a42, 0xbdde65df, 0x3dbe4ad5, 0xbdebaaef, 0xbdda32ce, 0x3cfaaf37, 0x3de6eb20, 0xbcb75775, 
    0xbcc7c768, 0x3e124794, 0xbd8eeeeb, 0x3de91d1e, 0x3dd7a258, 0xbd674567, 0xbe288dd3, 0xbdd04bf8, 
    0xbd16f31f, 0x3e191f19, 0xbd41ffc3, 0xbd582c70, 0xbcdecaac, 0xbe0b9c83, 0xbdd73249, 0x3b9e1d34, 
    0x3db72e47, 0xbdfe654a, 0xbd1e4185, 0xbdb4c94f, 0x3db3d255, 0xbe276d74, 0x3e02743d, 0x3dc7f88d, 
    0xbce27692, 0x3e09fdd8, 0x3d90dc0b, 0x3c9f95ce, 0xbe262f36, 0x3db417c7, 0x3e288f65, 0xbdd20074, 
    0x3db0691c, 0x3d71456b, 0x3d9ca5c1, 0x3e188e56, 0xbda8c1ff, 0xbe0dbf5f, 0x3e184c63, 0xbd8d2d19, 
    0xbd37e25f, 0x3e2468e1, 0xbdbb3828, 0x3dd5d83b, 0xbd05d8d8, 0x3e222d1a, 0xbdc46193, 0xbe0cad8e, 
    0xbe24c87e, 0x3dc0eab0, 0xbe03167e, 0x3e38d8f1, 0x3df22ac6, 0xbe0630ec, 0x3d9e1647, 0xbc1e7db7, 
    0x3e1d09f0, 0x3d552861, 0xbd48fe1a, 0xbd0f940c, 0x3d4da275, 0xbe144fe1, 0x3e20424c, 0xbcf6ab85, 
    0xbd8b6184, 0x3cb95ee8, 0x3bd0aef8, 0x3dd21c8d, 0xbe0ffdaa, 0x3e07b4c5, 0x3de439fc, 0x3d05e80e, 
    0xbdea9ec3, 0x3dd70df6, 0x3e2e6009, 0xbda216a1, 0x3c5661bd, 0x3b30fbcc, 0x3d166894, 0xbd8f1ba3, 
    0x3cae8eae, 0x3e05815b, 0x3e074d3f, 0x3dbc9c03, 0x3d88dc52, 0x3cdf89c5, 0x3d9277ad, 0x3d7c8fd7, 
    0x3d0b35b0, 0xbd6e4092, 0xbd2fad66, 0x3b2c2bfd, 0xbd550ce4, 0xbded1fb3, 0x3c36aeb9, 0xbe293b81, 
    0xbe199b58, 0x3ccab640, 0x3d5bf72e, 0xbd8a1b9c, 0xbd5dba44, 0x3dc0c4ce, 0xbe02cd9b, 0x3da0339f, 
    0xbe2f2405, 0x3de5308e, 0xbd176324, 0x3deab595, 0xbdd5d8a9, 0x3e182c67, 0xbd757341, 0x3d089b03, 
    0xbe0605f7, 0x3da46f24, 0x3df3dd23, 0x3df9c860, 0xbde285e6, 0x3d782034, 0x3e0e7fd1, 0x3cfeb3db, 
    0x3d6d9a14, 0x3e0c4338, 0xbdf867a2, 0xbcc62145, 0xbd1dce46, 0xbe18dfa2, 0x3ccc1da2, 0x3dce6445, 
    0x3dc46600, 0x3cc7a6d8, 0xbe32b51f, 0xbd9b5489, 0x3dc0d09d, 0x3e2837f8, 0x3db87774, 0xbdc19134, 
    0x3d8f2048, 0x3d560809, 0x3d97c68d, 0xbdaf0e4a, 0xbd6bb5f8, 0x3dd1afd5, 0x3d929f56, 0xbd3f5664, 
    0xbdb3cfd1, 0x3da1f598, 0xbd2587af, 0x3b699261, 0x3dd7eae9, 0x3d90d20e, 0x3e0b8eee, 0x3de3c5bc, 
    0x3c88eef1, 0x3c316f46, 0xbda80ed0, 0x3e2e8013, 0x3dacaa26, 0xbdb4360b, 0x3e137f73, 0xbdee81c7, 
    0xbdad7de7, 0xbd2ae510, 0xbd1bd4ae, 0x3cd44b27, 0xbddb58cf, 0xbe30bae2, 0xbd455adb, 0x3d0f011d, 
    0x3e2fbad4, 0x3d51ef2c, 0x3bc06d4b, 0x3bd1c2c5, 0xbda2433f, 0xbdc4e4d7, 0x3e1595b6, 0xbe207fa5, 
    0x3e20a2d9, 0xbc07b1e7, 0x3d9787fa, 0x3d9fbc7a, 0x3d45a6d5, 0x3db45ec1, 0xbe20b0b9, 0xbdb18959, 
    0x3d38c114, 0x3dc45247, 0xbe24f06e, 0xbe238645, 0x3dcf1469, 0xbe345690, 0xbe1a58bf, 0xbdaab54b, 
    0xb9e68d2f, 0x3bff5400, 0x3ccb1714, 0xbccb3abb, 0xbdf4640e, 0x3baff9b8, 0xbd58a89c, 0xbdec5e83, 
    0x3d2229aa, 0xbc5438e1, 0x3d598454, 0x3e163bfe, 0x3da84d49, 0xbe20ad75, 0xbde31f60, 0xbdcf8f9a, 
    0x3e0939fe, 0x3d4b365d, 0xbd885bf2, 0x3e006ced, 0x3de92fee, 0xbe336d3d, 0xbe17bb59, 0x3d87cf8e, 
    0x3e2a6179, 0xbce7c30b, 0x3c3a2772, 0x3c553d0d, 0xbe228dc6, 0x3dd4991b, 0xbd7b26c7, 0xbdd7caf3, 
    0xbd1eb17d, 0x3dd2ba9c, 0x3dd9c68d, 0x3c89c1ac, 0xbc51c3b0, 0xbde86e9f, 0xbdefccfb, 0xbd9c3e45, 
    0xbc9e8f4f, 0xbddbc6dd, 0xbe0d56d8, 0x3d5c7f6d, 0xbde53aea, 0xbde548ab, 0xbdc1c93b, 0xbd9ba3a2, 
    0xbe21a993, 0x3d4122c8, 0x3e070a72, 0x3d2640dc, 0xbe0d104d, 0xbcf17a55, 0xbdc73186, 0xbde2fce6, 
    0xbd1257ad, 0x3e2d741e, 0xbc910909, 0xbbee50b3, 0xbda1b109, 0xbc4b44d1, 0xbdea353c, 0x3d177595, 
    0x3c7aeee5, 0xbd6148d3, 0xbbdf7a15, 0x3e160776, 0xbde85f45, 0x3e0c7e88, 0x3e152d1f, 0xbe1ffff3, 
    0x3d09fc05, 0xbcc9fd15, 0x3d6dc326, 0xbe21746c, 0x3ca66160, 0x3dd1c582, 0xbda4f5ca, 0xbe13bdf1, 
    0xbcb39008, 0x3de9173f, 0x3e005641, 0xbe0dbf7b, 0xbe214afe, 0x3d47ba58, 0xbe2888fe, 0xbde671a3, 
    0x3e119760, 0xbe1f19b4, 0x3d019285, 0xbd91479f, 0x3d880607, 0x3e264ff7, 0xbd863b67, 0xbc2ecc34, 
    0xbd69b2b2, 0x3db31602, 0xbded5d58, 0x3e22ac58, 0x3e1236b8, 0x3dc4aac1, 0xbd566651, 0xbdae82d7, 
    0xbb8694f7, 0x3d306180, 0x3ddbad16, 0xbdd2ebb9, 0xbc29f66d, 0x3de9dbea, 0xbdcd915e, 0x3d5dc1c2, 
    0xbd70e07a, 0x3e3821d5, 0xbe33471e, 0xbdc15e5f, 0x3e25a378, 0xbdda40d3, 0xbe0fb012, 0x3e053d77, 
    0x3de2e4dd, 0x3d51f785, 0xbe1ea2a2, 0x3e1a2393, 0x3ddb3d7a, 0x3dfb00f9, 0xbe2532f9, 0xbdcbc8d6, 
    0xbe08b7d4, 0xbd856515, 0x3db5183d, 0x3ddccb41, 0x3e2e9b59, 0xbd90de91, 0xbe0b9834, 0xbd0053da, 
    0x3d1c62f5, 0xbe0ebd3f, 0xbe112aed, 0xbdb052a7, 0x3e08a4b7, 0xbe0d3138, 0xbdbf0151, 0x3dd43a0b, 
    0x3de8c8fc, 0xbd200c94, 0xbe21764e, 0xbe143608, 0x3de6a65f, 0x3e041068, 0x3d7cd1dd, 0x3d0f516d, 
    0xbd79eb73, 0x3e1071c9, 0xbe12b449, 0xbe0d6ec0, 0x3e3335cf, 0x3e34e912, 0x3e28cb34, 0x3da38113, 
    0x3e2925ad, 0xbe2f3159, 0xbdb2bcaa, 0xbe1e2052, 0x3da87d7c, 0x3b84aaf0, 0x3e0a83c3, 0x3d4e3341, 
    0xbdfd07d6, 0x3e28d331, 0x3dc0e9f0, 0x3d0c880f, 0x3d7457c3, 0xbd1c9fcc, 0xbe2a8506, 0x3e37a7f7, 
    0xbe0f19c2, 0x3d373f75, 0x3dd354a4, 0xbd6e27a5, 0xbd95e413, 0x3e28ce03, 0xbc9716ba, 0x3db8ef8e, 
    0x3e0ca77a, 0x3de16a5e, 0xbe0c95a2, 0x3dbfce42, 0xbd592f1c, 0xbbcede72, 0x3dac0524, 0x3c057e92, 
    0xbd16029a, 0xbc822d6e, 0x3d15c458, 0x3d8f481d, 0xbdfec7d4, 0x3dfa9e9e, 0xbe06e78f, 0x3e1a3134, 
    0x3db3952e, 0x3e18905c, 0x3e0d2fb5, 0x3d4c0364, 0xbcd82ca6, 0x3d5f318c, 0xbd3d7a55, 0x3d8d26dd, 
    0x3d2f3cbe, 0xbc8dd6e8, 0xbe0b429c, 0x3e00ae85, 0xbde73721, 0xbdd9c91c, 0x3e12bd55, 0xbdb58bea, 
    0xbcf59ac7, 0x3dde617d, 0x3d1e0a7c, 0x3e29f084, 0xbc054e31, 0x3e232215, 0xbd9dd0e2, 0xbd7ab30b, 
    0x3bbfce5c, 0x3da870e6, 0x3e02914e, 0xbd575d37, 0xbc9f2e78, 0xbd876481, 0x3dde26cc, 0xbdd0395c, 
    0x3dccb525, 0xbe21a884, 0x3e28e6af, 0xbdc3c700, 0x3d8ee03f, 0x3e265c4c, 0x3d714fcd, 0xbd2a90cd, 
    0xbd8942a4, 0x3e019e3c, 0x3e0bf40b, 0x3dbbf372, 0x3e09cb62, 0xbe26d736, 0xbe28ac9f, 0xbd146060, 
    0xbdce2dc1, 0xbe293cf0, 0xbd5fdb63, 0x3e31ceb2, 0xbdf4cc48, 0xbdcb28bc, 0x3d2d3643, 0xbdd781e1, 
    0x3e2198a4, 0xbe05f859, 0x3e2ad572, 0x3db218df, 0x3de1f31b, 0x3e11ab34, 0x3dd0f609, 0xbdc3ed5e, 
    0xbd8d5107, 0x3c81481c, 0xbd8b3aca, 0x3d9e3b8f, 0x3d2c4f57, 0xbe27d68a, 0x3d39e3f8, 0xbd90c08a, 
    0xbd8a0ac6, 0xbdfde407, 0x3decd135, 0xbdfb839f, 0x3e1df561, 0x3e317e40, 0x3d078040, 0x3bcb7f95, 
    0x3e141ae2, 0x3dbabb90, 0x3d0d774b, 0xbcd6f7a1, 0x3a05ad38, 0x3df77b80, 0x3e175d00, 0xbdba1baf, 
    0x3cef1a22, 0xbc84d51f, 0x3e0abffc, 0x3e1403e2, 0x3c21ecde, 0x3d979bc3, 0x3dfaab15, 0xbd0799f3, 
    0x3e0c476f, 0x3e2834e0, 0x3e0a4abb, 0xbe08db0a, 0x3da8d663, 0x3c231b2a, 0x3df4ee05, 0x3b25d922, 
    0xbd1d2561, 0x3e220f44, 0x3e046fcf, 0xbd69e900, 0x3c1b5aa0, 0xbd1e0e8f, 0xbe2e5802, 0xbe22e05a, 
    0xbdef0d96, 0x3d6757d2, 0x3dc702ce, 0xbd72540e, 0xbd19745f, 0x3e230578, 0x3d3ff402, 0xbd0faf33, 
    0xbddceca0, 0xbe2e48b5, 0x3daf193b, 0xbe317fdd, 0xbda5fd51, 0xbc08b707, 0x3dbe6b2c, 0x3d4cb852, 
    0x3da8fb26, 0xbdb5b213, 0x3b46c4e5, 0xbb7c2db8, 0xbe209013, 0x3e040848, 0x3c1aa678, 0xbdb0130d, 
    0xbd956f1f, 0x3dde3b46, 0x3d3207ad, 0x3d0e697e, 0x3e036b76, 0xbd67a86e, 0x3dc26973, 0xbcdb37f5, 
    0x3dc8ca8c, 0xbe1969e6, 0xbd966f72, 0x3dfcacaa, 0x3ca0f2c8, 0xbe26f605, 0x3d8ac6d3, 0xbd54d006, 
    0xbc933ac0, 0x3c9fe627, 0x3e21b31f, 0xbc8581e6, 0xbe044792, 0xbd14fa11, 0xbd59cbd9, 0x3cf5715e, 
    0x3e29fb87, 0xbdb2cd8e, 0x3c8c3350, 0x3daf9490, 0xbe2ed939, 0xbc3b92df, 0xba4cb821, 0x3ce87a75, 
    0xbe160a25, 0x3e01a390, 0xbe323eee, 0xbd8bf39e, 0x3e3c2b41, 0xbcd406b0, 0xbd30ef65, 0x3d893783, 
    0xbe0a023c, 0x3ddd89f8, 0xbd8cb128, 0xbca994f4, 0xbe19f844, 0xbb3a297e, 0xbe25e6ca, 0xbde09e89, 
    0x3d86ebc0, 0xbcf71c08, 0xbc8f6df2, 0x3e003d2d, 0x3e163446, 0x3c568358, 0x3e3a3c8e, 0xbe14305b, 
    0x3cbb4fa3, 0xbe2c5a46, 0xbe3a33a9, 0x3de0013e, 0x3e2db060, 0x3cfba1cc, 0xbb1767e0, 0x3dae8e6e, 
    0xbda0df22, 0x3d4c14f8, 0xbd8f09f4, 0x3d68759a, 0xbbce379a, 0xbe350a62, 0xbd7e6a0f, 0xbe170651, 
    0xbe25957c, 0xbdd1681e, 0xbe0f0719, 0xbad6bda0, 0x3e2fe2c1, 0x3e310246, 0xbe24da50, 0x3e1123a3, 
    0x3e127cdb, 0x3d8952b9, 0xbde8a609, 0xbe0aff88, 0xbd13abed, 0xbda217b2, 0xbd2429e4, 0x3d8430c4, 
    0xbd06c5ca, 0xbdd318d9, 0x3e2497b8, 0xbe1153bf, 0xbe186283, 0x3e15bce7, 0xbbfe5f68, 0x3dc79399, 
    0xbdc6b6c9, 0x3e2b79e3, 0xbd8d97cf, 0x3dd76129, 0x3d60efc1, 0xbaaf8711, 0x3e30804f, 0xbcc5e8fd, 
    0xbcbae57b, 0x3dff3b33, 0x3d206de8, 0x3d501dd7, 0x3de02ce9, 0xbe2a6ca0, 0xbe2323b9, 0xbcd896c0, 
    0xbdb2b8f3, 0x3e2a95ff, 0x3d8b5a02, 0x3cc9ffaa, 0x3d9d3e38, 0xbdb56146, 0xbdf6ff30, 0x3dd00366, 
    0x3deec63c, 0xbdf7b840, 0xbd53ba9d, 0xbc39896b, 0x3d2f2acc, 0xbc2ecb02, 0x3d83f114, 0x3dbaa1d6, 
    0x3ddd449c, 0x3e26d2cd, 0xbe0f246f, 0xbe167b1a, 0x3e1eb0ab, 0x3dd65230, 0xbe20737e, 0x3cf4c088, 
    0xbdf4f218, 0xbd544833, 0xba337759, 0xbdd9f1c2, 0xbd6e0f0f, 0x3c8bad28, 0x3e1fd4f7, 0xbe1f1016, 
    0xbd05ac54, 0xbdad4eb8, 0xbda45e96, 0xbcea6c96, 0x3dbccc6e, 0xbe1b107c, 0x3e01afd9, 0x3e29468f, 
    0xbddf8fae, 0xbdaf3634, 0x3dc64b9b, 0x3e33a6ec, 0xbcfe710b, 0x3d988472, 0x3e0446e1, 0xbdb3dcf8, 
    0xbc8f7db3, 0xbdcd9e3f, 0x3e1f794a, 0xbe241185, 0xbd0c27c9, 0x3d2ded9b, 0xbcc7e10f, 0xbd5ae189, 
    0xbe1a5fe6, 0x3e01a29b, 0x3c8f172c, 0xbda0713d, 0xbc7c6d13, 0x3c149b05, 0xbe07383a, 0xbc762f91, 
    0xbd16ab9b, 0xbe0cdb91, 0xbd5226fa, 0xbdd9a8d1, 0xbdab94cc, 0x3dfaf556, 0xbdd02740, 0xbca2200e, 
    0x3b9bf08f, 0x3dce1c0d, 0xbd7fc0ce, 0xbe2008ed, 0x3cd11b3b, 0x3e1f18c0, 0xbd3863eb, 0xbd3ee6bd, 
    0x3d1aaf55, 0x3d82ad8c, 0xbe1fc223, 0xbd0bf93d, 0x3e2e53de, 0xbd702d9c, 0x3d06e6e3, 0x3e13ea4b, 
    0xbd330041, 0x3e0f4857, 0xbd00dd90, 0xbd28b265, 0xbd95db70, 0x3be5cd47, 0xbd904484, 0x3e0a7c61, 
    0x3da49955, 0xbd1ebb14, 0xbd350be3, 0x3ce7e4f6, 0x3d40ea70, 0x3c06d84d, 0xbdb5fcb7, 0xbe26e702, 
    0x3d23015e, 0xbe065f0c, 0x3d30169b, 0x3e03a9b5, 0x3e180ac0, 0xbdbfed16, 0xbcd09fad, 0xbde90162, 
    0xbdb2f068, 0x3e174c00, 0xbcd37960, 0xbd820622, 0xbd1fac82, 0xbc6628d9, 0xbdb51bcd, 0x3c158dd9, 
    0x3cf5c283, 0xbe2c6c11, 0xbd63fe71, 0xbd052868, 0xbd110ef2, 0x3e128567, 0x3df33e2e, 0xbdd80de7, 
    0xbd0fdbc0, 0xbb3f606e, 0xbde0e8f8, 0x3e15f256, 0x3d498f44, 0xbe2f85fb, 0xbe33f903, 0xbe389fc2, 
    0xbdcea898, 0xbe07edff, 0xbcf9c435, 0x3e1ad66f, 0x3ccf1038, 0xbd4d6b65, 0x3e1457cb, 0x3d8f3de5, 
    0x3dd13f11, 0x3dfd6238, 0x3deec5ed, 0xbe2192e9, 0x3d8cbf64, 0xbde5c400, 0xbdfcacff, 0x3dcb57f8, 
    0xbd156695, 0xbdd411c9, 0xbd8c63ba, 0xbb39af45, 0x3dee324d, 0xbdf516c4, 0xbda256e8, 0x3d5fdcc2, 
    0xbd8adb3b, 0x3e22ee84, 0xbe00f0be, 0xbdbc6f6c, 0xbe06d576, 0xbd2c6b60, 0x3d732fbe, 0xbdcd51b9, 
    0xbcc9f5fd, 0x3d4d48fd, 0x3e1d9647, 0x3e1d2d5b, 0x3e235b49, 0x3e0c8d6d, 0x3e0bfc09, 0x3e1e7422, 
    0xbbbfb0ad, 0x3db90c5f, 0x3bbb771e, 0x3d0ff523, 0x3d29dfe8, 0x3dda2a94, 0xbbb287e2, 0x3e258d9c, 
    0x3dd6f120, 0xbc6174ba, 0xbc4cfd72, 0xbe05e6c7, 0xbe2e8dee, 0xbd04552e, 0x3df4275d, 0x3d809bf9, 
    0x3e142530, 0x3d58912a, 0x3e0d7d73, 0x3c62596e, 0xbd08e5cf, 0xbe0b9d4f, 0x3cf58aa2, 0xbc3c59a3, 
    0x3dd1e003, 0x3c1b63a8, 0xbc1c79da, 0x3d0628c3, 0x3c77f097, 0xbd5e674e, 0xbde63e81, 0xbe27b792, 
    0xbe1b7128, 0xbd048fa7, 0x3d8ac07b, 0x3d0e7e61, 0xbd50efa7, 0xbd5ec89d, 0xbdbd3037, 0xbd23eb7f, 
    0x3d91bca6, 0xbe2409e1, 0x3d8d7fe0, 0xbd87126b, 0x3d944fdb, 0xbe1f0ef2, 0x3d91ad9c, 0xbd93effa, 
    0xbdb1ce58, 0x3defe0b8, 0xbca569d5, 0x3dd5f30e, 0x3e0484da, 0xbde697ee, 0x3d840e89, 0xbc42ee68, 
    0xbe2360ea, 0xbd913a1d, 0xbe2ce47e, 0x3e0b986e, 0x3e1f0d4b, 0xbd33cfa4, 0xbd87937d, 0x3d4e381a, 
    0x3d746f5c, 0xbda97097, 0xbdc6aa79, 0x3cf59634, 0xbe1afbd6, 0xbdce2f79, 0x3e1e734f, 0x3c4b911b, 
    0xbd20418a, 0xbd707dcd, 0x3d826a9d, 0x3c260210, 0x3d5d50ba, 0x3d9885fc, 0xbe0ad69e, 0xbe0a7ae9, 
    0xbd40a1b7, 0xba903c98, 0xbd3ce559, 0xbcf67edc, 0xbd072658, 0xbdad1b99, 0xbe3503fa, 0x3e188eed, 
    0x3d5e8461, 0xbdc3456b, 0xbd1b3585, 0x3def893c, 0xbd3e7386, 0x3d793a72, 0x3cdbf0a0, 0xbce717aa, 
    0x3e0794dd, 0xbdc496a5, 0xbe24eb03, 0x3e29cf31, 0x3e04ee99, 0xbe010580, 0x3e0ad34c, 0xbb685427, 
    0x3c249953, 0x3dbe0e60, 0xbe15eadd, 0xbe22b983, 0xbd84bada, 0x3d543f55, 0xbdb92558, 0xbdaf0d04, 
    0xbd4e87b7, 0x3dac1c66, 0xbe0e0dff, 0xbc989c79, 0x3dee6c07, 0xbde6ff37, 0xbe2a2e5d, 0x3cb57366, 
    0xbcb04e0c, 0xbd851419, 0xbc8cb962, 0xbe204915, 0x3d07da75, 0x3e155c27, 0xbe101fab, 0xbdad128c, 
    0x3e24d2be, 0x3de2c287, 0x3e12e853, 0x3e1ed387, 0xbdd533a3, 0xbdba15d7, 0xbe221443, 0x3e21e6f0, 
    0x3d75d67d, 0xbd5c9d1c, 0xbd354ddf, 0xbc6be701, 0xbe0d24b9, 0x3d9d15b8, 0xbddc1c79, 0xbe1073a0, 
    0x3dfaf372, 0x3d80e00a, 0xbdb34133, 0x3dac8da8, 0xbba0d99c, 0x3c8bb631, 0xbe12382f, 0x3cc8409a, 
    0xbd523708, 0xbe32e360, 0xbe296d53, 0x3e082950, 0xbd8e566d, 0x3d6d660b, 0x3d67ce46, 0x3e079761, 
    0x3e0d6f80, 0x3db67af6, 0x3e06c9a6, 0x3bb4d99e, 0x3d8d38e4, 0xbceaffd5, 0xba2f350d, 0xbbd4b92f, 
    0x3e26750f, 0x3dff2d5f, 0x3d5541db, 0xbd46fdf0, 0x3d3d6923, 0xbd9e9d9d, 0x3dced961, 0x3e1341fc, 
    0xbdcabc23, 0xbc9ff259, 0xbdd934fc, 0x3dc289c8, 0x3d6e6f43, 0xbe2d66e7, 0xbd6f53ff, 0xbd7d6e79, 
    0x3c68728f, 0xbdefba46, 0xbd5ab800, 0xbc368b2e, 0x3c268199, 0xbdbcf827, 0xbe08e224, 0xbdb67219, 
    0xbdb3b5ad, 0xbc779654, 0x3d09faa1, 0xbcf54278, 0xbd8e6f92, 0xbdabcd4e, 0xbe02af25, 0x3e299c96, 
    0x3e2f4145, 0x3dbf072d, 0x3d1e3c32, 0xbe24ac8a, 0x3ca46a25, 0x3de1b3d5, 0x3e065ba7, 0x3dc7f685, 
    0xbc7cd605, 0x3e257838, 0xbe2114dc, 0xbb9b41d0, 0xbd956b6b, 0x3e2f41ff, 0x3db29084, 0xbdcbcf6f, 
    0xbdcf4071, 0xbcf7901f, 0x3de276fd, 0xbde26a04, 0x3d9f3adc, 0xbe1d824a, 0xbe103cf0, 0x3d392837, 
    0x3d3bb91a, 0x3de6560a, 0x3e10b77f, 0x3af0b691, 0xbd675eb1, 0xbb0e2dfb, 0x3dea6eb5, 0x3d9783dd, 
    0xbd7bed8f, 0x3dddf61d, 0xbdd59d37, 0xbca8b696, 0xbe321870, 0x3e289e70, 0x3e032c10, 0x3e3c07a7, 
    0xbe28f2bd, 0xbe35752b, 0xbd345bb4, 0xbdad7815, 0xb9ac3d5a, 0xbdb5fdce, 0x3deec9bc, 0xbdeecd99, 
    0x3d36fe98, 0x3d7b3f48, 0x3da2c9b3, 0x3dd150e6, 0x3e24826a, 0x3d426061, 0xbde9ec09, 0x3dc26e56, 
    0x3d9155b0, 0x3c033a9d, 0x3d77dc69, 0xbd4f3788, 0x3e02f901, 0xbdc76663, 0xbde40254, 0xbd9cb98f, 
    0xbe03c8c1, 0xbd7c9bd6, 0x3d8498fb, 0x3d9a74a1, 0xbc6c7675, 0xbce25b9d, 0xbde52a23, 0xbe1105ad, 
    0xbdc3ba4c, 0xbd362d58, 0x3e305717, 0x3db99dc9, 0x3cdafa39, 0xbdc26c0d, 0x3dbb9609, 0xbe2a76c7, 
    0x3d6791db, 0xbdc1076b, 0xbdec44ba, 0xbd8ea467, 0xbe1ed237, 0xbdc73045, 0x3de5ef0e, 0xbdbb608a, 
    0xbe1b4e81, 0x3e1cb8c6, 0xbd8cf9f2, 0xbe09fece, 0xbe120944, 0x3c6b6326, 0x3e23a071, 0xbdf7fe53, 
    0xbd90d436, 0xbcde0a8d, 0xbe11bf7e, 0xbdbf5aea, 0x3da308e4, 0xbd0212d9, 0x3dd62f9d, 0x3d94bc36, 
    0xbe1abc9c, 0x3dadefd7, 0x3e15f233, 0x3dd3aa43, 0x3dbda429, 0xbdd3735a, 0x3d984469, 0xbdd529e3, 
    0xbdcbb409, 0x3e107f8b, 0x3bdd9443, 0x3cdb7051, 0x3c59bd4d, 0xbe312751, 0xbc5d2915, 0x3e09ef1d, 
    0xbda99883, 0x3da6e238, 0x3d88f513, 0xbc8b08f4, 0x3e2eab34, 0x3ccfc2b3, 0xbe2b99f8, 0xbe00221c, 
    0xbd865092, 0x3d170530, 0xbe10bf8a, 0xbdf13e43, 0x3e046e08, 0x3dc5d058, 0xbd1e6776, 0x3e1f2bca, 
    0x3bf42871, 0x3d014e12, 0xbdca2213, 0xbe09bfa8, 0xbd1b4360, 0xbbc465c5, 0xbd8afca3, 0x3dfadeba, 
    0x3c9acd65, 0xbd2630f1, 0xbe17d935, 0xbd997f00, 0xbe27cc3d, 0xbe12ce24, 0xbe1ec7e3, 0xbe266d80, 
    0x3da502f2, 0xbd066ca1, 0x3dc609f5, 0x3d536b2f, 0xbde14a12, 0x3da1f46f, 0x3d23fb05, 0xbdd7d90d, 
    0xbd6377eb, 0xbd2295d9, 0xbd51076f, 0x3e2d09ff, 0x3bd3c69f, 0xbd196147, 0xbe1ec5df, 0x3c206733, 
    0xbb85502b, 0x3d59787b, 0xbe1efa1b, 0xbe337928, 0xbdb5c35a, 0xbe3242e9, 0x3d9f901e, 0x3d00e56c, 
    0xbe258463, 0xbd61322e, 0x3d240816, 0x3c381763, 0xbd3a1d79, 0x3db89723, 0x3e261d6c, 0x3c544d2d, 
    0x3d892b50, 0x3ca07b9a, 0x3dfba209, 0xbe26bf0f, 0xbdf9854d, 0x3d3c8920, 0xbd34d6a3, 0x3e29c863, 
    0xbcdf8fe0, 0xbdbcd5ed, 0xbe2aedac, 0x3d121f0f, 0xbe2ff5ad, 0xbdbd39df, 0x3d74b180, 0x3d41437f, 
    0x3e28cce6, 0x3e04abbd, 0x3df27277, 0xbd15622b, 0xbd866705, 0x3d545aaa, 0xbdcfc57b, 0x3e3086ac, 
    0xbdd21909, 0xbd7c362b, 0xbd9f7942, 0xbcc7a318, 0xbe0a5605, 0xbd9d9fc3, 0x3d80d031, 0xbe1a0554, 
    0xbe3b52cf, 0xbd8b6e3d, 0xbcbf15b0, 0xbd20d1cd, 0xbe04fdad, 0xbe1b0bb8, 0xbdea0acc, 0x3e14940f, 
    0x3d863c07, 0x3e32429d, 0x3e1f0662, 0xbb9be22e, 0x3e17c961, 0xbce34206, 0xbe0dabab, 0xbdcd51db, 
    0xbe17c74e, 0x3db403b4, 0xbd050a7c, 0x3df8a33f, 0xbe17546f, 0xbcc3e45a, 0xbe03c65d, 0xbdcb1201, 
    0x3def0d04, 0x3d65293d, 0xbd6907cf, 0x3d4c4a8e, 0x3deeb407, 0x3cfe45ba, 0xbd9ef28e, 0x3dd942eb, 
    0xbd89fa49, 0x3d8847e0, 0x3e0a7a6e, 0x3cedd184, 0xbd992ece, 0xbe29febb, 0x3e23dc07, 0x3e1fa8e7, 
    0x3d079a64, 0x3e1d2ded, 0xbd8d8b3f, 0x3bab5459, 0x3e206608, 0x3e2b0f2b, 0xbb4b3201, 0x3d4d0d04, 
    0x3e162fdb, 0xbdef8acb, 0xbdb9cbdd, 0x3de05b9e, 0x3c4d562c, 0x3e184448, 0xbd93db89, 0xbdaf4195, 
    0xbe1cdc38, 0x3e215547, 0xbddbea5d, 0xbdb9bff5, 0x3dbcd011, 0x3cc6f2d6, 0x3d811ad4, 0xbcd5df68, 
    0x3dbea699, 0xbccb38cf, 0x3c4a7c15, 0x3cd546f7, 0xbd9eaee4, 0xbb3f982f, 0x3d0e1286, 0xbbdf81e5, 
    0x3e1bbdac, 0xbdb9e267, 0x3e3233dc, 0x3d83e313, 0xbcb90ac3, 0xbe13b3b4, 0x3cf1c64b, 0x3e21656b, 
    0xbe043c58, 0xbe20d51b, 0xbc11ea1b, 0xbdeacf35, 0x3e1bb9d1, 0x3db5c271, 0xbc92c158, 0x3dedb9d6, 
    0x3ba80ad7, 0x3b86cbbb, 0xbb9e0c88, 0xbd6c5066, 0xbe0e954e, 0xbe0a2cbd, 0x3cbe2372, 0xbd75d78c, 
    0xbe26b8cd, 0xbb538ae8, 0x3dee4b5e, 0xbe179653, 0xbe1158b2, 0x3af31f15, 0xbd395887, 0xbd2f7a8b, 
    0x3dffefb9, 0x3c3bc0c9, 0xbe022948, 0x3e272f9f, 0x3d2dcb1d, 0x3e266f06, 0x3e09008a, 0xbdfcb561, 
    0x3def1c0b, 0xbe07e7ee, 0xbe0cd730, 0x3da20eba, 0x3e3b008c, 0x3ddbf4d7, 0x3e08925a, 0xbe27928b, 
    0xbe18a582, 0x3dc8ed8d, 0x3e10aa8d, 0xbd227687, 0xbdcfb543, 0xbd540c3c, 0x3c5fb88d, 0xbd1904ff, 
    0x3d36b4c0, 0xbcdc0403, 0xbd298957, 0x3e06d11a, 0x3dc7d479, 0xbd614f42, 0x3c976635, 0x3e057ce7, 
    0x3ddc51c8, 0xbe217ad5, 0x3d7d5eb6, 0x3d030f6a, 0x3d67b35f, 0x3cfee763, 0xbe1f53d0, 0x3dec5fc4, 
    0x3e115b66, 0x3e1f4f9e, 0x3cebde72, 0xbe012a5a, 0xbe0cee92, 0x3dd9fdff, 0xbc8404cf, 0x3d6d44b8, 
    0x3e204077, 0xbe2ba240, 0x3d6ebe61, 0xbe0a86ec, 0x3d703bf7, 0xbdf70cc9, 0xbe09589f, 0xbe270307, 
    0x3e0a81b2, 0xbb85b958, 0x3d2ecd9e, 0x3d05d99a, 0x3e1491f4, 0xbe356864, 0xbc194994, 0xbd2e6722, 
    0x3d8e6e33, 0x3db97e8f, 0xbda614b0, 0x3e0f5451, 0xbdde24b5, 0xbdf66200, 0x3c3ef1c0, 0xbd3a5470, 
    0xbe32fcf8, 0xbd25fec5, 0x3e0a8a9f, 0x3b47609a, 0x3db1fb97, 0xbe159ce7, 0xbe31f3bc, 0x3deecc29, 
    0xbe05c9f6, 0xbd9c2f26, 0xbdceac65, 0x3d912c1a, 0xbdecee20, 0xbe000d7e, 0x3d8c58e1, 0x3d89baab, 
    0xbdedc739, 0xbde8ae4e, 0x3e125606, 0x3d344f9b, 0x3ceefe58, 0xbe280448, 0xbd4b5fc4, 0xbe0d8132, 
    0xbcbb3f1b, 0xbe1f1b56, 0x3db90ca6, 0x3e189539, 0xbde3e04a, 0xbd4f678c, 0x3a2ff9f7, 0xbe04758f, 
    0xbd274129, 0x3cf04634, 0x3d91c210, 0x3e1ba67b, 0xbbd52d93, 0x3e045fbf, 0xbe0478eb, 0x3d44e24f, 
    0x3dbdbb19, 0x3e094ba7, 0x3c44bb58, 0x3e0125a0, 0xbda442ae, 0xbe335542, 0xbc8648fb, 0xbc4ef2d6, 
    0xbd46cfe6, 0x3e27e078, 0xbe1cd2ce, 0xbda90500, 0xbd24451e, 0x3d132b34, 0xbd115953, 0xbe18a562, 
    0xbd13e92f, 0xbe3575dd, 0xbe144115, 0xbe03e6d0, 0x3da02f0f, 0xbd09464a, 0xbd921023, 0x3e1e6d9c, 
    0x3e198218, 0xbdf8fb6b, 0x3e278c7e, 0x3e019375, 0xbe19200e, 0xbe1e985c, 0xbdbc351a, 0xbe2b4c1c, 
    0xbde75a93, 0x3d99fe28, 0x3bc57c05, 0x3de15486, 0x3c8e94b1, 0x3c37b646, 0xbd331a88, 0xbe0c38ff, 
    0xbd58c855, 0xbc86598c, 0x3cb9d5b9, 0xbdc90ea5, 0x3e2393d3, 0x3e146786, 0xbe08d911, 0xbcf54c0e, 
    0x3d7c1613, 0x3dd9e6d7, 0x3e089abf, 0xbd1f179e, 0xbe1571e6, 0x3db35864, 0xbdfe1efe, 0x3dbf9e36, 
    0xbe0751f5, 0xbdbeacbc, 0xbd7ca7be, 0xbd156c31, 0xbdfdb615, 0xbd88f6c0, 0xbe055f07, 0x3d5b6723, 
    0xbde82eeb, 0xbdffb955, 0xbdcd52ac, 0x3d8b5915, 0x3d83948e, 0xbe110298, 0xbd902a07, 0x3ce939bd, 
    0xbda8d435, 0x3e338d08, 0x3e25b573, 0xbcb224d5, 0xbccbd150, 0x3dec03bf, 0x3b352a19, 0xbe325818, 
    0xbd0c0e2a, 0x3db3a971, 0xbe0ba499, 0x3dbc09d0, 0x3d7fb495, 0x3d759885, 0x3dd2e9f9, 0x3c33c401, 
    0x3e19b88b, 0x3e0981a7, 0x3cef817d, 0xbdf724ef, 0x3ce048b6, 0xbdea6d26, 0xbe11fbd8, 0x3d9a9f5d, 
    0x3d367829, 0x3dbd2d8b, 0x3e0cdcda, 0x3e0d2c70, 0x3dfd78ab, 0x3dfeea68, 0x3d9abf6b, 0xbd2802fd, 
    0xbca85ab1, 0x3dee18bc, 0x3d94944d, 0x3db8cc3a, 0xbdbd52b5, 0xbd27976d, 0x3d96ca41, 0x3e0f95d6, 
    0xbe105776, 0x3d34cb2f, 0x3e0dd731, 0x3da42c86, 0x3e05c324, 0xbc32ab90, 0x3d88593d, 0x3de0ab5f, 
    0x3d018c67, 0x3db71570, 0x3dabee90, 0x3dd45fb5, 0x3e0d120b, 0x3dd10cc8, 0x3de43ad9, 0xbe2eb222, 
    0x3d0cfe0b, 0x3d92c615, 0xbe290e22, 0xbe176f36, 0xbde1d85e, 0xbe2f2aea, 0xbdc310bd, 0x3e2c7552, 
    0x3e248225, 0x3e0b5ce5, 0xbe19c605, 0xbd9429da, 0xbe055e70, 0x3d5b42a8, 0x3d662b90, 0x3d098890, 
    0x3d1c5a07, 0x3d35bdec, 0x3d732514, 0x3e31c854, 0x3e2e306f, 0xbd82163e, 0xbcebd107, 0xbdcb4da0, 
    0xbdb07e7e, 0xbde50b30, 0xbc3b424a, 0x3c07c309, 0x3e3350ae, 0xbd8d9147, 0xbda51be6, 0xbda27462
};

static const uint32_t _K40[] = {
    0xbca12bc8, 0x3df1c88b, 0x3def815d, 0x3d3d5e12, 0x3c7fd866, 0xbe00a71d, 0xbd0a92e3, 0xbc4af6a5, 
    0x3e24bb2c, 0x3de6f52f, 0x3d6d5cdb, 0x3dd0a227, 0xbe20dbf1, 0xbd7afecf, 0xbdb1f751, 0xbe29bbf9, 
    0xbdee29a0, 0x3dee4506, 0xbd5c622e, 0xbd296bc0, 0x3ccd437e, 0xbc74aa88, 0xbdde9175, 0x3ceb24d9, 
    0x3e2eecd4, 0x3da4422b, 0x3d6c6647, 0xbcd5fdc1, 0xbdab84a0, 0x3d1a3590, 0x3dcc1ea3, 0x3b558222, 
    0xbda990ac, 0x3d37284a, 0xbd077c2d, 0x3d38eec8, 0x3e1f554c, 0x3e2dad9c, 0xbc5ae4f5, 0xbe158773, 
    0x3e31834d, 0x3dcccee2, 0xbd96e122, 0xbde20e93, 0x3cc3ac94, 0x3e15288f, 0x3ddb6031, 0xbdaa69d7, 
    0xbe01fae2, 0x3cd09b05, 0xbcb678e8, 0xbdf1ee7a, 0xbe3203b8, 0xbde12988, 0xbd8637ab, 0xbc74f8be, 
    0x3e343c89, 0xbd144656, 0x3dc5eea7, 0xbb4f7487, 0xbd105cbf, 0x3d0b9aac, 0xbe2e4751, 0x3e234437, 
    0x3d49101d, 0xbdfe22b6, 0xbc54843c, 0x3e0259ca, 0xbcf33528, 0xbde1b794, 0x3d914f30, 0x3d925f2b, 
    0x3e30f825, 0x3e1727b3, 0x3d97c3bd, 0x3d82fe48, 0xbdc4d90f, 0xbdde29d9, 0x3d4f34f4, 0xbd9aa7b6, 
    0x3dac8310, 0xbc603607, 0xbd55400e, 0xbb821f44, 0xbc42a7cd, 0x3d395b6f, 0xbd2549b7, 0xbe1ff0a2, 
    0x3b8bf722, 0x3d6ea103, 0xbd6bdf7f, 0xbe085361, 0x3e410ffc, 0xbb3ea582, 0xbe04ab2c, 0xbd9d6eb7, 
    0x3e2bae02, 0xbdd1e6a7, 0x3e16ef2b, 0xbd9ccfb3, 0xbdbc69a3, 0x3dd9dbee, 0x39826ae6, 0xbe2f2fc0, 
    0x3dca5f33, 0x3a8311ae, 0xbe03e700, 0xbe2d33f6, 0xbda50b4e, 0xbc9b5e00, 0x3de2ab86, 0xbe0c2b95, 
    0xbb763a9d, 0x3e25a83c, 0xbe0f2fb5, 0xbd65c498, 0xbce68f24, 0xbc5f9a72, 0xbcb13430, 0xbd83c222, 
    0x3df0e8b0, 0xbbe03d03, 0x3e2f1d9e, 0xbe145fb7, 0x3c027bff, 0x3dbca53e, 0xbd8fe6ea, 0x3da9d653, 
    0xbbc16036, 0xbe2dcbac, 0xbdcc2def, 0xbe357140, 0xbe2548a9, 0xbe18154f, 0x3d61743c, 0xbdee3235, 
    0x3d7b8abd, 0x3ca6f610, 0xbc1a0fe3, 0xbd773d56, 0x3e186322, 0xbe07434e, 0x3dc20f42, 0xbc524285, 
    0xbd92b94f, 0xbd6ff0eb, 0xbe173172, 0xbe2599f2, 0xbe125cdf, 0x3df78e9d, 0x3ddfc96e, 0x3db340fd, 
    0xbde96d86, 0x3db9906c, 0x3dabd7eb, 0xbd81a4d2, 0xbe27a914, 0xbe33d9c5, 0x3e2ef2e4, 0xbc7184c0, 
    0x3c240251, 0x3cd25eac, 0xbd827f01, 0xbc952091, 0xbdb43ab4, 0x3d9f8c4d, 0xbe1dd421, 0xbd115d15, 
    0x3da4674c, 0xbcdd0f2a, 0xbca60665, 0xbd03529e, 0x3de568f0, 0x3ca2e120, 0x3e2d9443, 0xbc983ff8, 
    0xbd3ff0ed, 0xbce1f1bf, 0xbdb4a868, 0xbe24f3fc, 0xbb484fe1, 0x3dafb7e5, 0x3ca62787, 0xbd0b389a, 
    0x3dcdabac, 0xbd136807, 0xbdc477a6, 0xbe074324, 0x3c54689a, 0x3e1ce458, 0x3d9eb2eb, 0x3dbc3724, 
    0x3de84da6, 0x3db8083c, 0x3e28127d, 0xbdc41cf9, 0x3cf509df, 0xbe284524, 0xbe1f6c51, 0xbd5f3282, 
    0x3e01445e, 0x3e2567e8, 0x3e2b59b3, 0x3cedc600, 0x3d4bb0ef, 0xbcac701b, 0x3d0e230b, 0x3c8e990b, 
    0xbdab5448, 0x3e223343, 0xbdff173c, 0x3cd43395, 0x3db64f3a, 0x3da6d450, 0x3de7107c, 0x3e1e87a8, 
    0x3cea8587, 0x3e19295a, 0xbd910f94, 0x3d08b6f3, 0x3de66c99, 0x3d518ba0, 0x3d391002, 0x3d5c62e9, 
    0xbd2901a4, 0x3dfc840c, 0xbdf53f64, 0xbe3746cc, 0xbdf6e9a4, 0x3e07c35e, 0x3bf9f0a7, 0xbdeeb8a6, 
    0x3e139695, 0xbc9fc6e6, 0x3da9b131, 0x3d7725c1, 0x3db65450, 0xbd4987e9, 0x3e008b13, 0xbdb3dfb3, 
    0xbb067984, 0xbd3e8f72, 0x3d65a6e6, 0xbe2e4412, 0x3d45c2f7, 0xbd275122, 0xbe1130b7, 0x3e11787c, 
    0xbc32772f, 0xbb13fb53, 0x3e1021e1, 0xbcd58e8e, 0xbdb544de, 0xbe002f38, 0x3dd723a0, 0xbe2353d7, 
    0xbe2448db, 0xbd51b851, 0xbda08b28, 0x3dbd31e2, 0x3e119fc2, 0x3da53032, 0x3ddef251, 0x3d888756, 
    0x3e0dfee8, 0xbd7a5ea0, 0x3d9ed767, 0xbdcd2cc0, 0xbda9830f, 0x3da3cb10, 0x3c93bfee, 0x3e20158c, 
    0xbdde6a41, 0x3e2d3b35, 0xbe00bd1e, 0xbe0b8e51, 0x3e216ff4, 0xbe2fb803, 0xbd9f732c, 0x3dd644e6, 
    0xbd2db939, 0x3e3bc813, 0xbc644b96, 0xbde55c08, 0xbc240395, 0x3d03e694, 0x3c42ccc5, 0x3dcf1c0d, 
    0xbd89c9f5, 0xbde87783, 0xbbac7885, 0xbe127676, 0x3d48c83f, 0x3d9fa198, 0xbd46ea20, 0xbc9d5774, 
    0x3e2099ab, 0x3e1510e2, 0xbd321b33, 0x3e202091, 0xbddbcb30, 0xbce22578, 0xbdd64e7e, 0x3de1fc02, 
    0xbd3b9833, 0x3d3ec1c1, 0x3d75bd0c, 0x3e20fbea, 0x3d836c45, 0x3dd1725c, 0x3dd70a5e, 0x3e2be32f, 
    0xbe254be9, 0xbc1e9446, 0x3d61d235, 0xbdaeb8cc, 0x3d9bef2f, 0x3e0b924c, 0xbe003309, 0xbd861d94, 
    0xbe1f2c7e, 0xbdfdef29, 0x389e9864, 0x3cd02145, 0xbe1fbb1e, 0xbdf659d7, 0x3dce8422, 0x3e2cf3e1, 
    0xbdf6cdab, 0xbe24583d, 0x3d935ed2, 0x3de2d68d, 0x3c604623, 0xbd0e7e05, 0x3ca3a965, 0x3c4f90bc, 
    0xbc413082, 0x3ce7d52a, 0x3d099f21, 0xbe29f255, 0x3dbe4746, 0xbdff6578, 0x3deea46c, 0x3c0965d7, 
    0x3db9836d, 0xbd2ae13b, 0x3c7ffd25, 0xbafde63b, 0xbd8ab6ee, 0xbe11ab06, 0x3df86270, 0x3dba28a8, 
    0xbe30acfe, 0xbe11d139, 0xbd512200, 0xbe1b3b33, 0xbd0c6dc0, 0x3d8ef40b, 0xbc0c534e, 0x3da11944, 
    0xbe07f169, 0x3c68c54b, 0xbe1fde89, 0xbccb3c6e, 0x3e0ddab5, 0xbe05cb71, 0xbd20e030, 0xbe04128d, 
    0xbdc675e0, 0xbdb79c7b, 0x3cc95a2a, 0xbd9d148d, 0xbdb410af, 0xbe0d627e, 0x3d96207d, 0xbdbf9635, 
    0xbd12e5dc, 0x3e146448, 0x3e10ead0, 0xbdb4decf, 0xbd00d0ea, 0xbe1d28bf, 0xbdf8c776, 0xbdf05a00, 
    0xbd390c2a, 0xbdef6128, 0x3de37b9f, 0x3da3ebd1, 0xbbb36b31, 0xbe0cb5f8, 0x3e25f84b, 0x3d39bc09, 
    0xbdf652ae, 0x3e2613fc, 0xbd9f16a0, 0x3dd43759, 0xbdff9457, 0xbdcbcd4a, 0xbdecb013, 0xbdefec67, 
    0xbd662095, 0x3e23db60, 0xbdd88c61, 0x3e0052d9, 0x3e18f180, 0x3d9b266f, 0xbe0d4e05, 0xbc8a9734, 
    0x3dbf6b8b, 0xbdf57723, 0x3d917084, 0x3dfb6465, 0xbe3731a4, 0x3e34c7ee, 0x3e169b17, 0xbdff57e4, 
    0x3e25af97, 0xbdc17d67, 0x3deee3c9, 0x3d1a9958, 0x3cc27086, 0xbda71da6, 0xbe107d25, 0xbd8b540f, 
    0x3e1fa9b3, 0x3e1d9b44, 0x3d142cbc, 0x3d8b2c77, 0x3d64e85d, 0xbe265d62, 0xbdb73659, 0xbe185f7c, 
    0xbe224bfc, 0x3e014fc4, 0xbdf0d5c8, 0x3e2818b7, 0x3d81f0c4, 0x3d9aedb2, 0x3d839bac, 0x3c4c1c75, 
    0xbdec5eca, 0xbdaeaff4, 0xbe1d1824, 0x3cc05118, 0x3ca322ed, 0x3dde10ab, 0x3df4c074, 0x3ddb5ebd, 
    0x3e255fd1, 0xbe31d2fc, 0xbdf3742a, 0xbd1aadf4, 0xbd1a1bbf, 0x3ddc3cb8, 0x3cc1d989, 0xbd6319a1, 
    0x3dd57a70, 0xbd10ef63, 0x3d8a9335, 0xbd5a6212, 0x3c813d15, 0x3d93704c, 0xbd295d93, 0x3dfa42d9, 
    0x3d712a32, 0x3cf313d2, 0xbdeee323, 0x3e16e769, 0xbbb7601f, 0x3db2aa99, 0xbdaa7919, 0x3c0ed9c7, 
    0xbe22aaff, 0xbdefcab4, 0x3e06ea98, 0x3dbf9c15, 0x3e0a46bf, 0x3de5b4df, 0x3daac8d1, 0x3d8ba86c, 
    0x3d226b40, 0x3e09fa08, 0xbe047cf0, 0x3d21aad2, 0xbe0cab48, 0xbe1b7a3f, 0x3d98e8cb, 0x3c0d5824, 
    0xbd8ba317, 0xbe216d06, 0x3d8e14cf, 0x3deec87a, 0x3ccbdeb5, 0x3d91a459, 0xbd9bd687, 0x3e22957c, 
    0x3cfe5543, 0x3e11be7d, 0xbd2f63b5, 0xbdcbdb10, 0x3d7e1280, 0xbca01251, 0x3d9eb610, 0xbe07cfd0, 
    0xbd1dd76c, 0xbd6d80f5, 0xbd334717, 0xbe18a6dc, 0x3aaf0e39, 0xbd013a40, 0xbdb58fef, 0x3df60c98, 
    0x3e0b5a47, 0x3e096494, 0xbe2cfaf1, 0xbe03e524, 0x3cfc86a4, 0xbd4de36a, 0x3e013982, 0x3cd3af02, 
    0x3e296b6a, 0x3d90f207, 0xbd5905b5, 0x3e12e8de, 0xbbef9d69, 0xbd0b8d66, 0x3deb4c7f, 0x3da5bd75, 
    0x3de00dac, 0xbd078eba, 0x3d86bd49, 0x3d871249, 0xbdfbfd2f, 0x3d0abc6f, 0x3d8c6938, 0xbd76c3ac, 
    0x3de39b9a, 0xbdd8fb75, 0xbd84fc25, 0x3d239f7c, 0xbdec91b9, 0xbd81d50a, 0xbd3d1df8, 0x3d2ef78a, 
    0x3dcbd41d, 0xbd670216, 0x3df5ef8d, 0x3da67127, 0x3db4758a, 0x3def9617, 0xbc4370c1, 0x3d8c9a11, 
    0xbd2e1c96, 0xbcb6b2f8, 0xbe03fb69, 0x3e19601a, 0xbcae67c7, 0x3e08cf35, 0x3e1ddf33, 0x3d50db25, 
    0x3d094d04, 0xbc23a515, 0xbde94dcb, 0x3dc3bb64, 0xbe2bafea, 0x3dad27c8, 0x3d565b51, 0x3cb77b82, 
    0xbd52e351, 0x3e2f43f7, 0x3dfefb70, 0xbca70d9d, 0x3df1f625, 0xbd84f023, 0xbd45f3a3, 0xbd8c2bbc, 
    0x3d571844, 0x3deca6d7, 0xbd575739, 0xbd7a26bc, 0x3d1e544d, 0x3e294ae7, 0x3a45ba1e, 0x3e239bc8, 
    0xbe23c530, 0xbda41bc2, 0x3dcdb3ae, 0xbdac1663, 0xbda92d8d, 0x3d4109f5, 0x3e2da41e, 0xbd8a00e5, 
    0x3cddab49, 0x3c6f216b, 0xbe2bb64a, 0x3d786267, 0xbcb8df8f, 0xbe348c79, 0x3db25fcc, 0xbe2b3371, 
    0x3c963595, 0x3e2139db, 0x3e2fdf5c, 0xbd478ae8, 0xbd8fbf35, 0x3d0cd905, 0x3de2aaaf, 0xbe220ac4, 
    0x3e09eb1b, 0x3e3819a2, 0xbd86ff12, 0x3dc58c54, 0x3c4014bf, 0xbb0400b1, 0x3dd87593, 0xbd67764d, 
    0x3deb7abc, 0x3d19be20, 0xbe0873ba, 0xbd63919b, 0xbe032929, 0xbe380a4a, 0x3d87b167, 0x3ddf1990, 
    0x3de4e54a, 0xbc73f3d0, 0x3db57a57, 0x3d76bd8b, 0x3df0c757, 0xbe258bf4, 0xbdb183c5, 0xbc8b3c96, 
    0xbda7c316, 0xbe130b7b, 0xbdf08855, 0x3dc9bf38, 0xbdadccfa, 0xbc6a62f1, 0xbdd15c4b, 0x3d244d8d, 
    0xbe2f24c7, 0x3dff0468, 0xbe2a5922, 0x3cb59492, 0x3e2927a3, 0x3b9139e0, 0x3b883381, 0x3d065ed5, 
    0xbda741dc, 0xbe34c52a, 0xbd1b49a3, 0x3e2a5406, 0x3ba5fd0b, 0x3dd2bfcc, 0x3e164c28, 0x3d90dde7, 
    0x3e0e0979, 0x3d16f0cc, 0xbe1e98e2, 0x3d19eeda, 0x3d9f3914, 0x3e334045, 0x3c9f7ed2, 0x3cb73b0c, 
    0x3dfe5511, 0x3d06c8d4, 0xbdba92e1, 0x3d78f94c, 0xbe08a58b, 0xbdfe8174, 0x3d920577, 0xbe1fb7e5, 
    0xbd7a38d1, 0xbe05f11d, 0xbd9da06a, 0x3e1d223d, 0xbc975c71, 0xbe103785, 0x3e3d0279, 0x3d9b52f8, 
    0x3d8de35c, 0xbdcfb732, 0xbe276fb9, 0x3c201485, 0x3df3b1c7, 0xbe1941ac, 0x3d474aae, 0xbd9457da, 
    0xbde2bf58, 0xbdbf7beb, 0x3d83a33b, 0xbd934ccc, 0xbd3b7d97, 0x3cafaefa, 0x3d09b82c, 0xbc3f6068, 
    0x3ca1971f, 0x3dc7f78e, 0xbdea40b0, 0xbdcc497a, 0x3d9ec7eb, 0x3de956f6, 0xbe19d8c2, 0x3d5a5484, 
    0xbb953e3a, 0xbd9c81c3, 0xbdf0001c, 0x3bce7c09, 0x3d0d6a61, 0x3e25f404, 0xbe16c15d, 0x3e351012, 
    0xbd2fce03, 0xbe0e04a2, 0x3e1db249, 0xbd48dfa3, 0xbcda3a3a, 0x3dad9200, 0x3e297329, 0x3c068977, 
    0xbe2db5c5, 0xbba745e5, 0xbbea4f9e, 0xbd084a68, 0x3d4685cb, 0x3ca90aff, 0x3dfdc530, 0x3d9d1e46, 
    0xbda58b6b, 0xbc9bc93b, 0x3d94c573, 0xbd0e99cf, 0xbe14e46e, 0xbe006670, 0x3c83cf18, 0x3d55785d, 
    0x3e07208c, 0xbdfa55f5, 0xbd844c14, 0x3d910e89, 0xbca0ca27, 0x3cc17f38, 0x3e3e43c1, 0x3dcae901, 
    0x3e2cc5c6, 0x3d3d8c09, 0x3d7ef738, 0x3dfcf03c, 0x3e3359a9, 0x3e0add95, 0x3cd00a73, 0xbd010c37, 
    0xbd3c6d2d, 0x3ce3428e, 0xbe2b6ec2, 0x3bbe7a5b, 0xbdda951e, 0xbdcbc687, 0x3d2e1015, 0x3e0f75b3, 
    0x3d6c8fc5, 0xbd20ce42, 0x3e1c873c, 0x3cc47dc6, 0xbab31756, 0x3d9e9fb9, 0x3dcc6a5d, 0x3dd2e474, 
    0xbc80ee11, 0xbd359f00, 0xbdf454e4, 0x3e103c44, 0xbd743da8, 0xbd8e5a01, 0x3c6ae59b, 0x3d88eec1, 
    0x3c9979a7, 0x3de90ee0, 0x3deebaa2, 0xbdd3d0b1, 0xbd153212, 0x3de916a5, 0x3e0b8cc5, 0x3e14dc9b, 
    0x3e1c3a5a, 0x3e3424e0, 0xbd5cde04, 0x3d8d45d5, 0x3d9fa0bf, 0x3d6bac88, 0xbe083ea0, 0xbe047ac3, 
    0x3db397da, 0x3ddd5c3c, 0xbce6abb8, 0xbc33722f, 0xbd2f70d0, 0xb8f952d6, 0xbd9435c8, 0xbb830bec, 
    0x3e2fd865, 0x3d43ecae, 0x3d541394, 0xbe2abd98, 0x3d318e56, 0x3d5c318a, 0x3dfce8aa, 0xbd772088, 
    0x3d85960e, 0xbe10e9fe, 0x3d834fb9, 0xbc133baf, 0xbe1f4e40, 0x3e2e7695, 0xbe433d7a, 0xbcf8a966, 
    0x3dbc5d42, 0x3d18ddfb, 0x3e1a5f2d, 0x3db2783d, 0x3e040ef3, 0xbddf3a40, 0x3e2635c2, 0x3ccb5eb9, 
    0x3df58cb6, 0xbc1918a7, 0x3d888e4d, 0x3dccf131, 0x3d15f3b5, 0x3e02317f, 0xbe1e74e4, 0xbe03c665, 
    0x3d9920d2, 0x3d82b5d1, 0x3dcb9c6c, 0xbcd34148, 0x3d674a3d, 0x3c02861e, 0x3baf9aba, 0x3e2dd2b4, 
    0x3cdd5964, 0x3dcb5cff, 0x3e24c0f5, 0xbe035cac, 0x3e0a271d, 0xbe296bdc, 0xbe3e4963, 0x3de7f8e3, 
    0x3e07fdd9, 0xbd6ec000, 0xbdcaa391, 0xbdbc0695, 0x3cd2b455, 0x3d89bcf8, 0xbc814fce, 0x3e153b38, 
    0x3d7da71c, 0x3e1b7c63, 0xbc2dfa87, 0x3dd50d7c, 0xbda633b7, 0x3df8290f, 0x3e1704a6, 0xbc9f2d1f, 
    0xbe20933d, 0x3d303116, 0xbdaaea8e, 0x3d75edb1, 0x3d82bdaf, 0xbd875797, 0x3d251af0, 0x3d76061a, 
    0x3c814acb, 0x3d1c0c85, 0x3dae5def, 0xbe2fb51b, 0xbdc5223b, 0xbe152846, 0x3e2a8f95, 0x3e157a79, 
    0xbdd664fe, 0x3dd84201, 0x3e035fb8, 0xbbfc9972, 0x3dc25ecd, 0xbe19218c, 0x3dd787a3, 0xbcd0f263, 
    0x3b778d51, 0x3d14f317, 0xbdd0e895, 0xbdc69ec7, 0xbdbc5fe7, 0xbdf4cef1, 0xbd0c775e, 0xbd30c7d3, 
    0x3ce4516a, 0xbcf65b94, 0xbe11b585, 0x3c94a129, 0xbc9e379e, 0xbd2863a2, 0x3e12191b, 0xbd13bb0d, 
    0xbca88778, 0x3da3e2be, 0x3d57d550, 0x3cf9a127, 0xbde4b4bc, 0xbdf96357, 0x3de7f225, 0xbb17bf8e, 
    0x3cb82331, 0x3dda94e7, 0x3de474ec, 0x3c18b801, 0xbda3b9c8, 0xbe35451e, 0x3d2b1cab, 0xbdef41ad, 
    0xbda7481c, 0xbd9bed44, 0xbe28fa80, 0xbd417c20, 0x3dcf2ff4, 0x3d1ae83c, 0x3e1a9a50, 0xbe1b080d, 
    0x3d82a092, 0xbe09fea5, 0x3c4b62b1, 0xbe0e1ddc, 0x3e22c0c2, 0xbc5adccd, 0x3deac97c, 0xbe096394, 
    0x3d48ec26, 0x3e2ea7f5, 0xbdd191cc, 0x3e2d1120, 0x3d6755dc, 0xbe0b595d, 0x3dde85ae, 0xbd3c8064, 
    0x3d46ab6c, 0xbe028a10, 0x3e0d8960, 0xbda87d73, 0x3dd9c888, 0x3d5997a8, 0xbdc02bbd, 0xbca88243, 
    0xbd166dcc, 0x3d1f9d3a, 0xbd9dcd34, 0xbcb1434c, 0xbe059375, 0x3cdc3003, 0xbd5d1f43, 0xbde0b6be, 
    0x3dd3800e, 0x3ded7d10, 0xbd9fb1a6, 0x3e274e71, 0x3dc54c50, 0x3d1dd2c5, 0xbdbb66cb, 0xbde970a3, 
    0x3c934914, 0xbca8c652, 0xbe09c968, 0xbc645938, 0x3d8feb98, 0x3af59810, 0xbdf6f219, 0x3cdf2f06, 
    0xbe37eb01, 0x3cf8fd0f, 0x3da88834, 0x3c465dcd, 0xbe365fed, 0x3e2b3dae, 0x3e3381da, 0xbd9bc119, 
    0x3cc7987c, 0xbd784bb8, 0xbd8293fb, 0xbb996530, 0xbe0e6ba9, 0x3debef2b, 0xbe259a3f, 0x3b57a696, 
    0xbdd723be, 0xbe31362d, 0xbd88b104, 0xbd0ca708, 0x3e0cc71d, 0xbe177d7c, 0xb9e8340b, 0x3cedf412, 
    0x3c1cb719, 0x3de94ab0, 0x3d5378e0, 0x3e354e89, 0x3d2278be, 0xbe2824fd, 0xbd105815, 0x3e17c685, 
    0x3dce9513, 0x3d988554, 0xbb9d26bd, 0xbe003d8c, 0x3b258ef8, 0xbdf0d97c, 0xbd5b3d37, 0x3d77c7fe, 
    0xbd9b2b70, 0x3df1d192, 0x3d06497c, 0xbc9637a9, 0xbe1bfceb, 0xbdb69a90, 0x3cfa25ce, 0x3e27e815, 
    0xbd911f1a, 0xbe2192f9, 0xbe162638, 0x3d55d39e, 0xbdb6872b, 0xbe2d2dea, 0xbc8774d7, 0x3e1819c3, 
    0xbdf86230, 0x3b13ecca, 0x3d6c4c4b, 0x3c9fec91, 0xbdfca221, 0xbb8ea462, 0xbe2d5323, 0x3dfc92ab, 
    0xbc0e3f20, 0xbdfdc468, 0x3d31bb10, 0xbd50bd7f, 0x3ca0a5cf, 0xbb4f8640, 0xbde8bcbe, 0xbd64f551, 
    0xbdc28068, 0xbe1be1e8, 0xbdbf555b, 0x3e32beaa, 0xbe01a5d6, 0xbdceb42b, 0xbd05b699, 0xbda564c7, 
    0xbe179350, 0xbd04c2de, 0xbe329cad, 0x3d23f9f1, 0xbe2172b7, 0x3dc0cc97, 0xbce242b5, 0xbe27bf23, 
    0x3da98dda, 0xbe0f3187, 0x3d9dadd0, 0x3e222534, 0x3db73b6d, 0x3dd4d709, 0x3b893344, 0x3b86dbcb, 
    0xbdaf2ab2, 0x3df56c5c, 0x3dc3a1bd, 0x3e20bbf0, 0x3c19cd38, 0xbe20cdc5, 0x3db2da85, 0x3df36e4e, 
    0xbd97103b, 0xbd9b6a64, 0x3c9ab0b5, 0xbc449817, 0xbe068260, 0x3e256f5a, 0xbaa020ff, 0x3e05883e, 
    0x3e14c91e, 0xbdda7db8, 0xbe06aada, 0xbbd4c127, 0x3d0911e3, 0x3d8b997d, 0xbd43a484, 0x3d77177d, 
    0x3e20593e, 0x3ddba576, 0xbd3cc8de, 0x3d3c04c1, 0xbe2816af, 0xbe04648c, 0x3de5b17a, 0xbd2cf17a, 
    0xbc3e7fa2, 0xbdd19bc0, 0xbdad7f65, 0xbd87926e, 0x3c4380ab, 0x3e2938e7, 0x3d6bcb28, 0xbdf33bb8, 
    0x3d3cec0d, 0xbda21659, 0xbe21c75b, 0xbe1e1f61, 0x3ced5fef, 0x3e332600, 0x3e365e19, 0xbde0cd8c, 
    0x3dce0899, 0xbde44f52, 0x3d9609b5, 0x3de320b4, 0x3e090f26, 0xbdb2bc13, 0xbe086fcd, 0x3dd37f7e, 
    0x3d68e5a7, 0xbdd9a445, 0xbd772f30, 0xbe105cbe, 0x3dd082c8, 0xbd80b46f, 0xbdceedb9, 0x3e0a13ef, 
    0xbd9fc17b, 0xbdaa8efd, 0x3d0bcb09, 0x3cff1761, 0x3d2eb624, 0x3bd96948, 0xbb3cd159, 0xbdd6a794, 
    0x3d97e504, 0xbe25740f, 0x3d5510f1, 0xbc3a7765, 0xbe331c26, 0x3d855c1d, 0x3c5fe2d9, 0xbd94bffa, 
    0xbb2ddde0, 0x3d02dd21, 0xbdce36c4, 0xbd85c187, 0xbda853dd, 0xbe1161b8, 0x3da6b30b, 0x3e3446b9, 
    0xbe228ced, 0x3d29cfa6, 0xbdffab8a, 0x3e196b50, 0x3d3801c8, 0x3e1d98e7, 0x3e0b6072, 0x3ddd1668, 
    0xbda0d289, 0xbc93021b, 0xbdf7b188, 0xbd80f8ae, 0xbe1ee81f, 0x3d4a1f83, 0x3c7a8c9a, 0xbd8bd2fe, 
    0xbe15b696, 0xbe05d751, 0x3e2b66a7, 0x3e2a86fb, 0xbccc4096, 0x3cd3ece4, 0x3df08147, 0xbe2293fe, 
    0x3e36791a, 0xbdd8e01e, 0xbd0733aa, 0x3d33bb02, 0xbd8ca556, 0x3dd0e5fd, 0x3c843b3c, 0xbcdbedc3, 
    0x3e34a61c, 0x3c9d32bd, 0xbdca69b4, 0xbe14960e, 0xbd1f3572, 0xbdddb690, 0x3c8ed36d, 0xbdd5d6bc, 
    0xbd5fa092, 0xbe108135, 0x3e02759d, 0x3e0b05f5, 0xbca52cc5, 0xbde9f111, 0xbe2bba3d, 0xbcd94310, 
    0x3e0433be, 0x3e0786c5, 0xbe155cc9, 0x3d94b416, 0x3d2c09e6, 0x3da1efc9, 0x3e007759, 0x3e2adaef, 
    0xbdfa12f1, 0xbe10b6ca, 0xbcdc8477, 0xbde25900, 0xbdb1e269, 0x3d5064e2, 0xbc8205f1, 0xbd787005, 
    0xbd657268, 0x3dc2cebc, 0xbe1e8d1d, 0xbd0604cd, 0xbda069b3, 0xbde47463, 0x3c95cbf4, 0x3d0c991c, 
    0xbddeb9b0, 0x3d88fc36, 0x3e22c0ee, 0xbe07725a, 0x3c9b86f8, 0xbe2a5822, 0xbdd2fd3c, 0xbd03de77, 
    0xbc52cf08, 0x3db12472, 0xbe0531bb, 0x3c565b3a, 0xbe0365bc, 0xbdcb8743, 0x3dde4f90, 0xbe1575ee, 
    0x3e2b37bf, 0x3d5bcabd, 0xbcfe1053, 0x3df52ebc, 0xbd442f9c, 0xbe14df67, 0x3e1de925, 0xbe108068, 
    0x3d6f3fe0, 0xbdd9cca9, 0x3bebd97d, 0x3dbdd887, 0xbd1dfbac, 0xbd381322, 0xbe34142b, 0xbcfc1752, 
    0xbdd65105, 0xbd8df0ce, 0xbdedbe92, 0xbbb21eb2, 0xbd7ddcc0, 0x3e24fbfa, 0xbe00d05a, 0xbcc38e4d, 
    0x3dfe0d2a, 0xbe17435b, 0xbe1b5d5f, 0xbd08a247, 0x3d595a57, 0x3cb537ef, 0xbdc792e3, 0xbe2521a9, 
    0x3cdfd3b0, 0xbe0a9d95, 0x3e2bf107, 0x3e2cc849, 0x3d026f4e, 0xbde255ef, 0x3c7c864a, 0xbda1976f, 
    0xbdbb8d68, 0x3e1ae2b3, 0xbbede31e, 0x3dc8b91a, 0x3dd5c916, 0xbe1c6ae1, 0xbce0e16f, 0xbc8089c7, 
    0xbd36231b, 0xbe340ca6, 0x3d98afb9, 0x3dd0603f, 0x3d71ddf7, 0x3e035e00, 0x3dd749fd, 0x3a9bddc7, 
    0x3e168365, 0x3e092193, 0xbdfc22bc, 0xbd19c5ff, 0xbdac153e, 0x3d1488c8, 0x3cd8a464, 0xbe1ba349, 
    0xbdb64e3d, 0x3e2c2aae, 0x3db4665d, 0x3c74a4c0, 0xbc354ad7, 0xbe0a3a12, 0x3cf38b5a, 0xbe05ac6f, 
    0xbcc81c25, 0xbdd829ab, 0x3bdb632b, 0xbd85a144, 0xbdc50c52, 0xbd7ad491, 0x3d2c3994, 0x3dcfae1c, 
    0x3d2901d8, 0xbd129a31, 0x3d9fe8af, 0xbc7c16b1, 0x3d6dd6bf, 0xbe27b82f, 0xbe009f44, 0xbdf40542, 
    0xbdbbdba6, 0x3d46dc21, 0xbdfda2ee, 0xbc7670a4, 0xbd1c5f77, 0x3e01b738, 0xbddf05a7, 0x3e1a277d, 
    0xbe0a2061, 0xbd13362c, 0xbde5804c, 0xbd18703f, 0x3e08ceab, 0x3e01956b, 0xbdd9320e, 0x3d9d2e77, 
    0x3db01751, 0x3d69b38c, 0x3dfcb2a9, 0x3adf4ce8, 0x3d155ed4, 0xbdff91c0, 0x3dfa4707, 0xbda76d6b, 
    0xbdec5cdc, 0x3ca2fc1c, 0xbcbcb085, 0xbdb1d875, 0x3d7621e1, 0x3e2b31be, 0x3ddf1e1e, 0xbd4fa3a0, 
    0x3e3754fa, 0x3e0203d7, 0x3d6d8078, 0xbe30017a, 0x3dfc1bca, 0xbe11c92c, 0xbe10bde1, 0xbe2a5cc0, 
    0xbdde4b8a, 0x3d955dad, 0x3d0f3fdd, 0xbc8ae8a9, 0x3da180ac, 0xbde67f0e, 0xbd8a9161, 0xbe320c88, 
    0xbde04cd5, 0xbda6f4b1, 0xbe07f688, 0xbc01ce74, 0xbd9a83a7, 0x3e1b40b9, 0x3dcbfb5d, 0x3c480f81, 
    0xbd80833b, 0xbdfd6e16, 0xbca9a491, 0xbd9e7cb2, 0xbe104ff1, 0xbdd3b23a, 0x3daa685c, 0xbb255418, 
    0x3dce79e5, 0x3cb5735a, 0xbe219657, 0xbd4e4592, 0xbd142256, 0x3dd90499, 0x3c48c3cd, 0x3cdfe526, 
    0x3c04fac9, 0x3c8b254c, 0x3e0c087d, 0xbdb66e99, 0xbde5813f, 0xbdc44e70, 0xbd6a697f, 0xbe2a5ede, 
    0x3e0f22f1, 0xbe322184, 0xbe2fa7ce, 0xbdc6fcf9, 0xbc65fb8a, 0xbe2eb6ac, 0x3e1efbdf, 0xbdd3bd38, 
    0x3d7b9b97, 0xbe25fd8d, 0xbc15bc8f, 0x3dbb8bd5, 0x3d5f57ca, 0xbd3d27cc, 0x3cf2a209, 0x3da4772a, 
    0x3d4a5a51, 0x3e1e23a3, 0xbe09a81e, 0xbe02c5ae, 0xbcdd3976, 0xbe188b7f, 0xbce7f421, 0x3e237a90, 
    0x3d6b4b06, 0x3d55fd80, 0xbd9d16a2, 0x3dbff22b, 0xbdc23635, 0xbd76f4d0, 0xbb1d99c6, 0xbe253f79, 
    0xbe0ad94c, 0xbe2828d2, 0xbe21961a, 0xbd5f9efc, 0xbca784ac, 0xbe1e1a7e, 0xbccfd5dd, 0x3db12833, 
    0xbdf5a622, 0xbd0aebad, 0xbc9e87ee, 0xbd7e4a6d, 0xbd87a6f7, 0xbe253dfb, 0xbe18e846, 0xbcbc1f75, 
    0x3e1a064b, 0xbd900ede, 0x3d7c277a, 0xbd35869e, 0x3e1a75fd, 0xbe055fb0, 0xbd35dba1, 0xbc30b78b, 
    0x3d3f2186, 0x3e12ec6c, 0x3e16b328, 0xbe30c605, 0xbe0602b6, 0x3d2653a3, 0xbe3a2194, 0xbdd11547, 
    0x3e1828e0, 0xbd832e6c, 0x3dbf46d3, 0xbd9ba6d1, 0x3d8d15db, 0x3e0e4aaa, 0x3e1f43ba, 0x3d152ed1, 
    0x3d6641db, 0xbd371b2f, 0xbdaa12a7, 0x3b23f93d, 0x3e0b5cfe, 0xbc2dc7f8, 0xbde64d9a, 0xbd333a61, 
    0xbe13c453, 0x3d7bb197, 0xbd9bb470, 0x3e1bab0a, 0x3da76e41, 0x3d2a7f4a, 0x3e1e3f4e, 0xbcf9db50, 
    0xbe2866ca, 0xbb896fc0, 0x3b12633a, 0x3db2e4ed, 0xbe272fdd, 0xbd2944bc, 0xbba9a206, 0x3cff56bc, 
    0xbe0595bd, 0xbe1bbfd5, 0xbbd0423a, 0x3e0bf6c5, 0xbda040a0, 0x3d931ed2, 0x3c91e439, 0xbcabdfd7, 
    0x3e23277e, 0xbe119926, 0x3d92b9e1, 0xbe19692b, 0x3df30ba8, 0x3d9dc6b8, 0xbc99a218, 0xbd891dd0, 
    0x3d2ced26, 0xbe2b2c00, 0x3c7aa437, 0x3d878b5d, 0xbe19aa84, 0xbd24cad0, 0x3d550bb2, 0xbd2d2a9e, 
    0xbdf9ea9f, 0xbe05d706, 0x3cd70ee8, 0xbe18e536, 0xbd43d7e7, 0xbe1dff12, 0x3dad084f, 0xbcc00fcc, 
    0xbe11e178, 0xbc0db9ff, 0xbe0e6ebf, 0xbcd6550d, 0xbdb519d6, 0xbdb1d582, 0x3ca1e92a, 0x3e22ce30, 
    0x3d1e3de7, 0x3d14b6d5, 0x3e2429b7, 0xbe1426fb, 0x3ddaaa7d, 0xbd9f2034, 0xbd885af1, 0x3e20a23d, 
    0x3d0a7b71, 0x3db142d7, 0x3dcc0474, 0xbd799788, 0xbdfbcde1, 0x3e24019b, 0xbdc4a456, 0x3d7fe444, 
    0x3e23d828, 0xbd394ccc, 0x3d3c2184, 0xbe1aa7e8, 0xbdd61099, 0xbe2b57ec, 0x3e12b37f, 0x3db29a7c, 
    0xbe241314, 0x3de831c2, 0x3daa69db, 0x3e089c8e, 0x3e1d03e5, 0xbd83ee2d, 0x3e16c4a0, 0x3c724823, 
    0xbe26e397, 0xbe293a78, 0x3c9e52f8, 0x3e19f400, 0x3e0659f3, 0x3d0ed0d8, 0xbb58ec85, 0x3d1d01f4, 
    0x3e221663, 0xbdc2d2b6, 0xbd840e33, 0x3e37034a, 0x3d0206dd, 0xbdd6ab6b, 0xbd961a51, 0x3d5a6a92, 
    0x3cee512b, 0x3e26dcf5, 0xbdc3f9f5, 0x3e2f9b88, 0xbd427d1c, 0xbe24683f, 0x3e2467e8, 0xbd9f7c9d, 
    0x3e171fb6, 0x3d1e361a, 0xbe01624a, 0x3c096434, 0xbe1d555c, 0xbddad4ef, 0x3dcc1547, 0x3d89f299, 
    0x3d8b3f43, 0xbdde7e5d, 0xbb564533, 0x3d8f7098, 0xbdf86d4c, 0xbe0a5c85, 0xbde5ead1, 0xbd2236c8, 
    0xbd761824, 0xbe268faf, 0x3db2d041, 0x3da57c35, 0x3cd083c0, 0xbd3b0ed6, 0x3e197cac, 0xbcf197c5, 
    0xbda0b22d, 0xbd3deb5a, 0xbd046237, 0x3e23021d, 0xbdb6dc1f, 0xbdcfd974, 0xbdf16748, 0x3e03ab7c, 
    0xbd8fdfa7, 0x3ce98d4d, 0xbd48ae6b, 0x3db35d87, 0xbd67a0c7, 0xbde788c7, 0x3da30ddf, 0xbdcb1853, 
    0xbe36d7f6, 0xbbfdf25b, 0xbd4996b7, 0x3db3439b, 0x3db5e341, 0x3d819f67, 0xbd93d11e, 0xbe0f0420, 
    0xbb946aa9, 0xbd2ca90c, 0xbd8c72f1, 0x3d2bb91c, 0xbe10e9b5, 0xbe2351fd, 0xbc709bc6, 0x3d3d6b81, 
    0xbe29c266, 0xbdf83976, 0x3e2f9f92, 0x3e15b694, 0x3e22639f, 0xbe01e53c, 0xbcd797ec, 0x3da29805, 
    0xbd9806f5, 0xbdd2e37a, 0xbe3acde8, 0x3e0e1b95, 0xbdfc3c1d, 0x3e2d6481, 0xbdd67a61, 0xbd7fa1c6, 
    0x3dbf9ccd, 0x3d41c6af, 0xbddd7172, 0xbd367d63, 0xbe0abf3a, 0x3e3edf3a, 0xb9c333ca, 0xbdc26f62, 
    0xbe22d9b3, 0x3c5e54b4, 0xbe1dc4ea, 0x3de565af, 0x3dc595f4, 0x3e14b099, 0x3d9d8385, 0x3c16e66e, 
    0x3d133df3, 0x3cabb770, 0xbdcc34b7, 0x3df042d6, 0x3d869a50, 0x3dd8c1cf, 0xbd1e3ee7, 0xbda47a31, 
    0xbd58e053, 0xbd9012c7, 0xbb3e877f, 0xbcb0f4f8, 0x3d75b0b1, 0xbd722f08, 0x3d902fec, 0x3e386695, 
    0xbe28975d, 0x3da5659a, 0xbda17de8, 0xbbf29368, 0x3d6faafe, 0x3bdf9f95, 0xbc9778c4, 0x3d531a85, 
    0x3e0db35d, 0xbe253819, 0xbe1f1f63, 0xbd8073b2, 0xbe0615f7, 0x3d28006e, 0xbe2c7823, 0xbd4a2c09, 
    0x3e0f6f11, 0x3e106f15, 0x3e01eccb, 0x3d165840, 0x3d8d3da7, 0x3d1214a6, 0x3e037725, 0xbe1f2d34, 
    0xbdea557c, 0x3e0cc6f9, 0x3dbe7b10, 0xbd955455, 0x3de1f301, 0xbe2e2f7d, 0xbb063ed2, 0x3e3514ce, 
    0x3d8d746f, 0x3df6556e, 0xbd9dfb37, 0xbd7d0a97, 0x3cd122fb, 0x3dc657b3, 0x3dee63f9, 0xbd44470a, 
    0x3cd6ba7f, 0xbc182842, 0xbce29caf, 0xbd568a45, 0x3e1acc38, 0x3db6547f, 0xbd74d60d, 0xbde1d99f, 
    0xbe1a8f03, 0xbc92a28a, 0x3d0e1e11, 0xb9caac4b, 0xbdfe8f32, 0xbcacd6ca, 0x3c958b4f, 0x3da13cea, 
    0x3e13f8bb, 0x3c9168d8, 0x3d9aad23, 0xbd74740b, 0xbc4899c9, 0x3e31b248, 0x3e2b9658, 0x3e096724, 
    0xbe21f90b, 0x3e25f95f, 0xbe157e2c, 0xbdd8e19a, 0x3e285999, 0x3c26a8d1, 0x3d9b51c3, 0xbc89966f, 
    0xbe16aa68, 0xbce84d54, 0xbdde6930, 0xbde6e9a7, 0xbdd6f945, 0xbe0db0b3, 0x3d4e2291, 0xbcc7855a, 
    0xbd22be41, 0x3d892068, 0x3e0f7a04, 0x3d186da2, 0x3e222e79, 0xbc56a21b, 0xbd845cc8, 0xbd33c095, 
    0x3e0e7798, 0xbda7b82b, 0x3dbea8b5, 0xbe275628, 0x3d64b801, 0xbd541cc3, 0xbd25071d, 0x3d3d0641, 
    0xbc9eee9f, 0x3e2d2959, 0x3da3c627, 0x3d465ac7, 0xbc8b112a, 0xbd4a267a, 0x3cc4e679, 0x3e1b8e36, 
    0x3e12dc75, 0xbd93f1dc, 0xbdb92628, 0xbdc788a1, 0xbd4e693e, 0x3dc1d1d2, 0x3b874e32, 0x3dc6dc38, 
    0x3dcb4af0, 0xbdc4437c, 0xbb5ecbd3, 0xbc84f112, 0xbd9f7bf9, 0xbe1592cb, 0x3c7203ab, 0xbda694b9, 
    0xbd4f341c, 0x3deb8468, 0x3ce4c0af, 0xbc8fefa9, 0x3e26029b, 0x3b756f99, 0x3cc85d17, 0xbb0c3247, 
    0xbde9c14f, 0xbd5309b1, 0xbd0573b6, 0xbc425840, 0x3df696bd, 0xbd3ba102, 0xbc869480, 0x3dc2b952, 
    0x3dfd08a6, 0x3b77d053, 0xbd346160, 0x3e2ff6a3, 0x3c21d457, 0xbdc8363f, 0xbdb8762d, 0xbdb91e3e, 
    0x3e09bb2f, 0x3e0c4a6d, 0x3db7c8fa, 0xbdde784b, 0x3e14a5eb, 0xbe05786a, 0x3e2f17a8, 0x3e2a9b9e, 
    0x3dbed027, 0x3d5c2c57, 0x3e1a8a63, 0x3c95d5d1, 0xbe0fea24, 0xbd5faba7, 0xbd112e6a, 0xbdb2cd69, 
    0x3e0f04c2, 0x3d6d18b2, 0x3c479338, 0x3e0410a2, 0x3bdde926, 0x3e0fc683, 0x3d9dda1e, 0xbdb58acd, 
    0xbc98c90e, 0x3e163da9, 0x3d3cc545, 0x3e14d8a9, 0xbd893b6a, 0xbcd5e90a, 0x3e0d3cdf, 0x3e1a1c07, 
    0xbdfcc9ad, 0x3cebaa67, 0x3de3a753, 0x3e1c62b5, 0xbc972dff, 0xbe09db90, 0x3e362ddd, 0x3da7b3d8, 
    0xbd95e21c, 0xbd4d85d5, 0xbdf6dff3, 0x3d7a1714, 0xbd0e736c, 0xbda1ed9e, 0x3df3eec3, 0x3e0978d3, 
    0xbd7efabd, 0xbd2a3283, 0xbd9ba629, 0xbe343576, 0xbe14562b, 0x3cc2c932, 0xbdfbf4d0, 0xbe31fc60, 
    0xbcd08d5a, 0xbdd774d8, 0x3c50b6dc, 0xbe1cfe6a, 0x3ce5b54f, 0xbd31f824, 0xbbdc2035, 0xbd886123, 
    0x3b862330, 0xbdccbfc7, 0xbcc6153d, 0x3e34285a, 0x3da5f3e0, 0xbd9e71a0, 0xbd2c0e8f, 0xbd0c6d31, 
    0xbd8e6ae6, 0xbdb4e713, 0xbdd63f67, 0xbdca0b73, 0x3d3b1b8f, 0xbd71aea9, 0xbce06399, 0xbdef3691, 
    0x3b9b920d, 0x3cd283f5, 0x3d5ceacd, 0x3cfc3b27, 0x3e27d486, 0xbd7c9043, 0x3de6a0d5, 0xbe167e1f, 
    0xbc85dbd7, 0xbdd26337, 0xbd2d258d, 0xbd4a13ba, 0xbe02b2ed, 0x3df1235c, 0xbde90732, 0xbcccbb01, 
    0xbe2bcd23, 0x3de287dc, 0x3e18ce32, 0xbcaa1a25, 0xbd7badaf, 0x3e157baf, 0x3ce9e72a, 0x3c0b51d9, 
    0x3e2106f7, 0xbe12923b, 0x3d53fd4e, 0x3c0dc31d, 0x3dd696bd, 0xbe00da49, 0xbdc96376, 0x3d70b508, 
    0xbda35093, 0xbd535c6d, 0x3d39ec14, 0xbe001fc3, 0x3deb73b6, 0x3c7a72c6, 0x3de2650d, 0x3c59c9ac, 
    0x3df32d4b, 0x3dda21a1, 0xbe084acb, 0x3d784a1f, 0x3e135b71, 0x3d0a26aa, 0x3d8638ac, 0xbd94dda0, 
    0xbc87b477, 0x3de71338, 0xbdd48aa1, 0xbe158dea, 0xbd892935, 0xbd80f044, 0x3e10ac9e, 0xbc90d22a, 
    0xbe049340, 0xbdb3dd43, 0xbdd23bb3, 0x3dc562d7, 0x3de4a538, 0x3e12bcdb, 0x3d9e232d, 0xb9670c80, 
    0xbe211659, 0x3da8d762, 0xbccd2349, 0xbd530fb7, 0x3e214a0a, 0x3e312940, 0xbda3cb5f, 0x3e27fc2c, 
    0x3b07841d, 0x3e32d771, 0xbe29b57b, 0xbe04975f, 0xbe1e0551, 0xbdf78fba, 0x3cf97e36, 0x3df47fed, 
    0x3bbaa679, 0x3df6ae24, 0xbe368fbb, 0x3bb645ea, 0x3d8f2fa5, 0xbd713082, 0x3d5aa01e, 0x3d0bf207, 
    0xbe03d935, 0x3e3053bf, 0xbe050a51, 0xbc1cf923, 0x3e236d1e, 0x3c9f6009, 0xbda6447b, 0x3e29f97c, 
    0xbdd52b0e, 0xbe292c4b, 0x3e1b5d33, 0xbe204d79, 0xbda5d8f0, 0xbe0ab105, 0x3d66907e, 0x3c9af701, 
    0x3d0d123e, 0x3de74957, 0x3da80f69, 0xbd707fda, 0xbdbcf6f9, 0xbe2a5cd0, 0xbae38508, 0xbcd42ef2, 
    0x3dacc344, 0x3dbc0457, 0xbc8a6a0b, 0x3d9e0b31, 0x3dd748b0, 0x3de87ed1, 0x3dade289, 0x3de2f4bf, 
    0xbd71364b, 0xbdc54e19, 0x3df6e9f5, 0x3e19c28e, 0x3e231cb2, 0x3e0179e3, 0x3e2981ab, 0x3cdf6d43, 
    0x3d9137af, 0x3c45f004, 0x3cc30794, 0xbd24600e, 0x3e13179d, 0xbe01bc10, 0xbd645a08, 0xbdcba65a, 
    0x3cf9c173, 0x3c113a7f, 0xbe183651, 0x3d5e2de6, 0xbde0b7c6, 0x3d2a7282, 0x3dddfb58, 0xbd2cc8ec, 
    0xbd6e56b7, 0xbb6e9925, 0x3d7af99c, 0xbe0ba3ff, 0xbd4b7dbe, 0x3e0965f5, 0xbe0c445c, 0x3da5c5c7, 
    0xbded8057, 0xbc3e7fc5, 0x3e015d97, 0xbdfd6d26, 0x3e142388, 0x3d12b4b9, 0xbc60c467, 0x3dd4efb0, 
    0xbdcedd05, 0xbd269d73, 0xbe2d0d2a, 0x3dda9ded, 0x3d831544, 0xbd9f2254, 0x3e24c58b, 0xbd951c1f, 
    0x3dc990e9, 0xbc9916ad, 0x3db89982, 0xbe10d5a6, 0xbddac2cd, 0xbdf4cb74, 0xbdd33c51, 0x3de296ed, 
    0xbca78a05, 0x3e2d570f, 0x3db9173d, 0xbca52914, 0xbd307a35, 0x3e0b396f, 0x3dde395a, 0x3d0326e9, 
    0x3ce5affb, 0x3d8db4b7, 0x3e163ac8, 0xbd950510, 0xbe12b980, 0x3d869fa4, 0xbc317534, 0x3cae99e2, 
    0xbe1d4d02, 0xbcb3d98c, 0xbd9af227, 0xbb69bb0f, 0x3e2e04b1, 0xbdbf75ec, 0x3d35bd5a, 0xbcf44e84, 
    0xbdaf3a2b, 0x3c1708a0, 0x3d70447d, 0xbe2db5b8, 0xbcefae68, 0xbe35c044, 0xbbbc55ca, 0x3d023476, 
    0xbde5ccb7, 0x3d379763, 0xbd3babbf, 0x3b953983, 0xbe085534, 0xbd86751f, 0x3bb0bfc0, 0xbe0ea9ce, 
    0xbccb5835, 0xbddad046, 0xba36d2a5, 0x3e0402a2, 0xbdafd93d, 0xbd06dc0c, 0x3d8a121a, 0x3c8d8ccd, 
    0xbd40a51c, 0xbdc1bdbb, 0xbce1071f, 0xbe2ed9a4, 0xbe336834, 0x3d7357a9, 0x3d87c48b, 0x3d9943ea, 
    0x3d9468e2, 0x3db31ec3, 0x3b32808b, 0xbd83533c, 0xbdfe3f40, 0x3bfe1fc9, 0x3cfb74a8, 0x3df66770, 
    0x3d6d867c, 0xbd49b6cd, 0x3d23730e, 0x3d9b9f72, 0xbe225d6a, 0xbe155cb9, 0xbde84116, 0x3e235bf7, 
    0xbd15dafd, 0xbda4083e, 0xbdc4e4ff, 0xbd101299, 0xbdc42ed3, 0x3e20b842, 0xbe0e5953, 0x3e0aace2, 
    0xbe2cf1c7, 0x3e38c396, 0xbdcfc840, 0x3dc45846, 0xbdabf78f, 0x3de5bbf5, 0xbe21ac52, 0xbdccd390, 
    0x3d280f5f, 0xbd927100, 0xbd820525, 0x3dd438fb, 0xbbf8bb98, 0xbcd4b3b1, 0xbdcc0ed2, 0xbdfef215, 
    0xbcbb9047, 0xbe276a76, 0xbdd80e04, 0x3bb9eccc, 0x3e20b465, 0xbdca3663, 0x3cab025d, 0xbb900bf7, 
    0xbdf49ef7, 0x3da5329b, 0xbe09858e, 0xbd6e9506, 0xbd582493, 0xbdc037e0, 0x3df9d2b9, 0xbd9c8183, 
    0xbe351332, 0xbdcb8fad, 0x3daf2d8c, 0x3e1301fb, 0x3ddfe597, 0x3cbefd02, 0x3df2918f, 0xbd8aceac, 
    0xbd99492e, 0xbd8f9a7c, 0x3e1b59fb, 0x3db3f36f, 0x3c859183, 0xbd0c616c, 0xbe023f06, 0x3cc76709, 
    0x3d210cdf, 0x3d6fd484, 0x3e267aca, 0x3d8aa77b, 0xba9e8ac9, 0x3e21eb08, 0x3b401eb5, 0xbc181825, 
    0x3d3604f2, 0xbd96991a, 0xbd45b61e, 0x3df9072c, 0xbc82b4fd, 0x3c1125c8, 0x3dd04939, 0xbde2fc67, 
    0xbe2b9f70, 0xbdb2da1a, 0x3de77396, 0xbe28e2d3, 0x3dd138d7, 0xbd945342, 0x3dbd4ddc, 0x3dba4a77, 
    0xbe2c8bc4, 0xbc550700, 0xbd4b2819, 0x3e1360a3, 0x3dde53a8, 0xbd9a48fa, 0xbbec3d78, 0x3e2cbb61, 
    0x3e022c2e, 0x3da74960, 0x3d4f51b5, 0x3d6a9798, 0x3e1eaf80, 0x3d357b89, 0x3d71f592, 0xbd7f1fed, 
    0x3e0f62c7, 0x3d3aeddd, 0xbcfa984e, 0xbe1d149f, 0x3e300ed4, 0xbd58be67, 0x3df77b1c, 0x3de1e53d, 
    0x3d8815f4, 0xbcdbd0e3, 0xbe129208, 0xbe124bf3, 0xbe2f016b, 0xbde2fcc5, 0x3dff472e, 0x3c68b13b, 
    0xbd5fa80f, 0x3dd373d0, 0x3d775436, 0xbda063e0, 0x3d887269, 0x3d24d764, 0x3e09e85f, 0x3d9cb053, 
    0x3d3dc7e7, 0x3cd8a41f, 0x3c902a85, 0x3deb7439, 0xbe0a0a53, 0x3e01f3ee, 0xbd9414c2, 0xbd69de74, 
    0xbdd1f51c, 0x3c40913a, 0x3c3475db, 0xbd5cd3ce, 0x3dff53e1, 0x3e1adf8b, 0x3df7aa24, 0x3d70d434, 
    0xbd94921f, 0x3e1c4a3c, 0x3b48e049, 0xbd1003b1, 0xbd8c0d6b, 0xbddf3e2b, 0x3d931743, 0xbddc1c00, 
    0x3df8542e, 0xbe0deafc, 0xbb5b6861, 0xbd0a1b06, 0x3d8f2844, 0x3e31eaf5, 0xbc2d4044, 0x3dcd27ce, 
    0xbd3b63da, 0xbe2905f3, 0xbe17179c, 0xbdebf55c, 0xbdda841c, 0xbe405b42, 0xbc151ea1, 0xbe1247ec, 
    0xbc0f3823, 0xbd48320b, 0x3de5ce2f, 0x3dcf0f54, 0xbd4c0b99, 0xbd97622c, 0xbdc846f4, 0x3d3b0ec0, 
    0x3d78604d, 0x3e106579, 0xbe03f14d, 0x3dbe8fda, 0x3d47802e, 0x3de72b4d, 0xbe1f359c, 0xbe09594c, 
    0x3d4711c9, 0xbe0840a1, 0x3dc9aedc, 0xbdb13ca2, 0xbd37e103, 0xbd2a6685, 0xbda10842, 0xbdd75ba0, 
    0x3d83f22e, 0xbdcfd958, 0x3c142a13, 0x3d10c245, 0x3e2711ba, 0xbe073970, 0x3e363a3a, 0x3dbf7b1c, 
    0xbddd2524, 0xbd767be9, 0xbd966670, 0x3dd1bfe7, 0x3ddf0409, 0x3e1d33d5, 0xbdfb5e5b, 0x3bbcb227, 
    0x3d418d67, 0x3d2aebb4, 0x3cc93bcf, 0xbe1c51fa, 0x3da50abf, 0x3e2cbe90, 0xbd4892f5, 0xbd7501fa, 
    0x3df98b70, 0xbd8ed48b, 0x3df98ad3, 0xbded5b13, 0x3c5bf9f0, 0xbd9359e2, 0x3dae4531, 0xbd292770, 
    0xbda17a6d, 0xbdc7f200, 0xbe0b2959, 0xbe091028, 0x3e1e9576, 0xbe06c39d, 0x3df45fbf, 0x3e2688b9, 
    0xbcba526a, 0xbdd0ad80, 0x3e0466f6, 0xbc80cfe2, 0x3cbb6a05, 0xbdea25cb, 0x3cca759a, 0xbdf92a00, 
    0x3a29a9fb, 0xbcab2173, 0x3dd215e8, 0xbe2d332d, 0x3d1afd55, 0x3d83bb94, 0xbd6a2854, 0x3d314012, 
    0xbbb6c6e1, 0xbdf959c3, 0x3d27138a, 0xbd12b273, 0xbdfbedb8, 0x3d9175c6, 0xbcfdbe9c, 0x3e0ed1e3, 
    0x3d9c5feb, 0x3dc2fbb2, 0xbe0fbcf3, 0x3e27610c, 0xbdc56a05, 0xbde2bb57, 0xbda4e219, 0x3d59457b, 
    0xbdbfa975, 0xbca39468, 0x3ac1040a, 0xbc4d2926, 0x3df6c429, 0xbd553360, 0x3d5a9133, 0xbd53932c, 
    0xbd40d69d, 0xbe31494b, 0xb97259c9, 0xbd97c1fc, 0xbe1de870, 0x3d2cd537, 0x3d701166, 0x3dc49998, 
    0xbd9952e9, 0x3dfa7175, 0x3d21d366, 0x3d9b755e, 0x3dfa8dd1, 0x3d8507c7, 0x3d54b7e4, 0xbd8c965e, 
    0xbd90cf44, 0x3dae6d55, 0x3e02c5e9, 0xbd8e7d47, 0x3cfe911e, 0xbdd7fff3, 0xbb7c48d0, 0xbd3f52cf, 
    0xbb07208b, 0xbd5119a2, 0xbe348cc0, 0x3df80bc0, 0x3e11ba41, 0xbac08da8, 0x3db70e3c, 0x3e079e73, 
    0xbdefa7ec, 0xbe0830f2, 0x3db23630, 0xbd73f033, 0xbe0aaffc, 0x3d5dd743, 0x3da2c2e4, 0xbe1f308f, 
    0xbdd98d19, 0xbdc731a6, 0x3e3a0745, 0x3dfe2e5a, 0xbdfdf58d, 0x3e2e8870, 0xba0e9b8b, 0xbd2a6604, 
    0xbe1f1c57, 0xbdba6a86, 0x3ab7cd6e, 0xbe1e8b4e, 0xbdd0e03d, 0xbe227411, 0x3e21ac97, 0xbcfb0c7e, 
    0xbe154fd3, 0xbc822032, 0x3d26dad0, 0x3e16c9bd, 0x3e09a736, 0xbda5efd4, 0x3ca26d5a, 0x3df87631, 
    0xbd85f6c5, 0xbe202001, 0x3e13cd31, 0xbb14e55e, 0x3dd3af9c, 0xbe1cf36a, 0xbd50b75b, 0x3dc6cfab, 
    0xbe09a52e, 0x3dadd5b7, 0x3cb93b60, 0xbd45ee50, 0xbd98c994, 0x3e21e676, 0xbd9dd55d, 0xbd154bd8, 
    0xbe24cecd, 0x3e275b10, 0x3e24def7, 0x3d513ad3, 0xbe253da9, 0x3e2adff2, 0xbe2616bb, 0x3bf6aace, 
    0x3cfa1185, 0x3c9eb2d7, 0xbde90552, 0x3d6b87a1, 0xbe0890e5, 0xbd1768da, 0x3c9b044d, 0x3d5eddc8, 
    0x3def5fac, 0xbe169823, 0x3ca32f66, 0xbdb7c58d, 0xbe1338b6, 0xbcdb83bc, 0x3cf90570, 0x3ccd90f5, 
    0xbdb15348, 0xbccec699, 0xbd8c56c9, 0xbd9163ec, 0xbd4ca48f, 0xbe10971c, 0xbd2d5239, 0xbe0564e5, 
    0xbd0e8f8e, 0xbe32e14f, 0xbe18c99d, 0x3d9a1076, 0xbe2154b9, 0xbd85df4e, 0xbd3ebed4, 0x3d60d936, 
    0xbe09dbac, 0xbe28ebd4, 0xbdf01d47, 0x3de357a0, 0x3e1ec3ba, 0x3e26a613, 0x3df3e125, 0x3d321535, 
    0x3df5ec3c, 0xbd4aa955, 0x3d9e510b, 0x3c929c14, 0xbe330a30, 0x3e075bec, 0xbe35918e, 0x3cdc846c, 
    0x3da12dc1, 0xbde70e38, 0xbdec5fa0, 0xbe11e330, 0x3ddc7fea, 0x3d661866, 0xbc3f7934, 0xbb5c50b3, 
    0xbceddde7, 0xbe24ffe5, 0xbcb59392, 0xbe26aa73, 0xbdf88ea2, 0xbd45f20f, 0x3e186fbe, 0xbd021449, 
    0xbda89c4c, 0xbd707550, 0xbdb65b56, 0xbd59d42e, 0x3dc318ec, 0x3e276d9e, 0x3e13dadb, 0x3da17cf7, 
    0x3da81496, 0xbdd73710, 0xbda576ac, 0xbe2f2d56, 0x3dd655c2, 0xbdc4cdbb, 0xbd8df520, 0xbe15dfbf, 
    0xbd4793f5, 0xbdfad774, 0xbe19db86, 0xbe29133a, 0x3dfe5733, 0xbe115be2, 0x3d14fb64, 0x3d807b47, 
    0xbd86364c, 0xbb971549, 0xbdebdf82, 0xbddaf905, 0x3deab480, 0xbdd9c1a5, 0xbc14c586, 0xbce21a4c, 
    0xbded6b91, 0x3dc67dd6, 0x3e1c18d7, 0xbdb7e429, 0xbe0dd58a, 0x3d9fceab, 0x3df9019a, 0x3e0540d6, 
    0xbe02ca80, 0xbd9c41de, 0xbe25b3f1, 0xbd9ae0b0, 0xbd946a0b, 0x3e1bf2ce, 0x3d8f8cf7, 0xbd603df9, 
    0x3de2c85c, 0x3d859285, 0x3e015b7f, 0xbe1aa363, 0x3db5e75f, 0x3d8b4f42, 0x3e072e60, 0x3d0915d6, 
    0x3e369f84, 0x3e36dab7, 0x3cd3a62c, 0x3c196173, 0x3e1a6957, 0xbd096e0c, 0x3daeeb21, 0x3e1f4192, 
    0xbc2c4ea4, 0x3c13388c, 0x3d6cf14a, 0x3dd36bca, 0xbe098de0, 0xbdd9de17, 0x3e3c9d6e, 0xbe1e5a9a, 
    0xbdd441b2, 0x3d3ba82a, 0xbcc864c8, 0xbe14fffb, 0xbd8b4fe4, 0xbd8285cd, 0xbc8d499a, 0xbdfcf6ff, 
    0x3d88e14d, 0xbe1687f1, 0xbe2cf2c7, 0x39e06825, 0x3e0cd7c4, 0xbdaecbcb, 0xbd98cb6a, 0x3e1616fe, 
    0x3d73b528, 0xbb988126, 0x3c6f414d, 0xbd5261fd, 0xbde69719, 0x3c150b0e, 0x3e22e2b2, 0xbd8a157b, 
    0xbdaf13a6, 0xbdf4e4cd, 0x3e14f469, 0xbae23a96, 0x3ce7174f, 0x3dd39c62, 0xbcede3c7, 0x3dd5f6f4, 
    0x3df49c6a, 0xbe2855d3, 0xbe0b3dac, 0x3ded0a2a, 0x3e068c99, 0xbd01452f, 0xbb35a9fc, 0x3d78dea7, 
    0xbdc30839, 0xbd0eeab6, 0xbda24d2c, 0x3cde3576, 0x3d7b5d58, 0x3de06d3c, 0x3e0a89bb, 0xbda42a7e, 
    0xbde5c477, 0x3cc324f6, 0xbca4fe43, 0x3cd32df5, 0xbd6db843, 0xbcdc7fff, 0x3df601d8, 0xbdcecae7, 
    0xbe287372, 0x3e05acc7, 0x3e0539dd, 0x3d9cf9e9, 0x3dd17fe8, 0x3d99b203, 0x3c456431, 0x3cf8eb0d, 
    0xbdd75d8f, 0x3ba41832, 0x3cd25227, 0x3d700ba5, 0xbd2806a8, 0x3e2bfe1f, 0xbe132f10, 0x3e0c67cc, 
    0x3e0b7f0f, 0xbb932cd2, 0x3de9f2e2, 0xbc848a18, 0xbd137e35, 0xbb5500da, 0xbd9dc523, 0x3e37fada, 
    0x3d9d5061, 0xbd8e9e75, 0x3d509ec3, 0xbd9e23aa, 0xbdd4403c, 0x3d7e79e0, 0xbe2d5fe2, 0xbdb98454, 
    0x3e1b5085, 0xbdb0412a, 0xbd1fd742, 0xbdde45a2, 0xbd6a4a60, 0x3dc7fc95, 0x3e21d1b5, 0xbc4409f8, 
    0xbdfca5ba, 0xbe1ad839, 0x3d5fc969, 0x3de8e8e9, 0x3b05b2b9, 0x3c8349fd, 0xbdfb8395, 0xbdf061cd, 
    0xbe06dac8, 0x3de55df4, 0x3e2f26c2, 0xbd347f1c, 0xbd7b175a, 0xbb6e7454, 0xbe340c01, 0x3d51ce8a, 
    0x3cb89ddd, 0x3e1ed1bb, 0xbdccbf41, 0xbd1e9021, 0x3d82079f, 0x3e28b7be, 0xbe264c35, 0xbe244aac, 
    0x3d8d7322, 0xbcaf1328, 0x3df0b30e, 0x3de8936d, 0xbdc7062d, 0xbe1adca0, 0xbd13cf2e, 0x3d86ae4c, 
    0x3dac9cb5, 0x3d8c43d8, 0x3d755bd5, 0x3a11d63e, 0x3e0d8026, 0x3d164aca, 0xbdc931d8, 0xbe06891e, 
    0xbde3f0b2, 0xbd93f766, 0x3cf97769, 0x3db933cf, 0xbcb5a3db, 0x3e0adc34, 0x3d480749, 0x3e11a6bf, 
    0xbe21cb66, 0xbdac3b39, 0x3e1ccc37, 0x3d24c40a, 0x3df50f8d, 0xbe0d1a15, 0x3db598a1, 0xbe3789bf, 
    0xbd8d614d, 0xbdbb0b8f, 0x3d9d3084, 0xbddf162e, 0x3e13ed9d, 0x3dceab1a, 0x3dbc225f, 0xbe2dde64, 
    0xbe01ed2d, 0xbe042d68, 0x3e1bb24b, 0x3c7547e9, 0x3d89d553, 0x3d046233, 0xbd82e889, 0x3dc2e1a4, 
    0x3e01da1f, 0xbc6919e9, 0x3de5914f, 0xbe306608, 0xbd2095f4, 0xbde846f9, 0x3b407a5b, 0xbd5dcb78, 
    0xbd83f325, 0x3dd038dc, 0xbd8b0b7e, 0x3d8d30b7, 0xbcc21b88, 0x3e05b100, 0x3d9ac606, 0x3d818f15, 
    0x3d9d1997, 0xbda86ef4, 0x3dc91e0b, 0xbd9aff3d, 0x3b7ae0a0, 0xbda0aaac, 0x3e37543e, 0xbd6fee5b, 
    0x3e2153fb, 0x3e0f0b32, 0x3d43301c, 0xbe286f59, 0x3d3ce77c, 0x3de475ee, 0x3dfaf73a, 0xbc7f4a54, 
    0xbdc6cb3b, 0x3e207750, 0xbdf08f27, 0xbd219ad6, 0x3b697a20, 0xbd31f84f, 0xbe31fe9e, 0xbddecc4d, 
    0xbd0fb60e, 0xbdc3ff10, 0x3c855526, 0xbd5b41e0, 0x3cb4e720, 0xbc9d26ed, 0xbe2c8fb4, 0x3c5c1840, 
    0x3c2a966d, 0x3debb1ed, 0xbd7a9a58, 0x3dcca098, 0x3e14a66d, 0x3dbb3788, 0xbdfc76f1, 0x3d1094e2, 
    0xbe1074cb, 0xbdb4a089, 0x3e2be673, 0x3bf2d556, 0xbd057693, 0xbc952668, 0x3dd30714, 0xbe17e08f, 
    0x3dc6dffe, 0x3ddcdd6e, 0xbe1c9cb8, 0x3d56ce9e, 0x3c114b8d, 0x3d450190, 0xbdf52d83, 0xbe29fecc, 
    0x3e0ecc66, 0xbe144114, 0x3e0ca0a8, 0xbc6ffaee, 0xbd9a0dd9, 0xbdede369, 0xbd9ada22, 0x3daa8b8e, 
    0x3cdd1a07, 0x3e0f1bba, 0xbe15ea1b, 0xbb7d124e, 0xbdd74ea4, 0xbdd13497, 0xbe0f92d1, 0xbde32f7b, 
    0x3e2078bc, 0xbe135db3, 0x3cc0359c, 0xbc4c8df3, 0xbdbda930, 0x3bdc9ab3, 0x3d61cdd2, 0xbd8c5935, 
    0xbc25bc6e, 0xbe03f089, 0xbdd269b3, 0xbd5439ca, 0x3e24e524, 0x3d86945f, 0xbbef82b0, 0x3dc1896d, 
    0xbcece6e9, 0x3e2314c4, 0x3dd51d88, 0x3e0a4bdc, 0xbc1650b0, 0xbd857bbc, 0xbd89201c, 0xbe0e585d, 
    0x3cd67bc5, 0x3d2a7aca, 0xbcba1c04, 0xbdee6679, 0x3e1a05b1, 0xbe1c27ee, 0x3db51551, 0xbd4b0a81, 
    0x3d05a292, 0xbe0f4554, 0xbdfa75f5, 0x3d128379, 0x3ce7c70e, 0x3d4e39d2, 0xbd94aeb7, 0x3e16895f, 
    0xbe28325b, 0xbc70b7b6, 0xbdd65a4b, 0xbd463c3e, 0x3dfc2ac1, 0xbccfc6da, 0x3e09ca7b, 0x3d50dce8, 
    0x3dd142cb, 0xbd4b336a, 0xbda4364b, 0xbc3aa0d1, 0x3bcef1a2, 0x3df38acf, 0x3c383ceb, 0x3cc9277f, 
    0xbde4b902, 0xbd8082dc, 0xbdf729fc, 0xbd62f202, 0x3cad7fb9, 0x3dd3bdd8, 0x3ded2859, 0xbd534e18, 
    0x3e21717c, 0x3e094bb0, 0xbdb62195, 0xbcf3f679, 0x3d8a310c, 0x3e22c232, 0x3d1c3845, 0x3dfbc0a6, 
    0xbdce7c9b, 0x3dce62b4, 0x3cf112ba, 0xbe15dcb2, 0x3d3610c9, 0x3e001ede, 0xbd883d01, 0xbe28891e, 
    0xbd97221f, 0xbdfb9c4a, 0x3c8b878c, 0xbe1624ea, 0xbc4bd01a, 0x3e25e54b, 0xbd9952c4, 0xbd200981, 
    0xbe1eca56, 0x3dcb0493, 0x3bba9d22, 0x3de33b47, 0xbda2094f, 0xbdda8064, 0xbb3bd764, 0xbe1c0c9c, 
    0x3e07c9b2, 0xbdf62bfe, 0xbd8a49fc, 0xbd9a285f, 0x3e27c652, 0x3d004d89, 0x3cbcc34d, 0xbde3c2eb, 
    0xbb98cee6, 0xbdd43153, 0xbe30478d, 0xbe2e4660, 0xbb0c144c, 0xbd97b14e, 0xbdbcf6ce, 0x3b86b80f, 
    0xbe13813d, 0xbe07f085, 0xbd06b46b, 0xbe11332f, 0x3dae0715, 0xbd4cf92c, 0xbdb031b5, 0xbcebcaa7, 
    0xbe248f5b, 0x3caaa111, 0x3ce5d4a9, 0xbd03dc50, 0xbd1e0a31, 0xbdd4927f, 0x3d189528, 0xbe17f832, 
    0x3dfc4730, 0xbcfb5b9b, 0x3e0ce0a5, 0x3e0692d6, 0xbe2ca0c0, 0x3e10728e, 0xbdc515ea, 0x3df45120, 
    0xbd19bc2a, 0xbdffaa34, 0x3cbaefd6, 0x3e222f13, 0x3dcd0744, 0xbdd73855, 0x3e1b5087, 0xbd59c89c
};

static const uint32_t _K42[] = {
    0x3fbfece2, 0x3fdd4339, 0x3fa461de, 0x3ffb129f, 0x3fc1d5d0, 0x402df7bd, 0x4003663c, 0x40172812, 
    0x3fbdc03a, 0x3f9915c2, 0x3ff6acd3, 0x3ff817b3, 0x400b550f, 0x3fcb6ff2, 0x3fe5f3a6, 0x401d8c3b, 
    0x3fd69c89, 0x3fe1ee0b, 0x400ef81c, 0x3fe99f99, 0x40419e16, 0x3ffc3fe6, 0x402ae1f5, 0x3fa8ac24, 
    0x3fce25f0, 0x3fa1420d, 0x400ef4bb, 0x3f8e7295, 0x3fea5609, 0x40262a3f, 0x3ff5f915, 0x40055417
};

static const uint32_t _K43[] = {
    0xbe65e81a, 0x3f46af39, 0xbea18226, 0x3ef9b9ff, 0x3f6e203b, 0x3f0b9117, 0xbf0d066d, 0x3f12f4ef, 
    0x3e61b634, 0xbe606042, 0x3ec58b74, 0x3da03215, 0x3f8624b8, 0x3f10a7c9, 0xbf9fa144, 0x3f32015e, 
    0x3f19126d, 0x3dca3db5, 0xbf28ab55, 0x3f642910, 0x3f05be3b, 0xbeca3493, 0x3f49fe8a, 0xbf166a19, 
    0x3fcd4887, 0x3f098f4c, 0xbe289b0c, 0xbe1041ae, 0xbf145e4f, 0xbf94f19d, 0xbf245498, 0xbf33e5dd
};

static const uint32_t _K47[] = {
    0xbe952f1e, 0xbe055acd, 0xbea38fe3, 0x3ec9dba4, 0xbe9e1f47, 0xbd1ad91c, 0x3ed63047, 0xbeb1ee1e, 
    0xbc04e70d, 0x3ea3a68c, 0xbe56786b, 0xbe7b88dc, 0xbe915c5b, 0x3cd85710, 0xbd2b9660, 0x3eb5567c, 
    0x3e2790f8, 0x3d9fc27c, 0x3eb16f47, 0xbe52bd15, 0xbeb83db8, 0x3e60646a, 0x3ea2464c, 0xbe8efa03, 
    0xbd8e4dd8, 0xbdb19a62, 0x3ec6adc9, 0xbe1fc8bf, 0x3e96128c, 0x3e64c870, 0x3de93ca3, 0xbe8c9a89, 
    0x3cfd06ac, 0xbe9dcc84, 0xbd1a1c91, 0xbe160719, 0x3e681a91, 0x3e864f0a, 0xbeb08e56, 0x3cd29307, 
    0x3ecccf86, 0xbe1db9ca, 0xbccc9299, 0x3ea19c2c, 0xbe7495ba, 0x3e827a2c, 0xbeca71fd, 0xbda261ed, 
    0x3ea9cdcb, 0x3ebc009c, 0xbed701a4, 0x3ec3c816, 0x3e138593, 0x3e5905f2, 0xbe76a8e7, 0x3dd95489, 
    0x3e954383, 0x3e2ccc67, 0x3e90cbbf, 0xbe5b46d9, 0xbed47ac7, 0xbed8cc59, 0x3dc7901d, 0xbe404992
};

static const uint32_t _K49[] = {
    0x3cca88a2, 0xbcca88a1
};

// Memory mapped buffers
#define _K11             ((int *)_K11)                       // s32[32] (128 bytes) 
#define _K18             ((float *)_K18)                     // f32[13,3,30] (4680 bytes) 
#define _K19             ((float *)_K19)                     // f32[13] (52 bytes) 
#define _K22             ((float *)_K22)                     // f32[16,3,13] (2496 bytes) 
#define _K24             ((float *)_K24)                     // f32[16] (64 bytes) 
#define _K25             ((float *)_K25)                     // f32[16] (64 bytes) 
#define _K29             ((float *)_K29)                     // f32[32,3,16] (6144 bytes) 
#define _K31             ((float *)_K31)                     // f32[32,3,32] (12288 bytes) 
#define _K33             ((float *)_K33)                     // f32[32] (128 bytes) 
#define _K34             ((float *)_K34)                     // f32[32] (128 bytes) 
#define _K38             ((float *)_K38)                     // f32[32,3,32] (12288 bytes) 
#define _K4              ((float *)_K4)                      // f32[512] (2048 bytes) 
#define _K40             ((float *)_K40)                     // f32[32,3,32] (12288 bytes) 
#define _K42             ((float *)_K42)                     // f32[32] (128 bytes) 
#define _K43             ((float *)_K43)                     // f32[32] (128 bytes) 
#define _K47             ((float *)_K47)                     // f32[2,32] (256 bytes) 
#define _K49             ((float *)_K49)                     // f32[2] (8 bytes) 
#define _K16             ((int8_t *)(_state + 0x000008d0))   // s8[6208] (6208 bytes) 
#define _K3              ((int8_t *)(_state + 0x00000000))   // s8[2256] (2256 bytes) 
#define _K7              ((int *)(_state + 0x00002110))      // s32[24] (96 bytes) 
#define _K8              ((float *)(_state + 0x00002170))    // f32[258] (1032 bytes) 
#define _K10             ((float *)(_buffer + 0x00000000))   // f32[257] (1028 bytes) 
#define _K12             ((float *)(_buffer + 0x00000404))   // f32[30] (120 bytes) 
#define _K13             ((float *)(_buffer + 0x00000000))   // f32[30] (120 bytes) 
#define _K14             ((float *)(_buffer + 0x00000078))   // f32[30] (120 bytes) 
#define _K15             ((float *)(_buffer + 0x00000000))   // f32[50,30] (6000 bytes) 
#define _K2              ((float *)(_buffer + 0x00000000))   // f32[512] (2048 bytes) 
#define _K20             ((float *)(_buffer + 0x00001770))   // f32[24,13] (1248 bytes) 
#define _K21             ((float *)(_buffer + 0x00000000))   // f32[12,16] (768 bytes) 
#define _K23             ((float *)(_buffer + 0x00000000))   // f32[12,16] (768 bytes) 
#define _K26             ((float *)(_buffer + 0x00000300))   // f32[12,16] (768 bytes) 
#define _K27             ((float *)(_buffer + 0x00000300))   // f32[12,16] (768 bytes) 
#define _K28             ((float *)(_buffer + 0x00000600))   // f32[12,32] (1536 bytes) 
#define _K30             ((float *)(_buffer + 0x00000000))   // f32[12,32] (1536 bytes) 
#define _K32             ((float *)(_buffer + 0x00000000))   // f32[12,32] (1536 bytes) 
#define _K35             ((float *)(_buffer + 0x00000600))   // f32[12,32] (1536 bytes) 
#define _K36             ((float *)(_buffer + 0x00000600))   // f32[12,32] (1536 bytes) 
#define _K37             ((float *)(_buffer + 0x00000000))   // f32[12,32] (1536 bytes) 
#define _K39             ((float *)(_buffer + 0x00000600))   // f32[12,32] (1536 bytes) 
#define _K41             ((float *)(_buffer + 0x00000600))   // f32[12,32] (1536 bytes) 
#define _K44             ((float *)(_buffer + 0x00000000))   // f32[12,32] (1536 bytes) 
#define _K45             ((float *)(_buffer + 0x00000000))   // f32[12,32] (1536 bytes) 
#define _K46             ((float *)(_buffer + 0x00000600))   // f32[32] (128 bytes) 
#define _K48             ((float *)(_buffer + 0x00000000))   // f32[2] (8 bytes) 
#define _K5              ((float *)(_buffer + 0x00000800))   // f32[512] (2048 bytes) 
#define _K50             ((float *)(_buffer + 0x00000008))   // f32[2] (8 bytes) 
#define _K6              ((float *)(_buffer + 0x00001000))   // f32[257,2] (2056 bytes) 
#define _K9              ((float *)(_buffer + 0x00000000))   // f32[512] (2048 bytes) 

// Represents a Circular Buffer
// https://en.wikipedia.org/wiki/Circular_buffer
typedef struct
{
	char *buf;
	int size;		// total bytes allocated in *buf
	int used;		// current bytes used in buffer.
	int read;
	int write;
} cbuffer_t;

#define CBUFFER_SUCCESS 0
#define CBUFFER_NOMEM -1

// Initializes a cbuffer handle with given memory and size.
static inline void cbuffer_init(cbuffer_t *dest, void *mem, int size) {
	dest->buf = mem;
	dest->size = size;
	dest->used = 0;
	dest->read = 0;
	dest->write = 0;
}

// Returns the number of free bytes in buffer.
static inline int cbuffer_get_free(cbuffer_t *buf) {
	return buf->size - buf->used;
}

// Returns the number of used bytes in buffer.
static inline int cbuffer_get_used(cbuffer_t *buf) {
	return buf->used;
}

// Writes given data to buffer.
// Returns CBUFFER_SUCCESS or CBUFFER_NOMEM if out of memory.
static inline int cbuffer_enqueue(cbuffer_t *buf, const void *data, int data_size) {
	int free = cbuffer_get_free(buf);

	// Out of memory?
	if (free < data_size)
		return CBUFFER_NOMEM;

	// Is the data split in the end?
	if (buf->write + data_size > buf->size) {
		int first_size = buf->size - buf->write;
		memcpy(buf->buf + buf->write, data, first_size);
		memcpy(buf->buf, ((char *)data) + first_size, data_size - first_size);
	}
	else {
		memcpy(buf->buf + buf->write, data, data_size);
	}
	buf->write += data_size;
	if (buf->write >= buf->size)
		buf->write -= buf->size;

	buf->used += data_size;
	return CBUFFER_SUCCESS;
}

// Advances the read pointer by given count.
// Returns CBUFFER_SUCCESS on success or CBUFFER_NOMEM if count is more than available data
static inline int cbuffer_advance(cbuffer_t *buf, int count) {
	int used = cbuffer_get_used(buf);

	if (count > used)
		return CBUFFER_NOMEM;

	buf->read += count;
	if (buf->read >= buf->size)
		buf->read -= buf->size;

	// Reset pointers to 0 if buffer is empty in order to avoid unwanted wrapps.
	if (buf->read == buf->write) {
		buf->read = 0;
		buf->write = 0;
	}

	buf->used -= count;
	return CBUFFER_SUCCESS;
}

// Reset instance (clear buffer)
static inline void cbuffer_reset(cbuffer_t *buf) {
	buf->read = 0;
	buf->write = 0;
	buf->used = 0;
}

// Copies given "count" bytes to the "dst" buffer without advancing the buffer read offset.
// Returns CBUFFER_SUCCESS on success or CBUFFER_NOMEM if count is more than available data.
static inline int cbuffer_copyto(cbuffer_t *buf, void *dst, int count, int offset) {
	
	if (count > cbuffer_get_used(buf))
		return CBUFFER_NOMEM;

	int a0 = buf->read + offset;
	if (a0 >= buf->size)
		a0 -= buf->size;

	int c0 = count;
	if (a0 + c0 > buf->size)
		c0 = buf->size - a0;
	
	memcpy(dst, buf->buf + a0, c0);
	
	int c1 = count - c0;

	if (c1 > 0)
		memcpy(((char *)dst) + c0, buf->buf, c1);

	return CBUFFER_SUCCESS;
}

// Returns a read pointer at given offset and  
// updates *can_read_bytes (if not NULL) with the number of bytes that can be read.
// 
// Note! Byte count written to can_read_bytes can be less than what cbuffer_get_used() returns.
// This happens when the read has to be split in two since it's a circular buffer.
static inline void *cbuffer_readptr(cbuffer_t* buf, int offset, int *can_read_bytes)
{
	int a0 = buf->read + offset;
	if (a0 >= buf->size)
		a0 -= buf->size;
	if (can_read_bytes != NULL)
	{
		int c0 = buf->used;
		if (a0 + c0 > buf->size)
			c0 = buf->size - a0;

		*can_read_bytes = c0;
	}
	return buf->buf + a0;
}

typedef struct {
	cbuffer_t data_buffer;			// Circular Buffer for features
	int input_size;					// Number of bytes in each input chunk
	int window_count;				// Number of input chunks in output window.
} fixwin_t;

#ifdef _MSC_VER
static_assert(sizeof(fixwin_t) <= 64, "Data structure 'fixwin_t' is too big");
#endif

#define IPWIN_RET_SUCCESS 0
#define IPWIN_RET_NODATA -1
#define IPWIN_RET_NOMEM -2

/*
* Try to dequeue a window.
*
* @param handle Pointer to an initialized handle.
* @param dst Pointer where to write window.
* @param stride_count Number of items (of size handle->input_size) to stride window.
* @return IPWIN_RET_SUCCESS (0) or IPWIN_RET_NODATA (-1) is no data is available.
*/
static inline int fixwin_dequeuef32(void* restrict handle, void* restrict dst, int stride_count)
{
	fixwin_t* fep = (fixwin_t*)handle;

	const int stride_bytes = stride_count * fep->input_size;
	const int size = fep->window_count * fep->input_size;
	if (cbuffer_get_used(&fep->data_buffer) >= size) {
		if (cbuffer_copyto(&fep->data_buffer, dst, size, 0) != 0)
			return IPWIN_RET_NOMEM;

		if (cbuffer_advance(&fep->data_buffer, stride_bytes) != 0)
			return IPWIN_RET_NOMEM;

		return IPWIN_RET_SUCCESS;
	}
	return IPWIN_RET_NODATA;
}

static inline void hannmul_f32(const float* restrict a, const float* restrict b, float* restrict result, int d0, int d1)
{
	for (int j = 0; j < d1; j++) {
		for (int i = 0; i < d0; i++) {
			*result++ = *a++ * b[i];
		}
	}
}

static void makeipt(int nw, int *ip)
{
    int j, l, m, m2, p, q;
    
    ip[2] = 0;
    ip[3] = 16;
    m = 2;
    for (l = nw; l > 32; l >>= 2) {
        m2 = m << 1;
        q = m2 << 3;
        for (j = m; j < m2; j++) {
            p = ip[j] << 2;
            ip[m + j] = p;
            ip[m2 + j] = p + q;
        }
        m = m2;
    }
}

static void makewt(int nw, int *ip, float *w)
{
    void makeipt(int nw, int *ip);
    int j, nwh, nw0, nw1;
    float delta, wn4r, wk1r, wk1i, wk3r, wk3i;
    
    ip[0] = nw;
    ip[1] = 1;
    if (nw > 2) {
        nwh = nw >> 1;
        delta = atan(1.0) / nwh;
        wn4r = cos(delta * nwh);
        w[0] = 1;
        w[1] = wn4r;
        if (nwh == 4) {
            w[2] = cos(delta * 2);
            w[3] = sin(delta * 2);
        } else if (nwh > 4) {
            makeipt(nw, ip);
            w[2] = 0.5 / cos(delta * 2);
            w[3] = 0.5 / cos(delta * 6);
            for (j = 4; j < nwh; j += 4) {
                w[j] = cos(delta * j);
                w[j + 1] = sin(delta * j);
                w[j + 2] = cos(3 * delta * j);
                w[j + 3] = -sin(3 * delta * j);
            }
        }
        nw0 = 0;
        while (nwh > 2) {
            nw1 = nw0 + nwh;
            nwh >>= 1;
            w[nw1] = 1;
            w[nw1 + 1] = wn4r;
            if (nwh == 4) {
                wk1r = w[nw0 + 4];
                wk1i = w[nw0 + 5];
                w[nw1 + 2] = wk1r;
                w[nw1 + 3] = wk1i;
            } else if (nwh > 4) {
                wk1r = w[nw0 + 4];
                wk3r = w[nw0 + 6];
                w[nw1 + 2] = 0.5 / wk1r;
                w[nw1 + 3] = 0.5 / wk3r;
                for (j = 4; j < nwh; j += 4) {
                    wk1r = w[nw0 + 2 * j];
                    wk1i = w[nw0 + 2 * j + 1];
                    wk3r = w[nw0 + 2 * j + 2];
                    wk3i = w[nw0 + 2 * j + 3];
                    w[nw1 + j] = wk1r;
                    w[nw1 + j + 1] = wk1i;
                    w[nw1 + j + 2] = wk3r;
                    w[nw1 + j + 3] = wk3i;
                }
            }
            nw0 = nw1;
        }
    }
}

static void makect(int nc, int *ip, float *c)
{
    int j, nch;
    float delta;
    
    ip[1] = nc;
    if (nc > 1) {
        nch = nc >> 1;
        delta = atan(1.0) / nch;
        c[0] = cos(delta * nch);
        c[nch] = 0.5 * c[0];
        for (j = 1; j < nch; j++) {
            c[j] = 0.5 * cos(delta * j);
            c[nc - j] = 0.5 * sin(delta * j);
        }
    }
}

static void bitrv2(int n, int *ip, float *a)
{
    int j, j1, k, k1, l, m, nh, nm;
    float xr, xi, yr, yi;
    
    m = 1;
    for (l = n >> 2; l > 8; l >>= 2) {
        m <<= 1;
    }
    nh = n >> 1;
    nm = 4 * m;
    if (l == 8) {
        for (k = 0; k < m; k++) {
            for (j = 0; j < k; j++) {
                j1 = 4 * j + 2 * ip[m + k];
                k1 = 4 * k + 2 * ip[m + j];
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += 2 * nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 -= nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += 2 * nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nh;
                k1 += 2;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= 2 * nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 += nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= 2 * nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += 2;
                k1 += nh;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += 2 * nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 -= nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += 2 * nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nh;
                k1 -= 2;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= 2 * nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 += nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= 2 * nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
            }
            k1 = 4 * k + 2 * ip[m + k];
            j1 = k1 + 2;
            k1 += nh;
            xr = a[j1];
            xi = a[j1 + 1];
            yr = a[k1];
            yi = a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            j1 += nm;
            k1 += 2 * nm;
            xr = a[j1];
            xi = a[j1 + 1];
            yr = a[k1];
            yi = a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            j1 += nm;
            k1 -= nm;
            xr = a[j1];
            xi = a[j1 + 1];
            yr = a[k1];
            yi = a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            j1 -= 2;
            k1 -= nh;
            xr = a[j1];
            xi = a[j1 + 1];
            yr = a[k1];
            yi = a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            j1 += nh + 2;
            k1 += nh + 2;
            xr = a[j1];
            xi = a[j1 + 1];
            yr = a[k1];
            yi = a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            j1 -= nh - nm;
            k1 += 2 * nm - 2;
            xr = a[j1];
            xi = a[j1 + 1];
            yr = a[k1];
            yi = a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
        }
    } else {
        for (k = 0; k < m; k++) {
            for (j = 0; j < k; j++) {
                j1 = 4 * j + ip[m + k];
                k1 = 4 * k + ip[m + j];
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nh;
                k1 += 2;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += 2;
                k1 += nh;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nh;
                k1 -= 2;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= nm;
                xr = a[j1];
                xi = a[j1 + 1];
                yr = a[k1];
                yi = a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
            }
            k1 = 4 * k + ip[m + k];
            j1 = k1 + 2;
            k1 += nh;
            xr = a[j1];
            xi = a[j1 + 1];
            yr = a[k1];
            yi = a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            j1 += nm;
            k1 += nm;
            xr = a[j1];
            xi = a[j1 + 1];
            yr = a[k1];
            yi = a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
        }
    }
}

static void bitrv216(float *a)
{
    float x1r, x1i, x2r, x2i, x3r, x3i, x4r, x4i, 
        x5r, x5i, x7r, x7i, x8r, x8i, x10r, x10i, 
        x11r, x11i, x12r, x12i, x13r, x13i, x14r, x14i;
    
    x1r = a[2];
    x1i = a[3];
    x2r = a[4];
    x2i = a[5];
    x3r = a[6];
    x3i = a[7];
    x4r = a[8];
    x4i = a[9];
    x5r = a[10];
    x5i = a[11];
    x7r = a[14];
    x7i = a[15];
    x8r = a[16];
    x8i = a[17];
    x10r = a[20];
    x10i = a[21];
    x11r = a[22];
    x11i = a[23];
    x12r = a[24];
    x12i = a[25];
    x13r = a[26];
    x13i = a[27];
    x14r = a[28];
    x14i = a[29];
    a[2] = x8r;
    a[3] = x8i;
    a[4] = x4r;
    a[5] = x4i;
    a[6] = x12r;
    a[7] = x12i;
    a[8] = x2r;
    a[9] = x2i;
    a[10] = x10r;
    a[11] = x10i;
    a[14] = x14r;
    a[15] = x14i;
    a[16] = x1r;
    a[17] = x1i;
    a[20] = x5r;
    a[21] = x5i;
    a[22] = x13r;
    a[23] = x13i;
    a[24] = x3r;
    a[25] = x3i;
    a[26] = x11r;
    a[27] = x11i;
    a[28] = x7r;
    a[29] = x7i;
}

static void bitrv208(float *a)
{
    float x1r, x1i, x3r, x3i, x4r, x4i, x6r, x6i;
    
    x1r = a[2];
    x1i = a[3];
    x3r = a[6];
    x3i = a[7];
    x4r = a[8];
    x4i = a[9];
    x6r = a[12];
    x6i = a[13];
    a[2] = x4r;
    a[3] = x4i;
    a[6] = x6r;
    a[7] = x6i;
    a[8] = x1r;
    a[9] = x1i;
    a[12] = x3r;
    a[13] = x3i;
}

static void cftf1st(int n, float *a, float *w)
{
    int j, j0, j1, j2, j3, k, m, mh;
    float wn4r, csc1, csc3, wk1r, wk1i, wk3r, wk3i, 
        wd1r, wd1i, wd3r, wd3i;
    float x0r, x0i, x1r, x1i, x2r, x2i, x3r, x3i, 
        y0r, y0i, y1r, y1i, y2r, y2i, y3r, y3i;
    
    mh = n >> 3;
    m = 2 * mh;
    j1 = m;
    j2 = j1 + m;
    j3 = j2 + m;
    x0r = a[0] + a[j2];
    x0i = a[1] + a[j2 + 1];
    x1r = a[0] - a[j2];
    x1i = a[1] - a[j2 + 1];
    x2r = a[j1] + a[j3];
    x2i = a[j1 + 1] + a[j3 + 1];
    x3r = a[j1] - a[j3];
    x3i = a[j1 + 1] - a[j3 + 1];
    a[0] = x0r + x2r;
    a[1] = x0i + x2i;
    a[j1] = x0r - x2r;
    a[j1 + 1] = x0i - x2i;
    a[j2] = x1r - x3i;
    a[j2 + 1] = x1i + x3r;
    a[j3] = x1r + x3i;
    a[j3 + 1] = x1i - x3r;
    wn4r = w[1];
    csc1 = w[2];
    csc3 = w[3];
    wd1r = 1;
    wd1i = 0;
    wd3r = 1;
    wd3i = 0;
    k = 0;
    for (j = 2; j < mh - 2; j += 4) {
        k += 4;
        wk1r = csc1 * (wd1r + w[k]);
        wk1i = csc1 * (wd1i + w[k + 1]);
        wk3r = csc3 * (wd3r + w[k + 2]);
        wk3i = csc3 * (wd3i + w[k + 3]);
        wd1r = w[k];
        wd1i = w[k + 1];
        wd3r = w[k + 2];
        wd3i = w[k + 3];
        j1 = j + m;
        j2 = j1 + m;
        j3 = j2 + m;
        x0r = a[j] + a[j2];
        x0i = a[j + 1] + a[j2 + 1];
        x1r = a[j] - a[j2];
        x1i = a[j + 1] - a[j2 + 1];
        y0r = a[j + 2] + a[j2 + 2];
        y0i = a[j + 3] + a[j2 + 3];
        y1r = a[j + 2] - a[j2 + 2];
        y1i = a[j + 3] - a[j2 + 3];
        x2r = a[j1] + a[j3];
        x2i = a[j1 + 1] + a[j3 + 1];
        x3r = a[j1] - a[j3];
        x3i = a[j1 + 1] - a[j3 + 1];
        y2r = a[j1 + 2] + a[j3 + 2];
        y2i = a[j1 + 3] + a[j3 + 3];
        y3r = a[j1 + 2] - a[j3 + 2];
        y3i = a[j1 + 3] - a[j3 + 3];
        a[j] = x0r + x2r;
        a[j + 1] = x0i + x2i;
        a[j + 2] = y0r + y2r;
        a[j + 3] = y0i + y2i;
        a[j1] = x0r - x2r;
        a[j1 + 1] = x0i - x2i;
        a[j1 + 2] = y0r - y2r;
        a[j1 + 3] = y0i - y2i;
        x0r = x1r - x3i;
        x0i = x1i + x3r;
        a[j2] = wk1r * x0r - wk1i * x0i;
        a[j2 + 1] = wk1r * x0i + wk1i * x0r;
        x0r = y1r - y3i;
        x0i = y1i + y3r;
        a[j2 + 2] = wd1r * x0r - wd1i * x0i;
        a[j2 + 3] = wd1r * x0i + wd1i * x0r;
        x0r = x1r + x3i;
        x0i = x1i - x3r;
        a[j3] = wk3r * x0r + wk3i * x0i;
        a[j3 + 1] = wk3r * x0i - wk3i * x0r;
        x0r = y1r + y3i;
        x0i = y1i - y3r;
        a[j3 + 2] = wd3r * x0r + wd3i * x0i;
        a[j3 + 3] = wd3r * x0i - wd3i * x0r;
        j0 = m - j;
        j1 = j0 + m;
        j2 = j1 + m;
        j3 = j2 + m;
        x0r = a[j0] + a[j2];
        x0i = a[j0 + 1] + a[j2 + 1];
        x1r = a[j0] - a[j2];
        x1i = a[j0 + 1] - a[j2 + 1];
        y0r = a[j0 - 2] + a[j2 - 2];
        y0i = a[j0 - 1] + a[j2 - 1];
        y1r = a[j0 - 2] - a[j2 - 2];
        y1i = a[j0 - 1] - a[j2 - 1];
        x2r = a[j1] + a[j3];
        x2i = a[j1 + 1] + a[j3 + 1];
        x3r = a[j1] - a[j3];
        x3i = a[j1 + 1] - a[j3 + 1];
        y2r = a[j1 - 2] + a[j3 - 2];
        y2i = a[j1 - 1] + a[j3 - 1];
        y3r = a[j1 - 2] - a[j3 - 2];
        y3i = a[j1 - 1] - a[j3 - 1];
        a[j0] = x0r + x2r;
        a[j0 + 1] = x0i + x2i;
        a[j0 - 2] = y0r + y2r;
        a[j0 - 1] = y0i + y2i;
        a[j1] = x0r - x2r;
        a[j1 + 1] = x0i - x2i;
        a[j1 - 2] = y0r - y2r;
        a[j1 - 1] = y0i - y2i;
        x0r = x1r - x3i;
        x0i = x1i + x3r;
        a[j2] = wk1i * x0r - wk1r * x0i;
        a[j2 + 1] = wk1i * x0i + wk1r * x0r;
        x0r = y1r - y3i;
        x0i = y1i + y3r;
        a[j2 - 2] = wd1i * x0r - wd1r * x0i;
        a[j2 - 1] = wd1i * x0i + wd1r * x0r;
        x0r = x1r + x3i;
        x0i = x1i - x3r;
        a[j3] = wk3i * x0r + wk3r * x0i;
        a[j3 + 1] = wk3i * x0i - wk3r * x0r;
        x0r = y1r + y3i;
        x0i = y1i - y3r;
        a[j3 - 2] = wd3i * x0r + wd3r * x0i;
        a[j3 - 1] = wd3i * x0i - wd3r * x0r;
    }
    wk1r = csc1 * (wd1r + wn4r);
    wk1i = csc1 * (wd1i + wn4r);
    wk3r = csc3 * (wd3r - wn4r);
    wk3i = csc3 * (wd3i - wn4r);
    j0 = mh;
    j1 = j0 + m;
    j2 = j1 + m;
    j3 = j2 + m;
    x0r = a[j0 - 2] + a[j2 - 2];
    x0i = a[j0 - 1] + a[j2 - 1];
    x1r = a[j0 - 2] - a[j2 - 2];
    x1i = a[j0 - 1] - a[j2 - 1];
    x2r = a[j1 - 2] + a[j3 - 2];
    x2i = a[j1 - 1] + a[j3 - 1];
    x3r = a[j1 - 2] - a[j3 - 2];
    x3i = a[j1 - 1] - a[j3 - 1];
    a[j0 - 2] = x0r + x2r;
    a[j0 - 1] = x0i + x2i;
    a[j1 - 2] = x0r - x2r;
    a[j1 - 1] = x0i - x2i;
    x0r = x1r - x3i;
    x0i = x1i + x3r;
    a[j2 - 2] = wk1r * x0r - wk1i * x0i;
    a[j2 - 1] = wk1r * x0i + wk1i * x0r;
    x0r = x1r + x3i;
    x0i = x1i - x3r;
    a[j3 - 2] = wk3r * x0r + wk3i * x0i;
    a[j3 - 1] = wk3r * x0i - wk3i * x0r;
    x0r = a[j0] + a[j2];
    x0i = a[j0 + 1] + a[j2 + 1];
    x1r = a[j0] - a[j2];
    x1i = a[j0 + 1] - a[j2 + 1];
    x2r = a[j1] + a[j3];
    x2i = a[j1 + 1] + a[j3 + 1];
    x3r = a[j1] - a[j3];
    x3i = a[j1 + 1] - a[j3 + 1];
    a[j0] = x0r + x2r;
    a[j0 + 1] = x0i + x2i;
    a[j1] = x0r - x2r;
    a[j1 + 1] = x0i - x2i;
    x0r = x1r - x3i;
    x0i = x1i + x3r;
    a[j2] = wn4r * (x0r - x0i);
    a[j2 + 1] = wn4r * (x0i + x0r);
    x0r = x1r + x3i;
    x0i = x1i - x3r;
    a[j3] = -wn4r * (x0r + x0i);
    a[j3 + 1] = -wn4r * (x0i - x0r);
    x0r = a[j0 + 2] + a[j2 + 2];
    x0i = a[j0 + 3] + a[j2 + 3];
    x1r = a[j0 + 2] - a[j2 + 2];
    x1i = a[j0 + 3] - a[j2 + 3];
    x2r = a[j1 + 2] + a[j3 + 2];
    x2i = a[j1 + 3] + a[j3 + 3];
    x3r = a[j1 + 2] - a[j3 + 2];
    x3i = a[j1 + 3] - a[j3 + 3];
    a[j0 + 2] = x0r + x2r;
    a[j0 + 3] = x0i + x2i;
    a[j1 + 2] = x0r - x2r;
    a[j1 + 3] = x0i - x2i;
    x0r = x1r - x3i;
    x0i = x1i + x3r;
    a[j2 + 2] = wk1i * x0r - wk1r * x0i;
    a[j2 + 3] = wk1i * x0i + wk1r * x0r;
    x0r = x1r + x3i;
    x0i = x1i - x3r;
    a[j3 + 2] = wk3i * x0r + wk3r * x0i;
    a[j3 + 3] = wk3i * x0i - wk3r * x0r;
}

static void cftmdl1(int n, float *a, float *w)
{
    int j, j0, j1, j2, j3, k, m, mh;
    float wn4r, wk1r, wk1i, wk3r, wk3i;
    float x0r, x0i, x1r, x1i, x2r, x2i, x3r, x3i;
    
    mh = n >> 3;
    m = 2 * mh;
    j1 = m;
    j2 = j1 + m;
    j3 = j2 + m;
    x0r = a[0] + a[j2];
    x0i = a[1] + a[j2 + 1];
    x1r = a[0] - a[j2];
    x1i = a[1] - a[j2 + 1];
    x2r = a[j1] + a[j3];
    x2i = a[j1 + 1] + a[j3 + 1];
    x3r = a[j1] - a[j3];
    x3i = a[j1 + 1] - a[j3 + 1];
    a[0] = x0r + x2r;
    a[1] = x0i + x2i;
    a[j1] = x0r - x2r;
    a[j1 + 1] = x0i - x2i;
    a[j2] = x1r - x3i;
    a[j2 + 1] = x1i + x3r;
    a[j3] = x1r + x3i;
    a[j3 + 1] = x1i - x3r;
    wn4r = w[1];
    k = 0;
    for (j = 2; j < mh; j += 2) {
        k += 4;
        wk1r = w[k];
        wk1i = w[k + 1];
        wk3r = w[k + 2];
        wk3i = w[k + 3];
        j1 = j + m;
        j2 = j1 + m;
        j3 = j2 + m;
        x0r = a[j] + a[j2];
        x0i = a[j + 1] + a[j2 + 1];
        x1r = a[j] - a[j2];
        x1i = a[j + 1] - a[j2 + 1];
        x2r = a[j1] + a[j3];
        x2i = a[j1 + 1] + a[j3 + 1];
        x3r = a[j1] - a[j3];
        x3i = a[j1 + 1] - a[j3 + 1];
        a[j] = x0r + x2r;
        a[j + 1] = x0i + x2i;
        a[j1] = x0r - x2r;
        a[j1 + 1] = x0i - x2i;
        x0r = x1r - x3i;
        x0i = x1i + x3r;
        a[j2] = wk1r * x0r - wk1i * x0i;
        a[j2 + 1] = wk1r * x0i + wk1i * x0r;
        x0r = x1r + x3i;
        x0i = x1i - x3r;
        a[j3] = wk3r * x0r + wk3i * x0i;
        a[j3 + 1] = wk3r * x0i - wk3i * x0r;
        j0 = m - j;
        j1 = j0 + m;
        j2 = j1 + m;
        j3 = j2 + m;
        x0r = a[j0] + a[j2];
        x0i = a[j0 + 1] + a[j2 + 1];
        x1r = a[j0] - a[j2];
        x1i = a[j0 + 1] - a[j2 + 1];
        x2r = a[j1] + a[j3];
        x2i = a[j1 + 1] + a[j3 + 1];
        x3r = a[j1] - a[j3];
        x3i = a[j1 + 1] - a[j3 + 1];
        a[j0] = x0r + x2r;
        a[j0 + 1] = x0i + x2i;
        a[j1] = x0r - x2r;
        a[j1 + 1] = x0i - x2i;
        x0r = x1r - x3i;
        x0i = x1i + x3r;
        a[j2] = wk1i * x0r - wk1r * x0i;
        a[j2 + 1] = wk1i * x0i + wk1r * x0r;
        x0r = x1r + x3i;
        x0i = x1i - x3r;
        a[j3] = wk3i * x0r + wk3r * x0i;
        a[j3 + 1] = wk3i * x0i - wk3r * x0r;
    }
    j0 = mh;
    j1 = j0 + m;
    j2 = j1 + m;
    j3 = j2 + m;
    x0r = a[j0] + a[j2];
    x0i = a[j0 + 1] + a[j2 + 1];
    x1r = a[j0] - a[j2];
    x1i = a[j0 + 1] - a[j2 + 1];
    x2r = a[j1] + a[j3];
    x2i = a[j1 + 1] + a[j3 + 1];
    x3r = a[j1] - a[j3];
    x3i = a[j1 + 1] - a[j3 + 1];
    a[j0] = x0r + x2r;
    a[j0 + 1] = x0i + x2i;
    a[j1] = x0r - x2r;
    a[j1 + 1] = x0i - x2i;
    x0r = x1r - x3i;
    x0i = x1i + x3r;
    a[j2] = wn4r * (x0r - x0i);
    a[j2 + 1] = wn4r * (x0i + x0r);
    x0r = x1r + x3i;
    x0i = x1i - x3r;
    a[j3] = -wn4r * (x0r + x0i);
    a[j3 + 1] = -wn4r * (x0i - x0r);
}

static void cftmdl2(int n, float *a, float *w)
{
    int j, j0, j1, j2, j3, k, kr, m, mh;
    float wn4r, wk1r, wk1i, wk3r, wk3i, wd1r, wd1i, wd3r, wd3i;
    float x0r, x0i, x1r, x1i, x2r, x2i, x3r, x3i, y0r, y0i, y2r, y2i;
    
    mh = n >> 3;
    m = 2 * mh;
    wn4r = w[1];
    j1 = m;
    j2 = j1 + m;
    j3 = j2 + m;
    x0r = a[0] - a[j2 + 1];
    x0i = a[1] + a[j2];
    x1r = a[0] + a[j2 + 1];
    x1i = a[1] - a[j2];
    x2r = a[j1] - a[j3 + 1];
    x2i = a[j1 + 1] + a[j3];
    x3r = a[j1] + a[j3 + 1];
    x3i = a[j1 + 1] - a[j3];
    y0r = wn4r * (x2r - x2i);
    y0i = wn4r * (x2i + x2r);
    a[0] = x0r + y0r;
    a[1] = x0i + y0i;
    a[j1] = x0r - y0r;
    a[j1 + 1] = x0i - y0i;
    y0r = wn4r * (x3r - x3i);
    y0i = wn4r * (x3i + x3r);
    a[j2] = x1r - y0i;
    a[j2 + 1] = x1i + y0r;
    a[j3] = x1r + y0i;
    a[j3 + 1] = x1i - y0r;
    k = 0;
    kr = 2 * m;
    for (j = 2; j < mh; j += 2) {
        k += 4;
        wk1r = w[k];
        wk1i = w[k + 1];
        wk3r = w[k + 2];
        wk3i = w[k + 3];
        kr -= 4;
        wd1i = w[kr];
        wd1r = w[kr + 1];
        wd3i = w[kr + 2];
        wd3r = w[kr + 3];
        j1 = j + m;
        j2 = j1 + m;
        j3 = j2 + m;
        x0r = a[j] - a[j2 + 1];
        x0i = a[j + 1] + a[j2];
        x1r = a[j] + a[j2 + 1];
        x1i = a[j + 1] - a[j2];
        x2r = a[j1] - a[j3 + 1];
        x2i = a[j1 + 1] + a[j3];
        x3r = a[j1] + a[j3 + 1];
        x3i = a[j1 + 1] - a[j3];
        y0r = wk1r * x0r - wk1i * x0i;
        y0i = wk1r * x0i + wk1i * x0r;
        y2r = wd1r * x2r - wd1i * x2i;
        y2i = wd1r * x2i + wd1i * x2r;
        a[j] = y0r + y2r;
        a[j + 1] = y0i + y2i;
        a[j1] = y0r - y2r;
        a[j1 + 1] = y0i - y2i;
        y0r = wk3r * x1r + wk3i * x1i;
        y0i = wk3r * x1i - wk3i * x1r;
        y2r = wd3r * x3r + wd3i * x3i;
        y2i = wd3r * x3i - wd3i * x3r;
        a[j2] = y0r + y2r;
        a[j2 + 1] = y0i + y2i;
        a[j3] = y0r - y2r;
        a[j3 + 1] = y0i - y2i;
        j0 = m - j;
        j1 = j0 + m;
        j2 = j1 + m;
        j3 = j2 + m;
        x0r = a[j0] - a[j2 + 1];
        x0i = a[j0 + 1] + a[j2];
        x1r = a[j0] + a[j2 + 1];
        x1i = a[j0 + 1] - a[j2];
        x2r = a[j1] - a[j3 + 1];
        x2i = a[j1 + 1] + a[j3];
        x3r = a[j1] + a[j3 + 1];
        x3i = a[j1 + 1] - a[j3];
        y0r = wd1i * x0r - wd1r * x0i;
        y0i = wd1i * x0i + wd1r * x0r;
        y2r = wk1i * x2r - wk1r * x2i;
        y2i = wk1i * x2i + wk1r * x2r;
        a[j0] = y0r + y2r;
        a[j0 + 1] = y0i + y2i;
        a[j1] = y0r - y2r;
        a[j1 + 1] = y0i - y2i;
        y0r = wd3i * x1r + wd3r * x1i;
        y0i = wd3i * x1i - wd3r * x1r;
        y2r = wk3i * x3r + wk3r * x3i;
        y2i = wk3i * x3i - wk3r * x3r;
        a[j2] = y0r + y2r;
        a[j2 + 1] = y0i + y2i;
        a[j3] = y0r - y2r;
        a[j3 + 1] = y0i - y2i;
    }
    wk1r = w[m];
    wk1i = w[m + 1];
    j0 = mh;
    j1 = j0 + m;
    j2 = j1 + m;
    j3 = j2 + m;
    x0r = a[j0] - a[j2 + 1];
    x0i = a[j0 + 1] + a[j2];
    x1r = a[j0] + a[j2 + 1];
    x1i = a[j0 + 1] - a[j2];
    x2r = a[j1] - a[j3 + 1];
    x2i = a[j1 + 1] + a[j3];
    x3r = a[j1] + a[j3 + 1];
    x3i = a[j1 + 1] - a[j3];
    y0r = wk1r * x0r - wk1i * x0i;
    y0i = wk1r * x0i + wk1i * x0r;
    y2r = wk1i * x2r - wk1r * x2i;
    y2i = wk1i * x2i + wk1r * x2r;
    a[j0] = y0r + y2r;
    a[j0 + 1] = y0i + y2i;
    a[j1] = y0r - y2r;
    a[j1 + 1] = y0i - y2i;
    y0r = wk1i * x1r - wk1r * x1i;
    y0i = wk1i * x1i + wk1r * x1r;
    y2r = wk1r * x3r - wk1i * x3i;
    y2i = wk1r * x3i + wk1i * x3r;
    a[j2] = y0r - y2r;
    a[j2 + 1] = y0i - y2i;
    a[j3] = y0r + y2r;
    a[j3 + 1] = y0i + y2i;
}

static int cfttree(int n, int j, int k, float *a, int nw, float *w)
{
    void cftmdl1(int n, float *a, float *w);
    void cftmdl2(int n, float *a, float *w);
    int i, isplt, m;
    
    if ((k & 3) != 0) {
        isplt = k & 1;
        if (isplt != 0) {
            cftmdl1(n, &a[j - n], &w[nw - (n >> 1)]);
        } else {
            cftmdl2(n, &a[j - n], &w[nw - n]);
        }
    } else {
        m = n;
        for (i = k; (i & 3) == 0; i >>= 2) {
            m <<= 2;
        }
        isplt = i & 1;
        if (isplt != 0) {
            while (m > 128) {
                cftmdl1(m, &a[j - m], &w[nw - (m >> 1)]);
                m >>= 2;
            }
        } else {
            while (m > 128) {
                cftmdl2(m, &a[j - m], &w[nw - m]);
                m >>= 2;
            }
        }
    }
    return isplt;
}

static void cftf161(float *a, float *w)
{
    float wn4r, wk1r, wk1i, 
        x0r, x0i, x1r, x1i, x2r, x2i, x3r, x3i, 
        y0r, y0i, y1r, y1i, y2r, y2i, y3r, y3i, 
        y4r, y4i, y5r, y5i, y6r, y6i, y7r, y7i, 
        y8r, y8i, y9r, y9i, y10r, y10i, y11r, y11i, 
        y12r, y12i, y13r, y13i, y14r, y14i, y15r, y15i;
    
    wn4r = w[1];
    wk1r = w[2];
    wk1i = w[3];
    x0r = a[0] + a[16];
    x0i = a[1] + a[17];
    x1r = a[0] - a[16];
    x1i = a[1] - a[17];
    x2r = a[8] + a[24];
    x2i = a[9] + a[25];
    x3r = a[8] - a[24];
    x3i = a[9] - a[25];
    y0r = x0r + x2r;
    y0i = x0i + x2i;
    y4r = x0r - x2r;
    y4i = x0i - x2i;
    y8r = x1r - x3i;
    y8i = x1i + x3r;
    y12r = x1r + x3i;
    y12i = x1i - x3r;
    x0r = a[2] + a[18];
    x0i = a[3] + a[19];
    x1r = a[2] - a[18];
    x1i = a[3] - a[19];
    x2r = a[10] + a[26];
    x2i = a[11] + a[27];
    x3r = a[10] - a[26];
    x3i = a[11] - a[27];
    y1r = x0r + x2r;
    y1i = x0i + x2i;
    y5r = x0r - x2r;
    y5i = x0i - x2i;
    x0r = x1r - x3i;
    x0i = x1i + x3r;
    y9r = wk1r * x0r - wk1i * x0i;
    y9i = wk1r * x0i + wk1i * x0r;
    x0r = x1r + x3i;
    x0i = x1i - x3r;
    y13r = wk1i * x0r - wk1r * x0i;
    y13i = wk1i * x0i + wk1r * x0r;
    x0r = a[4] + a[20];
    x0i = a[5] + a[21];
    x1r = a[4] - a[20];
    x1i = a[5] - a[21];
    x2r = a[12] + a[28];
    x2i = a[13] + a[29];
    x3r = a[12] - a[28];
    x3i = a[13] - a[29];
    y2r = x0r + x2r;
    y2i = x0i + x2i;
    y6r = x0r - x2r;
    y6i = x0i - x2i;
    x0r = x1r - x3i;
    x0i = x1i + x3r;
    y10r = wn4r * (x0r - x0i);
    y10i = wn4r * (x0i + x0r);
    x0r = x1r + x3i;
    x0i = x1i - x3r;
    y14r = wn4r * (x0r + x0i);
    y14i = wn4r * (x0i - x0r);
    x0r = a[6] + a[22];
    x0i = a[7] + a[23];
    x1r = a[6] - a[22];
    x1i = a[7] - a[23];
    x2r = a[14] + a[30];
    x2i = a[15] + a[31];
    x3r = a[14] - a[30];
    x3i = a[15] - a[31];
    y3r = x0r + x2r;
    y3i = x0i + x2i;
    y7r = x0r - x2r;
    y7i = x0i - x2i;
    x0r = x1r - x3i;
    x0i = x1i + x3r;
    y11r = wk1i * x0r - wk1r * x0i;
    y11i = wk1i * x0i + wk1r * x0r;
    x0r = x1r + x3i;
    x0i = x1i - x3r;
    y15r = wk1r * x0r - wk1i * x0i;
    y15i = wk1r * x0i + wk1i * x0r;
    x0r = y12r - y14r;
    x0i = y12i - y14i;
    x1r = y12r + y14r;
    x1i = y12i + y14i;
    x2r = y13r - y15r;
    x2i = y13i - y15i;
    x3r = y13r + y15r;
    x3i = y13i + y15i;
    a[24] = x0r + x2r;
    a[25] = x0i + x2i;
    a[26] = x0r - x2r;
    a[27] = x0i - x2i;
    a[28] = x1r - x3i;
    a[29] = x1i + x3r;
    a[30] = x1r + x3i;
    a[31] = x1i - x3r;
    x0r = y8r + y10r;
    x0i = y8i + y10i;
    x1r = y8r - y10r;
    x1i = y8i - y10i;
    x2r = y9r + y11r;
    x2i = y9i + y11i;
    x3r = y9r - y11r;
    x3i = y9i - y11i;
    a[16] = x0r + x2r;
    a[17] = x0i + x2i;
    a[18] = x0r - x2r;
    a[19] = x0i - x2i;
    a[20] = x1r - x3i;
    a[21] = x1i + x3r;
    a[22] = x1r + x3i;
    a[23] = x1i - x3r;
    x0r = y5r - y7i;
    x0i = y5i + y7r;
    x2r = wn4r * (x0r - x0i);
    x2i = wn4r * (x0i + x0r);
    x0r = y5r + y7i;
    x0i = y5i - y7r;
    x3r = wn4r * (x0r - x0i);
    x3i = wn4r * (x0i + x0r);
    x0r = y4r - y6i;
    x0i = y4i + y6r;
    x1r = y4r + y6i;
    x1i = y4i - y6r;
    a[8] = x0r + x2r;
    a[9] = x0i + x2i;
    a[10] = x0r - x2r;
    a[11] = x0i - x2i;
    a[12] = x1r - x3i;
    a[13] = x1i + x3r;
    a[14] = x1r + x3i;
    a[15] = x1i - x3r;
    x0r = y0r + y2r;
    x0i = y0i + y2i;
    x1r = y0r - y2r;
    x1i = y0i - y2i;
    x2r = y1r + y3r;
    x2i = y1i + y3i;
    x3r = y1r - y3r;
    x3i = y1i - y3i;
    a[0] = x0r + x2r;
    a[1] = x0i + x2i;
    a[2] = x0r - x2r;
    a[3] = x0i - x2i;
    a[4] = x1r - x3i;
    a[5] = x1i + x3r;
    a[6] = x1r + x3i;
    a[7] = x1i - x3r;
}

static void cftf162(float *a, float *w)
{
    float wn4r, wk1r, wk1i, wk2r, wk2i, wk3r, wk3i, 
        x0r, x0i, x1r, x1i, x2r, x2i, 
        y0r, y0i, y1r, y1i, y2r, y2i, y3r, y3i, 
        y4r, y4i, y5r, y5i, y6r, y6i, y7r, y7i, 
        y8r, y8i, y9r, y9i, y10r, y10i, y11r, y11i, 
        y12r, y12i, y13r, y13i, y14r, y14i, y15r, y15i;
    
    wn4r = w[1];
    wk1r = w[4];
    wk1i = w[5];
    wk3r = w[6];
    wk3i = -w[7];
    wk2r = w[8];
    wk2i = w[9];
    x1r = a[0] - a[17];
    x1i = a[1] + a[16];
    x0r = a[8] - a[25];
    x0i = a[9] + a[24];
    x2r = wn4r * (x0r - x0i);
    x2i = wn4r * (x0i + x0r);
    y0r = x1r + x2r;
    y0i = x1i + x2i;
    y4r = x1r - x2r;
    y4i = x1i - x2i;
    x1r = a[0] + a[17];
    x1i = a[1] - a[16];
    x0r = a[8] + a[25];
    x0i = a[9] - a[24];
    x2r = wn4r * (x0r - x0i);
    x2i = wn4r * (x0i + x0r);
    y8r = x1r - x2i;
    y8i = x1i + x2r;
    y12r = x1r + x2i;
    y12i = x1i - x2r;
    x0r = a[2] - a[19];
    x0i = a[3] + a[18];
    x1r = wk1r * x0r - wk1i * x0i;
    x1i = wk1r * x0i + wk1i * x0r;
    x0r = a[10] - a[27];
    x0i = a[11] + a[26];
    x2r = wk3i * x0r - wk3r * x0i;
    x2i = wk3i * x0i + wk3r * x0r;
    y1r = x1r + x2r;
    y1i = x1i + x2i;
    y5r = x1r - x2r;
    y5i = x1i - x2i;
    x0r = a[2] + a[19];
    x0i = a[3] - a[18];
    x1r = wk3r * x0r - wk3i * x0i;
    x1i = wk3r * x0i + wk3i * x0r;
    x0r = a[10] + a[27];
    x0i = a[11] - a[26];
    x2r = wk1r * x0r + wk1i * x0i;
    x2i = wk1r * x0i - wk1i * x0r;
    y9r = x1r - x2r;
    y9i = x1i - x2i;
    y13r = x1r + x2r;
    y13i = x1i + x2i;
    x0r = a[4] - a[21];
    x0i = a[5] + a[20];
    x1r = wk2r * x0r - wk2i * x0i;
    x1i = wk2r * x0i + wk2i * x0r;
    x0r = a[12] - a[29];
    x0i = a[13] + a[28];
    x2r = wk2i * x0r - wk2r * x0i;
    x2i = wk2i * x0i + wk2r * x0r;
    y2r = x1r + x2r;
    y2i = x1i + x2i;
    y6r = x1r - x2r;
    y6i = x1i - x2i;
    x0r = a[4] + a[21];
    x0i = a[5] - a[20];
    x1r = wk2i * x0r - wk2r * x0i;
    x1i = wk2i * x0i + wk2r * x0r;
    x0r = a[12] + a[29];
    x0i = a[13] - a[28];
    x2r = wk2r * x0r - wk2i * x0i;
    x2i = wk2r * x0i + wk2i * x0r;
    y10r = x1r - x2r;
    y10i = x1i - x2i;
    y14r = x1r + x2r;
    y14i = x1i + x2i;
    x0r = a[6] - a[23];
    x0i = a[7] + a[22];
    x1r = wk3r * x0r - wk3i * x0i;
    x1i = wk3r * x0i + wk3i * x0r;
    x0r = a[14] - a[31];
    x0i = a[15] + a[30];
    x2r = wk1i * x0r - wk1r * x0i;
    x2i = wk1i * x0i + wk1r * x0r;
    y3r = x1r + x2r;
    y3i = x1i + x2i;
    y7r = x1r - x2r;
    y7i = x1i - x2i;
    x0r = a[6] + a[23];
    x0i = a[7] - a[22];
    x1r = wk1i * x0r + wk1r * x0i;
    x1i = wk1i * x0i - wk1r * x0r;
    x0r = a[14] + a[31];
    x0i = a[15] - a[30];
    x2r = wk3i * x0r - wk3r * x0i;
    x2i = wk3i * x0i + wk3r * x0r;
    y11r = x1r + x2r;
    y11i = x1i + x2i;
    y15r = x1r - x2r;
    y15i = x1i - x2i;
    x1r = y0r + y2r;
    x1i = y0i + y2i;
    x2r = y1r + y3r;
    x2i = y1i + y3i;
    a[0] = x1r + x2r;
    a[1] = x1i + x2i;
    a[2] = x1r - x2r;
    a[3] = x1i - x2i;
    x1r = y0r - y2r;
    x1i = y0i - y2i;
    x2r = y1r - y3r;
    x2i = y1i - y3i;
    a[4] = x1r - x2i;
    a[5] = x1i + x2r;
    a[6] = x1r + x2i;
    a[7] = x1i - x2r;
    x1r = y4r - y6i;
    x1i = y4i + y6r;
    x0r = y5r - y7i;
    x0i = y5i + y7r;
    x2r = wn4r * (x0r - x0i);
    x2i = wn4r * (x0i + x0r);
    a[8] = x1r + x2r;
    a[9] = x1i + x2i;
    a[10] = x1r - x2r;
    a[11] = x1i - x2i;
    x1r = y4r + y6i;
    x1i = y4i - y6r;
    x0r = y5r + y7i;
    x0i = y5i - y7r;
    x2r = wn4r * (x0r - x0i);
    x2i = wn4r * (x0i + x0r);
    a[12] = x1r - x2i;
    a[13] = x1i + x2r;
    a[14] = x1r + x2i;
    a[15] = x1i - x2r;
    x1r = y8r + y10r;
    x1i = y8i + y10i;
    x2r = y9r - y11r;
    x2i = y9i - y11i;
    a[16] = x1r + x2r;
    a[17] = x1i + x2i;
    a[18] = x1r - x2r;
    a[19] = x1i - x2i;
    x1r = y8r - y10r;
    x1i = y8i - y10i;
    x2r = y9r + y11r;
    x2i = y9i + y11i;
    a[20] = x1r - x2i;
    a[21] = x1i + x2r;
    a[22] = x1r + x2i;
    a[23] = x1i - x2r;
    x1r = y12r - y14i;
    x1i = y12i + y14r;
    x0r = y13r + y15i;
    x0i = y13i - y15r;
    x2r = wn4r * (x0r - x0i);
    x2i = wn4r * (x0i + x0r);
    a[24] = x1r + x2r;
    a[25] = x1i + x2i;
    a[26] = x1r - x2r;
    a[27] = x1i - x2i;
    x1r = y12r + y14i;
    x1i = y12i - y14r;
    x0r = y13r - y15i;
    x0i = y13i + y15r;
    x2r = wn4r * (x0r - x0i);
    x2i = wn4r * (x0i + x0r);
    a[28] = x1r - x2i;
    a[29] = x1i + x2r;
    a[30] = x1r + x2i;
    a[31] = x1i - x2r;
}

static void cftf081(float *a, float *w)
{
    float wn4r, x0r, x0i, x1r, x1i, x2r, x2i, x3r, x3i, 
        y0r, y0i, y1r, y1i, y2r, y2i, y3r, y3i, 
        y4r, y4i, y5r, y5i, y6r, y6i, y7r, y7i;
    
    wn4r = w[1];
    x0r = a[0] + a[8];
    x0i = a[1] + a[9];
    x1r = a[0] - a[8];
    x1i = a[1] - a[9];
    x2r = a[4] + a[12];
    x2i = a[5] + a[13];
    x3r = a[4] - a[12];
    x3i = a[5] - a[13];
    y0r = x0r + x2r;
    y0i = x0i + x2i;
    y2r = x0r - x2r;
    y2i = x0i - x2i;
    y1r = x1r - x3i;
    y1i = x1i + x3r;
    y3r = x1r + x3i;
    y3i = x1i - x3r;
    x0r = a[2] + a[10];
    x0i = a[3] + a[11];
    x1r = a[2] - a[10];
    x1i = a[3] - a[11];
    x2r = a[6] + a[14];
    x2i = a[7] + a[15];
    x3r = a[6] - a[14];
    x3i = a[7] - a[15];
    y4r = x0r + x2r;
    y4i = x0i + x2i;
    y6r = x0r - x2r;
    y6i = x0i - x2i;
    x0r = x1r - x3i;
    x0i = x1i + x3r;
    x2r = x1r + x3i;
    x2i = x1i - x3r;
    y5r = wn4r * (x0r - x0i);
    y5i = wn4r * (x0r + x0i);
    y7r = wn4r * (x2r - x2i);
    y7i = wn4r * (x2r + x2i);
    a[8] = y1r + y5r;
    a[9] = y1i + y5i;
    a[10] = y1r - y5r;
    a[11] = y1i - y5i;
    a[12] = y3r - y7i;
    a[13] = y3i + y7r;
    a[14] = y3r + y7i;
    a[15] = y3i - y7r;
    a[0] = y0r + y4r;
    a[1] = y0i + y4i;
    a[2] = y0r - y4r;
    a[3] = y0i - y4i;
    a[4] = y2r - y6i;
    a[5] = y2i + y6r;
    a[6] = y2r + y6i;
    a[7] = y2i - y6r;
}

static void cftf082(float *a, float *w)
{
    float wn4r, wk1r, wk1i, x0r, x0i, x1r, x1i, 
        y0r, y0i, y1r, y1i, y2r, y2i, y3r, y3i, 
        y4r, y4i, y5r, y5i, y6r, y6i, y7r, y7i;
    
    wn4r = w[1];
    wk1r = w[2];
    wk1i = w[3];
    y0r = a[0] - a[9];
    y0i = a[1] + a[8];
    y1r = a[0] + a[9];
    y1i = a[1] - a[8];
    x0r = a[4] - a[13];
    x0i = a[5] + a[12];
    y2r = wn4r * (x0r - x0i);
    y2i = wn4r * (x0i + x0r);
    x0r = a[4] + a[13];
    x0i = a[5] - a[12];
    y3r = wn4r * (x0r - x0i);
    y3i = wn4r * (x0i + x0r);
    x0r = a[2] - a[11];
    x0i = a[3] + a[10];
    y4r = wk1r * x0r - wk1i * x0i;
    y4i = wk1r * x0i + wk1i * x0r;
    x0r = a[2] + a[11];
    x0i = a[3] - a[10];
    y5r = wk1i * x0r - wk1r * x0i;
    y5i = wk1i * x0i + wk1r * x0r;
    x0r = a[6] - a[15];
    x0i = a[7] + a[14];
    y6r = wk1i * x0r - wk1r * x0i;
    y6i = wk1i * x0i + wk1r * x0r;
    x0r = a[6] + a[15];
    x0i = a[7] - a[14];
    y7r = wk1r * x0r - wk1i * x0i;
    y7i = wk1r * x0i + wk1i * x0r;
    x0r = y0r + y2r;
    x0i = y0i + y2i;
    x1r = y4r + y6r;
    x1i = y4i + y6i;
    a[0] = x0r + x1r;
    a[1] = x0i + x1i;
    a[2] = x0r - x1r;
    a[3] = x0i - x1i;
    x0r = y0r - y2r;
    x0i = y0i - y2i;
    x1r = y4r - y6r;
    x1i = y4i - y6i;
    a[4] = x0r - x1i;
    a[5] = x0i + x1r;
    a[6] = x0r + x1i;
    a[7] = x0i - x1r;
    x0r = y1r - y3i;
    x0i = y1i + y3r;
    x1r = y5r - y7r;
    x1i = y5i - y7i;
    a[8] = x0r + x1r;
    a[9] = x0i + x1i;
    a[10] = x0r - x1r;
    a[11] = x0i - x1i;
    x0r = y1r + y3i;
    x0i = y1i - y3r;
    x1r = y5r + y7r;
    x1i = y5i + y7i;
    a[12] = x0r - x1i;
    a[13] = x0i + x1r;
    a[14] = x0r + x1i;
    a[15] = x0i - x1r;
}

static void cftleaf(int n, int isplt, float *a, int nw, float *w)
{
    void cftmdl1(int n, float *a, float *w);
    void cftmdl2(int n, float *a, float *w);
    void cftf161(float *a, float *w);
    void cftf162(float *a, float *w);
    void cftf081(float *a, float *w);
    void cftf082(float *a, float *w);
    
    if (n == 512) {
        cftmdl1(128, a, &w[nw - 64]);
        cftf161(a, &w[nw - 8]);
        cftf162(&a[32], &w[nw - 32]);
        cftf161(&a[64], &w[nw - 8]);
        cftf161(&a[96], &w[nw - 8]);
        cftmdl2(128, &a[128], &w[nw - 128]);
        cftf161(&a[128], &w[nw - 8]);
        cftf162(&a[160], &w[nw - 32]);
        cftf161(&a[192], &w[nw - 8]);
        cftf162(&a[224], &w[nw - 32]);
        cftmdl1(128, &a[256], &w[nw - 64]);
        cftf161(&a[256], &w[nw - 8]);
        cftf162(&a[288], &w[nw - 32]);
        cftf161(&a[320], &w[nw - 8]);
        cftf161(&a[352], &w[nw - 8]);
        if (isplt != 0) {
            cftmdl1(128, &a[384], &w[nw - 64]);
            cftf161(&a[480], &w[nw - 8]);
        } else {
            cftmdl2(128, &a[384], &w[nw - 128]);
            cftf162(&a[480], &w[nw - 32]);
        }
        cftf161(&a[384], &w[nw - 8]);
        cftf162(&a[416], &w[nw - 32]);
        cftf161(&a[448], &w[nw - 8]);
    } else {
        cftmdl1(64, a, &w[nw - 32]);
        cftf081(a, &w[nw - 8]);
        cftf082(&a[16], &w[nw - 8]);
        cftf081(&a[32], &w[nw - 8]);
        cftf081(&a[48], &w[nw - 8]);
        cftmdl2(64, &a[64], &w[nw - 64]);
        cftf081(&a[64], &w[nw - 8]);
        cftf082(&a[80], &w[nw - 8]);
        cftf081(&a[96], &w[nw - 8]);
        cftf082(&a[112], &w[nw - 8]);
        cftmdl1(64, &a[128], &w[nw - 32]);
        cftf081(&a[128], &w[nw - 8]);
        cftf082(&a[144], &w[nw - 8]);
        cftf081(&a[160], &w[nw - 8]);
        cftf081(&a[176], &w[nw - 8]);
        if (isplt != 0) {
            cftmdl1(64, &a[192], &w[nw - 32]);
            cftf081(&a[240], &w[nw - 8]);
        } else {
            cftmdl2(64, &a[192], &w[nw - 64]);
            cftf082(&a[240], &w[nw - 8]);
        }
        cftf081(&a[192], &w[nw - 8]);
        cftf082(&a[208], &w[nw - 8]);
        cftf081(&a[224], &w[nw - 8]);
    }
}

static void cftrec4(int n, float *a, int nw, float *w)
{
    int cfttree(int n, int j, int k, float *a, int nw, float *w);
    void cftleaf(int n, int isplt, float *a, int nw, float *w);
    void cftmdl1(int n, float *a, float *w);
    int isplt, j, k, m;
    
    m = n;
    while (m > 512) {
        m >>= 2;
        cftmdl1(m, &a[n - m], &w[nw - (m >> 1)]);
    }
    cftleaf(m, 1, &a[n - m], nw, w);
    k = 0;
    for (j = n - m; j > 0; j -= m) {
        k++;
        isplt = cfttree(m, j, k, a, nw, w);
        cftleaf(m, isplt, &a[j - m], nw, w);
    }
}

static void cftfx41(int n, float *a, int nw, float *w)
{
    void cftf161(float *a, float *w);
    void cftf162(float *a, float *w);
    void cftf081(float *a, float *w);
    void cftf082(float *a, float *w);
    
    if (n == 128) {
        cftf161(a, &w[nw - 8]);
        cftf162(&a[32], &w[nw - 32]);
        cftf161(&a[64], &w[nw - 8]);
        cftf161(&a[96], &w[nw - 8]);
    } else {
        cftf081(a, &w[nw - 8]);
        cftf082(&a[16], &w[nw - 8]);
        cftf081(&a[32], &w[nw - 8]);
        cftf081(&a[48], &w[nw - 8]);
    }
}

static void cftf040(float *a)
{
    float x0r, x0i, x1r, x1i, x2r, x2i, x3r, x3i;
    
    x0r = a[0] + a[4];
    x0i = a[1] + a[5];
    x1r = a[0] - a[4];
    x1i = a[1] - a[5];
    x2r = a[2] + a[6];
    x2i = a[3] + a[7];
    x3r = a[2] - a[6];
    x3i = a[3] - a[7];
    a[0] = x0r + x2r;
    a[1] = x0i + x2i;
    a[2] = x1r - x3i;
    a[3] = x1i + x3r;
    a[4] = x0r - x2r;
    a[5] = x0i - x2i;
    a[6] = x1r + x3i;
    a[7] = x1i - x3r;
}

static void cftx020(float *a)
{
    float x0r, x0i;
    
    x0r = a[0] - a[2];
    x0i = a[1] - a[3];
    a[0] += a[2];
    a[1] += a[3];
    a[2] = x0r;
    a[3] = x0i;
}

#ifdef USE_CDFT_THREADS
struct cdft_arg_st {
    int n0;
    int n;
    float *a;
    int nw;
    float *w;
};
typedef struct cdft_arg_st cdft_arg_t;


static void cftrec4_th(int n, float *a, int nw, float *w)
{
    void *cftrec1_th(void *p);
    void *cftrec2_th(void *p);
    int i, idiv4, m, nthread;
    cdft_thread_t th[4];
    cdft_arg_t ag[4];
    
    nthread = 2;
    idiv4 = 0;
    m = n >> 1;
    if (n > CDFT_4THREADS_BEGIN_N) {
        nthread = 4;
        idiv4 = 1;
        m >>= 1;
    }
    for (i = 0; i < nthread; i++) {
        ag[i].n0 = n;
        ag[i].n = m;
        ag[i].a = &a[i * m];
        ag[i].nw = nw;
        ag[i].w = w;
        if (i != idiv4) {
            cdft_thread_create(&th[i], cftrec1_th, &ag[i]);
        } else {
            cdft_thread_create(&th[i], cftrec2_th, &ag[i]);
        }
    }
    for (i = 0; i < nthread; i++) {
        cdft_thread_wait(th[i]);
    }
}


static void *cftrec1_th(void *p)
{
    int cfttree(int n, int j, int k, float *a, int nw, float *w);
    void cftleaf(int n, int isplt, float *a, int nw, float *w);
    void cftmdl1(int n, float *a, float *w);
    int isplt, j, k, m, n, n0, nw;
    float *a, *w;
    
    n0 = ((cdft_arg_t *) p)->n0;
    n = ((cdft_arg_t *) p)->n;
    a = ((cdft_arg_t *) p)->a;
    nw = ((cdft_arg_t *) p)->nw;
    w = ((cdft_arg_t *) p)->w;
    m = n0;
    while (m > 512) {
        m >>= 2;
        cftmdl1(m, &a[n - m], &w[nw - (m >> 1)]);
    }
    cftleaf(m, 1, &a[n - m], nw, w);
    k = 0;
    for (j = n - m; j > 0; j -= m) {
        k++;
        isplt = cfttree(m, j, k, a, nw, w);
        cftleaf(m, isplt, &a[j - m], nw, w);
    }
    return (void *) 0;
}


static void *cftrec2_th(void *p)
{
    int cfttree(int n, int j, int k, float *a, int nw, float *w);
    void cftleaf(int n, int isplt, float *a, int nw, float *w);
    void cftmdl2(int n, float *a, float *w);
    int isplt, j, k, m, n, n0, nw;
    float *a, *w;
    
    n0 = ((cdft_arg_t *) p)->n0;
    n = ((cdft_arg_t *) p)->n;
    a = ((cdft_arg_t *) p)->a;
    nw = ((cdft_arg_t *) p)->nw;
    w = ((cdft_arg_t *) p)->w;
    k = 1;
    m = n0;
    while (m > 512) {
        m >>= 2;
        k <<= 2;
        cftmdl2(m, &a[n - m], &w[nw - m]);
    }
    cftleaf(m, 0, &a[n - m], nw, w);
    k >>= 1;
    for (j = n - m; j > 0; j -= m) {
        k++;
        isplt = cfttree(m, j, k, a, nw, w);
        cftleaf(m, isplt, &a[j - m], nw, w);
    }
    return (void *) 0;
}
#endif /* USE_CDFT_THREADS */

static void cftfsub(int n, float *a, int *ip, int nw, float *w)
{
    void bitrv2(int n, int *ip, float *a);
    void bitrv216(float *a);
    void bitrv208(float *a);
    void cftf1st(int n, float *a, float *w);
    void cftrec4(int n, float *a, int nw, float *w);
    void cftleaf(int n, int isplt, float *a, int nw, float *w);
    void cftfx41(int n, float *a, int nw, float *w);
    void cftf161(float *a, float *w);
    void cftf081(float *a, float *w);
    void cftf040(float *a);
    void cftx020(float *a);
#ifdef USE_CDFT_THREADS
    void cftrec4_th(int n, float *a, int nw, float *w);
#endif /* USE_CDFT_THREADS */
    
    if (n > 8) {
        if (n > 32) {
            cftf1st(n, a, &w[nw - (n >> 2)]);
#ifdef USE_CDFT_THREADS
            if (n > CDFT_THREADS_BEGIN_N) {
                cftrec4_th(n, a, nw, w);
            } else 
#endif /* USE_CDFT_THREADS */
            if (n > 512) {
                cftrec4(n, a, nw, w);
            } else if (n > 128) {
                cftleaf(n, 1, a, nw, w);
            } else {
                cftfx41(n, a, nw, w);
            }
            bitrv2(n, ip, a);
        } else if (n == 32) {
            cftf161(a, &w[nw - 8]);
            bitrv216(a);
        } else {
            cftf081(a, w);
            bitrv208(a);
        }
    } else if (n == 8) {
        cftf040(a);
    } else if (n == 4) {
        cftx020(a);
    }
}

static void bitrv2conj(int n, int *ip, float *a)
{
    int j, j1, k, k1, l, m, nh, nm;
    float xr, xi, yr, yi;
    
    m = 1;
    for (l = n >> 2; l > 8; l >>= 2) {
        m <<= 1;
    }
    nh = n >> 1;
    nm = 4 * m;
    if (l == 8) {
        for (k = 0; k < m; k++) {
            for (j = 0; j < k; j++) {
                j1 = 4 * j + 2 * ip[m + k];
                k1 = 4 * k + 2 * ip[m + j];
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += 2 * nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 -= nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += 2 * nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nh;
                k1 += 2;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= 2 * nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 += nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= 2 * nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += 2;
                k1 += nh;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += 2 * nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 -= nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += 2 * nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nh;
                k1 -= 2;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= 2 * nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 += nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= 2 * nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
            }
            k1 = 4 * k + 2 * ip[m + k];
            j1 = k1 + 2;
            k1 += nh;
            a[j1 - 1] = -a[j1 - 1];
            xr = a[j1];
            xi = -a[j1 + 1];
            yr = a[k1];
            yi = -a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            a[k1 + 3] = -a[k1 + 3];
            j1 += nm;
            k1 += 2 * nm;
            xr = a[j1];
            xi = -a[j1 + 1];
            yr = a[k1];
            yi = -a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            j1 += nm;
            k1 -= nm;
            xr = a[j1];
            xi = -a[j1 + 1];
            yr = a[k1];
            yi = -a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            j1 -= 2;
            k1 -= nh;
            xr = a[j1];
            xi = -a[j1 + 1];
            yr = a[k1];
            yi = -a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            j1 += nh + 2;
            k1 += nh + 2;
            xr = a[j1];
            xi = -a[j1 + 1];
            yr = a[k1];
            yi = -a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            j1 -= nh - nm;
            k1 += 2 * nm - 2;
            a[j1 - 1] = -a[j1 - 1];
            xr = a[j1];
            xi = -a[j1 + 1];
            yr = a[k1];
            yi = -a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            a[k1 + 3] = -a[k1 + 3];
        }
    } else {
        for (k = 0; k < m; k++) {
            for (j = 0; j < k; j++) {
                j1 = 4 * j + ip[m + k];
                k1 = 4 * k + ip[m + j];
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nh;
                k1 += 2;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += 2;
                k1 += nh;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 += nm;
                k1 += nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nh;
                k1 -= 2;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
                j1 -= nm;
                k1 -= nm;
                xr = a[j1];
                xi = -a[j1 + 1];
                yr = a[k1];
                yi = -a[k1 + 1];
                a[j1] = yr;
                a[j1 + 1] = yi;
                a[k1] = xr;
                a[k1 + 1] = xi;
            }
            k1 = 4 * k + ip[m + k];
            j1 = k1 + 2;
            k1 += nh;
            a[j1 - 1] = -a[j1 - 1];
            xr = a[j1];
            xi = -a[j1 + 1];
            yr = a[k1];
            yi = -a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            a[k1 + 3] = -a[k1 + 3];
            j1 += nm;
            k1 += nm;
            a[j1 - 1] = -a[j1 - 1];
            xr = a[j1];
            xi = -a[j1 + 1];
            yr = a[k1];
            yi = -a[k1 + 1];
            a[j1] = yr;
            a[j1 + 1] = yi;
            a[k1] = xr;
            a[k1 + 1] = xi;
            a[k1 + 3] = -a[k1 + 3];
        }
    }
}

static void bitrv216neg(float *a)
{
    float x1r, x1i, x2r, x2i, x3r, x3i, x4r, x4i, 
        x5r, x5i, x6r, x6i, x7r, x7i, x8r, x8i, 
        x9r, x9i, x10r, x10i, x11r, x11i, x12r, x12i, 
        x13r, x13i, x14r, x14i, x15r, x15i;
    
    x1r = a[2];
    x1i = a[3];
    x2r = a[4];
    x2i = a[5];
    x3r = a[6];
    x3i = a[7];
    x4r = a[8];
    x4i = a[9];
    x5r = a[10];
    x5i = a[11];
    x6r = a[12];
    x6i = a[13];
    x7r = a[14];
    x7i = a[15];
    x8r = a[16];
    x8i = a[17];
    x9r = a[18];
    x9i = a[19];
    x10r = a[20];
    x10i = a[21];
    x11r = a[22];
    x11i = a[23];
    x12r = a[24];
    x12i = a[25];
    x13r = a[26];
    x13i = a[27];
    x14r = a[28];
    x14i = a[29];
    x15r = a[30];
    x15i = a[31];
    a[2] = x15r;
    a[3] = x15i;
    a[4] = x7r;
    a[5] = x7i;
    a[6] = x11r;
    a[7] = x11i;
    a[8] = x3r;
    a[9] = x3i;
    a[10] = x13r;
    a[11] = x13i;
    a[12] = x5r;
    a[13] = x5i;
    a[14] = x9r;
    a[15] = x9i;
    a[16] = x1r;
    a[17] = x1i;
    a[18] = x14r;
    a[19] = x14i;
    a[20] = x6r;
    a[21] = x6i;
    a[22] = x10r;
    a[23] = x10i;
    a[24] = x2r;
    a[25] = x2i;
    a[26] = x12r;
    a[27] = x12i;
    a[28] = x4r;
    a[29] = x4i;
    a[30] = x8r;
    a[31] = x8i;
}

static void bitrv208neg(float *a)
{
    float x1r, x1i, x2r, x2i, x3r, x3i, x4r, x4i, 
        x5r, x5i, x6r, x6i, x7r, x7i;
    
    x1r = a[2];
    x1i = a[3];
    x2r = a[4];
    x2i = a[5];
    x3r = a[6];
    x3i = a[7];
    x4r = a[8];
    x4i = a[9];
    x5r = a[10];
    x5i = a[11];
    x6r = a[12];
    x6i = a[13];
    x7r = a[14];
    x7i = a[15];
    a[2] = x7r;
    a[3] = x7i;
    a[4] = x3r;
    a[5] = x3i;
    a[6] = x5r;
    a[7] = x5i;
    a[8] = x1r;
    a[9] = x1i;
    a[10] = x6r;
    a[11] = x6i;
    a[12] = x2r;
    a[13] = x2i;
    a[14] = x4r;
    a[15] = x4i;
}

static void cftb1st(int n, float *a, float *w)
{
    int j, j0, j1, j2, j3, k, m, mh;
    float wn4r, csc1, csc3, wk1r, wk1i, wk3r, wk3i, 
        wd1r, wd1i, wd3r, wd3i;
    float x0r, x0i, x1r, x1i, x2r, x2i, x3r, x3i, 
        y0r, y0i, y1r, y1i, y2r, y2i, y3r, y3i;
    
    mh = n >> 3;
    m = 2 * mh;
    j1 = m;
    j2 = j1 + m;
    j3 = j2 + m;
    x0r = a[0] + a[j2];
    x0i = -a[1] - a[j2 + 1];
    x1r = a[0] - a[j2];
    x1i = -a[1] + a[j2 + 1];
    x2r = a[j1] + a[j3];
    x2i = a[j1 + 1] + a[j3 + 1];
    x3r = a[j1] - a[j3];
    x3i = a[j1 + 1] - a[j3 + 1];
    a[0] = x0r + x2r;
    a[1] = x0i - x2i;
    a[j1] = x0r - x2r;
    a[j1 + 1] = x0i + x2i;
    a[j2] = x1r + x3i;
    a[j2 + 1] = x1i + x3r;
    a[j3] = x1r - x3i;
    a[j3 + 1] = x1i - x3r;
    wn4r = w[1];
    csc1 = w[2];
    csc3 = w[3];
    wd1r = 1;
    wd1i = 0;
    wd3r = 1;
    wd3i = 0;
    k = 0;
    for (j = 2; j < mh - 2; j += 4) {
        k += 4;
        wk1r = csc1 * (wd1r + w[k]);
        wk1i = csc1 * (wd1i + w[k + 1]);
        wk3r = csc3 * (wd3r + w[k + 2]);
        wk3i = csc3 * (wd3i + w[k + 3]);
        wd1r = w[k];
        wd1i = w[k + 1];
        wd3r = w[k + 2];
        wd3i = w[k + 3];
        j1 = j + m;
        j2 = j1 + m;
        j3 = j2 + m;
        x0r = a[j] + a[j2];
        x0i = -a[j + 1] - a[j2 + 1];
        x1r = a[j] - a[j2];
        x1i = -a[j + 1] + a[j2 + 1];
        y0r = a[j + 2] + a[j2 + 2];
        y0i = -a[j + 3] - a[j2 + 3];
        y1r = a[j + 2] - a[j2 + 2];
        y1i = -a[j + 3] + a[j2 + 3];
        x2r = a[j1] + a[j3];
        x2i = a[j1 + 1] + a[j3 + 1];
        x3r = a[j1] - a[j3];
        x3i = a[j1 + 1] - a[j3 + 1];
        y2r = a[j1 + 2] + a[j3 + 2];
        y2i = a[j1 + 3] + a[j3 + 3];
        y3r = a[j1 + 2] - a[j3 + 2];
        y3i = a[j1 + 3] - a[j3 + 3];
        a[j] = x0r + x2r;
        a[j + 1] = x0i - x2i;
        a[j + 2] = y0r + y2r;
        a[j + 3] = y0i - y2i;
        a[j1] = x0r - x2r;
        a[j1 + 1] = x0i + x2i;
        a[j1 + 2] = y0r - y2r;
        a[j1 + 3] = y0i + y2i;
        x0r = x1r + x3i;
        x0i = x1i + x3r;
        a[j2] = wk1r * x0r - wk1i * x0i;
        a[j2 + 1] = wk1r * x0i + wk1i * x0r;
        x0r = y1r + y3i;
        x0i = y1i + y3r;
        a[j2 + 2] = wd1r * x0r - wd1i * x0i;
        a[j2 + 3] = wd1r * x0i + wd1i * x0r;
        x0r = x1r - x3i;
        x0i = x1i - x3r;
        a[j3] = wk3r * x0r + wk3i * x0i;
        a[j3 + 1] = wk3r * x0i - wk3i * x0r;
        x0r = y1r - y3i;
        x0i = y1i - y3r;
        a[j3 + 2] = wd3r * x0r + wd3i * x0i;
        a[j3 + 3] = wd3r * x0i - wd3i * x0r;
        j0 = m - j;
        j1 = j0 + m;
        j2 = j1 + m;
        j3 = j2 + m;
        x0r = a[j0] + a[j2];
        x0i = -a[j0 + 1] - a[j2 + 1];
        x1r = a[j0] - a[j2];
        x1i = -a[j0 + 1] + a[j2 + 1];
        y0r = a[j0 - 2] + a[j2 - 2];
        y0i = -a[j0 - 1] - a[j2 - 1];
        y1r = a[j0 - 2] - a[j2 - 2];
        y1i = -a[j0 - 1] + a[j2 - 1];
        x2r = a[j1] + a[j3];
        x2i = a[j1 + 1] + a[j3 + 1];
        x3r = a[j1] - a[j3];
        x3i = a[j1 + 1] - a[j3 + 1];
        y2r = a[j1 - 2] + a[j3 - 2];
        y2i = a[j1 - 1] + a[j3 - 1];
        y3r = a[j1 - 2] - a[j3 - 2];
        y3i = a[j1 - 1] - a[j3 - 1];
        a[j0] = x0r + x2r;
        a[j0 + 1] = x0i - x2i;
        a[j0 - 2] = y0r + y2r;
        a[j0 - 1] = y0i - y2i;
        a[j1] = x0r - x2r;
        a[j1 + 1] = x0i + x2i;
        a[j1 - 2] = y0r - y2r;
        a[j1 - 1] = y0i + y2i;
        x0r = x1r + x3i;
        x0i = x1i + x3r;
        a[j2] = wk1i * x0r - wk1r * x0i;
        a[j2 + 1] = wk1i * x0i + wk1r * x0r;
        x0r = y1r + y3i;
        x0i = y1i + y3r;
        a[j2 - 2] = wd1i * x0r - wd1r * x0i;
        a[j2 - 1] = wd1i * x0i + wd1r * x0r;
        x0r = x1r - x3i;
        x0i = x1i - x3r;
        a[j3] = wk3i * x0r + wk3r * x0i;
        a[j3 + 1] = wk3i * x0i - wk3r * x0r;
        x0r = y1r - y3i;
        x0i = y1i - y3r;
        a[j3 - 2] = wd3i * x0r + wd3r * x0i;
        a[j3 - 1] = wd3i * x0i - wd3r * x0r;
    }
    wk1r = csc1 * (wd1r + wn4r);
    wk1i = csc1 * (wd1i + wn4r);
    wk3r = csc3 * (wd3r - wn4r);
    wk3i = csc3 * (wd3i - wn4r);
    j0 = mh;
    j1 = j0 + m;
    j2 = j1 + m;
    j3 = j2 + m;
    x0r = a[j0 - 2] + a[j2 - 2];
    x0i = -a[j0 - 1] - a[j2 - 1];
    x1r = a[j0 - 2] - a[j2 - 2];
    x1i = -a[j0 - 1] + a[j2 - 1];
    x2r = a[j1 - 2] + a[j3 - 2];
    x2i = a[j1 - 1] + a[j3 - 1];
    x3r = a[j1 - 2] - a[j3 - 2];
    x3i = a[j1 - 1] - a[j3 - 1];
    a[j0 - 2] = x0r + x2r;
    a[j0 - 1] = x0i - x2i;
    a[j1 - 2] = x0r - x2r;
    a[j1 - 1] = x0i + x2i;
    x0r = x1r + x3i;
    x0i = x1i + x3r;
    a[j2 - 2] = wk1r * x0r - wk1i * x0i;
    a[j2 - 1] = wk1r * x0i + wk1i * x0r;
    x0r = x1r - x3i;
    x0i = x1i - x3r;
    a[j3 - 2] = wk3r * x0r + wk3i * x0i;
    a[j3 - 1] = wk3r * x0i - wk3i * x0r;
    x0r = a[j0] + a[j2];
    x0i = -a[j0 + 1] - a[j2 + 1];
    x1r = a[j0] - a[j2];
    x1i = -a[j0 + 1] + a[j2 + 1];
    x2r = a[j1] + a[j3];
    x2i = a[j1 + 1] + a[j3 + 1];
    x3r = a[j1] - a[j3];
    x3i = a[j1 + 1] - a[j3 + 1];
    a[j0] = x0r + x2r;
    a[j0 + 1] = x0i - x2i;
    a[j1] = x0r - x2r;
    a[j1 + 1] = x0i + x2i;
    x0r = x1r + x3i;
    x0i = x1i + x3r;
    a[j2] = wn4r * (x0r - x0i);
    a[j2 + 1] = wn4r * (x0i + x0r);
    x0r = x1r - x3i;
    x0i = x1i - x3r;
    a[j3] = -wn4r * (x0r + x0i);
    a[j3 + 1] = -wn4r * (x0i - x0r);
    x0r = a[j0 + 2] + a[j2 + 2];
    x0i = -a[j0 + 3] - a[j2 + 3];
    x1r = a[j0 + 2] - a[j2 + 2];
    x1i = -a[j0 + 3] + a[j2 + 3];
    x2r = a[j1 + 2] + a[j3 + 2];
    x2i = a[j1 + 3] + a[j3 + 3];
    x3r = a[j1 + 2] - a[j3 + 2];
    x3i = a[j1 + 3] - a[j3 + 3];
    a[j0 + 2] = x0r + x2r;
    a[j0 + 3] = x0i - x2i;
    a[j1 + 2] = x0r - x2r;
    a[j1 + 3] = x0i + x2i;
    x0r = x1r + x3i;
    x0i = x1i + x3r;
    a[j2 + 2] = wk1i * x0r - wk1r * x0i;
    a[j2 + 3] = wk1i * x0i + wk1r * x0r;
    x0r = x1r - x3i;
    x0i = x1i - x3r;
    a[j3 + 2] = wk3i * x0r + wk3r * x0i;
    a[j3 + 3] = wk3i * x0i - wk3r * x0r;
}

static void cftb040(float *a)
{
    float x0r, x0i, x1r, x1i, x2r, x2i, x3r, x3i;
    
    x0r = a[0] + a[4];
    x0i = a[1] + a[5];
    x1r = a[0] - a[4];
    x1i = a[1] - a[5];
    x2r = a[2] + a[6];
    x2i = a[3] + a[7];
    x3r = a[2] - a[6];
    x3i = a[3] - a[7];
    a[0] = x0r + x2r;
    a[1] = x0i + x2i;
    a[2] = x1r + x3i;
    a[3] = x1i - x3r;
    a[4] = x0r - x2r;
    a[5] = x0i - x2i;
    a[6] = x1r - x3i;
    a[7] = x1i + x3r;
}

static void cftbsub(int n, float *a, int *ip, int nw, float *w)
{
    void bitrv2conj(int n, int *ip, float *a);
    void bitrv216neg(float *a);
    void bitrv208neg(float *a);
    void cftb1st(int n, float *a, float *w);
    void cftrec4(int n, float *a, int nw, float *w);
    void cftleaf(int n, int isplt, float *a, int nw, float *w);
    void cftfx41(int n, float *a, int nw, float *w);
    void cftf161(float *a, float *w);
    void cftf081(float *a, float *w);
    void cftb040(float *a);
    void cftx020(float *a);
#ifdef USE_CDFT_THREADS
    void cftrec4_th(int n, float *a, int nw, float *w);
#endif /* USE_CDFT_THREADS */
    
    if (n > 8) {
        if (n > 32) {
            cftb1st(n, a, &w[nw - (n >> 2)]);
#ifdef USE_CDFT_THREADS
            if (n > CDFT_THREADS_BEGIN_N) {
                cftrec4_th(n, a, nw, w);
            } else 
#endif /* USE_CDFT_THREADS */
            if (n > 512) {
                cftrec4(n, a, nw, w);
            } else if (n > 128) {
                cftleaf(n, 1, a, nw, w);
            } else {
                cftfx41(n, a, nw, w);
            }
            bitrv2conj(n, ip, a);
        } else if (n == 32) {
            cftf161(a, &w[nw - 8]);
            bitrv216neg(a);
        } else {
            cftf081(a, w);
            bitrv208neg(a);
        }
    } else if (n == 8) {
        cftb040(a);
    } else if (n == 4) {
        cftx020(a);
    }
}

static void rftfsub(int n, float *a, int nc, float *c)
{
    int j, k, kk, ks, m;
    float wkr, wki, xr, xi, yr, yi;
    
    m = n >> 1;
    ks = 2 * nc / m;
    kk = 0;
    for (j = 2; j < m; j += 2) {
        k = n - j;
        kk += ks;
        wkr = 0.5 - c[nc - kk];
        wki = c[kk];
        xr = a[j] - a[k];
        xi = a[j + 1] + a[k + 1];
        yr = wkr * xr - wki * xi;
        yi = wkr * xi + wki * xr;
        a[j] -= yr;
        a[j + 1] -= yi;
        a[k] += yr;
        a[k + 1] -= yi;
    }
}

static void rftbsub(int n, float *a, int nc, float *c)
{
    int j, k, kk, ks, m;
    float wkr, wki, xr, xi, yr, yi;
    
    m = n >> 1;
    ks = 2 * nc / m;
    kk = 0;
    for (j = 2; j < m; j += 2) {
        k = n - j;
        kk += ks;
        wkr = 0.5 - c[nc - kk];
        wki = c[kk];
        xr = a[j] - a[k];
        xi = a[j + 1] + a[k + 1];
        yr = wkr * xr + wki * xi;
        yi = wkr * xi - wki * xr;
        a[j] -= yr;
        a[j + 1] -= yi;
        a[k] += yr;
        a[k + 1] -= yi;
    }
}

static void rdft(int n, int isgn, float *a, int *ip, float *w)
{
    void makewt(int nw, int *ip, float *w);
    void makect(int nc, int *ip, float *c);
    void cftfsub(int n, float *a, int *ip, int nw, float *w);
    void cftbsub(int n, float *a, int *ip, int nw, float *w);
    void rftfsub(int n, float *a, int nc, float *c);
    void rftbsub(int n, float *a, int nc, float *c);
    int nw, nc;
    float xi;
    
    nw = ip[0];
    if (n > (nw << 2)) {
        nw = n >> 2;
        makewt(nw, ip, w);
    }
    nc = ip[1];
    if (n > (nc << 2)) {
        nc = n >> 2;
        makect(nc, ip, w + nw);
    }
    if (isgn >= 0) {
        if (n > 4) {
            cftfsub(n, a, ip, nw, w);
            rftfsub(n, a, nc, w + nw);
        } else if (n == 4) {
            cftfsub(n, a, ip, nw, w);
        }
        xi = a[0] - a[1];
        a[0] += a[1];
        a[1] = xi;
    } else {
        a[1] = 0.5 * (a[0] - a[1]);
        a[0] -= a[1];
        if (n > 4) {
            rftbsub(n, a, nc, w + nw);
            cftbsub(n, a, ip, nw, w);
        } else if (n == 4) {
            cftbsub(n, a, ip, nw, w);
        }
    }
}

// input array (any shape >= 1D)
// output array (shape = input.shape.replace(axis, n).insert(0,2))
// d0 = input.shape.step(axis)
// d1 = input.shape.size(axis)
// d2 = input.shape.slot(axis)
static inline void rdft_ndim_f32(
    const float* restrict input, 
    float* restrict output, 
    int d0, int d1, int d2,
    int* restrict temp_ip, float* restrict temp_w, float* restrict temp_a)
{
    void rdft(int n, int isgn, float* a, int* ip, float* w);

    int d3 = d0 * d1;
    int d_out = (d1 >> 1) + 1;

    for (int k = 0; k < d2; k++)
    {
        int dk = k * d3;
        int dm = k * 2 * d_out * d0;
        for (int i = 0; i < d0; i++)
        {                	           
            for (int j = 0; j < d1; j++)
            {
                temp_a[j] = input[dk + j * d0 + i];
            }
            rdft(d1, 1, temp_a, temp_ip, temp_w);

            for (int m = 2; m < d1; m+=2)
            {
                int index = (m * d0) + 2 * i + dm;
                output[index] = temp_a[m];
                output[index + 1] = -temp_a[m + 1];
            }
            int beta = dm + 2 * i;
            output[beta] = temp_a[0];
            output[beta + 1] = 0;
            output[beta + d3] = temp_a[1];
            output[beta + d3 + 1] = 0;
        }
    }
}

static inline float __norm_f32(const float* input, int step, int count)
{
	float sum = 0;
	for (int j = 0; j < count; j++) {
		float item = input[j * step];
		sum += item * item;
	}
	return sqrtf(sum);
}

// input array (any shape >= 2D)
// output array (same shape as input array except with axis removed)
// d0 = input.shape.step(axis)
// d1 = input.shape.size(axis)
// d2 = input.shape.slot(axis)
static inline void norm_f32(const float* restrict input, int d0, int d1, int d2, float* restrict output)
{
	const int d3 = d0 * d1;

	for (int k = 0; k < d2; k++) {
		int k3 = k * d3;
		int k0 = k * d0;
		for (int i = 0; i < d0; i++) {			
			*(output + i + k0) = __norm_f32(input + i + k3, d0, d1);
		}
	}
}

static inline float __mel_f32(const float* restrict input, const int* restrict filter_points, int filter)
{
	int n0 = filter_points[filter];
	int n1 = filter_points[filter+1];
	int n2 = filter_points[filter+2];
	int c0 = n1 - n0;
	int c1 = n2 - n1;
	float sum = 0;
	
	for (int i = 0; i <= c0; i++) {
		float rate = i / (float)c0;
		float value = input[i + n0];
		sum += value * rate;
	}

	for (int i = 1; i <= c1; i++) {
		float rate = i / (float)c1;
		float value = input[i + n1];
		sum += value * (1.0 - rate);
	}

	return sum;
}

// input array (any shape >= 1D)
// output array (same shape as input array except with 0 replaced with num_filter)
// size = input.shape.size(0)
// slot = input.shape.slot(0)
static inline void mel_f32(const float* restrict input, const int* restrict filter_points, int size, int slot, int num_filter, float* restrict output)
{	
	for (int k = 0; k < slot; k++) {
		const float *ip = input + k * size;
		for (int i = 0; i < num_filter; i++) {
			*output++ = __mel_f32(ip, filter_points, i);
		}
	}
}

static inline void clip_f32(const float* restrict input, int count, float min, float max, float* restrict output)
{	
	for (int i = 0; i < count; i++) {
		float value = input[i];
		if (value > max)
			value = max;
		if (value < min)
			value = min;

		output[i] = value;
	}
}

static inline void loge_f32(const float* restrict x, int count, float* restrict result)
{
	for (int i = 0; i < count; i++) {
		*result++ = logf(*x++);
	}
}

/**
 * Enqueue handle->input_size values from given *data pointer to internal window buffer.
 *
 * @param handle Pointer to an initialized handle.
 * @param data Data to enqueue.
 * @return IPWIN_RET_SUCCESS (0) or IPWIN_RET_NOMEM (-2) if internal buffer is out of memory.
 */
static inline int fixwin_enqueuef32(void* restrict handle, const void* restrict data)
{
	fixwin_t* fep = (fixwin_t*)handle;

	if (cbuffer_enqueue(&fep->data_buffer, data, fep->input_size) != 0)
		return IPWIN_RET_NOMEM;

	return IPWIN_RET_SUCCESS;
}

static inline float mac_f32(const float* restrict a, const float* restrict b, int count)
{
	float sum = 0;
	for (int i = 0; i < count; i++) {
		sum += *a++ * *b++;
	}
	return sum;
}

static inline void conv1d_flat_f32(
	const float* restrict input,
	const float* restrict weight,
	float* restrict output,
	int top,
	int bottom,
	int n_output_rows,
	int filters,
	int strides,
	int kernel_size)
{
	for (int i = 0; i < n_output_rows; i++) {
		const float* wp = weight;		// Weight matrix
		const float* bp = input;		// Input matrix
		const int step = i * strides;	// Row size
		int len = kernel_size;			// Normally do one kernel

		int skip = top - step;			// Pad top?
		if (skip > 0) {
			len -= skip;				// Trim kernel length
			wp += skip;					// Advance kernel
		}
		else {						// No top padding,
			bp -= skip;					// Rollback input
		}

		skip = step + len - bottom;		// Pad bottom?
		if (skip > 0)
			len -= skip;				// Just cut the kernel at end

		float* op = output + i * filters;
		for (int j = 0; j < filters; j++) {
			*op++ = mac_f32(wp + j * kernel_size, bp, len);
		}
	}
}

static inline void add_f32(
	const float* restrict a,
	const float* restrict b,
	int l, int g1, int m, int g2, int r,
	float* restrict output)
{
	int index = 0;
	for (int x = 0; x < l; x++) {
		for (int i = 0; i < g1; i++) {
			for (int y = 0; y < m; y++) {
				for (int j = 0; j < g2; j++) {
					for (int z = 0; z < r; z++) {
						output[index] = a[index] + b[x * m * r + y * r + z];
						index++;
					}
				}
			}
		}
	}
}

static inline void mul_f32(
	const float* restrict a,
	const float* restrict b,
	int l, int g1, int m, int g2, int r,
	float* restrict output)
{
	int index = 0;
	for (int x = 0; x < l; x++) {
		for (int i = 0; i < g1; i++) {
			for (int y = 0; y < m; y++) {
				for (int j = 0; j < g2; j++) {
					for (int z = 0; z < r; z++) {
						output[index] = a[index] * b[x * m * r + y * r + z];
						index++;
					}
				}
			}
		}
	}
}

static inline void relu_f32(const float* restrict x, int count, float* restrict result)
{
	for (int i = 0; i < count; i++) {
		const float value = *x++;
		*result++ = value > 0 ? value : 0;
	}
}

static inline float _globav1d_f32_mean(const float *restrict x, int nchannel, int nsteps)
{
	float mean = 0.0;
	for (int i = 0; i < nsteps; i++) {
		const float value = *(x + i * nchannel);
		mean = mean + value;
	}
	mean = mean/(float)nsteps;
	return mean;
}

static inline void globav1d_f32(const float *restrict x, int nsteps, int nchannel, float *restrict result)
{
	// Loop over all channels
	for (int i = 0; i < nchannel; i++) {
		const float* xp = x + i;
		*result++ = _globav1d_f32_mean(xp, nchannel, nsteps);
	}
}

static inline void dott_f32(const float *restrict a, const float *restrict b, float *restrict out, int d0, int d1, int d2)
{
	for (int i = 0; i < d2; i++) {
		float* op = out;
		for (int j = 0; j < d1; j++) {
			*op++ = mac_f32(a + j * d0, b, d0);
		}
		out += d1;
		b += d0;
	}
}

static inline void softmax_f32(const float* restrict x, int count, float* restrict result)
{
	float sum = 0;
	for (int i = 0; i < count; i++) {
		float value = expf(x[i]);
		sum += value;
		result[i] = value;
	}
	for (int i = 0; i < count; i++) {
		result[i] /= sum;
	}
}

/**
* Initializes a fixwin sampler handle.
*
* @param handle Pointer to a preallocated memory area of fixwin_handle_size() bytes to initialize.
*
* @param input_size Number of bytes to enqueue.
* @param window_count Number of items (of size input_size) in each window
*/
static inline void fixwin_initf32(void* restrict handle, int input_size, int window_count)
{
	fixwin_t* fep = (fixwin_t*)handle;
	fep->input_size = input_size;
	fep->window_count = window_count;

	char* mem = ((char*)handle) + sizeof(fixwin_t);

	int data_buffer = input_size * window_count;
	
	cbuffer_init(&fep->data_buffer, mem, data_buffer);
}

#define __RETURN_ERROR(_exp) do { int __ret = (_exp); if(__ret < 0) return __ret; } while(0)
#define __RETURN_ERROR_BREAK_EMPTY(_exp) {  int __ret = (_exp); if(__ret == -1) break; if(__ret < 0) return __ret;  } 

int IMAI_dequeue(float *restrict data_out) {    
    while(1) {
        __RETURN_ERROR_BREAK_EMPTY(fixwin_dequeuef32(_K3, _K2, 320));
        hannmul_f32(_K2, _K4, _K5, 512, 1);
        rdft_ndim_f32(_K5, _K6, 1, 512, 1, _K7, _K8, _K9);
        norm_f32(_K6, 1, 2, 257, _K10);
        mel_f32(_K10, _K11, 257, 1, 30, _K12);
        clip_f32(_K12, 30, 0.000316227766016, 3.40282347E+38, _K13);
        loge_f32(_K13, 30, _K14);
        __RETURN_ERROR_BREAK_EMPTY(fixwin_enqueuef32(_K16, _K14));
    }
    __RETURN_ERROR(fixwin_dequeuef32(_K16, _K15, 6));
    conv1d_flat_f32(_K15, _K18, _K20, 0, 1500, 24, 13, 60, 90);
    add_f32(_K20, _K19, 1, 1, 1, 24, 13, _K20);
    conv1d_flat_f32(_K20, _K22, _K21, 0, 312, 12, 16, 26, 39);
    mul_f32(_K21, _K24, 1, 1, 1, 12, 16, _K26);
    add_f32(_K26, _K25, 1, 1, 1, 12, 16, _K23);
    relu_f32(_K23, 192, _K27);
    conv1d_flat_f32(_K27, _K29, _K28, 16, 208, 12, 32, 16, 48);
    conv1d_flat_f32(_K28, _K31, _K30, 32, 416, 12, 32, 32, 96);
    mul_f32(_K30, _K33, 1, 1, 1, 12, 32, _K35);
    add_f32(_K35, _K34, 1, 1, 1, 12, 32, _K32);
    relu_f32(_K32, 384, _K36);
    conv1d_flat_f32(_K36, _K38, _K37, 32, 416, 12, 32, 32, 96);
    conv1d_flat_f32(_K37, _K40, _K39, 32, 416, 12, 32, 32, 96);
    mul_f32(_K39, _K42, 1, 1, 1, 12, 32, _K44);
    add_f32(_K44, _K43, 1, 1, 1, 12, 32, _K41);
    relu_f32(_K41, 384, _K45);
    globav1d_f32(_K45, 12, 32, _K46);
    dott_f32(_K47, _K46, _K48, 32, 2, 1);
    add_f32(_K48, _K49, 1, 1, 1, 1, 2, _K50);
    softmax_f32(_K50, 2, data_out);
    return 0;
}

int IMAI_enqueue(const float *restrict data_in) {    
    __RETURN_ERROR(fixwin_enqueuef32(_K3, data_in));
    return 0;
}

void IMAI_init(void) {    
    fixwin_initf32(_K3, 4, 512);
    fixwin_initf32(_K16, 120, 50);
}

